/* sudoku-game.c generated by valac 0.56.13, the Vala compiler
 * generated from sudoku-game.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include "libsudoku.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <string.h>

#define SUDOKU_GAME_TYPE_UNDO_ITEM (sudoku_game_undo_item_get_type ())
typedef struct _SudokuGameUndoItem SudokuGameUndoItem;
enum  {
	SUDOKU_GAME_0_PROPERTY,
	SUDOKU_GAME_PAUSED_PROPERTY,
	SUDOKU_GAME_NUM_PROPERTIES
};
static GParamSpec* sudoku_game_properties[SUDOKU_GAME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_timer_destroy0(var) ((var == NULL) ? NULL : (var = (g_timer_destroy (var), NULL)))
#define _sudoku_game_undo_item_free0(var) ((var == NULL) ? NULL : (var = (sudoku_game_undo_item_free (var), NULL)))
enum  {
	SUDOKU_GAME_TICK_SIGNAL,
	SUDOKU_GAME_PAUSED_CHANGED_SIGNAL,
	SUDOKU_GAME_CELL_CHANGED_SIGNAL,
	SUDOKU_GAME_NUM_SIGNALS
};
static guint sudoku_game_signals[SUDOKU_GAME_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SudokuGameUndoItem {
	gint row;
	gint col;
	gint val;
	gboolean* earmarks;
	gint earmarks_length1;
	gint _earmarks_size_;
};

struct _SudokuGamePrivate {
	guint clock_timeout;
	gboolean _paused;
	GeeList* undostack;
	GeeList* redostack;
};

static gint SudokuGame_private_offset;
static gpointer sudoku_game_parent_class = NULL;

static GType sudoku_game_undo_item_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static SudokuGameUndoItem* sudoku_game_undo_item_dup (const SudokuGameUndoItem* self);
static void sudoku_game_undo_item_free (SudokuGameUndoItem* self);
static void sudoku_game_undo_item_copy (const SudokuGameUndoItem* self,
                                 SudokuGameUndoItem* dest);
static void sudoku_game_undo_item_destroy (SudokuGameUndoItem* self);
static void sudoku_game_apply_stack (SudokuGame* self,
                              GeeList* from,
                              GeeList* to);
static void sudoku_game_add_to_stack (SudokuGame* self,
                               GeeList* stack,
                               gint r,
                               gint c,
                               gint v,
                               gboolean* e,
                               gint e_length1);
static gboolean* _vala_array_dup10 (gboolean* self,
                             gssize length);
static gboolean sudoku_game_timeout_cb (SudokuGame* self);
static gboolean _sudoku_game_timeout_cb_gsource_func (gpointer self);
static void sudoku_game_set_paused (SudokuGame* self,
                             gboolean value);
static void g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data);
static gboolean* _vala_array_dup11 (gboolean* self,
                             gssize length);
static void sudoku_game_finalize (GObject * obj);
static GType sudoku_game_get_type_once (void);
static void _vala_sudoku_game_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_game_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
sudoku_game_get_instance_private (SudokuGame* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuGame_private_offset);
}

gboolean
sudoku_game_is_undostack_null (SudokuGame* self)
{
	GeeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result;
#line 58 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 60 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->undostack;
#line 60 "../lib/sudoku-game.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 60 "../lib/sudoku-game.vala"
	_tmp2_ = _tmp1_;
#line 60 "../lib/sudoku-game.vala"
	result = _tmp2_ == 0;
#line 60 "../lib/sudoku-game.vala"
	return result;
#line 144 "sudoku-game.c"
}

gboolean
sudoku_game_is_redostack_null (SudokuGame* self)
{
	GeeList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result;
#line 63 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 65 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->redostack;
#line 65 "../lib/sudoku-game.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 65 "../lib/sudoku-game.vala"
	_tmp2_ = _tmp1_;
#line 65 "../lib/sudoku-game.vala"
	result = _tmp2_ == 0;
#line 65 "../lib/sudoku-game.vala"
	return result;
#line 166 "sudoku-game.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 70 "../lib/sudoku-game.vala"
	return self ? g_object_ref (self) : NULL;
#line 174 "sudoku-game.c"
}

SudokuGame*
sudoku_game_construct (GType object_type,
                       SudokuBoard* board)
{
	SudokuGame * self = NULL;
	SudokuBoard* _tmp0_;
	GTimer* _tmp1_;
	GeeArrayList* _tmp2_;
	GeeArrayList* _tmp3_;
#line 68 "../lib/sudoku-game.vala"
	g_return_val_if_fail (board != NULL, NULL);
#line 68 "../lib/sudoku-game.vala"
	self = (SudokuGame*) g_object_new (object_type, NULL);
#line 70 "../lib/sudoku-game.vala"
	_tmp0_ = _g_object_ref0 (board);
#line 70 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->board);
#line 70 "../lib/sudoku-game.vala"
	self->board = _tmp0_;
#line 71 "../lib/sudoku-game.vala"
	self->mode = GAME_MODE_PLAY;
#line 72 "../lib/sudoku-game.vala"
	_tmp1_ = g_timer_new ();
#line 72 "../lib/sudoku-game.vala"
	_g_timer_destroy0 (self->timer);
#line 72 "../lib/sudoku-game.vala"
	self->timer = _tmp1_;
#line 73 "../lib/sudoku-game.vala"
	_tmp2_ = gee_array_list_new (SUDOKU_GAME_TYPE_UNDO_ITEM, (GBoxedCopyFunc) sudoku_game_undo_item_dup, (GDestroyNotify) sudoku_game_undo_item_free, NULL, NULL, NULL);
#line 73 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->priv->undostack);
#line 73 "../lib/sudoku-game.vala"
	self->priv->undostack = (GeeList*) _tmp2_;
#line 74 "../lib/sudoku-game.vala"
	_tmp3_ = gee_array_list_new (SUDOKU_GAME_TYPE_UNDO_ITEM, (GBoxedCopyFunc) sudoku_game_undo_item_dup, (GDestroyNotify) sudoku_game_undo_item_free, NULL, NULL, NULL);
#line 74 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->priv->redostack);
#line 74 "../lib/sudoku-game.vala"
	self->priv->redostack = (GeeList*) _tmp3_;
#line 68 "../lib/sudoku-game.vala"
	return self;
#line 218 "sudoku-game.c"
}

SudokuGame*
sudoku_game_new (SudokuBoard* board)
{
#line 68 "../lib/sudoku-game.vala"
	return sudoku_game_construct (TYPE_SUDOKU_GAME, board);
#line 226 "sudoku-game.c"
}

void
sudoku_game_enable_earmark (SudokuGame* self,
                            gint row,
                            gint col,
                            gint k_no)
{
	gint old_val = 0;
	SudokuBoard* _tmp0_;
	gboolean* old_earmarks = NULL;
	SudokuBoard* _tmp1_;
	gint _tmp2_ = 0;
	gboolean* _tmp3_;
	gint old_earmarks_length1;
	gint _old_earmarks_size_;
	SudokuBoard* _tmp4_;
#line 77 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 79 "../lib/sudoku-game.vala"
	_tmp0_ = self->board;
#line 79 "../lib/sudoku-game.vala"
	old_val = sudoku_board_get (_tmp0_, row, col);
#line 80 "../lib/sudoku-game.vala"
	_tmp1_ = self->board;
#line 80 "../lib/sudoku-game.vala"
	_tmp3_ = sudoku_board_get_earmarks (_tmp1_, row, col, &_tmp2_);
#line 80 "../lib/sudoku-game.vala"
	old_earmarks = _tmp3_;
#line 80 "../lib/sudoku-game.vala"
	old_earmarks_length1 = _tmp2_;
#line 80 "../lib/sudoku-game.vala"
	_old_earmarks_size_ = old_earmarks_length1;
#line 81 "../lib/sudoku-game.vala"
	sudoku_game_update_undo (self, row, col, old_val, old_earmarks, (gint) old_earmarks_length1);
#line 83 "../lib/sudoku-game.vala"
	_tmp4_ = self->board;
#line 83 "../lib/sudoku-game.vala"
	sudoku_board_enable_earmark (_tmp4_, row, col, k_no);
#line 77 "../lib/sudoku-game.vala"
	old_earmarks = (g_free (old_earmarks), NULL);
#line 268 "sudoku-game.c"
}

void
sudoku_game_disable_earmark (SudokuGame* self,
                             gint row,
                             gint col,
                             gint k_no)
{
	gint old_val = 0;
	SudokuBoard* _tmp0_;
	gboolean* old_earmarks = NULL;
	SudokuBoard* _tmp1_;
	gint _tmp2_ = 0;
	gboolean* _tmp3_;
	gint old_earmarks_length1;
	gint _old_earmarks_size_;
	SudokuBoard* _tmp4_;
#line 86 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 88 "../lib/sudoku-game.vala"
	_tmp0_ = self->board;
#line 88 "../lib/sudoku-game.vala"
	old_val = sudoku_board_get (_tmp0_, row, col);
#line 89 "../lib/sudoku-game.vala"
	_tmp1_ = self->board;
#line 89 "../lib/sudoku-game.vala"
	_tmp3_ = sudoku_board_get_earmarks (_tmp1_, row, col, &_tmp2_);
#line 89 "../lib/sudoku-game.vala"
	old_earmarks = _tmp3_;
#line 89 "../lib/sudoku-game.vala"
	old_earmarks_length1 = _tmp2_;
#line 89 "../lib/sudoku-game.vala"
	_old_earmarks_size_ = old_earmarks_length1;
#line 90 "../lib/sudoku-game.vala"
	sudoku_game_update_undo (self, row, col, old_val, old_earmarks, (gint) old_earmarks_length1);
#line 92 "../lib/sudoku-game.vala"
	_tmp4_ = self->board;
#line 92 "../lib/sudoku-game.vala"
	sudoku_board_disable_earmark (_tmp4_, row, col, k_no);
#line 86 "../lib/sudoku-game.vala"
	old_earmarks = (g_free (old_earmarks), NULL);
#line 310 "sudoku-game.c"
}

void
sudoku_game_disable_all_earmarks (SudokuGame* self,
                                  gint row,
                                  gint col)
{
	gint old_val = 0;
	SudokuBoard* _tmp0_;
	gboolean* old_earmarks = NULL;
	SudokuBoard* _tmp1_;
	gint _tmp2_ = 0;
	gboolean* _tmp3_;
	gint old_earmarks_length1;
	gint _old_earmarks_size_;
	SudokuBoard* _tmp4_;
#line 95 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 97 "../lib/sudoku-game.vala"
	_tmp0_ = self->board;
#line 97 "../lib/sudoku-game.vala"
	old_val = sudoku_board_get (_tmp0_, row, col);
#line 98 "../lib/sudoku-game.vala"
	_tmp1_ = self->board;
#line 98 "../lib/sudoku-game.vala"
	_tmp3_ = sudoku_board_get_earmarks (_tmp1_, row, col, &_tmp2_);
#line 98 "../lib/sudoku-game.vala"
	old_earmarks = _tmp3_;
#line 98 "../lib/sudoku-game.vala"
	old_earmarks_length1 = _tmp2_;
#line 98 "../lib/sudoku-game.vala"
	_old_earmarks_size_ = old_earmarks_length1;
#line 99 "../lib/sudoku-game.vala"
	sudoku_game_update_undo (self, row, col, old_val, old_earmarks, (gint) old_earmarks_length1);
#line 101 "../lib/sudoku-game.vala"
	_tmp4_ = self->board;
#line 101 "../lib/sudoku-game.vala"
	sudoku_board_disable_all_earmarks (_tmp4_, row, col);
#line 95 "../lib/sudoku-game.vala"
	old_earmarks = (g_free (old_earmarks), NULL);
#line 351 "sudoku-game.c"
}

void
sudoku_game_insert (SudokuGame* self,
                    gint row,
                    gint col,
                    gint val)
{
	gint old_val = 0;
	SudokuBoard* _tmp0_;
	gboolean* old_earmarks = NULL;
	SudokuBoard* _tmp1_;
	gint _tmp2_ = 0;
	gboolean* _tmp3_;
	gint old_earmarks_length1;
	gint _old_earmarks_size_;
	gboolean* _tmp4_;
	gint _tmp4__length1;
#line 104 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 106 "../lib/sudoku-game.vala"
	_tmp0_ = self->board;
#line 106 "../lib/sudoku-game.vala"
	old_val = sudoku_board_get (_tmp0_, row, col);
#line 107 "../lib/sudoku-game.vala"
	_tmp1_ = self->board;
#line 107 "../lib/sudoku-game.vala"
	_tmp3_ = sudoku_board_get_earmarks (_tmp1_, row, col, &_tmp2_);
#line 107 "../lib/sudoku-game.vala"
	old_earmarks = _tmp3_;
#line 107 "../lib/sudoku-game.vala"
	old_earmarks_length1 = _tmp2_;
#line 107 "../lib/sudoku-game.vala"
	_old_earmarks_size_ = old_earmarks_length1;
#line 108 "../lib/sudoku-game.vala"
	_tmp4_ = old_earmarks;
#line 108 "../lib/sudoku-game.vala"
	_tmp4__length1 = old_earmarks_length1;
#line 108 "../lib/sudoku-game.vala"
	sudoku_game_update_undo (self, row, col, old_val, _tmp4_, (gint) _tmp4__length1);
#line 110 "../lib/sudoku-game.vala"
	if (self->mode == GAME_MODE_CREATE) {
#line 394 "sudoku-game.c"
		SudokuBoard* _tmp5_;
		SudokuBoard* _tmp6_;
		gboolean* _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
#line 112 "../lib/sudoku-game.vala"
		_tmp5_ = self->board;
#line 112 "../lib/sudoku-game.vala"
		sudoku_board_insert (_tmp5_, row, col, val, TRUE);
#line 113 "../lib/sudoku-game.vala"
		_tmp6_ = self->board;
#line 113 "../lib/sudoku-game.vala"
		_tmp7_ = _tmp6_->is_fixed;
#line 113 "../lib/sudoku-game.vala"
		_tmp7__length1 = _tmp6_->is_fixed_length1;
#line 113 "../lib/sudoku-game.vala"
		_tmp7__length2 = _tmp6_->is_fixed_length2;
#line 113 "../lib/sudoku-game.vala"
		_tmp7_[(row * _tmp7__length2) + col] = TRUE;
#line 414 "sudoku-game.c"
	} else {
		SudokuBoard* _tmp8_;
#line 116 "../lib/sudoku-game.vala"
		_tmp8_ = self->board;
#line 116 "../lib/sudoku-game.vala"
		sudoku_board_insert (_tmp8_, row, col, val, FALSE);
#line 421 "sudoku-game.c"
	}
#line 118 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_CELL_CHANGED_SIGNAL], 0, row, col, old_val, val);
#line 104 "../lib/sudoku-game.vala"
	old_earmarks = (g_free (old_earmarks), NULL);
#line 427 "sudoku-game.c"
}

void
sudoku_game_remove (SudokuGame* self,
                    gint row,
                    gint col)
{
	gint old_val = 0;
	SudokuBoard* _tmp0_;
	gboolean* old_earmarks = NULL;
	SudokuBoard* _tmp1_;
	gint _tmp2_ = 0;
	gboolean* _tmp3_;
	gint old_earmarks_length1;
	gint _old_earmarks_size_;
	gboolean* _tmp4_;
	gint _tmp4__length1;
#line 121 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 123 "../lib/sudoku-game.vala"
	_tmp0_ = self->board;
#line 123 "../lib/sudoku-game.vala"
	old_val = sudoku_board_get (_tmp0_, row, col);
#line 124 "../lib/sudoku-game.vala"
	_tmp1_ = self->board;
#line 124 "../lib/sudoku-game.vala"
	_tmp3_ = sudoku_board_get_earmarks (_tmp1_, row, col, &_tmp2_);
#line 124 "../lib/sudoku-game.vala"
	old_earmarks = _tmp3_;
#line 124 "../lib/sudoku-game.vala"
	old_earmarks_length1 = _tmp2_;
#line 124 "../lib/sudoku-game.vala"
	_old_earmarks_size_ = old_earmarks_length1;
#line 125 "../lib/sudoku-game.vala"
	_tmp4_ = old_earmarks;
#line 125 "../lib/sudoku-game.vala"
	_tmp4__length1 = old_earmarks_length1;
#line 125 "../lib/sudoku-game.vala"
	sudoku_game_update_undo (self, row, col, old_val, _tmp4_, (gint) _tmp4__length1);
#line 127 "../lib/sudoku-game.vala"
	if (self->mode == GAME_MODE_CREATE) {
#line 469 "sudoku-game.c"
		SudokuBoard* _tmp5_;
		SudokuBoard* _tmp6_;
		gboolean* _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
#line 129 "../lib/sudoku-game.vala"
		_tmp5_ = self->board;
#line 129 "../lib/sudoku-game.vala"
		sudoku_board_remove (_tmp5_, row, col, TRUE);
#line 130 "../lib/sudoku-game.vala"
		_tmp6_ = self->board;
#line 130 "../lib/sudoku-game.vala"
		_tmp7_ = _tmp6_->is_fixed;
#line 130 "../lib/sudoku-game.vala"
		_tmp7__length1 = _tmp6_->is_fixed_length1;
#line 130 "../lib/sudoku-game.vala"
		_tmp7__length2 = _tmp6_->is_fixed_length2;
#line 130 "../lib/sudoku-game.vala"
		_tmp7_[(row * _tmp7__length2) + col] = FALSE;
#line 489 "sudoku-game.c"
	} else {
		SudokuBoard* _tmp8_;
#line 133 "../lib/sudoku-game.vala"
		_tmp8_ = self->board;
#line 133 "../lib/sudoku-game.vala"
		sudoku_board_remove (_tmp8_, row, col, FALSE);
#line 496 "sudoku-game.c"
	}
#line 135 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_CELL_CHANGED_SIGNAL], 0, row, col, old_val, 0);
#line 121 "../lib/sudoku-game.vala"
	old_earmarks = (g_free (old_earmarks), NULL);
#line 502 "sudoku-game.c"
}

gboolean
sudoku_game_is_empty (SudokuGame* self)
{
	gboolean result;
#line 138 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 140 "../lib/sudoku-game.vala"
	if (self->mode == GAME_MODE_CREATE) {
#line 513 "sudoku-game.c"
		SudokuBoard* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
#line 141 "../lib/sudoku-game.vala"
		_tmp0_ = self->board;
#line 141 "../lib/sudoku-game.vala"
		_tmp1_ = sudoku_board_get_filled (_tmp0_);
#line 141 "../lib/sudoku-game.vala"
		_tmp2_ = _tmp1_;
#line 141 "../lib/sudoku-game.vala"
		result = _tmp2_ == 0;
#line 141 "../lib/sudoku-game.vala"
		return result;
#line 527 "sudoku-game.c"
	} else {
		SudokuBoard* _tmp3_;
#line 143 "../lib/sudoku-game.vala"
		_tmp3_ = self->board;
#line 143 "../lib/sudoku-game.vala"
		result = sudoku_board_is_empty (_tmp3_);
#line 143 "../lib/sudoku-game.vala"
		return result;
#line 536 "sudoku-game.c"
	}
}

void
sudoku_game_undo (SudokuGame* self)
{
	GeeList* _tmp0_;
	GeeList* _tmp1_;
#line 146 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 148 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->undostack;
#line 148 "../lib/sudoku-game.vala"
	_tmp1_ = self->priv->redostack;
#line 148 "../lib/sudoku-game.vala"
	sudoku_game_apply_stack (self, _tmp0_, _tmp1_);
#line 553 "sudoku-game.c"
}

void
sudoku_game_redo (SudokuGame* self)
{
	GeeList* _tmp0_;
	GeeList* _tmp1_;
#line 151 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 153 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->redostack;
#line 153 "../lib/sudoku-game.vala"
	_tmp1_ = self->priv->undostack;
#line 153 "../lib/sudoku-game.vala"
	sudoku_game_apply_stack (self, _tmp0_, _tmp1_);
#line 569 "sudoku-game.c"
}

void
sudoku_game_reset (SudokuGame* self)
{
	SudokuBoard* _tmp0_;
	GTimer* _tmp1_;
	GeeList* _tmp2_;
	GeeList* _tmp3_;
	SudokuBoard* _tmp25_;
	GeeSet* _tmp26_;
#line 156 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 158 "../lib/sudoku-game.vala"
	_tmp0_ = self->board;
#line 158 "../lib/sudoku-game.vala"
	sudoku_board_set_previous_played_time (_tmp0_, (gdouble) 0);
#line 159 "../lib/sudoku-game.vala"
	_tmp1_ = self->timer;
#line 159 "../lib/sudoku-game.vala"
	g_timer_start (_tmp1_);
#line 160 "../lib/sudoku-game.vala"
	_tmp2_ = self->priv->undostack;
#line 160 "../lib/sudoku-game.vala"
	gee_collection_clear ((GeeCollection*) _tmp2_);
#line 161 "../lib/sudoku-game.vala"
	_tmp3_ = self->priv->redostack;
#line 161 "../lib/sudoku-game.vala"
	gee_collection_clear ((GeeCollection*) _tmp3_);
#line 599 "sudoku-game.c"
	{
		gint l1 = 0;
#line 162 "../lib/sudoku-game.vala"
		l1 = 0;
#line 604 "sudoku-game.c"
		{
			gboolean _tmp4_ = FALSE;
#line 162 "../lib/sudoku-game.vala"
			_tmp4_ = TRUE;
#line 162 "../lib/sudoku-game.vala"
			while (TRUE) {
#line 611 "sudoku-game.c"
				SudokuBoard* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 162 "../lib/sudoku-game.vala"
				if (!_tmp4_) {
#line 617 "sudoku-game.c"
					gint _tmp5_;
#line 162 "../lib/sudoku-game.vala"
					_tmp5_ = l1;
#line 162 "../lib/sudoku-game.vala"
					l1 = _tmp5_ + 1;
#line 623 "sudoku-game.c"
				}
#line 162 "../lib/sudoku-game.vala"
				_tmp4_ = FALSE;
#line 162 "../lib/sudoku-game.vala"
				_tmp6_ = self->board;
#line 162 "../lib/sudoku-game.vala"
				_tmp7_ = sudoku_board_get_rows (_tmp6_);
#line 162 "../lib/sudoku-game.vala"
				_tmp8_ = _tmp7_;
#line 162 "../lib/sudoku-game.vala"
				if (!(l1 < _tmp8_)) {
#line 162 "../lib/sudoku-game.vala"
					break;
#line 637 "sudoku-game.c"
				}
				{
					gint l2 = 0;
#line 164 "../lib/sudoku-game.vala"
					l2 = 0;
#line 643 "sudoku-game.c"
					{
						gboolean _tmp9_ = FALSE;
#line 164 "../lib/sudoku-game.vala"
						_tmp9_ = TRUE;
#line 164 "../lib/sudoku-game.vala"
						while (TRUE) {
#line 650 "sudoku-game.c"
							SudokuBoard* _tmp11_;
							gint _tmp12_;
							gint _tmp13_;
							gboolean _tmp14_ = FALSE;
							SudokuBoard* _tmp18_;
							SudokuBoard* _tmp19_;
							gboolean* _tmp20_;
							gint _tmp20__length1;
							gint _tmp20__length2;
							gboolean _tmp21_;
							SudokuBoard* _tmp22_;
							gboolean* _tmp23_;
							gint _tmp23__length1;
							gint _tmp23__length2;
							SudokuBoard* _tmp24_;
#line 164 "../lib/sudoku-game.vala"
							if (!_tmp9_) {
#line 668 "sudoku-game.c"
								gint _tmp10_;
#line 164 "../lib/sudoku-game.vala"
								_tmp10_ = l2;
#line 164 "../lib/sudoku-game.vala"
								l2 = _tmp10_ + 1;
#line 674 "sudoku-game.c"
							}
#line 164 "../lib/sudoku-game.vala"
							_tmp9_ = FALSE;
#line 164 "../lib/sudoku-game.vala"
							_tmp11_ = self->board;
#line 164 "../lib/sudoku-game.vala"
							_tmp12_ = sudoku_board_get_cols (_tmp11_);
#line 164 "../lib/sudoku-game.vala"
							_tmp13_ = _tmp12_;
#line 164 "../lib/sudoku-game.vala"
							if (!(l2 < _tmp13_)) {
#line 164 "../lib/sudoku-game.vala"
								break;
#line 688 "sudoku-game.c"
							}
#line 166 "../lib/sudoku-game.vala"
							if (self->mode == GAME_MODE_PLAY) {
#line 692 "sudoku-game.c"
								SudokuBoard* _tmp15_;
								gboolean* _tmp16_;
								gint _tmp16__length1;
								gint _tmp16__length2;
								gboolean _tmp17_;
#line 166 "../lib/sudoku-game.vala"
								_tmp15_ = self->board;
#line 166 "../lib/sudoku-game.vala"
								_tmp16_ = _tmp15_->is_fixed;
#line 166 "../lib/sudoku-game.vala"
								_tmp16__length1 = _tmp15_->is_fixed_length1;
#line 166 "../lib/sudoku-game.vala"
								_tmp16__length2 = _tmp15_->is_fixed_length2;
#line 166 "../lib/sudoku-game.vala"
								_tmp17_ = _tmp16_[(l1 * _tmp16__length2) + l2];
#line 166 "../lib/sudoku-game.vala"
								_tmp14_ = _tmp17_;
#line 710 "sudoku-game.c"
							} else {
#line 166 "../lib/sudoku-game.vala"
								_tmp14_ = FALSE;
#line 714 "sudoku-game.c"
							}
#line 166 "../lib/sudoku-game.vala"
							if (_tmp14_) {
#line 167 "../lib/sudoku-game.vala"
								continue;
#line 720 "sudoku-game.c"
							}
#line 169 "../lib/sudoku-game.vala"
							_tmp18_ = self->board;
#line 169 "../lib/sudoku-game.vala"
							_tmp19_ = self->board;
#line 169 "../lib/sudoku-game.vala"
							_tmp20_ = _tmp19_->is_fixed;
#line 169 "../lib/sudoku-game.vala"
							_tmp20__length1 = _tmp19_->is_fixed_length1;
#line 169 "../lib/sudoku-game.vala"
							_tmp20__length2 = _tmp19_->is_fixed_length2;
#line 169 "../lib/sudoku-game.vala"
							_tmp21_ = _tmp20_[(l1 * _tmp20__length2) + l2];
#line 169 "../lib/sudoku-game.vala"
							sudoku_board_remove (_tmp18_, l1, l2, _tmp21_);
#line 170 "../lib/sudoku-game.vala"
							_tmp22_ = self->board;
#line 170 "../lib/sudoku-game.vala"
							_tmp23_ = _tmp22_->is_fixed;
#line 170 "../lib/sudoku-game.vala"
							_tmp23__length1 = _tmp22_->is_fixed_length1;
#line 170 "../lib/sudoku-game.vala"
							_tmp23__length2 = _tmp22_->is_fixed_length2;
#line 170 "../lib/sudoku-game.vala"
							_tmp23_[(l1 * _tmp23__length2) + l2] = FALSE;
#line 171 "../lib/sudoku-game.vala"
							_tmp24_ = self->board;
#line 171 "../lib/sudoku-game.vala"
							g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_CELL_CHANGED_SIGNAL], 0, l1, l2, sudoku_board_get (_tmp24_, l1, l2), 0);
#line 750 "sudoku-game.c"
						}
					}
				}
			}
		}
	}
#line 174 "../lib/sudoku-game.vala"
	_tmp25_ = self->board;
#line 174 "../lib/sudoku-game.vala"
	_tmp26_ = _tmp25_->broken_coords;
#line 174 "../lib/sudoku-game.vala"
	gee_collection_clear ((GeeCollection*) _tmp26_);
#line 763 "sudoku-game.c"
}

void
sudoku_game_cell_changed_cb (SudokuGame* self,
                             gint row,
                             gint col,
                             gint old_val,
                             gint new_val)
{
#line 177 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 179 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_CELL_CHANGED_SIGNAL], 0, row, col, old_val, new_val);
#line 777 "sudoku-game.c"
}

void
sudoku_game_update_undo (SudokuGame* self,
                         gint row,
                         gint col,
                         gint old_val,
                         gboolean* old_earmarks,
                         gint old_earmarks_length1)
{
	GeeList* _tmp0_;
	GeeList* _tmp1_;
#line 182 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 184 "../lib/sudoku-game.vala"
	_tmp0_ = self->priv->undostack;
#line 184 "../lib/sudoku-game.vala"
	sudoku_game_add_to_stack (self, _tmp0_, row, col, old_val, old_earmarks, (gint) old_earmarks_length1);
#line 185 "../lib/sudoku-game.vala"
	_tmp1_ = self->priv->redostack;
#line 185 "../lib/sudoku-game.vala"
	gee_collection_clear ((GeeCollection*) _tmp1_);
#line 800 "sudoku-game.c"
}

static gboolean*
_vala_array_dup10 (gboolean* self,
                   gssize length)
{
#line 190 "../lib/sudoku-game.vala"
	if (length > 0) {
#line 190 "../lib/sudoku-game.vala"
		return _vala_memdup2 (self, length * sizeof (gboolean));
#line 811 "sudoku-game.c"
	}
#line 190 "../lib/sudoku-game.vala"
	return NULL;
#line 815 "sudoku-game.c"
}

static void
sudoku_game_add_to_stack (SudokuGame* self,
                          GeeList* stack,
                          gint r,
                          gint c,
                          gint v,
                          gboolean* e,
                          gint e_length1)
{
	SudokuGameUndoItem step = {0};
	gboolean* _tmp0_;
	gint _tmp0__length1;
	SudokuGameUndoItem _tmp1_ = {0};
	SudokuGameUndoItem _tmp2_;
#line 188 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 188 "../lib/sudoku-game.vala"
	g_return_if_fail (stack != NULL);
#line 190 "../lib/sudoku-game.vala"
	_tmp0_ = (e != NULL) ? _vala_array_dup10 (e, e_length1) : e;
#line 190 "../lib/sudoku-game.vala"
	_tmp0__length1 = e_length1;
#line 190 "../lib/sudoku-game.vala"
	_tmp1_.row = r;
#line 190 "../lib/sudoku-game.vala"
	_tmp1_.col = c;
#line 190 "../lib/sudoku-game.vala"
	_tmp1_.val = v;
#line 190 "../lib/sudoku-game.vala"
	_tmp1_.earmarks = (g_free (_tmp1_.earmarks), NULL);
#line 190 "../lib/sudoku-game.vala"
	_tmp1_.earmarks = _tmp0_;
#line 190 "../lib/sudoku-game.vala"
	_tmp1_.earmarks_length1 = _tmp0__length1;
#line 190 "../lib/sudoku-game.vala"
	_tmp1_._earmarks_size_ = _tmp1_.earmarks_length1;
#line 190 "../lib/sudoku-game.vala"
	step = _tmp1_;
#line 191 "../lib/sudoku-game.vala"
	_tmp2_ = step;
#line 191 "../lib/sudoku-game.vala"
	gee_collection_add ((GeeCollection*) stack, &_tmp2_);
#line 188 "../lib/sudoku-game.vala"
	sudoku_game_undo_item_destroy (&step);
#line 862 "sudoku-game.c"
}

static void
sudoku_game_apply_stack (SudokuGame* self,
                         GeeList* from,
                         GeeList* to)
{
	gint _tmp0_;
	gint _tmp1_;
	SudokuGameUndoItem* top = NULL;
	gint _tmp2_;
	gint _tmp3_;
	gpointer _tmp4_;
	gint old_val = 0;
	SudokuBoard* _tmp5_;
	SudokuGameUndoItem* _tmp6_;
	SudokuGameUndoItem* _tmp7_;
	gboolean* old_earmarks = NULL;
	SudokuBoard* _tmp8_;
	SudokuGameUndoItem* _tmp9_;
	SudokuGameUndoItem* _tmp10_;
	gint _tmp11_ = 0;
	gboolean* _tmp12_;
	gint old_earmarks_length1;
	gint _old_earmarks_size_;
	SudokuGameUndoItem* _tmp13_;
	SudokuGameUndoItem* _tmp14_;
	gboolean* _tmp15_;
	gint _tmp15__length1;
	SudokuGameUndoItem* _tmp31_;
	SudokuGameUndoItem* _tmp62_;
	SudokuGameUndoItem* _tmp63_;
	SudokuGameUndoItem* _tmp64_;
#line 194 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 194 "../lib/sudoku-game.vala"
	g_return_if_fail (from != NULL);
#line 194 "../lib/sudoku-game.vala"
	g_return_if_fail (to != NULL);
#line 196 "../lib/sudoku-game.vala"
	_tmp0_ = gee_collection_get_size ((GeeCollection*) from);
#line 196 "../lib/sudoku-game.vala"
	_tmp1_ = _tmp0_;
#line 196 "../lib/sudoku-game.vala"
	if (_tmp1_ == 0) {
#line 197 "../lib/sudoku-game.vala"
		return;
#line 910 "sudoku-game.c"
	}
#line 199 "../lib/sudoku-game.vala"
	_tmp2_ = gee_collection_get_size ((GeeCollection*) from);
#line 199 "../lib/sudoku-game.vala"
	_tmp3_ = _tmp2_;
#line 199 "../lib/sudoku-game.vala"
	_tmp4_ = gee_list_remove_at (from, _tmp3_ - 1);
#line 199 "../lib/sudoku-game.vala"
	top = (SudokuGameUndoItem*) _tmp4_;
#line 200 "../lib/sudoku-game.vala"
	_tmp5_ = self->board;
#line 200 "../lib/sudoku-game.vala"
	_tmp6_ = top;
#line 200 "../lib/sudoku-game.vala"
	_tmp7_ = top;
#line 200 "../lib/sudoku-game.vala"
	old_val = sudoku_board_get (_tmp5_, (*_tmp6_).row, (*_tmp7_).col);
#line 201 "../lib/sudoku-game.vala"
	_tmp8_ = self->board;
#line 201 "../lib/sudoku-game.vala"
	_tmp9_ = top;
#line 201 "../lib/sudoku-game.vala"
	_tmp10_ = top;
#line 201 "../lib/sudoku-game.vala"
	_tmp12_ = sudoku_board_get_earmarks (_tmp8_, (*_tmp9_).row, (*_tmp10_).col, &_tmp11_);
#line 201 "../lib/sudoku-game.vala"
	old_earmarks = _tmp12_;
#line 201 "../lib/sudoku-game.vala"
	old_earmarks_length1 = _tmp11_;
#line 201 "../lib/sudoku-game.vala"
	_old_earmarks_size_ = old_earmarks_length1;
#line 202 "../lib/sudoku-game.vala"
	_tmp13_ = top;
#line 202 "../lib/sudoku-game.vala"
	_tmp14_ = top;
#line 202 "../lib/sudoku-game.vala"
	_tmp15_ = old_earmarks;
#line 202 "../lib/sudoku-game.vala"
	_tmp15__length1 = old_earmarks_length1;
#line 202 "../lib/sudoku-game.vala"
	sudoku_game_add_to_stack (self, to, (*_tmp13_).row, (*_tmp14_).col, old_val, _tmp15_, (gint) _tmp15__length1);
#line 204 "../lib/sudoku-game.vala"
	if (self->mode == GAME_MODE_CREATE) {
#line 954 "sudoku-game.c"
		SudokuBoard* _tmp16_;
		SudokuGameUndoItem* _tmp17_;
		SudokuGameUndoItem* _tmp18_;
		SudokuBoard* _tmp19_;
		gboolean* _tmp20_;
		gint _tmp20__length1;
		gint _tmp20__length2;
		SudokuGameUndoItem* _tmp21_;
		SudokuGameUndoItem* _tmp22_;
		gboolean _tmp23_;
		SudokuBoard* _tmp24_;
		gboolean* _tmp25_;
		gint _tmp25__length1;
		gint _tmp25__length2;
		SudokuGameUndoItem* _tmp26_;
		SudokuGameUndoItem* _tmp27_;
#line 206 "../lib/sudoku-game.vala"
		_tmp16_ = self->board;
#line 206 "../lib/sudoku-game.vala"
		_tmp17_ = top;
#line 206 "../lib/sudoku-game.vala"
		_tmp18_ = top;
#line 206 "../lib/sudoku-game.vala"
		_tmp19_ = self->board;
#line 206 "../lib/sudoku-game.vala"
		_tmp20_ = _tmp19_->is_fixed;
#line 206 "../lib/sudoku-game.vala"
		_tmp20__length1 = _tmp19_->is_fixed_length1;
#line 206 "../lib/sudoku-game.vala"
		_tmp20__length2 = _tmp19_->is_fixed_length2;
#line 206 "../lib/sudoku-game.vala"
		_tmp21_ = top;
#line 206 "../lib/sudoku-game.vala"
		_tmp22_ = top;
#line 206 "../lib/sudoku-game.vala"
		_tmp23_ = _tmp20_[((*_tmp21_).row * _tmp20__length2) + (*_tmp22_).col];
#line 206 "../lib/sudoku-game.vala"
		sudoku_board_remove (_tmp16_, (*_tmp17_).row, (*_tmp18_).col, _tmp23_);
#line 207 "../lib/sudoku-game.vala"
		_tmp24_ = self->board;
#line 207 "../lib/sudoku-game.vala"
		_tmp25_ = _tmp24_->is_fixed;
#line 207 "../lib/sudoku-game.vala"
		_tmp25__length1 = _tmp24_->is_fixed_length1;
#line 207 "../lib/sudoku-game.vala"
		_tmp25__length2 = _tmp24_->is_fixed_length2;
#line 207 "../lib/sudoku-game.vala"
		_tmp26_ = top;
#line 207 "../lib/sudoku-game.vala"
		_tmp27_ = top;
#line 207 "../lib/sudoku-game.vala"
		_tmp25_[((*_tmp26_).row * _tmp25__length2) + (*_tmp27_).col] = FALSE;
#line 1007 "sudoku-game.c"
	} else {
		SudokuBoard* _tmp28_;
		SudokuGameUndoItem* _tmp29_;
		SudokuGameUndoItem* _tmp30_;
#line 210 "../lib/sudoku-game.vala"
		_tmp28_ = self->board;
#line 210 "../lib/sudoku-game.vala"
		_tmp29_ = top;
#line 210 "../lib/sudoku-game.vala"
		_tmp30_ = top;
#line 210 "../lib/sudoku-game.vala"
		sudoku_board_remove (_tmp28_, (*_tmp29_).row, (*_tmp30_).col, FALSE);
#line 1020 "sudoku-game.c"
	}
#line 212 "../lib/sudoku-game.vala"
	_tmp31_ = top;
#line 212 "../lib/sudoku-game.vala"
	if ((*_tmp31_).val != 0) {
#line 214 "../lib/sudoku-game.vala"
		if (self->mode == GAME_MODE_CREATE) {
#line 1028 "sudoku-game.c"
			SudokuBoard* _tmp32_;
			SudokuGameUndoItem* _tmp33_;
			SudokuGameUndoItem* _tmp34_;
			SudokuGameUndoItem* _tmp35_;
			SudokuBoard* _tmp36_;
			gboolean* _tmp37_;
			gint _tmp37__length1;
			gint _tmp37__length2;
			SudokuGameUndoItem* _tmp38_;
			SudokuGameUndoItem* _tmp39_;
			gboolean _tmp40_;
			SudokuBoard* _tmp41_;
			gboolean* _tmp42_;
			gint _tmp42__length1;
			gint _tmp42__length2;
			SudokuGameUndoItem* _tmp43_;
			SudokuGameUndoItem* _tmp44_;
#line 216 "../lib/sudoku-game.vala"
			_tmp32_ = self->board;
#line 216 "../lib/sudoku-game.vala"
			_tmp33_ = top;
#line 216 "../lib/sudoku-game.vala"
			_tmp34_ = top;
#line 216 "../lib/sudoku-game.vala"
			_tmp35_ = top;
#line 216 "../lib/sudoku-game.vala"
			_tmp36_ = self->board;
#line 216 "../lib/sudoku-game.vala"
			_tmp37_ = _tmp36_->is_fixed;
#line 216 "../lib/sudoku-game.vala"
			_tmp37__length1 = _tmp36_->is_fixed_length1;
#line 216 "../lib/sudoku-game.vala"
			_tmp37__length2 = _tmp36_->is_fixed_length2;
#line 216 "../lib/sudoku-game.vala"
			_tmp38_ = top;
#line 216 "../lib/sudoku-game.vala"
			_tmp39_ = top;
#line 216 "../lib/sudoku-game.vala"
			_tmp40_ = _tmp37_[((*_tmp38_).row * _tmp37__length2) + (*_tmp39_).col];
#line 216 "../lib/sudoku-game.vala"
			sudoku_board_insert (_tmp32_, (*_tmp33_).row, (*_tmp34_).col, (*_tmp35_).val, _tmp40_);
#line 217 "../lib/sudoku-game.vala"
			_tmp41_ = self->board;
#line 217 "../lib/sudoku-game.vala"
			_tmp42_ = _tmp41_->is_fixed;
#line 217 "../lib/sudoku-game.vala"
			_tmp42__length1 = _tmp41_->is_fixed_length1;
#line 217 "../lib/sudoku-game.vala"
			_tmp42__length2 = _tmp41_->is_fixed_length2;
#line 217 "../lib/sudoku-game.vala"
			_tmp43_ = top;
#line 217 "../lib/sudoku-game.vala"
			_tmp44_ = top;
#line 217 "../lib/sudoku-game.vala"
			_tmp42_[((*_tmp43_).row * _tmp42__length2) + (*_tmp44_).col] = TRUE;
#line 1084 "sudoku-game.c"
		} else {
			SudokuBoard* _tmp45_;
			SudokuGameUndoItem* _tmp46_;
			SudokuGameUndoItem* _tmp47_;
			SudokuGameUndoItem* _tmp48_;
#line 220 "../lib/sudoku-game.vala"
			_tmp45_ = self->board;
#line 220 "../lib/sudoku-game.vala"
			_tmp46_ = top;
#line 220 "../lib/sudoku-game.vala"
			_tmp47_ = top;
#line 220 "../lib/sudoku-game.vala"
			_tmp48_ = top;
#line 220 "../lib/sudoku-game.vala"
			sudoku_board_insert (_tmp45_, (*_tmp46_).row, (*_tmp47_).col, (*_tmp48_).val, FALSE);
#line 1100 "sudoku-game.c"
		}
	}
	{
		gint i = 0;
#line 223 "../lib/sudoku-game.vala"
		i = 1;
#line 1107 "sudoku-game.c"
		{
			gboolean _tmp49_ = FALSE;
#line 223 "../lib/sudoku-game.vala"
			_tmp49_ = TRUE;
#line 223 "../lib/sudoku-game.vala"
			while (TRUE) {
#line 1114 "sudoku-game.c"
				SudokuGameUndoItem* _tmp51_;
				gboolean* _tmp52_;
				gint _tmp52__length1;
				SudokuGameUndoItem* _tmp53_;
				gboolean* _tmp54_;
				gint _tmp54__length1;
				gboolean _tmp55_;
#line 223 "../lib/sudoku-game.vala"
				if (!_tmp49_) {
#line 1124 "sudoku-game.c"
					gint _tmp50_;
#line 223 "../lib/sudoku-game.vala"
					_tmp50_ = i;
#line 223 "../lib/sudoku-game.vala"
					i = _tmp50_ + 1;
#line 1130 "sudoku-game.c"
				}
#line 223 "../lib/sudoku-game.vala"
				_tmp49_ = FALSE;
#line 223 "../lib/sudoku-game.vala"
				_tmp51_ = top;
#line 223 "../lib/sudoku-game.vala"
				_tmp52_ = (*_tmp51_).earmarks;
#line 223 "../lib/sudoku-game.vala"
				_tmp52__length1 = (*_tmp51_).earmarks_length1;
#line 223 "../lib/sudoku-game.vala"
				if (!(i <= _tmp52__length1)) {
#line 223 "../lib/sudoku-game.vala"
					break;
#line 1144 "sudoku-game.c"
				}
#line 225 "../lib/sudoku-game.vala"
				_tmp53_ = top;
#line 225 "../lib/sudoku-game.vala"
				_tmp54_ = (*_tmp53_).earmarks;
#line 225 "../lib/sudoku-game.vala"
				_tmp54__length1 = (*_tmp53_).earmarks_length1;
#line 225 "../lib/sudoku-game.vala"
				_tmp55_ = _tmp54_[i - 1];
#line 225 "../lib/sudoku-game.vala"
				if (_tmp55_) {
#line 1156 "sudoku-game.c"
					SudokuBoard* _tmp56_;
					SudokuGameUndoItem* _tmp57_;
					SudokuGameUndoItem* _tmp58_;
#line 226 "../lib/sudoku-game.vala"
					_tmp56_ = self->board;
#line 226 "../lib/sudoku-game.vala"
					_tmp57_ = top;
#line 226 "../lib/sudoku-game.vala"
					_tmp58_ = top;
#line 226 "../lib/sudoku-game.vala"
					sudoku_board_enable_earmark (_tmp56_, (*_tmp57_).row, (*_tmp58_).col, i);
#line 1168 "sudoku-game.c"
				} else {
					SudokuBoard* _tmp59_;
					SudokuGameUndoItem* _tmp60_;
					SudokuGameUndoItem* _tmp61_;
#line 228 "../lib/sudoku-game.vala"
					_tmp59_ = self->board;
#line 228 "../lib/sudoku-game.vala"
					_tmp60_ = top;
#line 228 "../lib/sudoku-game.vala"
					_tmp61_ = top;
#line 228 "../lib/sudoku-game.vala"
					sudoku_board_disable_earmark (_tmp59_, (*_tmp60_).row, (*_tmp61_).col, i);
#line 1181 "sudoku-game.c"
				}
			}
		}
	}
#line 231 "../lib/sudoku-game.vala"
	_tmp62_ = top;
#line 231 "../lib/sudoku-game.vala"
	_tmp63_ = top;
#line 231 "../lib/sudoku-game.vala"
	_tmp64_ = top;
#line 231 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_CELL_CHANGED_SIGNAL], 0, (*_tmp62_).row, (*_tmp63_).col, old_val, (*_tmp64_).val);
#line 194 "../lib/sudoku-game.vala"
	old_earmarks = (g_free (old_earmarks), NULL);
#line 194 "../lib/sudoku-game.vala"
	_sudoku_game_undo_item_free0 (top);
#line 1198 "sudoku-game.c"
}

gdouble
sudoku_game_get_total_time_played (SudokuGame* self)
{
	SudokuBoard* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	GTimer* _tmp3_;
	gdouble result;
#line 234 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 236 "../lib/sudoku-game.vala"
	_tmp0_ = self->board;
#line 236 "../lib/sudoku-game.vala"
	_tmp1_ = sudoku_board_get_previous_played_time (_tmp0_);
#line 236 "../lib/sudoku-game.vala"
	_tmp2_ = _tmp1_;
#line 236 "../lib/sudoku-game.vala"
	_tmp3_ = self->timer;
#line 236 "../lib/sudoku-game.vala"
	result = _tmp2_ + g_timer_elapsed (_tmp3_, NULL);
#line 236 "../lib/sudoku-game.vala"
	return result;
#line 1223 "sudoku-game.c"
}

static gboolean
_sudoku_game_timeout_cb_gsource_func (gpointer self)
{
	gboolean result;
	result = sudoku_game_timeout_cb ((SudokuGame*) self);
#line 241 "../lib/sudoku-game.vala"
	return result;
#line 1233 "sudoku-game.c"
}

static gboolean
sudoku_game_timeout_cb (SudokuGame* self)
{
	gboolean result;
#line 239 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 241 "../lib/sudoku-game.vala"
	self->priv->clock_timeout = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 1, _sudoku_game_timeout_cb_gsource_func, g_object_ref (self), g_object_unref);
#line 242 "../lib/sudoku-game.vala"
	g_source_set_name_by_id (self->priv->clock_timeout, "[gnome-sudoku] timeout_cb");
#line 243 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_TICK_SIGNAL], 0);
#line 244 "../lib/sudoku-game.vala"
	result = FALSE;
#line 244 "../lib/sudoku-game.vala"
	return result;
#line 1252 "sudoku-game.c"
}

void
sudoku_game_start_clock (SudokuGame* self)
{
	GTimer* _tmp0_;
	GTimer* _tmp2_;
#line 247 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 249 "../lib/sudoku-game.vala"
	_tmp0_ = self->timer;
#line 249 "../lib/sudoku-game.vala"
	if (_tmp0_ == NULL) {
#line 1266 "sudoku-game.c"
		GTimer* _tmp1_;
#line 250 "../lib/sudoku-game.vala"
		_tmp1_ = g_timer_new ();
#line 250 "../lib/sudoku-game.vala"
		_g_timer_destroy0 (self->timer);
#line 250 "../lib/sudoku-game.vala"
		self->timer = _tmp1_;
#line 1274 "sudoku-game.c"
	}
#line 251 "../lib/sudoku-game.vala"
	_tmp2_ = self->timer;
#line 251 "../lib/sudoku-game.vala"
	g_timer_start (_tmp2_);
#line 252 "../lib/sudoku-game.vala"
	sudoku_game_timeout_cb (self);
#line 1282 "sudoku-game.c"
}

void
sudoku_game_stop_clock (SudokuGame* self)
{
	GTimer* _tmp0_;
	GTimer* _tmp1_;
#line 255 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 255 "../lib/sudoku-game.vala"
	_tmp0_ = self->timer;
#line 255 "../lib/sudoku-game.vala"
	_vala_return_if_fail (_tmp0_ != NULL, "timer != null");
#line 258 "../lib/sudoku-game.vala"
	if (self->priv->clock_timeout != ((guint) 0)) {
#line 259 "../lib/sudoku-game.vala"
		g_source_remove (self->priv->clock_timeout);
#line 1300 "sudoku-game.c"
	}
#line 260 "../lib/sudoku-game.vala"
	self->priv->clock_timeout = (guint) 0;
#line 261 "../lib/sudoku-game.vala"
	sudoku_game_set_paused (self, TRUE);
#line 262 "../lib/sudoku-game.vala"
	_tmp1_ = self->timer;
#line 262 "../lib/sudoku-game.vala"
	g_timer_stop (_tmp1_);
#line 263 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_TICK_SIGNAL], 0);
#line 1312 "sudoku-game.c"
}

void
sudoku_game_resume_clock (SudokuGame* self)
{
	GTimer* _tmp0_;
	GTimer* _tmp1_;
#line 266 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 266 "../lib/sudoku-game.vala"
	_tmp0_ = self->timer;
#line 266 "../lib/sudoku-game.vala"
	_vala_return_if_fail ((_tmp0_ != NULL) && (self->priv->clock_timeout == ((guint) 0)), "timer != null && clock_timeout == 0");
#line 269 "../lib/sudoku-game.vala"
	_tmp1_ = self->timer;
#line 269 "../lib/sudoku-game.vala"
	g_timer_continue (_tmp1_);
#line 270 "../lib/sudoku-game.vala"
	sudoku_game_set_paused (self, FALSE);
#line 271 "../lib/sudoku-game.vala"
	sudoku_game_timeout_cb (self);
#line 1334 "sudoku-game.c"
}

gboolean
sudoku_game_get_paused (SudokuGame* self)
{
	gboolean result;
#line 42 "../lib/sudoku-game.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 42 "../lib/sudoku-game.vala"
	result = self->priv->_paused;
#line 42 "../lib/sudoku-game.vala"
	return result;
#line 1347 "sudoku-game.c"
}

static void
sudoku_game_set_paused (SudokuGame* self,
                        gboolean value)
{
#line 37 "../lib/sudoku-game.vala"
	g_return_if_fail (self != NULL);
#line 39 "../lib/sudoku-game.vala"
	self->priv->_paused = value;
#line 40 "../lib/sudoku-game.vala"
	g_signal_emit (self, sudoku_game_signals[SUDOKU_GAME_PAUSED_CHANGED_SIGNAL], 0);
#line 37 "../lib/sudoku-game.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_game_properties[SUDOKU_GAME_PAUSED_PROPERTY]);
#line 1362 "sudoku-game.c"
}

static void
g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_INT_INT) (gpointer data1, gint arg_1, gint arg_2, gint arg_3, gint arg_4, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 24 "../lib/sudoku-game.vala"
	g_return_if_fail (n_param_values == 5);
#line 24 "../lib/sudoku-game.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 24 "../lib/sudoku-game.vala"
		data1 = closure->data;
#line 24 "../lib/sudoku-game.vala"
		data2 = param_values->data[0].v_pointer;
#line 1387 "sudoku-game.c"
	} else {
#line 24 "../lib/sudoku-game.vala"
		data1 = param_values->data[0].v_pointer;
#line 24 "../lib/sudoku-game.vala"
		data2 = closure->data;
#line 1393 "sudoku-game.c"
	}
#line 24 "../lib/sudoku-game.vala"
	callback = (GMarshalFunc_VOID__INT_INT_INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 24 "../lib/sudoku-game.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), g_value_get_int (param_values + 4), data2);
#line 1399 "sudoku-game.c"
}

static gboolean*
_vala_array_dup11 (gboolean* self,
                   gssize length)
{
#line 45 "../lib/sudoku-game.vala"
	if (length > 0) {
#line 45 "../lib/sudoku-game.vala"
		return _vala_memdup2 (self, length * sizeof (gboolean));
#line 1410 "sudoku-game.c"
	}
#line 45 "../lib/sudoku-game.vala"
	return NULL;
#line 1414 "sudoku-game.c"
}

static void
sudoku_game_undo_item_copy (const SudokuGameUndoItem* self,
                            SudokuGameUndoItem* dest)
{
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gboolean* _tmp1_;
	gint _tmp1__length1;
#line 45 "../lib/sudoku-game.vala"
	(*dest).row = (*self).row;
#line 45 "../lib/sudoku-game.vala"
	(*dest).col = (*self).col;
#line 45 "../lib/sudoku-game.vala"
	(*dest).val = (*self).val;
#line 45 "../lib/sudoku-game.vala"
	_tmp0_ = (*self).earmarks;
#line 45 "../lib/sudoku-game.vala"
	_tmp0__length1 = (*self).earmarks_length1;
#line 45 "../lib/sudoku-game.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup11 (_tmp0_, _tmp0__length1) : _tmp0_;
#line 45 "../lib/sudoku-game.vala"
	_tmp1__length1 = _tmp0__length1;
#line 45 "../lib/sudoku-game.vala"
	(*dest).earmarks = (g_free ((*dest).earmarks), NULL);
#line 45 "../lib/sudoku-game.vala"
	(*dest).earmarks = _tmp1_;
#line 45 "../lib/sudoku-game.vala"
	(*dest).earmarks_length1 = _tmp1__length1;
#line 45 "../lib/sudoku-game.vala"
	(*dest)._earmarks_size_ = (*dest).earmarks_length1;
#line 1447 "sudoku-game.c"
}

static void
sudoku_game_undo_item_destroy (SudokuGameUndoItem* self)
{
#line 50 "../lib/sudoku-game.vala"
	(*self).earmarks = (g_free ((*self).earmarks), NULL);
#line 1455 "sudoku-game.c"
}

static SudokuGameUndoItem*
sudoku_game_undo_item_dup (const SudokuGameUndoItem* self)
{
	SudokuGameUndoItem* dup;
#line 45 "../lib/sudoku-game.vala"
	dup = g_new0 (SudokuGameUndoItem, 1);
#line 45 "../lib/sudoku-game.vala"
	sudoku_game_undo_item_copy (self, dup);
#line 45 "../lib/sudoku-game.vala"
	return dup;
#line 1468 "sudoku-game.c"
}

static void
sudoku_game_undo_item_free (SudokuGameUndoItem* self)
{
#line 45 "../lib/sudoku-game.vala"
	sudoku_game_undo_item_destroy (self);
#line 45 "../lib/sudoku-game.vala"
	g_free (self);
#line 1478 "sudoku-game.c"
}

static GType
sudoku_game_undo_item_get_type_once (void)
{
	GType sudoku_game_undo_item_type_id;
	sudoku_game_undo_item_type_id = g_boxed_type_register_static ("SudokuGameUndoItem", (GBoxedCopyFunc) sudoku_game_undo_item_dup, (GBoxedFreeFunc) sudoku_game_undo_item_free);
	return sudoku_game_undo_item_type_id;
}

static GType
sudoku_game_undo_item_get_type (void)
{
	static volatile gsize sudoku_game_undo_item_type_id__once = 0;
	if (g_once_init_enter (&sudoku_game_undo_item_type_id__once)) {
		GType sudoku_game_undo_item_type_id;
		sudoku_game_undo_item_type_id = sudoku_game_undo_item_get_type_once ();
		g_once_init_leave (&sudoku_game_undo_item_type_id__once, sudoku_game_undo_item_type_id);
	}
	return sudoku_game_undo_item_type_id__once;
}

static void
sudoku_game_class_init (SudokuGameClass * klass,
                        gpointer klass_data)
{
#line 24 "../lib/sudoku-game.vala"
	sudoku_game_parent_class = g_type_class_peek_parent (klass);
#line 24 "../lib/sudoku-game.vala"
	g_type_class_adjust_private_offset (klass, &SudokuGame_private_offset);
#line 24 "../lib/sudoku-game.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_game_get_property;
#line 24 "../lib/sudoku-game.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_game_set_property;
#line 24 "../lib/sudoku-game.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_game_finalize;
#line 24 "../lib/sudoku-game.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_GAME_PAUSED_PROPERTY, sudoku_game_properties[SUDOKU_GAME_PAUSED_PROPERTY] = g_param_spec_boolean ("paused", "paused", "paused", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-game.vala"
	sudoku_game_signals[SUDOKU_GAME_TICK_SIGNAL] = g_signal_new ("tick", TYPE_SUDOKU_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 24 "../lib/sudoku-game.vala"
	sudoku_game_signals[SUDOKU_GAME_PAUSED_CHANGED_SIGNAL] = g_signal_new ("paused-changed", TYPE_SUDOKU_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 24 "../lib/sudoku-game.vala"
	sudoku_game_signals[SUDOKU_GAME_CELL_CHANGED_SIGNAL] = g_signal_new ("cell-changed", TYPE_SUDOKU_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_INT_INT, G_TYPE_NONE, 4, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT);
#line 1523 "sudoku-game.c"
}

static void
sudoku_game_instance_init (SudokuGame * self,
                           gpointer klass)
{
#line 24 "../lib/sudoku-game.vala"
	self->priv = sudoku_game_get_instance_private (self);
#line 34 "../lib/sudoku-game.vala"
	self->priv->_paused = FALSE;
#line 1534 "sudoku-game.c"
}

static void
sudoku_game_finalize (GObject * obj)
{
	SudokuGame * self;
#line 24 "../lib/sudoku-game.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_GAME, SudokuGame);
#line 26 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->board);
#line 28 "../lib/sudoku-game.vala"
	_g_timer_destroy0 (self->timer);
#line 55 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->priv->undostack);
#line 56 "../lib/sudoku-game.vala"
	_g_object_unref0 (self->priv->redostack);
#line 24 "../lib/sudoku-game.vala"
	G_OBJECT_CLASS (sudoku_game_parent_class)->finalize (obj);
#line 1553 "sudoku-game.c"
}

static GType
sudoku_game_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuGameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuGame), 0, (GInstanceInitFunc) sudoku_game_instance_init, NULL };
	GType sudoku_game_type_id;
	sudoku_game_type_id = g_type_register_static (G_TYPE_OBJECT, "SudokuGame", &g_define_type_info, 0);
	SudokuGame_private_offset = g_type_add_instance_private (sudoku_game_type_id, sizeof (SudokuGamePrivate));
	return sudoku_game_type_id;
}

GType
sudoku_game_get_type (void)
{
	static volatile gsize sudoku_game_type_id__once = 0;
	if (g_once_init_enter (&sudoku_game_type_id__once)) {
		GType sudoku_game_type_id;
		sudoku_game_type_id = sudoku_game_get_type_once ();
		g_once_init_leave (&sudoku_game_type_id__once, sudoku_game_type_id);
	}
	return sudoku_game_type_id__once;
}

static void
_vala_sudoku_game_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_GAME, SudokuGame);
#line 24 "../lib/sudoku-game.vala"
	switch (property_id) {
#line 24 "../lib/sudoku-game.vala"
		case SUDOKU_GAME_PAUSED_PROPERTY:
#line 24 "../lib/sudoku-game.vala"
		g_value_set_boolean (value, sudoku_game_get_paused (self));
#line 24 "../lib/sudoku-game.vala"
		break;
#line 1594 "sudoku-game.c"
		default:
#line 24 "../lib/sudoku-game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/sudoku-game.vala"
		break;
#line 1600 "sudoku-game.c"
	}
}

static void
_vala_sudoku_game_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuGame * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_GAME, SudokuGame);
#line 24 "../lib/sudoku-game.vala"
	switch (property_id) {
#line 24 "../lib/sudoku-game.vala"
		case SUDOKU_GAME_PAUSED_PROPERTY:
#line 24 "../lib/sudoku-game.vala"
		sudoku_game_set_paused (self, g_value_get_boolean (value));
#line 24 "../lib/sudoku-game.vala"
		break;
#line 1620 "sudoku-game.c"
		default:
#line 24 "../lib/sudoku-game.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/sudoku-game.vala"
		break;
#line 1626 "sudoku-game.c"
	}
}

static GType
game_mode_get_type_once (void)
{
	static const GEnumValue values[] = {{GAME_MODE_PLAY, "GAME_MODE_PLAY", "play"}, {GAME_MODE_CREATE, "GAME_MODE_CREATE", "create"}, {0, NULL, NULL}};
	GType game_mode_type_id;
	game_mode_type_id = g_enum_register_static ("GameMode", values);
	return game_mode_type_id;
}

GType
game_mode_get_type (void)
{
	static volatile gsize game_mode_type_id__once = 0;
	if (g_once_init_enter (&game_mode_type_id__once)) {
		GType game_mode_type_id;
		game_mode_type_id = game_mode_get_type_once ();
		g_once_init_leave (&game_mode_type_id__once, game_mode_type_id);
	}
	return game_mode_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

