/* sudoku-cell.c generated by valac 0.56.13, the Vala compiler
 * generated from sudoku-cell.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2023 Jamie Murphy <jmurphy@gnome.org>
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include "libsudoku.h"
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>
#include <gee.h>
#include <gsk/gsk.h>
#include <graphene-gobject.h>
#include <pango/pango.h>

#define SUDOKU_CELL_size_ratio 2
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_CELL (sudoku_cell_get_type ())
#define SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL, SudokuCell))
#define SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL, SudokuCellClass))
#define IS_SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL))
#define IS_SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL))
#define SUDOKU_CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL, SudokuCellClass))

typedef struct _SudokuCell SudokuCell;
typedef struct _SudokuCellClass SudokuCellClass;
typedef struct _SudokuCellPrivate SudokuCellPrivate;
enum  {
	SUDOKU_CELL_0_PROPERTY,
	SUDOKU_CELL_VALUE_PROPERTY,
	SUDOKU_CELL_IS_FIXED_PROPERTY,
	SUDOKU_CELL_SELECTED_PROPERTY,
	SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY,
	SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY,
	SUDOKU_CELL_SHOW_WARNINGS_PROPERTY,
	SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY,
	SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY,
	SUDOKU_CELL_NUM_PROPERTIES
};
static GParamSpec* sudoku_cell_properties[SUDOKU_CELL_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_NUMBER_PICKER (number_picker_get_type ())
#define NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NUMBER_PICKER, NumberPicker))
#define NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NUMBER_PICKER, NumberPickerClass))
#define IS_NUMBER_PICKER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NUMBER_PICKER))
#define IS_NUMBER_PICKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NUMBER_PICKER))
#define NUMBER_PICKER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NUMBER_PICKER, NumberPickerClass))

typedef struct _NumberPicker NumberPicker;
typedef struct _NumberPickerClass NumberPickerClass;
typedef struct _NumberPickerPrivate NumberPickerPrivate;
typedef struct _Block10Data Block10Data;
#define _gsk_transform_unref0(var) ((var == NULL) ? NULL : (var = (gsk_transform_unref (var), NULL)))
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))

struct _SudokuCell {
	GtkWidget parent_instance;
	SudokuCellPrivate * priv;
	GtkPopover* popover;
	gboolean show_possibilities;
};

struct _SudokuCellClass {
	GtkWidgetClass parent_class;
};

struct _SudokuCellPrivate {
	gint row;
	gint col;
	SudokuGame* game;
	GtkGestureClick* button_controller;
	GtkGestureLongPress* long_press_controller;
	GtkEventControllerKey* key_controller;
	GtkLabel* value_label;
	GtkLabel** earmark_labels;
	gint earmark_labels_length1;
	gint _earmark_labels_size_;
	gboolean _selected;
	gboolean _highlighted_background;
	gboolean _highlighted_value;
	gboolean _show_warnings;
	gboolean _show_extra_warnings;
	gboolean control_key_pressed;
	gboolean initialized_earmarks;
	gboolean _initialize_earmarks;
};

struct _NumberPicker {
	GtkGrid parent_instance;
	NumberPickerPrivate * priv;
	gboolean is_earmark;
};

struct _NumberPickerClass {
	GtkGridClass parent_class;
};

struct _Block10Data {
	int _ref_count_;
	SudokuCell* self;
	NumberPicker* earmark_picker;
};

static gint SudokuCell_private_offset;
static gpointer sudoku_cell_parent_class = NULL;

VALA_EXTERN GType sudoku_cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCell, g_object_unref)
VALA_EXTERN SudokuCell* sudoku_cell_new (gint row,
                             gint col,
                             SudokuGame** game);
VALA_EXTERN SudokuCell* sudoku_cell_construct (GType object_type,
                                   gint row,
                                   gint col,
                                   SudokuGame** game);
VALA_EXTERN void sudoku_cell_set_value (SudokuCell* self,
                            gint value);
VALA_EXTERN gboolean sudoku_cell_get_is_fixed (SudokuCell* self);
static void sudoku_cell_long_press_cb (SudokuCell* self,
                                GtkGestureLongPress* event,
                                gdouble x,
                                gdouble y);
static void _sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                                gdouble x,
                                                                gdouble y,
                                                                gpointer self);
static void sudoku_cell_button_released_cb (SudokuCell* self,
                                     GtkGestureClick* event,
                                     gint n_press,
                                     gdouble x,
                                     gdouble y);
static void _sudoku_cell_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                                 gint n_press,
                                                                 gdouble x,
                                                                 gdouble y,
                                                                 gpointer self);
static gboolean sudoku_cell_key_pressed_cb (SudokuCell* self,
                                     guint keyval,
                                     guint keycode,
                                     GdkModifierType state);
static gboolean _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                           guint keyval,
                                                                           guint keycode,
                                                                           GdkModifierType state,
                                                                           gpointer self);
static void sudoku_cell_key_released_cb (SudokuCell* self,
                                  guint keyval,
                                  guint keycode,
                                  GdkModifierType state);
static void _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                         guint keyval,
                                                                         guint keycode,
                                                                         GdkModifierType state,
                                                                         gpointer self);
static void sudoku_cell_cell_changed_cb (SudokuCell* self,
                                  gint row,
                                  gint col,
                                  gint old_val,
                                  gint new_val);
static void _sudoku_cell_cell_changed_cb_sudoku_game_cell_changed (SudokuGame* _sender,
                                                            gint row,
                                                            gint col,
                                                            gint old_val,
                                                            gint new_val,
                                                            gpointer self);
static void __lambda9_ (SudokuCell* self);
VALA_EXTERN void sudoku_cell_check_warnings (SudokuCell* self);
static void ___lambda9__gtk_popover_closed (GtkPopover* _sender,
                                     gpointer self);
static void sudoku_cell_get_visible_earmarks (SudokuCell* self);
static gint sudoku_cell_get_key_number (SudokuCell* self,
                                 guint keyval);
VALA_EXTERN GType number_picker_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (NumberPicker, g_object_unref)
VALA_EXTERN void number_picker_set_earmark (NumberPicker* self,
                                gint row,
                                gint col,
                                gint index,
                                gboolean state);
static void sudoku_cell_show_number_picker (SudokuCell* self);
static void sudoku_cell_show_earmark_picker (SudokuCell* self);
VALA_EXTERN gint sudoku_cell_get_value (SudokuCell* self);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
VALA_EXTERN NumberPicker* number_picker_new (SudokuBoard** board,
                                 gboolean earmark);
VALA_EXTERN NumberPicker* number_picker_construct (GType object_type,
                                       SudokuBoard** board,
                                       gboolean earmark);
VALA_EXTERN void number_picker_set_clear_button_visibility (NumberPicker* self,
                                                gboolean visible);
VALA_EXTERN void number_picker_set_clear_button_enabled (NumberPicker* self,
                                             gboolean enabled);
static void __lambda7_ (Block10Data* _data10_,
                 gint number,
                 gboolean state);
static void ___lambda7__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                      gint number,
                                                      gboolean active,
                                                      gpointer self);
VALA_EXTERN void number_picker_set_earmarks (NumberPicker* self,
                                 gint row,
                                 gint col);
static void __lambda8_ (SudokuCell* self,
                 NumberPicker* o,
                 gint number);
static void ___lambda8__number_picker_number_picked (NumberPicker* _sender,
                                              gint number,
                                              gpointer self);
VALA_EXTERN gboolean sudoku_cell_get_show_warnings (SudokuCell* self);
static gboolean sudoku_cell_warn_incorrect_solution (SudokuCell* self);
VALA_EXTERN gboolean sudoku_cell_get_show_extra_warnings (SudokuCell* self);
static void sudoku_cell_real_dispose (GObject* base);
static void sudoku_cell_real_size_allocate (GtkWidget* base,
                                     gint width,
                                     gint height,
                                     gint baseline);
static void sudoku_cell_set_font_size (SudokuCell* self,
                                GtkLabel** label,
                                gint font_size);
VALA_EXTERN gboolean sudoku_cell_get_selected (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_selected (SudokuCell* self,
                               gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_highlighted_background (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_background (SudokuCell* self,
                                             gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_highlighted_value (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_value (SudokuCell* self,
                                        gboolean value);
VALA_EXTERN void sudoku_cell_set_show_warnings (SudokuCell* self,
                                    gboolean value);
VALA_EXTERN void sudoku_cell_set_show_extra_warnings (SudokuCell* self,
                                          gboolean value);
VALA_EXTERN gboolean sudoku_cell_get_initialize_earmarks (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_initialize_earmarks (SudokuCell* self,
                                          gboolean value);
static void sudoku_cell_finalize (GObject * obj);
static GType sudoku_cell_get_type_once (void);
static void _vala_sudoku_cell_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_cell_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sudoku_cell_get_instance_private (SudokuCell* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuCell_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 165 "../src/sudoku-cell.vala"
	return self ? g_object_ref (self) : NULL;
#line 299 "sudoku-cell.c"
}

static void
_sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed (GtkGestureLongPress* _sender,
                                                           gdouble x,
                                                           gdouble y,
                                                           gpointer self)
{
#line 180 "../src/sudoku-cell.vala"
	sudoku_cell_long_press_cb ((SudokuCell*) self, _sender, x, y);
#line 310 "sudoku-cell.c"
}

static void
_sudoku_cell_button_released_cb_gtk_gesture_click_released (GtkGestureClick* _sender,
                                                            gint n_press,
                                                            gdouble x,
                                                            gdouble y,
                                                            gpointer self)
{
#line 181 "../src/sudoku-cell.vala"
	sudoku_cell_button_released_cb ((SudokuCell*) self, _sender, n_press, x, y);
#line 322 "sudoku-cell.c"
}

static gboolean
_sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                  guint keyval,
                                                                  guint keycode,
                                                                  GdkModifierType state,
                                                                  gpointer self)
{
	gboolean result;
	result = sudoku_cell_key_pressed_cb ((SudokuCell*) self, keyval, keycode, state);
#line 182 "../src/sudoku-cell.vala"
	return result;
#line 336 "sudoku-cell.c"
}

static void
_sudoku_cell_key_released_cb_gtk_event_controller_key_key_released (GtkEventControllerKey* _sender,
                                                                    guint keyval,
                                                                    guint keycode,
                                                                    GdkModifierType state,
                                                                    gpointer self)
{
#line 183 "../src/sudoku-cell.vala"
	sudoku_cell_key_released_cb ((SudokuCell*) self, keyval, keycode, state);
#line 348 "sudoku-cell.c"
}

static void
_sudoku_cell_cell_changed_cb_sudoku_game_cell_changed (SudokuGame* _sender,
                                                       gint row,
                                                       gint col,
                                                       gint old_val,
                                                       gint new_val,
                                                       gpointer self)
{
#line 184 "../src/sudoku-cell.vala"
	sudoku_cell_cell_changed_cb ((SudokuCell*) self, row, col, old_val, new_val);
#line 361 "sudoku-cell.c"
}

static void
__lambda9_ (SudokuCell* self)
{
	GtkPopover* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 209 "../src/sudoku-cell.vala"
	_tmp0_ = self->popover;
#line 209 "../src/sudoku-cell.vala"
	_tmp1_ = gtk_widget_get_visible ((GtkWidget*) _tmp0_);
#line 209 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 209 "../src/sudoku-cell.vala"
	if (_tmp2_) {
#line 378 "sudoku-cell.c"
		GtkPopover* _tmp3_;
#line 211 "../src/sudoku-cell.vala"
		_tmp3_ = self->popover;
#line 211 "../src/sudoku-cell.vala"
		gtk_popover_set_child (_tmp3_, NULL);
#line 213 "../src/sudoku-cell.vala"
		sudoku_cell_check_warnings (self);
#line 214 "../src/sudoku-cell.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 388 "sudoku-cell.c"
	}
}

static void
___lambda9__gtk_popover_closed (GtkPopover* _sender,
                                gpointer self)
{
#line 208 "../src/sudoku-cell.vala"
	__lambda9_ ((SudokuCell*) self);
#line 398 "sudoku-cell.c"
}

SudokuCell*
sudoku_cell_construct (GType object_type,
                       gint row,
                       gint col,
                       SudokuGame** game)
{
	SudokuCell * self = NULL;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkGestureClick* _tmp4_;
	GtkEventController* _tmp5_;
	GtkGestureLongPress* _tmp6_;
	GtkEventController* _tmp7_;
	GtkEventControllerKey* _tmp8_;
	GtkEventController* _tmp9_;
	GtkGestureClick* _tmp10_;
	GtkGestureLongPress* _tmp11_;
	GtkGestureLongPress* _tmp12_;
	GtkGestureClick* _tmp13_;
	GtkEventControllerKey* _tmp14_;
	GtkEventControllerKey* _tmp15_;
	GtkLabel* _tmp16_;
	gint num = 0;
	GtkPopover* _tmp36_;
	GtkEventControllerKey* popover_controller = NULL;
	GtkEventControllerKey* _tmp37_;
	GtkEventControllerKey* _tmp38_;
	GtkEventControllerKey* _tmp39_;
	GtkWidget* _tmp40_ = NULL;
	GtkPopover* _tmp41_;
	GtkPopover* _tmp44_;
#line 159 "../src/sudoku-cell.vala"
	g_return_val_if_fail (*game != NULL, NULL);
#line 159 "../src/sudoku-cell.vala"
	self = (SudokuCell*) g_object_new (object_type, NULL);
#line 161 "../src/sudoku-cell.vala"
	gtk_widget_class_set_accessible_role (G_TYPE_INSTANCE_GET_CLASS (self, gtk_widget_get_type (), GtkWidgetClass), GTK_ACCESSIBLE_ROLE_BUTTON);
#line 163 "../src/sudoku-cell.vala"
	self->priv->row = row;
#line 164 "../src/sudoku-cell.vala"
	self->priv->col = col;
#line 165 "../src/sudoku-cell.vala"
	_tmp0_ = _g_object_ref0 (*game);
#line 165 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->game);
#line 165 "../src/sudoku-cell.vala"
	self->priv->game = _tmp0_;
#line 167 "../src/sudoku-cell.vala"
	_tmp1_ = (*game)->board;
#line 167 "../src/sudoku-cell.vala"
	sudoku_cell_set_value (self, sudoku_board_get (_tmp1_, row, col));
#line 169 "../src/sudoku-cell.vala"
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
#line 170 "../src/sudoku-cell.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
#line 172 "../src/sudoku-cell.vala"
	_tmp2_ = sudoku_cell_get_is_fixed (self);
#line 172 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 172 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 173 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "fixed");
#line 466 "sudoku-cell.c"
	}
#line 175 "../src/sudoku-cell.vala"
	_tmp4_ = self->priv->button_controller;
#line 175 "../src/sudoku-cell.vala"
	_tmp5_ = _g_object_ref0 ((GtkEventController*) _tmp4_);
#line 175 "../src/sudoku-cell.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp5_);
#line 176 "../src/sudoku-cell.vala"
	_tmp6_ = self->priv->long_press_controller;
#line 176 "../src/sudoku-cell.vala"
	_tmp7_ = _g_object_ref0 ((GtkEventController*) _tmp6_);
#line 176 "../src/sudoku-cell.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp7_);
#line 177 "../src/sudoku-cell.vala"
	_tmp8_ = self->priv->key_controller;
#line 177 "../src/sudoku-cell.vala"
	_tmp9_ = _g_object_ref0 ((GtkEventController*) _tmp8_);
#line 177 "../src/sudoku-cell.vala"
	gtk_widget_add_controller ((GtkWidget*) self, _tmp9_);
#line 178 "../src/sudoku-cell.vala"
	_tmp10_ = self->priv->button_controller;
#line 178 "../src/sudoku-cell.vala"
	_tmp11_ = self->priv->long_press_controller;
#line 178 "../src/sudoku-cell.vala"
	gtk_gesture_group ((GtkGesture*) _tmp10_, (GtkGesture*) _tmp11_);
#line 180 "../src/sudoku-cell.vala"
	_tmp12_ = self->priv->long_press_controller;
#line 180 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp12_, "pressed", (GCallback) _sudoku_cell_long_press_cb_gtk_gesture_long_press_pressed, self, 0);
#line 181 "../src/sudoku-cell.vala"
	_tmp13_ = self->priv->button_controller;
#line 181 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp13_, "released", (GCallback) _sudoku_cell_button_released_cb_gtk_gesture_click_released, self, 0);
#line 182 "../src/sudoku-cell.vala"
	_tmp14_ = self->priv->key_controller;
#line 182 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp14_, "key-pressed", (GCallback) _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed, self, 0);
#line 183 "../src/sudoku-cell.vala"
	_tmp15_ = self->priv->key_controller;
#line 183 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp15_, "key-released", (GCallback) _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released, self, 0);
#line 184 "../src/sudoku-cell.vala"
	g_signal_connect_object (*game, "cell-changed", (GCallback) _sudoku_cell_cell_changed_cb_sudoku_game_cell_changed, self, 0);
#line 186 "../src/sudoku-cell.vala"
	_tmp16_ = self->priv->value_label;
#line 186 "../src/sudoku-cell.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp16_, (GtkWidget*) self);
#line 188 "../src/sudoku-cell.vala"
	num = 0;
#line 516 "sudoku-cell.c"
	{
		gint row_tmp = 0;
#line 189 "../src/sudoku-cell.vala"
		row_tmp = 0;
#line 521 "sudoku-cell.c"
		{
			gboolean _tmp17_ = FALSE;
#line 189 "../src/sudoku-cell.vala"
			_tmp17_ = TRUE;
#line 189 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 528 "sudoku-cell.c"
				SudokuBoard* _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
#line 189 "../src/sudoku-cell.vala"
				if (!_tmp17_) {
#line 534 "sudoku-cell.c"
					gint _tmp18_;
#line 189 "../src/sudoku-cell.vala"
					_tmp18_ = row_tmp;
#line 189 "../src/sudoku-cell.vala"
					row_tmp = _tmp18_ + 1;
#line 540 "sudoku-cell.c"
				}
#line 189 "../src/sudoku-cell.vala"
				_tmp17_ = FALSE;
#line 189 "../src/sudoku-cell.vala"
				_tmp19_ = (*game)->board;
#line 189 "../src/sudoku-cell.vala"
				_tmp20_ = sudoku_board_get_block_rows (_tmp19_);
#line 189 "../src/sudoku-cell.vala"
				_tmp21_ = _tmp20_;
#line 189 "../src/sudoku-cell.vala"
				if (!(row_tmp < _tmp21_)) {
#line 189 "../src/sudoku-cell.vala"
					break;
#line 554 "sudoku-cell.c"
				}
				{
					gint col_tmp = 0;
#line 191 "../src/sudoku-cell.vala"
					col_tmp = 0;
#line 560 "sudoku-cell.c"
					{
						gboolean _tmp22_ = FALSE;
#line 191 "../src/sudoku-cell.vala"
						_tmp22_ = TRUE;
#line 191 "../src/sudoku-cell.vala"
						while (TRUE) {
#line 567 "sudoku-cell.c"
							SudokuBoard* _tmp24_;
							gint _tmp25_;
							gint _tmp26_;
							gint _tmp27_;
							GtkLabel** _tmp28_;
							gint _tmp28__length1;
							gchar* _tmp29_;
							gchar* _tmp30_;
							GtkLabel* _tmp31_ = NULL;
							GtkLabel** _tmp32_;
							gint _tmp32__length1;
							GtkLabel* _tmp33_;
							GtkLabel** _tmp34_;
							gint _tmp34__length1;
							GtkLabel* _tmp35_;
#line 191 "../src/sudoku-cell.vala"
							if (!_tmp22_) {
#line 585 "sudoku-cell.c"
								gint _tmp23_;
#line 191 "../src/sudoku-cell.vala"
								_tmp23_ = col_tmp;
#line 191 "../src/sudoku-cell.vala"
								col_tmp = _tmp23_ + 1;
#line 591 "sudoku-cell.c"
							}
#line 191 "../src/sudoku-cell.vala"
							_tmp22_ = FALSE;
#line 191 "../src/sudoku-cell.vala"
							_tmp24_ = (*game)->board;
#line 191 "../src/sudoku-cell.vala"
							_tmp25_ = sudoku_board_get_block_cols (_tmp24_);
#line 191 "../src/sudoku-cell.vala"
							_tmp26_ = _tmp25_;
#line 191 "../src/sudoku-cell.vala"
							if (!(col_tmp < _tmp26_)) {
#line 191 "../src/sudoku-cell.vala"
								break;
#line 605 "sudoku-cell.c"
							}
#line 193 "../src/sudoku-cell.vala"
							_tmp27_ = num;
#line 193 "../src/sudoku-cell.vala"
							num = _tmp27_ + 1;
#line 195 "../src/sudoku-cell.vala"
							_tmp28_ = self->priv->earmark_labels;
#line 195 "../src/sudoku-cell.vala"
							_tmp28__length1 = self->priv->earmark_labels_length1;
#line 195 "../src/sudoku-cell.vala"
							_tmp29_ = g_strdup_printf ("%i", num);
#line 195 "../src/sudoku-cell.vala"
							_tmp30_ = _tmp29_;
#line 195 "../src/sudoku-cell.vala"
							_tmp31_ = (GtkLabel*) gtk_label_new (_tmp30_);
#line 195 "../src/sudoku-cell.vala"
							gtk_widget_set_visible ((GtkWidget*) _tmp31_, FALSE);
#line 195 "../src/sudoku-cell.vala"
							g_object_ref_sink (_tmp31_);
#line 195 "../src/sudoku-cell.vala"
							_g_object_unref0 (_tmp28_[num - 1]);
#line 195 "../src/sudoku-cell.vala"
							_tmp28_[num - 1] = _tmp31_;
#line 195 "../src/sudoku-cell.vala"
							_g_free0 (_tmp30_);
#line 198 "../src/sudoku-cell.vala"
							_tmp32_ = self->priv->earmark_labels;
#line 198 "../src/sudoku-cell.vala"
							_tmp32__length1 = self->priv->earmark_labels_length1;
#line 198 "../src/sudoku-cell.vala"
							_tmp33_ = _tmp32_[num - 1];
#line 198 "../src/sudoku-cell.vala"
							gtk_widget_set_parent ((GtkWidget*) _tmp33_, (GtkWidget*) self);
#line 199 "../src/sudoku-cell.vala"
							_tmp34_ = self->priv->earmark_labels;
#line 199 "../src/sudoku-cell.vala"
							_tmp34__length1 = self->priv->earmark_labels_length1;
#line 199 "../src/sudoku-cell.vala"
							_tmp35_ = _tmp34_[num - 1];
#line 199 "../src/sudoku-cell.vala"
							gtk_widget_add_css_class ((GtkWidget*) _tmp35_, "earmark");
#line 647 "sudoku-cell.c"
						}
					}
				}
			}
		}
	}
#line 203 "../src/sudoku-cell.vala"
	_tmp36_ = self->popover;
#line 203 "../src/sudoku-cell.vala"
	gtk_widget_set_parent ((GtkWidget*) _tmp36_, (GtkWidget*) self);
#line 204 "../src/sudoku-cell.vala"
	_tmp37_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
#line 204 "../src/sudoku-cell.vala"
	popover_controller = _tmp37_;
#line 205 "../src/sudoku-cell.vala"
	_tmp38_ = popover_controller;
#line 205 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp38_, "key-pressed", (GCallback) _sudoku_cell_key_pressed_cb_gtk_event_controller_key_key_pressed, self, 0);
#line 206 "../src/sudoku-cell.vala"
	_tmp39_ = popover_controller;
#line 206 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp39_, "key-released", (GCallback) _sudoku_cell_key_released_cb_gtk_event_controller_key_key_released, self, 0);
#line 207 "../src/sudoku-cell.vala"
	_tmp41_ = self->popover;
#line 207 "../src/sudoku-cell.vala"
	_tmp40_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp41_, gtk_widget_get_type ()) ? ((GtkWidget*) _tmp41_) : NULL;
#line 207 "../src/sudoku-cell.vala"
	if (_tmp40_ != NULL) {
#line 676 "sudoku-cell.c"
		GtkEventControllerKey* _tmp42_;
		GtkEventController* _tmp43_;
#line 207 "../src/sudoku-cell.vala"
		_tmp42_ = popover_controller;
#line 207 "../src/sudoku-cell.vala"
		_tmp43_ = _g_object_ref0 ((GtkEventController*) _tmp42_);
#line 207 "../src/sudoku-cell.vala"
		gtk_widget_add_controller (_tmp40_, _tmp43_);
#line 685 "sudoku-cell.c"
	}
#line 208 "../src/sudoku-cell.vala"
	_tmp44_ = self->popover;
#line 208 "../src/sudoku-cell.vala"
	g_signal_connect_object (_tmp44_, "closed", (GCallback) ___lambda9__gtk_popover_closed, self, 0);
#line 219 "../src/sudoku-cell.vala"
	sudoku_cell_get_visible_earmarks (self);
#line 159 "../src/sudoku-cell.vala"
	_g_object_unref0 (popover_controller);
#line 159 "../src/sudoku-cell.vala"
	return self;
#line 697 "sudoku-cell.c"
}

SudokuCell*
sudoku_cell_new (gint row,
                 gint col,
                 SudokuGame** game)
{
#line 159 "../src/sudoku-cell.vala"
	return sudoku_cell_construct (TYPE_SUDOKU_CELL, row, col, game);
#line 707 "sudoku-cell.c"
}

static void
sudoku_cell_cell_changed_cb (SudokuCell* self,
                             gint row,
                             gint col,
                             gint old_val,
                             gint new_val)
{
	gboolean _tmp0_ = FALSE;
#line 226 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 231 "../src/sudoku-cell.vala"
	if (row == self->priv->row) {
#line 231 "../src/sudoku-cell.vala"
		_tmp0_ = col == self->priv->col;
#line 724 "sudoku-cell.c"
	} else {
#line 231 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 728 "sudoku-cell.c"
	}
#line 231 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 233 "../src/sudoku-cell.vala"
		sudoku_cell_set_value (self, new_val);
#line 234 "../src/sudoku-cell.vala"
		g_object_notify ((GObject*) self, "value");
#line 235 "../src/sudoku-cell.vala"
		sudoku_cell_get_visible_earmarks (self);
#line 738 "sudoku-cell.c"
	}
}

static gboolean
sudoku_cell_key_pressed_cb (SudokuCell* self,
                            guint keyval,
                            guint keycode,
                            GdkModifierType state)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 239 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 243 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_Control_L) {
#line 243 "../src/sudoku-cell.vala"
		_tmp0_ = TRUE;
#line 756 "sudoku-cell.c"
	} else {
#line 243 "../src/sudoku-cell.vala"
		_tmp0_ = keyval == GDK_KEY_Control_R;
#line 760 "sudoku-cell.c"
	}
#line 243 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 244 "../src/sudoku-cell.vala"
		self->priv->control_key_pressed = TRUE;
#line 766 "sudoku-cell.c"
	}
#line 248 "../src/sudoku-cell.vala"
	result = FALSE;
#line 248 "../src/sudoku-cell.vala"
	return result;
#line 772 "sudoku-cell.c"
}

static void
sudoku_cell_key_released_cb (SudokuCell* self,
                             guint keyval,
                             guint keycode,
                             GdkModifierType state)
{
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
	gboolean _tmp8_ = FALSE;
	gint key = 0;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp30_ = FALSE;
#line 251 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 255 "../src/sudoku-cell.vala"
	_tmp1_ = self->priv->game;
#line 255 "../src/sudoku-cell.vala"
	if (_tmp1_->mode == GAME_MODE_PLAY) {
#line 796 "sudoku-cell.c"
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 255 "../src/sudoku-cell.vala"
		_tmp3_ = sudoku_cell_get_is_fixed (self);
#line 255 "../src/sudoku-cell.vala"
		_tmp4_ = _tmp3_;
#line 255 "../src/sudoku-cell.vala"
		if (_tmp4_) {
#line 255 "../src/sudoku-cell.vala"
			_tmp2_ = TRUE;
#line 808 "sudoku-cell.c"
		} else {
			SudokuGame* _tmp5_;
			gboolean _tmp6_;
			gboolean _tmp7_;
#line 255 "../src/sudoku-cell.vala"
			_tmp5_ = self->priv->game;
#line 255 "../src/sudoku-cell.vala"
			_tmp6_ = sudoku_game_get_paused (_tmp5_);
#line 255 "../src/sudoku-cell.vala"
			_tmp7_ = _tmp6_;
#line 255 "../src/sudoku-cell.vala"
			_tmp2_ = _tmp7_;
#line 821 "sudoku-cell.c"
		}
#line 255 "../src/sudoku-cell.vala"
		_tmp0_ = _tmp2_;
#line 825 "sudoku-cell.c"
	} else {
#line 255 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 829 "sudoku-cell.c"
	}
#line 255 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 256 "../src/sudoku-cell.vala"
		return;
#line 835 "sudoku-cell.c"
	}
#line 258 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_Control_L) {
#line 258 "../src/sudoku-cell.vala"
		_tmp8_ = TRUE;
#line 841 "sudoku-cell.c"
	} else {
#line 258 "../src/sudoku-cell.vala"
		_tmp8_ = keyval == GDK_KEY_Control_R;
#line 845 "sudoku-cell.c"
	}
#line 258 "../src/sudoku-cell.vala"
	if (_tmp8_) {
#line 260 "../src/sudoku-cell.vala"
		self->priv->control_key_pressed = FALSE;
#line 261 "../src/sudoku-cell.vala"
		sudoku_cell_check_warnings (self);
#line 853 "sudoku-cell.c"
	}
#line 264 "../src/sudoku-cell.vala"
	key = sudoku_cell_get_key_number (self, keyval);
#line 265 "../src/sudoku-cell.vala"
	if (key >= 1) {
#line 265 "../src/sudoku-cell.vala"
		_tmp9_ = key <= 9;
#line 861 "sudoku-cell.c"
	} else {
#line 265 "../src/sudoku-cell.vala"
		_tmp9_ = FALSE;
#line 865 "sudoku-cell.c"
	}
#line 265 "../src/sudoku-cell.vala"
	if (_tmp9_) {
#line 869 "sudoku-cell.c"
		NumberPicker* earmark_picker = NULL;
		GtkPopover* _tmp10_;
		GtkWidget* _tmp11_;
		NumberPicker* _tmp12_;
		gboolean _tmp13_ = FALSE;
		gboolean _tmp14_ = FALSE;
		NumberPicker* _tmp15_;
		gboolean want_earmark = FALSE;
		gboolean _tmp17_ = FALSE;
#line 268 "../src/sudoku-cell.vala"
		_tmp10_ = self->popover;
#line 268 "../src/sudoku-cell.vala"
		_tmp11_ = gtk_popover_get_child (_tmp10_);
#line 268 "../src/sudoku-cell.vala"
		_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, TYPE_NUMBER_PICKER, NumberPicker));
#line 268 "../src/sudoku-cell.vala"
		earmark_picker = _tmp12_;
#line 270 "../src/sudoku-cell.vala"
		_tmp15_ = earmark_picker;
#line 270 "../src/sudoku-cell.vala"
		if (_tmp15_ != NULL) {
#line 891 "sudoku-cell.c"
			NumberPicker* _tmp16_;
#line 270 "../src/sudoku-cell.vala"
			_tmp16_ = earmark_picker;
#line 270 "../src/sudoku-cell.vala"
			_tmp14_ = _tmp16_->is_earmark;
#line 897 "sudoku-cell.c"
		} else {
#line 270 "../src/sudoku-cell.vala"
			_tmp14_ = FALSE;
#line 901 "sudoku-cell.c"
		}
#line 270 "../src/sudoku-cell.vala"
		if (_tmp14_) {
#line 270 "../src/sudoku-cell.vala"
			_tmp13_ = TRUE;
#line 907 "sudoku-cell.c"
		} else {
#line 271 "../src/sudoku-cell.vala"
			_tmp13_ = (state & GDK_CONTROL_MASK) > 0;
#line 911 "sudoku-cell.c"
		}
#line 270 "../src/sudoku-cell.vala"
		want_earmark = _tmp13_;
#line 272 "../src/sudoku-cell.vala"
		if (want_earmark) {
#line 917 "sudoku-cell.c"
			SudokuGame* _tmp18_;
#line 272 "../src/sudoku-cell.vala"
			_tmp18_ = self->priv->game;
#line 272 "../src/sudoku-cell.vala"
			_tmp17_ = _tmp18_->mode == GAME_MODE_PLAY;
#line 923 "sudoku-cell.c"
		} else {
#line 272 "../src/sudoku-cell.vala"
			_tmp17_ = FALSE;
#line 927 "sudoku-cell.c"
		}
#line 272 "../src/sudoku-cell.vala"
		if (_tmp17_) {
#line 931 "sudoku-cell.c"
			gboolean new_state = FALSE;
			SudokuGame* _tmp19_;
			SudokuBoard* _tmp20_;
			NumberPicker* _tmp23_;
#line 274 "../src/sudoku-cell.vala"
			_tmp19_ = self->priv->game;
#line 274 "../src/sudoku-cell.vala"
			_tmp20_ = _tmp19_->board;
#line 274 "../src/sudoku-cell.vala"
			new_state = !sudoku_board_is_earmark_enabled (_tmp20_, self->priv->row, self->priv->col, key);
#line 275 "../src/sudoku-cell.vala"
			if (new_state) {
#line 944 "sudoku-cell.c"
				SudokuGame* _tmp21_;
#line 276 "../src/sudoku-cell.vala"
				_tmp21_ = self->priv->game;
#line 276 "../src/sudoku-cell.vala"
				sudoku_game_enable_earmark (_tmp21_, self->priv->row, self->priv->col, key);
#line 950 "sudoku-cell.c"
			} else {
				SudokuGame* _tmp22_;
#line 278 "../src/sudoku-cell.vala"
				_tmp22_ = self->priv->game;
#line 278 "../src/sudoku-cell.vala"
				sudoku_game_disable_earmark (_tmp22_, self->priv->row, self->priv->col, key);
#line 957 "sudoku-cell.c"
			}
#line 280 "../src/sudoku-cell.vala"
			_tmp23_ = earmark_picker;
#line 280 "../src/sudoku-cell.vala"
			if (_tmp23_ != NULL) {
#line 963 "sudoku-cell.c"
				NumberPicker* _tmp24_;
#line 281 "../src/sudoku-cell.vala"
				_tmp24_ = earmark_picker;
#line 281 "../src/sudoku-cell.vala"
				number_picker_set_earmark (_tmp24_, self->priv->row, self->priv->col, key - 1, new_state);
#line 969 "sudoku-cell.c"
			}
		} else {
			SudokuGame* _tmp25_;
			SudokuBoard* _tmp26_;
#line 285 "../src/sudoku-cell.vala"
			sudoku_cell_set_value (self, key);
#line 286 "../src/sudoku-cell.vala"
			_tmp25_ = self->priv->game;
#line 286 "../src/sudoku-cell.vala"
			_tmp26_ = _tmp25_->board;
#line 286 "../src/sudoku-cell.vala"
			sudoku_board_disable_all_earmarks (_tmp26_, self->priv->row, self->priv->col);
#line 982 "sudoku-cell.c"
		}
#line 288 "../src/sudoku-cell.vala"
		_g_object_unref0 (earmark_picker);
#line 288 "../src/sudoku-cell.vala"
		return;
#line 988 "sudoku-cell.c"
	}
#line 291 "../src/sudoku-cell.vala"
	if (key == 0) {
#line 291 "../src/sudoku-cell.vala"
		_tmp28_ = TRUE;
#line 994 "sudoku-cell.c"
	} else {
#line 292 "../src/sudoku-cell.vala"
		_tmp28_ = keyval == GDK_KEY_BackSpace;
#line 998 "sudoku-cell.c"
	}
#line 291 "../src/sudoku-cell.vala"
	if (_tmp28_) {
#line 291 "../src/sudoku-cell.vala"
		_tmp27_ = TRUE;
#line 1004 "sudoku-cell.c"
	} else {
#line 293 "../src/sudoku-cell.vala"
		_tmp27_ = keyval == GDK_KEY_Delete;
#line 1008 "sudoku-cell.c"
	}
#line 291 "../src/sudoku-cell.vala"
	if (_tmp27_) {
#line 295 "../src/sudoku-cell.vala"
		sudoku_cell_set_value (self, 0);
#line 296 "../src/sudoku-cell.vala"
		g_object_notify ((GObject*) self, "value");
#line 297 "../src/sudoku-cell.vala"
		return;
#line 1018 "sudoku-cell.c"
	}
#line 300 "../src/sudoku-cell.vala"
	if (keyval == GDK_KEY_space) {
#line 300 "../src/sudoku-cell.vala"
		_tmp30_ = TRUE;
#line 1024 "sudoku-cell.c"
	} else {
#line 301 "../src/sudoku-cell.vala"
		_tmp30_ = keyval == GDK_KEY_Return;
#line 1028 "sudoku-cell.c"
	}
#line 300 "../src/sudoku-cell.vala"
	if (_tmp30_) {
#line 300 "../src/sudoku-cell.vala"
		_tmp29_ = TRUE;
#line 1034 "sudoku-cell.c"
	} else {
#line 302 "../src/sudoku-cell.vala"
		_tmp29_ = keyval == GDK_KEY_KP_Enter;
#line 1038 "sudoku-cell.c"
	}
#line 300 "../src/sudoku-cell.vala"
	if (_tmp29_) {
#line 1042 "sudoku-cell.c"
		GtkPopover* _tmp31_;
		gboolean _tmp32_;
		gboolean _tmp33_;
#line 304 "../src/sudoku-cell.vala"
		_tmp31_ = self->popover;
#line 304 "../src/sudoku-cell.vala"
		_tmp32_ = gtk_widget_get_visible ((GtkWidget*) _tmp31_);
#line 304 "../src/sudoku-cell.vala"
		_tmp33_ = _tmp32_;
#line 304 "../src/sudoku-cell.vala"
		if (_tmp33_) {
#line 305 "../src/sudoku-cell.vala"
			return;
#line 1056 "sudoku-cell.c"
		}
#line 306 "../src/sudoku-cell.vala"
		sudoku_cell_show_number_picker (self);
#line 307 "../src/sudoku-cell.vala"
		return;
#line 1062 "sudoku-cell.c"
	}
}

static void
sudoku_cell_long_press_cb (SudokuCell* self,
                           GtkGestureLongPress* event,
                           gdouble x,
                           gdouble y)
{
	gboolean _tmp0_ = FALSE;
	SudokuGame* _tmp1_;
#line 311 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 311 "../src/sudoku-cell.vala"
	g_return_if_fail (event != NULL);
#line 315 "../src/sudoku-cell.vala"
	_tmp1_ = self->priv->game;
#line 315 "../src/sudoku-cell.vala"
	if (_tmp1_->mode == GAME_MODE_PLAY) {
#line 1082 "sudoku-cell.c"
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 315 "../src/sudoku-cell.vala"
		_tmp3_ = sudoku_cell_get_is_fixed (self);
#line 315 "../src/sudoku-cell.vala"
		_tmp4_ = _tmp3_;
#line 315 "../src/sudoku-cell.vala"
		if (_tmp4_) {
#line 315 "../src/sudoku-cell.vala"
			_tmp2_ = TRUE;
#line 1094 "sudoku-cell.c"
		} else {
			SudokuGame* _tmp5_;
			gboolean _tmp6_;
			gboolean _tmp7_;
#line 315 "../src/sudoku-cell.vala"
			_tmp5_ = self->priv->game;
#line 315 "../src/sudoku-cell.vala"
			_tmp6_ = sudoku_game_get_paused (_tmp5_);
#line 315 "../src/sudoku-cell.vala"
			_tmp7_ = _tmp6_;
#line 315 "../src/sudoku-cell.vala"
			_tmp2_ = _tmp7_;
#line 1107 "sudoku-cell.c"
		}
#line 315 "../src/sudoku-cell.vala"
		_tmp0_ = _tmp2_;
#line 1111 "sudoku-cell.c"
	} else {
#line 315 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 1115 "sudoku-cell.c"
	}
#line 315 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 316 "../src/sudoku-cell.vala"
		return;
#line 1121 "sudoku-cell.c"
	}
#line 318 "../src/sudoku-cell.vala"
	sudoku_cell_show_earmark_picker (self);
#line 1125 "sudoku-cell.c"
}

static void
sudoku_cell_button_released_cb (SudokuCell* self,
                                GtkGestureClick* event,
                                gint n_press,
                                gdouble x,
                                gdouble y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	SudokuGame* _tmp4_;
#line 321 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 321 "../src/sudoku-cell.vala"
	g_return_if_fail (event != NULL);
#line 326 "../src/sudoku-cell.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) event) != ((guint) GDK_BUTTON_PRIMARY)) {
#line 327 "../src/sudoku-cell.vala"
		_tmp0_ = gtk_gesture_single_get_current_button ((GtkGestureSingle*) event) != ((guint) GDK_BUTTON_SECONDARY);
#line 1148 "sudoku-cell.c"
	} else {
#line 326 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 1152 "sudoku-cell.c"
	}
#line 326 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 328 "../src/sudoku-cell.vala"
		return;
#line 1158 "sudoku-cell.c"
	}
#line 330 "../src/sudoku-cell.vala"
	g_object_get ((GtkWidget*) self, "has-focus", &_tmp1_, NULL);
#line 330 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_;
#line 330 "../src/sudoku-cell.vala"
	if (!_tmp2_) {
#line 331 "../src/sudoku-cell.vala"
		gtk_widget_grab_focus ((GtkWidget*) self);
#line 1168 "sudoku-cell.c"
	}
#line 333 "../src/sudoku-cell.vala"
	_tmp4_ = self->priv->game;
#line 333 "../src/sudoku-cell.vala"
	if (_tmp4_->mode == GAME_MODE_PLAY) {
#line 1174 "sudoku-cell.c"
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_;
		gboolean _tmp7_;
#line 333 "../src/sudoku-cell.vala"
		_tmp6_ = sudoku_cell_get_is_fixed (self);
#line 333 "../src/sudoku-cell.vala"
		_tmp7_ = _tmp6_;
#line 333 "../src/sudoku-cell.vala"
		if (_tmp7_) {
#line 333 "../src/sudoku-cell.vala"
			_tmp5_ = TRUE;
#line 1186 "sudoku-cell.c"
		} else {
			SudokuGame* _tmp8_;
			gboolean _tmp9_;
			gboolean _tmp10_;
#line 333 "../src/sudoku-cell.vala"
			_tmp8_ = self->priv->game;
#line 333 "../src/sudoku-cell.vala"
			_tmp9_ = sudoku_game_get_paused (_tmp8_);
#line 333 "../src/sudoku-cell.vala"
			_tmp10_ = _tmp9_;
#line 333 "../src/sudoku-cell.vala"
			_tmp5_ = _tmp10_;
#line 1199 "sudoku-cell.c"
		}
#line 333 "../src/sudoku-cell.vala"
		_tmp3_ = _tmp5_;
#line 1203 "sudoku-cell.c"
	} else {
#line 333 "../src/sudoku-cell.vala"
		_tmp3_ = FALSE;
#line 1207 "sudoku-cell.c"
	}
#line 333 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 334 "../src/sudoku-cell.vala"
		return;
#line 1213 "sudoku-cell.c"
	}
#line 336 "../src/sudoku-cell.vala"
	if (gtk_gesture_single_get_current_button ((GtkGestureSingle*) event) == ((guint) GDK_BUTTON_PRIMARY)) {
#line 1217 "sudoku-cell.c"
		gboolean _tmp11_ = FALSE;
#line 338 "../src/sudoku-cell.vala"
		if (!self->show_possibilities) {
#line 1221 "sudoku-cell.c"
			GdkEventSequence* _tmp12_;
			GdkEvent* _tmp13_;
#line 339 "../src/sudoku-cell.vala"
			_tmp12_ = gtk_gesture_get_last_updated_sequence ((GtkGesture*) event);
#line 339 "../src/sudoku-cell.vala"
			_tmp13_ = gtk_gesture_get_last_event ((GtkGesture*) event, _tmp12_);
#line 339 "../src/sudoku-cell.vala"
			_tmp11_ = (gdk_event_get_modifier_state (_tmp13_) & GDK_CONTROL_MASK) > 0;
#line 1230 "sudoku-cell.c"
		} else {
#line 338 "../src/sudoku-cell.vala"
			_tmp11_ = FALSE;
#line 1234 "sudoku-cell.c"
		}
#line 338 "../src/sudoku-cell.vala"
		if (_tmp11_) {
#line 340 "../src/sudoku-cell.vala"
			sudoku_cell_show_earmark_picker (self);
#line 1240 "sudoku-cell.c"
		} else {
#line 342 "../src/sudoku-cell.vala"
			sudoku_cell_show_number_picker (self);
#line 1244 "sudoku-cell.c"
		}
	} else {
		gboolean _tmp14_ = FALSE;
#line 344 "../src/sudoku-cell.vala"
		if (!self->show_possibilities) {
#line 345 "../src/sudoku-cell.vala"
			_tmp14_ = gtk_gesture_single_get_current_button ((GtkGestureSingle*) event) == ((guint) GDK_BUTTON_SECONDARY);
#line 1252 "sudoku-cell.c"
		} else {
#line 344 "../src/sudoku-cell.vala"
			_tmp14_ = FALSE;
#line 1256 "sudoku-cell.c"
		}
#line 344 "../src/sudoku-cell.vala"
		if (_tmp14_) {
#line 346 "../src/sudoku-cell.vala"
			sudoku_cell_show_earmark_picker (self);
#line 1262 "sudoku-cell.c"
		}
	}
}

static gint
sudoku_cell_get_key_number (SudokuCell* self,
                            guint keyval)
{
	gint result;
#line 349 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 351 "../src/sudoku-cell.vala"
	switch (keyval) {
#line 351 "../src/sudoku-cell.vala"
		case GDK_KEY_0:
#line 351 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_0:
#line 1280 "sudoku-cell.c"
		{
#line 355 "../src/sudoku-cell.vala"
			result = 0;
#line 355 "../src/sudoku-cell.vala"
			return result;
#line 1286 "sudoku-cell.c"
		}
#line 351 "../src/sudoku-cell.vala"
		case GDK_KEY_1:
#line 351 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_1:
#line 1292 "sudoku-cell.c"
		{
#line 358 "../src/sudoku-cell.vala"
			result = 1;
#line 358 "../src/sudoku-cell.vala"
			return result;
#line 1298 "sudoku-cell.c"
		}
#line 351 "../src/sudoku-cell.vala"
		case GDK_KEY_2:
#line 351 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_2:
#line 1304 "sudoku-cell.c"
		{
#line 361 "../src/sudoku-cell.vala"
			result = 2;
#line 361 "../src/sudoku-cell.vala"
			return result;
#line 1310 "sudoku-cell.c"
		}
#line 351 "../src/sudoku-cell.vala"
		case GDK_KEY_3:
#line 351 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_3:
#line 1316 "sudoku-cell.c"
		{
#line 364 "../src/sudoku-cell.vala"
			result = 3;
#line 364 "../src/sudoku-cell.vala"
			return result;
#line 1322 "sudoku-cell.c"
		}
#line 351 "../src/sudoku-cell.vala"
		case GDK_KEY_4:
#line 351 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_4:
#line 1328 "sudoku-cell.c"
		{
#line 367 "../src/sudoku-cell.vala"
			result = 4;
#line 367 "../src/sudoku-cell.vala"
			return result;
#line 1334 "sudoku-cell.c"
		}
#line 351 "../src/sudoku-cell.vala"
		case GDK_KEY_5:
#line 351 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_5:
#line 1340 "sudoku-cell.c"
		{
#line 370 "../src/sudoku-cell.vala"
			result = 5;
#line 370 "../src/sudoku-cell.vala"
			return result;
#line 1346 "sudoku-cell.c"
		}
#line 351 "../src/sudoku-cell.vala"
		case GDK_KEY_6:
#line 351 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_6:
#line 1352 "sudoku-cell.c"
		{
#line 373 "../src/sudoku-cell.vala"
			result = 6;
#line 373 "../src/sudoku-cell.vala"
			return result;
#line 1358 "sudoku-cell.c"
		}
#line 351 "../src/sudoku-cell.vala"
		case GDK_KEY_7:
#line 351 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_7:
#line 1364 "sudoku-cell.c"
		{
#line 376 "../src/sudoku-cell.vala"
			result = 7;
#line 376 "../src/sudoku-cell.vala"
			return result;
#line 1370 "sudoku-cell.c"
		}
#line 351 "../src/sudoku-cell.vala"
		case GDK_KEY_8:
#line 351 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_8:
#line 1376 "sudoku-cell.c"
		{
#line 379 "../src/sudoku-cell.vala"
			result = 8;
#line 379 "../src/sudoku-cell.vala"
			return result;
#line 1382 "sudoku-cell.c"
		}
#line 351 "../src/sudoku-cell.vala"
		case GDK_KEY_9:
#line 351 "../src/sudoku-cell.vala"
		case GDK_KEY_KP_9:
#line 1388 "sudoku-cell.c"
		{
#line 382 "../src/sudoku-cell.vala"
			result = 9;
#line 382 "../src/sudoku-cell.vala"
			return result;
#line 1394 "sudoku-cell.c"
		}
		default:
		{
#line 384 "../src/sudoku-cell.vala"
			result = -1;
#line 384 "../src/sudoku-cell.vala"
			return result;
#line 1402 "sudoku-cell.c"
		}
	}
}

static void
sudoku_cell_get_visible_earmarks (SudokuCell* self)
{
	gboolean* marks = NULL;
	gint marks_length1;
	gint _marks_size_;
	gint num = 0;
#line 388 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 390 "../src/sudoku-cell.vala"
	marks = NULL;
#line 390 "../src/sudoku-cell.vala"
	marks_length1 = 0;
#line 390 "../src/sudoku-cell.vala"
	_marks_size_ = marks_length1;
#line 391 "../src/sudoku-cell.vala"
	if (!self->show_possibilities) {
#line 1424 "sudoku-cell.c"
		SudokuGame* _tmp18_;
		SudokuBoard* _tmp19_;
		gint _tmp20_ = 0;
		gboolean* _tmp21_;
#line 393 "../src/sudoku-cell.vala"
		if (!self->priv->initialized_earmarks) {
#line 1431 "sudoku-cell.c"
			gboolean _tmp0_ = FALSE;
			gboolean _tmp1_ = FALSE;
#line 395 "../src/sudoku-cell.vala"
			if (self->priv->_initialize_earmarks) {
#line 1436 "sudoku-cell.c"
				SudokuGame* _tmp2_;
#line 395 "../src/sudoku-cell.vala"
				_tmp2_ = self->priv->game;
#line 395 "../src/sudoku-cell.vala"
				_tmp1_ = _tmp2_->mode == GAME_MODE_PLAY;
#line 1442 "sudoku-cell.c"
			} else {
#line 395 "../src/sudoku-cell.vala"
				_tmp1_ = FALSE;
#line 1446 "sudoku-cell.c"
			}
#line 395 "../src/sudoku-cell.vala"
			if (_tmp1_) {
#line 1450 "sudoku-cell.c"
				SudokuGame* _tmp3_;
				SudokuBoard* _tmp4_;
				gdouble _tmp5_;
				gdouble _tmp6_;
#line 396 "../src/sudoku-cell.vala"
				_tmp3_ = self->priv->game;
#line 396 "../src/sudoku-cell.vala"
				_tmp4_ = _tmp3_->board;
#line 396 "../src/sudoku-cell.vala"
				_tmp5_ = sudoku_board_get_previous_played_time (_tmp4_);
#line 396 "../src/sudoku-cell.vala"
				_tmp6_ = _tmp5_;
#line 396 "../src/sudoku-cell.vala"
				_tmp0_ = _tmp6_ == 0.0;
#line 1465 "sudoku-cell.c"
			} else {
#line 395 "../src/sudoku-cell.vala"
				_tmp0_ = FALSE;
#line 1469 "sudoku-cell.c"
			}
#line 395 "../src/sudoku-cell.vala"
			if (_tmp0_) {
#line 1473 "sudoku-cell.c"
				SudokuGame* _tmp7_;
				SudokuBoard* _tmp8_;
				gint _tmp9_ = 0;
				gboolean* _tmp10_;
#line 398 "../src/sudoku-cell.vala"
				_tmp7_ = self->priv->game;
#line 398 "../src/sudoku-cell.vala"
				_tmp8_ = _tmp7_->board;
#line 398 "../src/sudoku-cell.vala"
				_tmp10_ = sudoku_board_get_possibilities_as_bool_array (_tmp8_, self->priv->row, self->priv->col, &_tmp9_);
#line 398 "../src/sudoku-cell.vala"
				marks = (g_free (marks), NULL);
#line 398 "../src/sudoku-cell.vala"
				marks = _tmp10_;
#line 398 "../src/sudoku-cell.vala"
				marks_length1 = _tmp9_;
#line 398 "../src/sudoku-cell.vala"
				_marks_size_ = marks_length1;
#line 1492 "sudoku-cell.c"
				{
					gint num = 0;
#line 399 "../src/sudoku-cell.vala"
					num = 1;
#line 1497 "sudoku-cell.c"
					{
						gboolean _tmp11_ = FALSE;
#line 399 "../src/sudoku-cell.vala"
						_tmp11_ = TRUE;
#line 399 "../src/sudoku-cell.vala"
						while (TRUE) {
#line 1504 "sudoku-cell.c"
							gboolean* _tmp13_;
							gint _tmp13__length1;
							gboolean* _tmp14_;
							gint _tmp14__length1;
							gboolean _tmp15_;
#line 399 "../src/sudoku-cell.vala"
							if (!_tmp11_) {
#line 1512 "sudoku-cell.c"
								gint _tmp12_;
#line 399 "../src/sudoku-cell.vala"
								_tmp12_ = num;
#line 399 "../src/sudoku-cell.vala"
								num = _tmp12_ + 1;
#line 1518 "sudoku-cell.c"
							}
#line 399 "../src/sudoku-cell.vala"
							_tmp11_ = FALSE;
#line 399 "../src/sudoku-cell.vala"
							_tmp13_ = marks;
#line 399 "../src/sudoku-cell.vala"
							_tmp13__length1 = marks_length1;
#line 399 "../src/sudoku-cell.vala"
							if (!(num <= _tmp13__length1)) {
#line 399 "../src/sudoku-cell.vala"
								break;
#line 1530 "sudoku-cell.c"
							}
#line 401 "../src/sudoku-cell.vala"
							_tmp14_ = marks;
#line 401 "../src/sudoku-cell.vala"
							_tmp14__length1 = marks_length1;
#line 401 "../src/sudoku-cell.vala"
							_tmp15_ = _tmp14_[num - 1];
#line 401 "../src/sudoku-cell.vala"
							if (_tmp15_) {
#line 1540 "sudoku-cell.c"
								SudokuGame* _tmp16_;
								SudokuBoard* _tmp17_;
#line 403 "../src/sudoku-cell.vala"
								_tmp16_ = self->priv->game;
#line 403 "../src/sudoku-cell.vala"
								_tmp17_ = _tmp16_->board;
#line 403 "../src/sudoku-cell.vala"
								sudoku_board_enable_earmark (_tmp17_, self->priv->row, self->priv->col, num);
#line 1549 "sudoku-cell.c"
							}
						}
					}
				}
			}
#line 407 "../src/sudoku-cell.vala"
			self->priv->initialized_earmarks = TRUE;
#line 1557 "sudoku-cell.c"
		}
#line 410 "../src/sudoku-cell.vala"
		_tmp18_ = self->priv->game;
#line 410 "../src/sudoku-cell.vala"
		_tmp19_ = _tmp18_->board;
#line 410 "../src/sudoku-cell.vala"
		_tmp21_ = sudoku_board_get_earmarks (_tmp19_, self->priv->row, self->priv->col, &_tmp20_);
#line 410 "../src/sudoku-cell.vala"
		marks = (g_free (marks), NULL);
#line 410 "../src/sudoku-cell.vala"
		marks = _tmp21_;
#line 410 "../src/sudoku-cell.vala"
		marks_length1 = _tmp20_;
#line 410 "../src/sudoku-cell.vala"
		_marks_size_ = marks_length1;
#line 1573 "sudoku-cell.c"
	} else {
		gint _tmp22_;
		gint _tmp23_;
#line 412 "../src/sudoku-cell.vala"
		_tmp22_ = sudoku_cell_get_value (self);
#line 412 "../src/sudoku-cell.vala"
		_tmp23_ = _tmp22_;
#line 412 "../src/sudoku-cell.vala"
		if (_tmp23_ == 0) {
#line 1583 "sudoku-cell.c"
			SudokuGame* _tmp24_;
			SudokuBoard* _tmp25_;
			gint _tmp26_ = 0;
			gboolean* _tmp27_;
#line 414 "../src/sudoku-cell.vala"
			_tmp24_ = self->priv->game;
#line 414 "../src/sudoku-cell.vala"
			_tmp25_ = _tmp24_->board;
#line 414 "../src/sudoku-cell.vala"
			_tmp27_ = sudoku_board_get_possibilities_as_bool_array (_tmp25_, self->priv->row, self->priv->col, &_tmp26_);
#line 414 "../src/sudoku-cell.vala"
			marks = (g_free (marks), NULL);
#line 414 "../src/sudoku-cell.vala"
			marks = _tmp27_;
#line 414 "../src/sudoku-cell.vala"
			marks_length1 = _tmp26_;
#line 414 "../src/sudoku-cell.vala"
			_marks_size_ = marks_length1;
#line 1602 "sudoku-cell.c"
		}
	}
#line 417 "../src/sudoku-cell.vala"
	num = 0;
#line 1607 "sudoku-cell.c"
	{
		gint row_tmp = 0;
#line 418 "../src/sudoku-cell.vala"
		row_tmp = 0;
#line 1612 "sudoku-cell.c"
		{
			gboolean _tmp28_ = FALSE;
#line 418 "../src/sudoku-cell.vala"
			_tmp28_ = TRUE;
#line 418 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 1619 "sudoku-cell.c"
				SudokuGame* _tmp30_;
				SudokuBoard* _tmp31_;
				gint _tmp32_;
				gint _tmp33_;
#line 418 "../src/sudoku-cell.vala"
				if (!_tmp28_) {
#line 1626 "sudoku-cell.c"
					gint _tmp29_;
#line 418 "../src/sudoku-cell.vala"
					_tmp29_ = row_tmp;
#line 418 "../src/sudoku-cell.vala"
					row_tmp = _tmp29_ + 1;
#line 1632 "sudoku-cell.c"
				}
#line 418 "../src/sudoku-cell.vala"
				_tmp28_ = FALSE;
#line 418 "../src/sudoku-cell.vala"
				_tmp30_ = self->priv->game;
#line 418 "../src/sudoku-cell.vala"
				_tmp31_ = _tmp30_->board;
#line 418 "../src/sudoku-cell.vala"
				_tmp32_ = sudoku_board_get_block_rows (_tmp31_);
#line 418 "../src/sudoku-cell.vala"
				_tmp33_ = _tmp32_;
#line 418 "../src/sudoku-cell.vala"
				if (!(row_tmp < _tmp33_)) {
#line 418 "../src/sudoku-cell.vala"
					break;
#line 1648 "sudoku-cell.c"
				}
				{
					gint col_tmp = 0;
#line 420 "../src/sudoku-cell.vala"
					col_tmp = 0;
#line 1654 "sudoku-cell.c"
					{
						gboolean _tmp34_ = FALSE;
#line 420 "../src/sudoku-cell.vala"
						_tmp34_ = TRUE;
#line 420 "../src/sudoku-cell.vala"
						while (TRUE) {
#line 1661 "sudoku-cell.c"
							SudokuGame* _tmp36_;
							SudokuBoard* _tmp37_;
							gint _tmp38_;
							gint _tmp39_;
							gint _tmp40_;
							gboolean _tmp41_ = FALSE;
							gboolean* _tmp42_;
							gint _tmp42__length1;
#line 420 "../src/sudoku-cell.vala"
							if (!_tmp34_) {
#line 1672 "sudoku-cell.c"
								gint _tmp35_;
#line 420 "../src/sudoku-cell.vala"
								_tmp35_ = col_tmp;
#line 420 "../src/sudoku-cell.vala"
								col_tmp = _tmp35_ + 1;
#line 1678 "sudoku-cell.c"
							}
#line 420 "../src/sudoku-cell.vala"
							_tmp34_ = FALSE;
#line 420 "../src/sudoku-cell.vala"
							_tmp36_ = self->priv->game;
#line 420 "../src/sudoku-cell.vala"
							_tmp37_ = _tmp36_->board;
#line 420 "../src/sudoku-cell.vala"
							_tmp38_ = sudoku_board_get_block_cols (_tmp37_);
#line 420 "../src/sudoku-cell.vala"
							_tmp39_ = _tmp38_;
#line 420 "../src/sudoku-cell.vala"
							if (!(col_tmp < _tmp39_)) {
#line 420 "../src/sudoku-cell.vala"
								break;
#line 1694 "sudoku-cell.c"
							}
#line 422 "../src/sudoku-cell.vala"
							_tmp40_ = num;
#line 422 "../src/sudoku-cell.vala"
							num = _tmp40_ + 1;
#line 424 "../src/sudoku-cell.vala"
							_tmp42_ = marks;
#line 424 "../src/sudoku-cell.vala"
							_tmp42__length1 = marks_length1;
#line 424 "../src/sudoku-cell.vala"
							if (_tmp42_ == NULL) {
#line 424 "../src/sudoku-cell.vala"
								_tmp41_ = TRUE;
#line 1708 "sudoku-cell.c"
							} else {
								gint _tmp43_;
								gint _tmp44_;
#line 424 "../src/sudoku-cell.vala"
								_tmp43_ = sudoku_cell_get_value (self);
#line 424 "../src/sudoku-cell.vala"
								_tmp44_ = _tmp43_;
#line 424 "../src/sudoku-cell.vala"
								_tmp41_ = _tmp44_ != 0;
#line 1718 "sudoku-cell.c"
							}
#line 424 "../src/sudoku-cell.vala"
							if (_tmp41_) {
#line 1722 "sudoku-cell.c"
								GtkLabel** _tmp45_;
								gint _tmp45__length1;
								GtkLabel* _tmp46_;
#line 425 "../src/sudoku-cell.vala"
								_tmp45_ = self->priv->earmark_labels;
#line 425 "../src/sudoku-cell.vala"
								_tmp45__length1 = self->priv->earmark_labels_length1;
#line 425 "../src/sudoku-cell.vala"
								_tmp46_ = _tmp45_[num - 1];
#line 425 "../src/sudoku-cell.vala"
								gtk_widget_set_visible ((GtkWidget*) _tmp46_, FALSE);
#line 1734 "sudoku-cell.c"
							} else {
								GtkLabel** _tmp47_;
								gint _tmp47__length1;
								GtkLabel* _tmp48_;
								gboolean* _tmp49_;
								gint _tmp49__length1;
								gboolean _tmp50_;
#line 427 "../src/sudoku-cell.vala"
								_tmp47_ = self->priv->earmark_labels;
#line 427 "../src/sudoku-cell.vala"
								_tmp47__length1 = self->priv->earmark_labels_length1;
#line 427 "../src/sudoku-cell.vala"
								_tmp48_ = _tmp47_[num - 1];
#line 427 "../src/sudoku-cell.vala"
								_tmp49_ = marks;
#line 427 "../src/sudoku-cell.vala"
								_tmp49__length1 = marks_length1;
#line 427 "../src/sudoku-cell.vala"
								_tmp50_ = _tmp49_[num - 1];
#line 427 "../src/sudoku-cell.vala"
								gtk_widget_set_visible ((GtkWidget*) _tmp48_, _tmp50_);
#line 1756 "sudoku-cell.c"
							}
						}
					}
				}
			}
		}
	}
#line 388 "../src/sudoku-cell.vala"
	marks = (g_free (marks), NULL);
#line 1766 "sudoku-cell.c"
}

static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 432 "../src/sudoku-cell.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 432 "../src/sudoku-cell.vala"
	return _data10_;
#line 1776 "sudoku-cell.c"
}

static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 432 "../src/sudoku-cell.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 1786 "sudoku-cell.c"
		SudokuCell* self;
#line 432 "../src/sudoku-cell.vala"
		self = _data10_->self;
#line 432 "../src/sudoku-cell.vala"
		_g_object_unref0 (_data10_->earmark_picker);
#line 432 "../src/sudoku-cell.vala"
		_g_object_unref0 (self);
#line 432 "../src/sudoku-cell.vala"
		g_slice_free (Block10Data, _data10_);
#line 1796 "sudoku-cell.c"
	}
}

static void
__lambda7_ (Block10Data* _data10_,
            gint number,
            gboolean state)
{
	SudokuCell* self;
	SudokuGame* _tmp3_;
	SudokuBoard* _tmp4_;
	SudokuGame* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
#line 438 "../src/sudoku-cell.vala"
	self = _data10_->self;
#line 439 "../src/sudoku-cell.vala"
	if (state) {
#line 1817 "sudoku-cell.c"
		SudokuGame* _tmp0_;
#line 440 "../src/sudoku-cell.vala"
		_tmp0_ = self->priv->game;
#line 440 "../src/sudoku-cell.vala"
		sudoku_game_enable_earmark (_tmp0_, self->priv->row, self->priv->col, number);
#line 1823 "sudoku-cell.c"
	} else {
#line 442 "../src/sudoku-cell.vala"
		if (number == 0) {
#line 1827 "sudoku-cell.c"
			SudokuGame* _tmp1_;
#line 443 "../src/sudoku-cell.vala"
			_tmp1_ = self->priv->game;
#line 443 "../src/sudoku-cell.vala"
			sudoku_game_disable_all_earmarks (_tmp1_, self->priv->row, self->priv->col);
#line 1833 "sudoku-cell.c"
		} else {
			SudokuGame* _tmp2_;
#line 445 "../src/sudoku-cell.vala"
			_tmp2_ = self->priv->game;
#line 445 "../src/sudoku-cell.vala"
			sudoku_game_disable_earmark (_tmp2_, self->priv->row, self->priv->col, number);
#line 1840 "sudoku-cell.c"
		}
	}
#line 447 "../src/sudoku-cell.vala"
	_tmp3_ = self->priv->game;
#line 447 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_->board;
#line 447 "../src/sudoku-cell.vala"
	if (!sudoku_board_has_earmarks (_tmp4_, self->priv->row, self->priv->col)) {
#line 1849 "sudoku-cell.c"
		NumberPicker* _tmp5_;
#line 448 "../src/sudoku-cell.vala"
		_tmp5_ = _data10_->earmark_picker;
#line 448 "../src/sudoku-cell.vala"
		number_picker_set_clear_button_enabled (_tmp5_, FALSE);
#line 1855 "sudoku-cell.c"
	} else {
		NumberPicker* _tmp6_;
#line 450 "../src/sudoku-cell.vala"
		_tmp6_ = _data10_->earmark_picker;
#line 450 "../src/sudoku-cell.vala"
		number_picker_set_clear_button_enabled (_tmp6_, TRUE);
#line 1862 "sudoku-cell.c"
	}
#line 452 "../src/sudoku-cell.vala"
	sudoku_cell_check_warnings (self);
#line 453 "../src/sudoku-cell.vala"
	_tmp7_ = self->priv->game;
#line 453 "../src/sudoku-cell.vala"
	_tmp8_ = sudoku_cell_get_value (self);
#line 453 "../src/sudoku-cell.vala"
	_tmp9_ = _tmp8_;
#line 453 "../src/sudoku-cell.vala"
	_tmp10_ = sudoku_cell_get_value (self);
#line 453 "../src/sudoku-cell.vala"
	_tmp11_ = _tmp10_;
#line 453 "../src/sudoku-cell.vala"
	g_signal_emit_by_name (_tmp7_, "cell-changed", self->priv->row, self->priv->col, _tmp9_, _tmp11_);
#line 1878 "sudoku-cell.c"
}

static void
___lambda7__number_picker_earmark_state_changed (NumberPicker* _sender,
                                                 gint number,
                                                 gboolean active,
                                                 gpointer self)
{
#line 438 "../src/sudoku-cell.vala"
	__lambda7_ (self, number, active);
#line 1889 "sudoku-cell.c"
}

static void
sudoku_cell_show_earmark_picker (SudokuCell* self)
{
	Block10Data* _data10_;
	SudokuGame* _tmp0_;
	NumberPicker* _tmp1_;
	NumberPicker* _tmp2_;
	SudokuGame* _tmp3_;
	SudokuBoard* _tmp4_;
	NumberPicker* _tmp6_;
	NumberPicker* _tmp7_;
	GtkPopover* _tmp8_;
	NumberPicker* _tmp9_;
	GtkPopover* _tmp10_;
#line 432 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 432 "../src/sudoku-cell.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 432 "../src/sudoku-cell.vala"
	_data10_->_ref_count_ = 1;
#line 432 "../src/sudoku-cell.vala"
	_data10_->self = g_object_ref (self);
#line 434 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 434 "../src/sudoku-cell.vala"
	_tmp1_ = number_picker_new (&_tmp0_->board, TRUE);
#line 434 "../src/sudoku-cell.vala"
	g_object_ref_sink (_tmp1_);
#line 434 "../src/sudoku-cell.vala"
	_data10_->earmark_picker = _tmp1_;
#line 435 "../src/sudoku-cell.vala"
	_tmp2_ = _data10_->earmark_picker;
#line 435 "../src/sudoku-cell.vala"
	number_picker_set_clear_button_visibility (_tmp2_, TRUE);
#line 436 "../src/sudoku-cell.vala"
	_tmp3_ = self->priv->game;
#line 436 "../src/sudoku-cell.vala"
	_tmp4_ = _tmp3_->board;
#line 436 "../src/sudoku-cell.vala"
	if (!sudoku_board_has_earmarks (_tmp4_, self->priv->row, self->priv->col)) {
#line 1932 "sudoku-cell.c"
		NumberPicker* _tmp5_;
#line 437 "../src/sudoku-cell.vala"
		_tmp5_ = _data10_->earmark_picker;
#line 437 "../src/sudoku-cell.vala"
		number_picker_set_clear_button_enabled (_tmp5_, FALSE);
#line 1938 "sudoku-cell.c"
	}
#line 438 "../src/sudoku-cell.vala"
	_tmp6_ = _data10_->earmark_picker;
#line 438 "../src/sudoku-cell.vala"
	g_signal_connect_data (_tmp6_, "earmark-state-changed", (GCallback) ___lambda7__number_picker_earmark_state_changed, block10_data_ref (_data10_), (GClosureNotify) block10_data_unref, 0);
#line 455 "../src/sudoku-cell.vala"
	_tmp7_ = _data10_->earmark_picker;
#line 455 "../src/sudoku-cell.vala"
	number_picker_set_earmarks (_tmp7_, self->priv->row, self->priv->col);
#line 456 "../src/sudoku-cell.vala"
	_tmp8_ = self->popover;
#line 456 "../src/sudoku-cell.vala"
	_tmp9_ = _data10_->earmark_picker;
#line 456 "../src/sudoku-cell.vala"
	gtk_popover_set_child (_tmp8_, (GtkWidget*) _tmp9_);
#line 458 "../src/sudoku-cell.vala"
	_tmp10_ = self->popover;
#line 458 "../src/sudoku-cell.vala"
	gtk_popover_popup (_tmp10_);
#line 432 "../src/sudoku-cell.vala"
	block10_data_unref (_data10_);
#line 432 "../src/sudoku-cell.vala"
	_data10_ = NULL;
#line 1962 "sudoku-cell.c"
}

static void
__lambda8_ (SudokuCell* self,
            NumberPicker* o,
            gint number)
{
	GtkPopover* _tmp0_;
	SudokuGame* _tmp1_;
	SudokuBoard* _tmp2_;
	SudokuGame* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
#line 464 "../src/sudoku-cell.vala"
	g_return_if_fail (o != NULL);
#line 465 "../src/sudoku-cell.vala"
	_tmp0_ = self->popover;
#line 465 "../src/sudoku-cell.vala"
	gtk_popover_popdown (_tmp0_);
#line 467 "../src/sudoku-cell.vala"
	sudoku_cell_set_value (self, number);
#line 468 "../src/sudoku-cell.vala"
	if (number == 0) {
#line 469 "../src/sudoku-cell.vala"
		g_object_notify ((GObject*) self, "value");
#line 1990 "sudoku-cell.c"
	}
#line 470 "../src/sudoku-cell.vala"
	_tmp1_ = self->priv->game;
#line 470 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_->board;
#line 470 "../src/sudoku-cell.vala"
	sudoku_board_disable_all_earmarks (_tmp2_, self->priv->row, self->priv->col);
#line 471 "../src/sudoku-cell.vala"
	_tmp3_ = self->priv->game;
#line 471 "../src/sudoku-cell.vala"
	_tmp4_ = sudoku_cell_get_value (self);
#line 471 "../src/sudoku-cell.vala"
	_tmp5_ = _tmp4_;
#line 471 "../src/sudoku-cell.vala"
	_tmp6_ = sudoku_cell_get_value (self);
#line 471 "../src/sudoku-cell.vala"
	_tmp7_ = _tmp6_;
#line 471 "../src/sudoku-cell.vala"
	g_signal_emit_by_name (_tmp3_, "cell-changed", self->priv->row, self->priv->col, _tmp5_, _tmp7_);
#line 2010 "sudoku-cell.c"
}

static void
___lambda8__number_picker_number_picked (NumberPicker* _sender,
                                         gint number,
                                         gpointer self)
{
#line 464 "../src/sudoku-cell.vala"
	__lambda8_ ((SudokuCell*) self, _sender, number);
#line 2020 "sudoku-cell.c"
}

static void
sudoku_cell_show_number_picker (SudokuCell* self)
{
	NumberPicker* number_picker = NULL;
	SudokuGame* _tmp0_;
	NumberPicker* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GtkPopover* _tmp4_;
	GtkPopover* _tmp5_;
#line 461 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 463 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 463 "../src/sudoku-cell.vala"
	_tmp1_ = number_picker_new (&_tmp0_->board, FALSE);
#line 463 "../src/sudoku-cell.vala"
	g_object_ref_sink (_tmp1_);
#line 463 "../src/sudoku-cell.vala"
	number_picker = _tmp1_;
#line 464 "../src/sudoku-cell.vala"
	g_signal_connect_object (number_picker, "number-picked", (GCallback) ___lambda8__number_picker_number_picked, self, 0);
#line 473 "../src/sudoku-cell.vala"
	_tmp2_ = sudoku_cell_get_value (self);
#line 473 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 473 "../src/sudoku-cell.vala"
	number_picker_set_clear_button_visibility (number_picker, _tmp3_ != 0);
#line 474 "../src/sudoku-cell.vala"
	_tmp4_ = self->popover;
#line 474 "../src/sudoku-cell.vala"
	gtk_popover_set_child (_tmp4_, (GtkWidget*) number_picker);
#line 476 "../src/sudoku-cell.vala"
	_tmp5_ = self->popover;
#line 476 "../src/sudoku-cell.vala"
	gtk_popover_popup (_tmp5_);
#line 461 "../src/sudoku-cell.vala"
	_g_object_unref0 (number_picker);
#line 2061 "sudoku-cell.c"
}

void
sudoku_cell_check_warnings (SudokuCell* self)
{
	gboolean _error_ = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_;
	gboolean _tmp33_;
#line 479 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 481 "../src/sudoku-cell.vala"
	_error_ = FALSE;
#line 483 "../src/sudoku-cell.vala"
	_tmp2_ = sudoku_cell_get_show_warnings (self);
#line 483 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 483 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 2085 "sudoku-cell.c"
		gint _tmp4_;
		gint _tmp5_;
#line 484 "../src/sudoku-cell.vala"
		_tmp4_ = sudoku_cell_get_value (self);
#line 484 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_;
#line 484 "../src/sudoku-cell.vala"
		_tmp1_ = _tmp5_ == 0;
#line 2094 "sudoku-cell.c"
	} else {
#line 483 "../src/sudoku-cell.vala"
		_tmp1_ = FALSE;
#line 2098 "sudoku-cell.c"
	}
#line 483 "../src/sudoku-cell.vala"
	if (_tmp1_) {
#line 2102 "sudoku-cell.c"
		SudokuGame* _tmp6_;
		SudokuBoard* _tmp7_;
#line 485 "../src/sudoku-cell.vala"
		_tmp6_ = self->priv->game;
#line 485 "../src/sudoku-cell.vala"
		_tmp7_ = _tmp6_->board;
#line 485 "../src/sudoku-cell.vala"
		_tmp0_ = sudoku_board_count_possibilities (_tmp7_, self->priv->row, self->priv->col) == 0;
#line 2111 "sudoku-cell.c"
	} else {
#line 483 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 2115 "sudoku-cell.c"
	}
#line 483 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 2119 "sudoku-cell.c"
		GtkLabel* _tmp8_;
#line 486 "../src/sudoku-cell.vala"
		_tmp8_ = self->priv->value_label;
#line 486 "../src/sudoku-cell.vala"
		gtk_label_set_label (_tmp8_, "X");
#line 2125 "sudoku-cell.c"
	} else {
		GtkLabel* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
#line 488 "../src/sudoku-cell.vala"
		_tmp9_ = self->priv->value_label;
#line 488 "../src/sudoku-cell.vala"
		_tmp10_ = sudoku_cell_get_value (self);
#line 488 "../src/sudoku-cell.vala"
		_tmp11_ = _tmp10_;
#line 488 "../src/sudoku-cell.vala"
		_tmp12_ = g_strdup_printf ("%i", _tmp11_);
#line 488 "../src/sudoku-cell.vala"
		_tmp13_ = _tmp12_;
#line 488 "../src/sudoku-cell.vala"
		gtk_label_set_label (_tmp9_, _tmp13_);
#line 488 "../src/sudoku-cell.vala"
		_g_free0 (_tmp13_);
#line 2146 "sudoku-cell.c"
	}
#line 490 "../src/sudoku-cell.vala"
	if (sudoku_cell_warn_incorrect_solution (self)) {
#line 2150 "sudoku-cell.c"
		gint solution = 0;
		SudokuGame* _tmp14_;
		SudokuBoard* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
#line 492 "../src/sudoku-cell.vala"
		_tmp14_ = self->priv->game;
#line 492 "../src/sudoku-cell.vala"
		_tmp15_ = _tmp14_->board;
#line 492 "../src/sudoku-cell.vala"
		solution = sudoku_board_get_solution (_tmp15_, self->priv->row, self->priv->col);
#line 493 "../src/sudoku-cell.vala"
		_tmp16_ = sudoku_cell_get_value (self);
#line 493 "../src/sudoku-cell.vala"
		_tmp17_ = _tmp16_;
#line 493 "../src/sudoku-cell.vala"
		if (_tmp17_ != 0) {
#line 2168 "sudoku-cell.c"
			gint _tmp18_;
			gint _tmp19_;
#line 495 "../src/sudoku-cell.vala"
			_tmp18_ = sudoku_cell_get_value (self);
#line 495 "../src/sudoku-cell.vala"
			_tmp19_ = _tmp18_;
#line 495 "../src/sudoku-cell.vala"
			_error_ = _tmp19_ != solution;
#line 2177 "sudoku-cell.c"
		} else {
			gboolean* marks = NULL;
			SudokuGame* _tmp20_;
			SudokuBoard* _tmp21_;
			gint _tmp22_ = 0;
			gboolean* _tmp23_;
			gint marks_length1;
			gint _marks_size_;
#line 499 "../src/sudoku-cell.vala"
			_tmp20_ = self->priv->game;
#line 499 "../src/sudoku-cell.vala"
			_tmp21_ = _tmp20_->board;
#line 499 "../src/sudoku-cell.vala"
			_tmp23_ = sudoku_board_get_earmarks (_tmp21_, self->priv->row, self->priv->col, &_tmp22_);
#line 499 "../src/sudoku-cell.vala"
			marks = _tmp23_;
#line 499 "../src/sudoku-cell.vala"
			marks_length1 = _tmp22_;
#line 499 "../src/sudoku-cell.vala"
			_marks_size_ = marks_length1;
#line 2198 "sudoku-cell.c"
			{
				gint num = 0;
#line 500 "../src/sudoku-cell.vala"
				num = 1;
#line 2203 "sudoku-cell.c"
				{
					gboolean _tmp24_ = FALSE;
#line 500 "../src/sudoku-cell.vala"
					_tmp24_ = TRUE;
#line 500 "../src/sudoku-cell.vala"
					while (TRUE) {
#line 2210 "sudoku-cell.c"
						gboolean* _tmp26_;
						gint _tmp26__length1;
						gboolean* _tmp27_;
						gint _tmp27__length1;
						gboolean _tmp28_;
#line 500 "../src/sudoku-cell.vala"
						if (!_tmp24_) {
#line 2218 "sudoku-cell.c"
							gint _tmp25_;
#line 500 "../src/sudoku-cell.vala"
							_tmp25_ = num;
#line 500 "../src/sudoku-cell.vala"
							num = _tmp25_ + 1;
#line 2224 "sudoku-cell.c"
						}
#line 500 "../src/sudoku-cell.vala"
						_tmp24_ = FALSE;
#line 500 "../src/sudoku-cell.vala"
						_tmp26_ = marks;
#line 500 "../src/sudoku-cell.vala"
						_tmp26__length1 = marks_length1;
#line 500 "../src/sudoku-cell.vala"
						if (!(num <= _tmp26__length1)) {
#line 500 "../src/sudoku-cell.vala"
							break;
#line 2236 "sudoku-cell.c"
						}
#line 502 "../src/sudoku-cell.vala"
						_tmp27_ = marks;
#line 502 "../src/sudoku-cell.vala"
						_tmp27__length1 = marks_length1;
#line 502 "../src/sudoku-cell.vala"
						_tmp28_ = _tmp27_[num - 1];
#line 502 "../src/sudoku-cell.vala"
						if (_tmp28_) {
#line 504 "../src/sudoku-cell.vala"
							if (num != solution) {
#line 2248 "sudoku-cell.c"
								GtkLabel** _tmp29_;
								gint _tmp29__length1;
								GtkLabel* _tmp30_;
#line 505 "../src/sudoku-cell.vala"
								_tmp29_ = self->priv->earmark_labels;
#line 505 "../src/sudoku-cell.vala"
								_tmp29__length1 = self->priv->earmark_labels_length1;
#line 505 "../src/sudoku-cell.vala"
								_tmp30_ = _tmp29_[num - 1];
#line 505 "../src/sudoku-cell.vala"
								gtk_widget_add_css_class ((GtkWidget*) _tmp30_, "error");
#line 2260 "sudoku-cell.c"
							}
						}
					}
				}
			}
#line 493 "../src/sudoku-cell.vala"
			marks = (g_free (marks), NULL);
#line 2268 "sudoku-cell.c"
		}
	}
#line 511 "../src/sudoku-cell.vala"
	_tmp32_ = sudoku_cell_get_show_warnings (self);
#line 511 "../src/sudoku-cell.vala"
	_tmp33_ = _tmp32_;
#line 511 "../src/sudoku-cell.vala"
	if (_tmp33_) {
#line 2277 "sudoku-cell.c"
		SudokuGame* _tmp34_;
		SudokuBoard* _tmp35_;
		GeeSet* _tmp36_;
		Coord _tmp37_ = {0};
#line 512 "../src/sudoku-cell.vala"
		_tmp34_ = self->priv->game;
#line 512 "../src/sudoku-cell.vala"
		_tmp35_ = _tmp34_->board;
#line 512 "../src/sudoku-cell.vala"
		_tmp36_ = _tmp35_->broken_coords;
#line 512 "../src/sudoku-cell.vala"
		coord_init (&_tmp37_, self->priv->row, self->priv->col);
#line 512 "../src/sudoku-cell.vala"
		_tmp31_ = gee_collection_contains ((GeeCollection*) _tmp36_, &_tmp37_);
#line 2292 "sudoku-cell.c"
	} else {
#line 511 "../src/sudoku-cell.vala"
		_tmp31_ = FALSE;
#line 2296 "sudoku-cell.c"
	}
#line 511 "../src/sudoku-cell.vala"
	if (_tmp31_) {
#line 513 "../src/sudoku-cell.vala"
		_error_ = TRUE;
#line 2302 "sudoku-cell.c"
	}
#line 515 "../src/sudoku-cell.vala"
	if (_error_) {
#line 516 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "error");
#line 2308 "sudoku-cell.c"
	} else {
#line 518 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "error");
#line 2312 "sudoku-cell.c"
	}
}

static gboolean
sudoku_cell_warn_incorrect_solution (SudokuCell* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean result;
#line 524 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 530 "../src/sudoku-cell.vala"
	_tmp2_ = sudoku_cell_get_show_extra_warnings (self);
#line 530 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 530 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 531 "../src/sudoku-cell.vala"
		_tmp1_ = !self->priv->control_key_pressed;
#line 2334 "sudoku-cell.c"
	} else {
#line 530 "../src/sudoku-cell.vala"
		_tmp1_ = FALSE;
#line 2338 "sudoku-cell.c"
	}
#line 530 "../src/sudoku-cell.vala"
	if (_tmp1_) {
#line 2342 "sudoku-cell.c"
		SudokuGame* _tmp4_;
		SudokuBoard* _tmp5_;
#line 532 "../src/sudoku-cell.vala"
		_tmp4_ = self->priv->game;
#line 532 "../src/sudoku-cell.vala"
		_tmp5_ = _tmp4_->board;
#line 532 "../src/sudoku-cell.vala"
		_tmp0_ = sudoku_board_solved (_tmp5_);
#line 2351 "sudoku-cell.c"
	} else {
#line 530 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 2355 "sudoku-cell.c"
	}
#line 530 "../src/sudoku-cell.vala"
	result = _tmp0_;
#line 530 "../src/sudoku-cell.vala"
	return result;
#line 2361 "sudoku-cell.c"
}

static void
sudoku_cell_real_dispose (GObject* base)
{
	SudokuCell * self;
	GtkLabel* _tmp0_;
#line 535 "../src/sudoku-cell.vala"
	self = (SudokuCell*) base;
#line 537 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (sudoku_cell_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
#line 539 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->value_label;
#line 539 "../src/sudoku-cell.vala"
	gtk_widget_unparent ((GtkWidget*) _tmp0_);
#line 2377 "sudoku-cell.c"
}

static gpointer
_gsk_transform_ref0 (gpointer self)
{
#line 557 "../src/sudoku-cell.vala"
	return self ? gsk_transform_ref (self) : NULL;
#line 2385 "sudoku-cell.c"
}

static void
sudoku_cell_real_size_allocate (GtkWidget* base,
                                gint width,
                                gint height,
                                gint baseline)
{
	SudokuCell * self;
	GtkPopover* _tmp0_;
	gint value_width = 0;
	gint value_height = 0;
	GskTransform* center = NULL;
	GskTransform* _tmp1_;
	graphene_point_t _tmp2_ = {0};
	graphene_point_t _tmp3_;
	GskTransform* _tmp4_;
	GtkLabel* _tmp5_;
	GskTransform* _tmp6_;
	GskTransform* _tmp7_;
	gint earmark_width = 0;
	gint earmark_height = 0;
	SudokuGame* _tmp8_;
	SudokuBoard* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	SudokuGame* _tmp12_;
	SudokuBoard* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint num = 0;
#line 542 "../src/sudoku-cell.vala"
	self = (SudokuCell*) base;
#line 546 "../src/sudoku-cell.vala"
	_tmp0_ = self->popover;
#line 546 "../src/sudoku-cell.vala"
	gtk_popover_present (_tmp0_);
#line 549 "../src/sudoku-cell.vala"
	value_height = MIN (width, height);
#line 549 "../src/sudoku-cell.vala"
	value_width = value_height;
#line 551 "../src/sudoku-cell.vala"
	sudoku_cell_set_font_size (self, &self->priv->value_label, height / SUDOKU_CELL_size_ratio);
#line 553 "../src/sudoku-cell.vala"
	_tmp1_ = gsk_transform_new ();
#line 553 "../src/sudoku-cell.vala"
	memset (&_tmp2_, 0, sizeof (graphene_point_t));
#line 553 "../src/sudoku-cell.vala"
	_tmp3_ = *graphene_point_init (&_tmp2_, (gfloat) ((width - value_width) / 2), (gfloat) ((height - value_height) / 2));
#line 553 "../src/sudoku-cell.vala"
	_tmp4_ = gsk_transform_translate (_tmp1_, &_tmp3_);
#line 553 "../src/sudoku-cell.vala"
	center = _tmp4_;
#line 557 "../src/sudoku-cell.vala"
	_tmp5_ = self->priv->value_label;
#line 557 "../src/sudoku-cell.vala"
	_tmp6_ = center;
#line 557 "../src/sudoku-cell.vala"
	_tmp7_ = _gsk_transform_ref0 (_tmp6_);
#line 557 "../src/sudoku-cell.vala"
	gtk_widget_allocate ((GtkWidget*) _tmp5_, value_width, value_height, baseline, _tmp7_);
#line 560 "../src/sudoku-cell.vala"
	_tmp8_ = self->priv->game;
#line 560 "../src/sudoku-cell.vala"
	_tmp9_ = _tmp8_->board;
#line 560 "../src/sudoku-cell.vala"
	_tmp10_ = sudoku_board_get_block_cols (_tmp9_);
#line 560 "../src/sudoku-cell.vala"
	_tmp11_ = _tmp10_;
#line 560 "../src/sudoku-cell.vala"
	earmark_width = width / _tmp11_;
#line 561 "../src/sudoku-cell.vala"
	_tmp12_ = self->priv->game;
#line 561 "../src/sudoku-cell.vala"
	_tmp13_ = _tmp12_->board;
#line 561 "../src/sudoku-cell.vala"
	_tmp14_ = sudoku_board_get_block_rows (_tmp13_);
#line 561 "../src/sudoku-cell.vala"
	_tmp15_ = _tmp14_;
#line 561 "../src/sudoku-cell.vala"
	earmark_height = height / _tmp15_;
#line 563 "../src/sudoku-cell.vala"
	num = 0;
#line 2469 "sudoku-cell.c"
	{
		gint row_tmp = 0;
#line 564 "../src/sudoku-cell.vala"
		row_tmp = 0;
#line 2474 "sudoku-cell.c"
		{
			gboolean _tmp16_ = FALSE;
#line 564 "../src/sudoku-cell.vala"
			_tmp16_ = TRUE;
#line 564 "../src/sudoku-cell.vala"
			while (TRUE) {
#line 2481 "sudoku-cell.c"
				SudokuGame* _tmp18_;
				SudokuBoard* _tmp19_;
				gint _tmp20_;
				gint _tmp21_;
#line 564 "../src/sudoku-cell.vala"
				if (!_tmp16_) {
#line 2488 "sudoku-cell.c"
					gint _tmp17_;
#line 564 "../src/sudoku-cell.vala"
					_tmp17_ = row_tmp;
#line 564 "../src/sudoku-cell.vala"
					row_tmp = _tmp17_ + 1;
#line 2494 "sudoku-cell.c"
				}
#line 564 "../src/sudoku-cell.vala"
				_tmp16_ = FALSE;
#line 564 "../src/sudoku-cell.vala"
				_tmp18_ = self->priv->game;
#line 564 "../src/sudoku-cell.vala"
				_tmp19_ = _tmp18_->board;
#line 564 "../src/sudoku-cell.vala"
				_tmp20_ = sudoku_board_get_block_rows (_tmp19_);
#line 564 "../src/sudoku-cell.vala"
				_tmp21_ = _tmp20_;
#line 564 "../src/sudoku-cell.vala"
				if (!(row_tmp < _tmp21_)) {
#line 564 "../src/sudoku-cell.vala"
					break;
#line 2510 "sudoku-cell.c"
				}
				{
					gint col_tmp = 0;
#line 566 "../src/sudoku-cell.vala"
					col_tmp = 0;
#line 2516 "sudoku-cell.c"
					{
						gboolean _tmp22_ = FALSE;
#line 566 "../src/sudoku-cell.vala"
						_tmp22_ = TRUE;
#line 566 "../src/sudoku-cell.vala"
						while (TRUE) {
#line 2523 "sudoku-cell.c"
							SudokuGame* _tmp24_;
							SudokuBoard* _tmp25_;
							gint _tmp26_;
							gint _tmp27_;
							gint _tmp28_;
							GtkLabel** _tmp29_;
							gint _tmp29__length1;
							GskTransform* earmark_position = NULL;
							GskTransform* _tmp30_;
							graphene_point_t _tmp31_ = {0};
							SudokuGame* _tmp32_;
							SudokuBoard* _tmp33_;
							gint _tmp34_;
							gint _tmp35_;
							graphene_point_t _tmp36_;
							GskTransform* _tmp37_;
							GtkLabel** _tmp38_;
							gint _tmp38__length1;
							GtkLabel* _tmp39_;
							GskTransform* _tmp40_;
							GskTransform* _tmp41_;
#line 566 "../src/sudoku-cell.vala"
							if (!_tmp22_) {
#line 2547 "sudoku-cell.c"
								gint _tmp23_;
#line 566 "../src/sudoku-cell.vala"
								_tmp23_ = col_tmp;
#line 566 "../src/sudoku-cell.vala"
								col_tmp = _tmp23_ + 1;
#line 2553 "sudoku-cell.c"
							}
#line 566 "../src/sudoku-cell.vala"
							_tmp22_ = FALSE;
#line 566 "../src/sudoku-cell.vala"
							_tmp24_ = self->priv->game;
#line 566 "../src/sudoku-cell.vala"
							_tmp25_ = _tmp24_->board;
#line 566 "../src/sudoku-cell.vala"
							_tmp26_ = sudoku_board_get_block_cols (_tmp25_);
#line 566 "../src/sudoku-cell.vala"
							_tmp27_ = _tmp26_;
#line 566 "../src/sudoku-cell.vala"
							if (!(col_tmp < _tmp27_)) {
#line 566 "../src/sudoku-cell.vala"
								break;
#line 2569 "sudoku-cell.c"
							}
#line 568 "../src/sudoku-cell.vala"
							_tmp28_ = num;
#line 568 "../src/sudoku-cell.vala"
							num = _tmp28_ + 1;
#line 570 "../src/sudoku-cell.vala"
							_tmp29_ = self->priv->earmark_labels;
#line 570 "../src/sudoku-cell.vala"
							_tmp29__length1 = self->priv->earmark_labels_length1;
#line 570 "../src/sudoku-cell.vala"
							sudoku_cell_set_font_size (self, &_tmp29_[num - 1], (height / SUDOKU_CELL_size_ratio) / 2);
#line 572 "../src/sudoku-cell.vala"
							_tmp30_ = gsk_transform_new ();
#line 572 "../src/sudoku-cell.vala"
							memset (&_tmp31_, 0, sizeof (graphene_point_t));
#line 572 "../src/sudoku-cell.vala"
							_tmp32_ = self->priv->game;
#line 572 "../src/sudoku-cell.vala"
							_tmp33_ = _tmp32_->board;
#line 572 "../src/sudoku-cell.vala"
							_tmp34_ = sudoku_board_get_block_rows (_tmp33_);
#line 572 "../src/sudoku-cell.vala"
							_tmp35_ = _tmp34_;
#line 572 "../src/sudoku-cell.vala"
							_tmp36_ = *graphene_point_init (&_tmp31_, (gfloat) (col_tmp * earmark_width), (gfloat) (((_tmp35_ - row_tmp) - 1) * earmark_height));
#line 572 "../src/sudoku-cell.vala"
							_tmp37_ = gsk_transform_translate (_tmp30_, &_tmp36_);
#line 572 "../src/sudoku-cell.vala"
							earmark_position = _tmp37_;
#line 577 "../src/sudoku-cell.vala"
							_tmp38_ = self->priv->earmark_labels;
#line 577 "../src/sudoku-cell.vala"
							_tmp38__length1 = self->priv->earmark_labels_length1;
#line 577 "../src/sudoku-cell.vala"
							_tmp39_ = _tmp38_[num - 1];
#line 577 "../src/sudoku-cell.vala"
							_tmp40_ = earmark_position;
#line 577 "../src/sudoku-cell.vala"
							_tmp41_ = _gsk_transform_ref0 (_tmp40_);
#line 577 "../src/sudoku-cell.vala"
							gtk_widget_allocate ((GtkWidget*) _tmp39_, earmark_width, earmark_height, baseline, _tmp41_);
#line 566 "../src/sudoku-cell.vala"
							_gsk_transform_unref0 (earmark_position);
#line 2613 "sudoku-cell.c"
						}
					}
				}
			}
		}
	}
#line 542 "../src/sudoku-cell.vala"
	_gsk_transform_unref0 (center);
#line 2622 "sudoku-cell.c"
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
#line 584 "../src/sudoku-cell.vala"
	return self ? pango_attr_list_ref (self) : NULL;
#line 2630 "sudoku-cell.c"
}

static void
sudoku_cell_set_font_size (SudokuCell* self,
                           GtkLabel** label,
                           gint font_size)
{
	PangoAttrList* attr_list = NULL;
	PangoAttrList* _tmp0_;
	PangoAttrList* _tmp1_;
	PangoAttrList* _tmp2_;
	PangoAttrList* _tmp4_;
	PangoAttribute* _tmp5_;
	PangoAttrList* _tmp6_;
#line 582 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 582 "../src/sudoku-cell.vala"
	g_return_if_fail (*label != NULL);
#line 584 "../src/sudoku-cell.vala"
	_tmp0_ = gtk_label_get_attributes (*label);
#line 584 "../src/sudoku-cell.vala"
	_tmp1_ = _pango_attr_list_ref0 (_tmp0_);
#line 584 "../src/sudoku-cell.vala"
	attr_list = _tmp1_;
#line 585 "../src/sudoku-cell.vala"
	_tmp2_ = attr_list;
#line 585 "../src/sudoku-cell.vala"
	if (_tmp2_ == NULL) {
#line 2659 "sudoku-cell.c"
		PangoAttrList* _tmp3_;
#line 586 "../src/sudoku-cell.vala"
		_tmp3_ = pango_attr_list_new ();
#line 586 "../src/sudoku-cell.vala"
		_pango_attr_list_unref0 (attr_list);
#line 586 "../src/sudoku-cell.vala"
		attr_list = _tmp3_;
#line 2667 "sudoku-cell.c"
	}
#line 588 "../src/sudoku-cell.vala"
	_tmp4_ = attr_list;
#line 588 "../src/sudoku-cell.vala"
	_tmp5_ = pango_attr_size_new_absolute (font_size * PANGO_SCALE);
#line 588 "../src/sudoku-cell.vala"
	pango_attr_list_change (_tmp4_, _tmp5_);
#line 592 "../src/sudoku-cell.vala"
	_tmp6_ = attr_list;
#line 592 "../src/sudoku-cell.vala"
	gtk_label_set_attributes (*label, _tmp6_);
#line 582 "../src/sudoku-cell.vala"
	_pango_attr_list_unref0 (attr_list);
#line 2681 "sudoku-cell.c"
}

gint
sudoku_cell_get_value (SudokuCell* self)
{
	gint result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
#line 48 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 48 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 48 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_->board;
#line 48 "../src/sudoku-cell.vala"
	result = sudoku_board_get (_tmp1_, self->priv->row, self->priv->col);
#line 48 "../src/sudoku-cell.vala"
	return result;
#line 2700 "sudoku-cell.c"
}

void
sudoku_cell_set_value (SudokuCell* self,
                       gint value)
{
	gboolean _tmp2_;
	gboolean _tmp3_;
	SudokuGame* _tmp9_;
	SudokuBoard* _tmp10_;
	GtkLabel* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	SudokuGame* _tmp14_;
#line 49 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 50 "../src/sudoku-cell.vala"
	if (value != 0) {
#line 2719 "sudoku-cell.c"
		GtkLabel* _tmp0_;
#line 51 "../src/sudoku-cell.vala"
		_tmp0_ = self->priv->value_label;
#line 51 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp0_, TRUE);
#line 2725 "sudoku-cell.c"
	} else {
		GtkLabel* _tmp1_;
#line 53 "../src/sudoku-cell.vala"
		_tmp1_ = self->priv->value_label;
#line 53 "../src/sudoku-cell.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, FALSE);
#line 2732 "sudoku-cell.c"
	}
#line 55 "../src/sudoku-cell.vala"
	_tmp2_ = sudoku_cell_get_is_fixed (self);
#line 55 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_;
#line 55 "../src/sudoku-cell.vala"
	if (_tmp3_) {
#line 2740 "sudoku-cell.c"
		SudokuGame* _tmp4_;
#line 57 "../src/sudoku-cell.vala"
		_tmp4_ = self->priv->game;
#line 57 "../src/sudoku-cell.vala"
		if (_tmp4_->mode == GAME_MODE_PLAY) {
#line 58 "../src/sudoku-cell.vala"
			return;
#line 2748 "sudoku-cell.c"
		}
	}
#line 61 "../src/sudoku-cell.vala"
	if (value == 0) {
#line 2753 "sudoku-cell.c"
		SudokuGame* _tmp5_;
		SudokuBoard* _tmp6_;
		SudokuGame* _tmp8_;
#line 63 "../src/sudoku-cell.vala"
		_tmp5_ = self->priv->game;
#line 63 "../src/sudoku-cell.vala"
		_tmp6_ = _tmp5_->board;
#line 63 "../src/sudoku-cell.vala"
		if (sudoku_board_get (_tmp6_, self->priv->row, self->priv->col) != 0) {
#line 2763 "sudoku-cell.c"
			SudokuGame* _tmp7_;
#line 64 "../src/sudoku-cell.vala"
			_tmp7_ = self->priv->game;
#line 64 "../src/sudoku-cell.vala"
			sudoku_game_remove (_tmp7_, self->priv->row, self->priv->col);
#line 2769 "sudoku-cell.c"
		}
#line 65 "../src/sudoku-cell.vala"
		_tmp8_ = self->priv->game;
#line 65 "../src/sudoku-cell.vala"
		if (_tmp8_->mode == GAME_MODE_PLAY) {
#line 66 "../src/sudoku-cell.vala"
			return;
#line 2777 "sudoku-cell.c"
		}
	}
#line 69 "../src/sudoku-cell.vala"
	_tmp9_ = self->priv->game;
#line 69 "../src/sudoku-cell.vala"
	_tmp10_ = _tmp9_->board;
#line 69 "../src/sudoku-cell.vala"
	if (value == sudoku_board_get (_tmp10_, self->priv->row, self->priv->col)) {
#line 70 "../src/sudoku-cell.vala"
		return;
#line 2788 "sudoku-cell.c"
	}
#line 72 "../src/sudoku-cell.vala"
	_tmp11_ = self->priv->value_label;
#line 72 "../src/sudoku-cell.vala"
	_tmp12_ = g_strdup_printf ("%i", value);
#line 72 "../src/sudoku-cell.vala"
	_tmp13_ = _tmp12_;
#line 72 "../src/sudoku-cell.vala"
	gtk_label_set_label (_tmp11_, _tmp13_);
#line 72 "../src/sudoku-cell.vala"
	_g_free0 (_tmp13_);
#line 74 "../src/sudoku-cell.vala"
	_tmp14_ = self->priv->game;
#line 74 "../src/sudoku-cell.vala"
	sudoku_game_insert (_tmp14_, self->priv->row, self->priv->col, value);
#line 49 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_VALUE_PROPERTY]);
#line 2806 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_is_fixed (SudokuCell* self)
{
	gboolean result;
	SudokuGame* _tmp0_;
	SudokuBoard* _tmp1_;
	gboolean* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gboolean _tmp3_;
#line 80 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 80 "../src/sudoku-cell.vala"
	_tmp0_ = self->priv->game;
#line 80 "../src/sudoku-cell.vala"
	_tmp1_ = _tmp0_->board;
#line 80 "../src/sudoku-cell.vala"
	_tmp2_ = _tmp1_->is_fixed;
#line 80 "../src/sudoku-cell.vala"
	_tmp2__length1 = _tmp1_->is_fixed_length1;
#line 80 "../src/sudoku-cell.vala"
	_tmp2__length2 = _tmp1_->is_fixed_length2;
#line 80 "../src/sudoku-cell.vala"
	_tmp3_ = _tmp2_[(self->priv->row * _tmp2__length2) + self->priv->col];
#line 80 "../src/sudoku-cell.vala"
	result = _tmp3_;
#line 80 "../src/sudoku-cell.vala"
	return result;
#line 2837 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_selected (SudokuCell* self)
{
	gboolean result;
#line 85 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 85 "../src/sudoku-cell.vala"
	result = self->priv->_selected;
#line 85 "../src/sudoku-cell.vala"
	return result;
#line 2850 "sudoku-cell.c"
}

void
sudoku_cell_set_selected (SudokuCell* self,
                          gboolean value)
{
#line 86 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 88 "../src/sudoku-cell.vala"
	self->priv->_selected = value;
#line 89 "../src/sudoku-cell.vala"
	if (value) {
#line 90 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "selected");
#line 2865 "sudoku-cell.c"
	} else {
#line 92 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "selected");
#line 2869 "sudoku-cell.c"
	}
#line 86 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_SELECTED_PROPERTY]);
#line 2873 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_highlighted_background (SudokuCell* self)
{
	gboolean result;
#line 98 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 98 "../src/sudoku-cell.vala"
	result = self->priv->_highlighted_background;
#line 98 "../src/sudoku-cell.vala"
	return result;
#line 2886 "sudoku-cell.c"
}

void
sudoku_cell_set_highlighted_background (SudokuCell* self,
                                        gboolean value)
{
#line 99 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 101 "../src/sudoku-cell.vala"
	self->priv->_highlighted_background = value;
#line 102 "../src/sudoku-cell.vala"
	if (value) {
#line 103 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "highlight-bg");
#line 2901 "sudoku-cell.c"
	} else {
#line 105 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "highlight-bg");
#line 2905 "sudoku-cell.c"
	}
#line 99 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY]);
#line 2909 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_highlighted_value (SudokuCell* self)
{
	gboolean result;
#line 111 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 111 "../src/sudoku-cell.vala"
	result = self->priv->_highlighted_value;
#line 111 "../src/sudoku-cell.vala"
	return result;
#line 2922 "sudoku-cell.c"
}

void
sudoku_cell_set_highlighted_value (SudokuCell* self,
                                   gboolean value)
{
	gboolean _tmp0_ = FALSE;
#line 112 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/sudoku-cell.vala"
	self->priv->_highlighted_value = value;
#line 115 "../src/sudoku-cell.vala"
	if (value) {
#line 115 "../src/sudoku-cell.vala"
		_tmp0_ = !gtk_widget_has_css_class ((GtkWidget*) self, "error");
#line 2938 "sudoku-cell.c"
	} else {
#line 115 "../src/sudoku-cell.vala"
		_tmp0_ = FALSE;
#line 2942 "sudoku-cell.c"
	}
#line 115 "../src/sudoku-cell.vala"
	if (_tmp0_) {
#line 116 "../src/sudoku-cell.vala"
		gtk_widget_add_css_class ((GtkWidget*) self, "highlight-label");
#line 2948 "sudoku-cell.c"
	} else {
#line 118 "../src/sudoku-cell.vala"
		gtk_widget_remove_css_class ((GtkWidget*) self, "highlight-label");
#line 2952 "sudoku-cell.c"
	}
#line 112 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY]);
#line 2956 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_show_warnings (SudokuCell* self)
{
	gboolean result;
#line 125 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 125 "../src/sudoku-cell.vala"
	result = self->priv->_show_warnings;
#line 125 "../src/sudoku-cell.vala"
	return result;
#line 2969 "sudoku-cell.c"
}

void
sudoku_cell_set_show_warnings (SudokuCell* self,
                               gboolean value)
{
#line 126 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/sudoku-cell.vala"
	self->priv->_show_warnings = value;
#line 129 "../src/sudoku-cell.vala"
	sudoku_cell_check_warnings (self);
#line 126 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_SHOW_WARNINGS_PROPERTY]);
#line 2984 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_show_extra_warnings (SudokuCell* self)
{
	gboolean result;
#line 136 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 136 "../src/sudoku-cell.vala"
	result = self->priv->_show_extra_warnings;
#line 136 "../src/sudoku-cell.vala"
	return result;
#line 2997 "sudoku-cell.c"
}

void
sudoku_cell_set_show_extra_warnings (SudokuCell* self,
                                     gboolean value)
{
#line 137 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 139 "../src/sudoku-cell.vala"
	self->priv->_show_extra_warnings = value;
#line 140 "../src/sudoku-cell.vala"
	sudoku_cell_check_warnings (self);
#line 137 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY]);
#line 3012 "sudoku-cell.c"
}

gboolean
sudoku_cell_get_initialize_earmarks (SudokuCell* self)
{
	gboolean result;
#line 151 "../src/sudoku-cell.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 151 "../src/sudoku-cell.vala"
	result = self->priv->_initialize_earmarks;
#line 151 "../src/sudoku-cell.vala"
	return result;
#line 3025 "sudoku-cell.c"
}

void
sudoku_cell_set_initialize_earmarks (SudokuCell* self,
                                     gboolean value)
{
#line 152 "../src/sudoku-cell.vala"
	g_return_if_fail (self != NULL);
#line 154 "../src/sudoku-cell.vala"
	self->priv->_initialize_earmarks = value;
#line 155 "../src/sudoku-cell.vala"
	sudoku_cell_get_visible_earmarks (self);
#line 152 "../src/sudoku-cell.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_cell_properties[SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY]);
#line 3040 "sudoku-cell.c"
}

static void
sudoku_cell_class_init (SudokuCellClass * klass,
                        gpointer klass_data)
{
#line 24 "../src/sudoku-cell.vala"
	sudoku_cell_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/sudoku-cell.vala"
	g_type_class_adjust_private_offset (klass, &SudokuCell_private_offset);
#line 24 "../src/sudoku-cell.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) sudoku_cell_real_dispose;
#line 24 "../src/sudoku-cell.vala"
	((GtkWidgetClass *) klass)->size_allocate = (void (*) (GtkWidget*, gint, gint, gint)) sudoku_cell_real_size_allocate;
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_cell_get_property;
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_cell_set_property;
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_cell_finalize;
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_VALUE_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_VALUE_PROPERTY] = g_param_spec_int ("value", "value", "value", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_IS_FIXED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_IS_FIXED_PROPERTY] = g_param_spec_boolean ("is-fixed", "is-fixed", "is-fixed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_SELECTED_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY] = g_param_spec_boolean ("highlighted-background", "highlighted-background", "highlighted-background", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY] = g_param_spec_boolean ("highlighted-value", "highlighted-value", "highlighted-value", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_SHOW_WARNINGS_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-extra-warnings", "show-extra-warnings", "show-extra-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/sudoku-cell.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY, sudoku_cell_properties[SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY] = g_param_spec_boolean ("initialize-earmarks", "initialize-earmarks", "initialize-earmarks", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 223 "../src/sudoku-cell.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "sudokucell");
#line 3079 "sudoku-cell.c"
}

static void
sudoku_cell_instance_init (SudokuCell * self,
                           gpointer klass)
{
	GtkGestureClick* _tmp0_;
	GtkGestureLongPress* _tmp1_;
	GtkEventControllerKey* _tmp2_;
	GtkPopover* _tmp3_;
	GtkLabel* _tmp4_ = NULL;
	GtkLabel** _tmp5_;
#line 24 "../src/sudoku-cell.vala"
	self->priv = sudoku_cell_get_instance_private (self);
#line 33 "../src/sudoku-cell.vala"
	_tmp0_ = (GtkGestureClick*) gtk_gesture_click_new ();
#line 33 "../src/sudoku-cell.vala"
	self->priv->button_controller = _tmp0_;
#line 34 "../src/sudoku-cell.vala"
	_tmp1_ = (GtkGestureLongPress*) gtk_gesture_long_press_new ();
#line 34 "../src/sudoku-cell.vala"
	self->priv->long_press_controller = _tmp1_;
#line 35 "../src/sudoku-cell.vala"
	_tmp2_ = (GtkEventControllerKey*) gtk_event_controller_key_new ();
#line 35 "../src/sudoku-cell.vala"
	self->priv->key_controller = _tmp2_;
#line 37 "../src/sudoku-cell.vala"
	_tmp3_ = (GtkPopover*) gtk_popover_new ();
#line 37 "../src/sudoku-cell.vala"
	g_object_ref_sink (_tmp3_);
#line 37 "../src/sudoku-cell.vala"
	self->popover = _tmp3_;
#line 41 "../src/sudoku-cell.vala"
	_tmp4_ = (GtkLabel*) gtk_label_new ("");
#line 41 "../src/sudoku-cell.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp4_, FALSE);
#line 41 "../src/sudoku-cell.vala"
	g_object_ref_sink (_tmp4_);
#line 41 "../src/sudoku-cell.vala"
	self->priv->value_label = _tmp4_;
#line 44 "../src/sudoku-cell.vala"
	_tmp5_ = g_new0 (GtkLabel*, 8 + 1);
#line 44 "../src/sudoku-cell.vala"
	self->priv->earmark_labels = _tmp5_;
#line 44 "../src/sudoku-cell.vala"
	self->priv->earmark_labels_length1 = 8;
#line 44 "../src/sudoku-cell.vala"
	self->priv->_earmark_labels_size_ = self->priv->earmark_labels_length1;
#line 83 "../src/sudoku-cell.vala"
	self->priv->_selected = FALSE;
#line 96 "../src/sudoku-cell.vala"
	self->priv->_highlighted_background = FALSE;
#line 109 "../src/sudoku-cell.vala"
	self->priv->_highlighted_value = FALSE;
#line 122 "../src/sudoku-cell.vala"
	self->priv->_show_warnings = TRUE;
#line 133 "../src/sudoku-cell.vala"
	self->priv->_show_extra_warnings = FALSE;
#line 3138 "sudoku-cell.c"
}

static void
sudoku_cell_finalize (GObject * obj)
{
	SudokuCell * self;
#line 24 "../src/sudoku-cell.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_CELL, SudokuCell);
#line 30 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->game);
#line 33 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->button_controller);
#line 34 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->long_press_controller);
#line 35 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->key_controller);
#line 37 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->popover);
#line 41 "../src/sudoku-cell.vala"
	_g_object_unref0 (self->priv->value_label);
#line 44 "../src/sudoku-cell.vala"
	self->priv->earmark_labels = (_vala_array_free (self->priv->earmark_labels, self->priv->earmark_labels_length1, (GDestroyNotify) g_object_unref), NULL);
#line 24 "../src/sudoku-cell.vala"
	G_OBJECT_CLASS (sudoku_cell_parent_class)->finalize (obj);
#line 3163 "sudoku-cell.c"
}

static GType
sudoku_cell_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuCellClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_cell_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuCell), 0, (GInstanceInitFunc) sudoku_cell_instance_init, NULL };
	GType sudoku_cell_type_id;
	sudoku_cell_type_id = g_type_register_static (gtk_widget_get_type (), "SudokuCell", &g_define_type_info, 0);
	SudokuCell_private_offset = g_type_add_instance_private (sudoku_cell_type_id, sizeof (SudokuCellPrivate));
	return sudoku_cell_type_id;
}

GType
sudoku_cell_get_type (void)
{
	static volatile gsize sudoku_cell_type_id__once = 0;
	if (g_once_init_enter (&sudoku_cell_type_id__once)) {
		GType sudoku_cell_type_id;
		sudoku_cell_type_id = sudoku_cell_get_type_once ();
		g_once_init_leave (&sudoku_cell_type_id__once, sudoku_cell_type_id);
	}
	return sudoku_cell_type_id__once;
}

static void
_vala_sudoku_cell_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL, SudokuCell);
#line 24 "../src/sudoku-cell.vala"
	switch (property_id) {
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_int (value, sudoku_cell_get_value (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_IS_FIXED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_is_fixed (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SELECTED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_selected (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_highlighted_background (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_highlighted_value (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SHOW_WARNINGS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_show_warnings (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_show_extra_warnings (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		g_value_set_boolean (value, sudoku_cell_get_initialize_earmarks (self));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 3246 "sudoku-cell.c"
		default:
#line 24 "../src/sudoku-cell.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/sudoku-cell.vala"
		break;
#line 3252 "sudoku-cell.c"
	}
}

static void
_vala_sudoku_cell_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuCell * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_CELL, SudokuCell);
#line 24 "../src/sudoku-cell.vala"
	switch (property_id) {
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_value (self, g_value_get_int (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SELECTED_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_selected (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_BACKGROUND_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_highlighted_background (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_HIGHLIGHTED_VALUE_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_highlighted_value (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SHOW_WARNINGS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_show_warnings (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_show_extra_warnings (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 24 "../src/sudoku-cell.vala"
		case SUDOKU_CELL_INITIALIZE_EARMARKS_PROPERTY:
#line 24 "../src/sudoku-cell.vala"
		sudoku_cell_set_initialize_earmarks (self, g_value_get_boolean (value));
#line 24 "../src/sudoku-cell.vala"
		break;
#line 3308 "sudoku-cell.c"
		default:
#line 24 "../src/sudoku-cell.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/sudoku-cell.vala"
		break;
#line 3314 "sudoku-cell.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

