/* sudoku-view.c generated by valac 0.56.13, the Vala compiler
 * generated from sudoku-view.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 * Copyright © 2023 Jamie Murphy <jmurphy@gnome.org>
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include <adwaita.h>
#include <glib-object.h>
#include "libsudoku.h"
#include <glib.h>
#include <gtk/gtk.h>
#include <pango/pango.h>
#include <gdk/gdk.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_SUDOKU_VIEW (sudoku_view_get_type ())
#define SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_VIEW, SudokuView))
#define SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_VIEW, SudokuViewClass))
#define IS_SUDOKU_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_VIEW))
#define IS_SUDOKU_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_VIEW))
#define SUDOKU_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_VIEW, SudokuViewClass))

typedef struct _SudokuView SudokuView;
typedef struct _SudokuViewClass SudokuViewClass;
typedef struct _SudokuViewPrivate SudokuViewPrivate;

#define TYPE_SUDOKU_CELL (sudoku_cell_get_type ())
#define SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_CELL, SudokuCell))
#define SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_CELL, SudokuCellClass))
#define IS_SUDOKU_CELL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_CELL))
#define IS_SUDOKU_CELL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_CELL))
#define SUDOKU_CELL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_CELL, SudokuCellClass))

typedef struct _SudokuCell SudokuCell;
typedef struct _SudokuCellClass SudokuCellClass;
enum  {
	SUDOKU_VIEW_0_PROPERTY,
	SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY,
	SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY,
	SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY,
	SUDOKU_VIEW_HIGHLIGHTER_PROPERTY,
	SUDOKU_VIEW_NUM_PROPERTIES
};
static GParamSpec* sudoku_view_properties[SUDOKU_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block11Data Block11Data;

#define TYPE_SUDOKU_FRAME (sudoku_frame_get_type ())
#define SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SUDOKU_FRAME, SudokuFrame))
#define SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SUDOKU_FRAME, SudokuFrameClass))
#define IS_SUDOKU_FRAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SUDOKU_FRAME))
#define IS_SUDOKU_FRAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SUDOKU_FRAME))
#define SUDOKU_FRAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SUDOKU_FRAME, SudokuFrameClass))

typedef struct _SudokuFrame SudokuFrame;
typedef struct _SudokuFrameClass SudokuFrameClass;
#define _pango_attr_list_unref0(var) ((var == NULL) ? NULL : (var = (pango_attr_list_unref (var), NULL)))
typedef struct _Block12Data Block12Data;
typedef struct _SudokuCellPrivate SudokuCellPrivate;

struct _SudokuView {
	AdwBin parent_instance;
	SudokuViewPrivate * priv;
	SudokuGame* game;
	gint selected_row;
	gint selected_col;
};

struct _SudokuViewClass {
	AdwBinClass parent_class;
};

struct _SudokuViewPrivate {
	SudokuCell** cells;
	gint cells_length1;
	gint cells_length2;
	GtkLabel* paused;
	gboolean previous_board_broken_state;
	GtkOverlay* overlay;
	GtkGrid* grid;
	gboolean _show_warnings;
	gboolean _show_extra_warnings;
	gboolean _show_possibilities;
	gboolean _initialize_earmarks;
	gboolean _highlighter;
};

struct _Block11Data {
	int _ref_count_;
	SudokuView* self;
	SudokuGame* game;
};

struct _Block12Data {
	int _ref_count_;
	Block11Data * _data11_;
	SudokuCell* cell;
	gint cell_row;
	gint cell_col;
};

struct _SudokuCell {
	GtkWidget parent_instance;
	SudokuCellPrivate * priv;
	GtkPopover* popover;
	gboolean show_possibilities;
};

struct _SudokuCellClass {
	GtkWidgetClass parent_class;
};

static gint SudokuView_private_offset;
static gpointer sudoku_view_parent_class = NULL;

VALA_EXTERN GType sudoku_view_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuView, g_object_unref)
VALA_EXTERN GType sudoku_cell_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuCell, g_object_unref)
static void sudoku_view_set_selected (SudokuView* self,
                               gint cell_row,
                               gint cell_col);
VALA_EXTERN void sudoku_cell_set_selected (SudokuCell* self,
                               gboolean value);
VALA_EXTERN SudokuView* sudoku_view_new (gint frame_size,
                             SudokuGame* game);
VALA_EXTERN SudokuView* sudoku_view_construct (GType object_type,
                                   gint frame_size,
                                   SudokuGame* game);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
VALA_EXTERN GType sudoku_frame_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SudokuFrame, g_object_unref)
VALA_EXTERN SudokuFrame* sudoku_frame_new (GtkWidget* child);
VALA_EXTERN SudokuFrame* sudoku_frame_construct (GType object_type,
                                     GtkWidget* child);
static void __lambda10_ (SudokuView* self);
static void ___lambda10__sudoku_game_paused_changed (SudokuGame* _sender,
                                              gpointer self);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
VALA_EXTERN SudokuCell* sudoku_cell_new (gint row,
                             gint col,
                             SudokuGame** game);
VALA_EXTERN SudokuCell* sudoku_cell_construct (GType object_type,
                                   gint row,
                                   gint col,
                                   SudokuGame** game);
static void ________lambda11_ (Block12Data* _data12_);
static void sudoku_view_update_highlights (SudokuView* self);
VALA_EXTERN void sudoku_cell_check_warnings (SudokuCell* self);
static void _________lambda11__g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self);
static void ________lambda12_ (Block12Data* _data12_,
                        GObject* s,
                        GParamSpec* p);
static void _________lambda12__g_object_notify (GObject* _sender,
                                         GParamSpec* pspec,
                                         gpointer self);
VALA_EXTERN gint sudoku_cell_get_value (SudokuCell* self);
VALA_EXTERN void sudoku_cell_set_highlighted_background (SudokuCell* self,
                                             gboolean value);
VALA_EXTERN void sudoku_cell_set_highlighted_value (SudokuCell* self,
                                        gboolean value);
VALA_EXTERN void sudoku_view_clear (SudokuView* self);
VALA_EXTERN void sudoku_view_redraw (SudokuView* self);
VALA_EXTERN gboolean sudoku_view_get_show_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_warnings (SudokuView* self,
                                    gboolean value);
VALA_EXTERN void sudoku_cell_set_show_warnings (SudokuCell* self,
                                    gboolean value);
VALA_EXTERN gboolean sudoku_view_get_show_extra_warnings (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_extra_warnings (SudokuView* self,
                                          gboolean value);
VALA_EXTERN void sudoku_cell_set_show_extra_warnings (SudokuCell* self,
                                          gboolean value);
VALA_EXTERN gboolean sudoku_view_get_show_possibilities (SudokuView* self);
VALA_EXTERN void sudoku_view_set_show_possibilities (SudokuView* self,
                                         gboolean value);
VALA_EXTERN gboolean sudoku_view_get_initialize_earmarks (SudokuView* self);
VALA_EXTERN void sudoku_view_set_initialize_earmarks (SudokuView* self,
                                          gboolean value);
VALA_EXTERN void sudoku_cell_set_initialize_earmarks (SudokuCell* self,
                                          gboolean value);
VALA_EXTERN gboolean sudoku_view_get_highlighter (SudokuView* self);
VALA_EXTERN void sudoku_view_set_highlighter (SudokuView* self,
                                  gboolean value);
static gboolean _sudoku_view___lambda13_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda13__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda14_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda14__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda15_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda15__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static gboolean _sudoku_view___lambda16_ (GtkWidget* _self_);
static gboolean __sudoku_view___lambda16__gtk_shortcut_func (GtkWidget* widget,
                                                      GVariant* args,
                                                      gpointer self);
static void sudoku_view_finalize (GObject * obj);
static GType sudoku_view_get_type_once (void);
static void _vala_sudoku_view_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_sudoku_view_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
sudoku_view_get_instance_private (SudokuView* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuView_private_offset);
}

static void
sudoku_view_set_selected (SudokuView* self,
                          gint cell_row,
                          gint cell_col)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp3_ = FALSE;
#line 39 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/sudoku-view.vala"
	if (self->selected_row >= 0) {
#line 41 "../src/sudoku-view.vala"
		_tmp0_ = self->selected_col >= 0;
#line 271 "sudoku-view.c"
	} else {
#line 41 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 275 "sudoku-view.c"
	}
#line 41 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 279 "sudoku-view.c"
		SudokuCell** _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		SudokuCell* _tmp2_;
#line 43 "../src/sudoku-view.vala"
		_tmp1_ = self->priv->cells;
#line 43 "../src/sudoku-view.vala"
		_tmp1__length1 = self->priv->cells_length1;
#line 43 "../src/sudoku-view.vala"
		_tmp1__length2 = self->priv->cells_length2;
#line 43 "../src/sudoku-view.vala"
		_tmp2_ = _tmp1_[(self->selected_row * _tmp1__length2) + self->selected_col];
#line 43 "../src/sudoku-view.vala"
		sudoku_cell_set_selected (_tmp2_, FALSE);
#line 294 "sudoku-view.c"
	}
#line 45 "../src/sudoku-view.vala"
	self->selected_row = cell_row;
#line 46 "../src/sudoku-view.vala"
	self->selected_col = cell_col;
#line 47 "../src/sudoku-view.vala"
	if (self->selected_row >= 0) {
#line 47 "../src/sudoku-view.vala"
		_tmp3_ = self->selected_col >= 0;
#line 304 "sudoku-view.c"
	} else {
#line 47 "../src/sudoku-view.vala"
		_tmp3_ = FALSE;
#line 308 "sudoku-view.c"
	}
#line 47 "../src/sudoku-view.vala"
	if (_tmp3_) {
#line 312 "sudoku-view.c"
		SudokuCell** _tmp4_;
		gint _tmp4__length1;
		gint _tmp4__length2;
		SudokuCell* _tmp5_;
#line 49 "../src/sudoku-view.vala"
		_tmp4_ = self->priv->cells;
#line 49 "../src/sudoku-view.vala"
		_tmp4__length1 = self->priv->cells_length1;
#line 49 "../src/sudoku-view.vala"
		_tmp4__length2 = self->priv->cells_length2;
#line 49 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_[(self->selected_row * _tmp4__length2) + self->selected_col];
#line 49 "../src/sudoku-view.vala"
		sudoku_cell_set_selected (_tmp5_, TRUE);
#line 327 "sudoku-view.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 53 "../src/sudoku-view.vala"
	return self ? g_object_ref (self) : NULL;
#line 336 "sudoku-view.c"
}

static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 53 "../src/sudoku-view.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 53 "../src/sudoku-view.vala"
	return _data11_;
#line 346 "sudoku-view.c"
}

static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 53 "../src/sudoku-view.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 356 "sudoku-view.c"
		SudokuView* self;
#line 53 "../src/sudoku-view.vala"
		self = _data11_->self;
#line 53 "../src/sudoku-view.vala"
		_g_object_unref0 (_data11_->game);
#line 53 "../src/sudoku-view.vala"
		_g_object_unref0 (self);
#line 53 "../src/sudoku-view.vala"
		g_slice_free (Block11Data, _data11_);
#line 366 "sudoku-view.c"
	}
}

static gpointer
_pango_attr_list_ref0 (gpointer self)
{
#line 73 "../src/sudoku-view.vala"
	return self ? pango_attr_list_ref (self) : NULL;
#line 375 "sudoku-view.c"
}

static void
__lambda10_ (SudokuView* self)
{
	PangoAttrList* attr_list = NULL;
	GtkLabel* _tmp0_;
	PangoAttrList* _tmp1_;
	PangoAttrList* _tmp2_;
	PangoAttrList* _tmp3_;
	PangoAttrList* _tmp5_;
	PangoAttribute* _tmp6_;
	GtkLabel* _tmp7_;
	PangoAttrList* _tmp8_;
	SudokuGame* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
#line 73 "../src/sudoku-view.vala"
	_tmp0_ = self->priv->paused;
#line 73 "../src/sudoku-view.vala"
	_tmp1_ = gtk_label_get_attributes (_tmp0_);
#line 73 "../src/sudoku-view.vala"
	_tmp2_ = _pango_attr_list_ref0 (_tmp1_);
#line 73 "../src/sudoku-view.vala"
	attr_list = _tmp2_;
#line 74 "../src/sudoku-view.vala"
	_tmp3_ = attr_list;
#line 74 "../src/sudoku-view.vala"
	if (_tmp3_ == NULL) {
#line 405 "sudoku-view.c"
		PangoAttrList* _tmp4_;
#line 75 "../src/sudoku-view.vala"
		_tmp4_ = pango_attr_list_new ();
#line 75 "../src/sudoku-view.vala"
		_pango_attr_list_unref0 (attr_list);
#line 75 "../src/sudoku-view.vala"
		attr_list = _tmp4_;
#line 413 "sudoku-view.c"
	}
#line 77 "../src/sudoku-view.vala"
	_tmp5_ = attr_list;
#line 77 "../src/sudoku-view.vala"
	_tmp6_ = pango_attr_size_new_absolute (((gint) (gtk_widget_get_allocated_width ((GtkWidget*) self) * 0.125)) * PANGO_SCALE);
#line 77 "../src/sudoku-view.vala"
	pango_attr_list_change (_tmp5_, _tmp6_);
#line 81 "../src/sudoku-view.vala"
	_tmp7_ = self->priv->paused;
#line 81 "../src/sudoku-view.vala"
	_tmp8_ = attr_list;
#line 81 "../src/sudoku-view.vala"
	gtk_label_set_attributes (_tmp7_, _tmp8_);
#line 83 "../src/sudoku-view.vala"
	_tmp9_ = self->game;
#line 83 "../src/sudoku-view.vala"
	_tmp10_ = sudoku_game_get_paused (_tmp9_);
#line 83 "../src/sudoku-view.vala"
	_tmp11_ = _tmp10_;
#line 83 "../src/sudoku-view.vala"
	if (_tmp11_) {
#line 435 "sudoku-view.c"
		GtkLabel* _tmp12_;
#line 84 "../src/sudoku-view.vala"
		_tmp12_ = self->priv->paused;
#line 84 "../src/sudoku-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp12_, TRUE);
#line 441 "sudoku-view.c"
	} else {
		GtkLabel* _tmp13_;
#line 86 "../src/sudoku-view.vala"
		_tmp13_ = self->priv->paused;
#line 86 "../src/sudoku-view.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp13_, FALSE);
#line 448 "sudoku-view.c"
	}
#line 71 "../src/sudoku-view.vala"
	_pango_attr_list_unref0 (attr_list);
#line 452 "sudoku-view.c"
}

static void
___lambda10__sudoku_game_paused_changed (SudokuGame* _sender,
                                         gpointer self)
{
#line 71 "../src/sudoku-view.vala"
	__lambda10_ ((SudokuView*) self);
#line 461 "sudoku-view.c"
}

static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 119 "../src/sudoku-view.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 119 "../src/sudoku-view.vala"
	return _data12_;
#line 471 "sudoku-view.c"
}

static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 119 "../src/sudoku-view.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 481 "sudoku-view.c"
		SudokuView* self;
#line 119 "../src/sudoku-view.vala"
		self = _data12_->_data11_->self;
#line 119 "../src/sudoku-view.vala"
		_g_object_unref0 (_data12_->cell);
#line 119 "../src/sudoku-view.vala"
		block11_data_unref (_data12_->_data11_);
#line 119 "../src/sudoku-view.vala"
		_data12_->_data11_ = NULL;
#line 119 "../src/sudoku-view.vala"
		g_slice_free (Block12Data, _data12_);
#line 493 "sudoku-view.c"
	}
}

static void
________lambda11_ (Block12Data* _data12_)
{
	Block11Data* _data11_;
	SudokuView* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_ = FALSE;
	SudokuCell* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	SudokuCell* _tmp10_;
#line 125 "../src/sudoku-view.vala"
	_data11_ = _data12_->_data11_;
#line 125 "../src/sudoku-view.vala"
	self = _data11_->self;
#line 126 "../src/sudoku-view.vala"
	_tmp0_ = sudoku_game_get_paused (_data11_->game);
#line 126 "../src/sudoku-view.vala"
	_tmp1_ = _tmp0_;
#line 126 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 127 "../src/sudoku-view.vala"
		return;
#line 521 "sudoku-view.c"
	}
#line 131 "../src/sudoku-view.vala"
	_tmp3_ = _data12_->cell;
#line 131 "../src/sudoku-view.vala"
	g_object_get ((GtkWidget*) _tmp3_, "has-focus", &_tmp4_, NULL);
#line 131 "../src/sudoku-view.vala"
	_tmp5_ = _tmp4_;
#line 131 "../src/sudoku-view.vala"
	if (_tmp5_) {
#line 131 "../src/sudoku-view.vala"
		_tmp2_ = TRUE;
#line 533 "sudoku-view.c"
	} else {
		SudokuCell* _tmp6_;
		GtkPopover* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 131 "../src/sudoku-view.vala"
		_tmp6_ = _data12_->cell;
#line 131 "../src/sudoku-view.vala"
		_tmp7_ = _tmp6_->popover;
#line 131 "../src/sudoku-view.vala"
		_tmp8_ = gtk_widget_get_visible ((GtkWidget*) _tmp7_);
#line 131 "../src/sudoku-view.vala"
		_tmp9_ = _tmp8_;
#line 131 "../src/sudoku-view.vala"
		_tmp2_ = _tmp9_;
#line 549 "sudoku-view.c"
	}
#line 131 "../src/sudoku-view.vala"
	if (_tmp2_) {
#line 132 "../src/sudoku-view.vala"
		sudoku_view_set_selected (self, _data12_->cell_row, _data12_->cell_col);
#line 555 "sudoku-view.c"
	} else {
#line 134 "../src/sudoku-view.vala"
		sudoku_view_set_selected (self, -1, -1);
#line 559 "sudoku-view.c"
	}
#line 136 "../src/sudoku-view.vala"
	sudoku_view_update_highlights (self);
#line 137 "../src/sudoku-view.vala"
	_tmp10_ = _data12_->cell;
#line 137 "../src/sudoku-view.vala"
	sudoku_cell_check_warnings (_tmp10_);
#line 567 "sudoku-view.c"
}

static void
_________lambda11__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self)
{
#line 125 "../src/sudoku-view.vala"
	________lambda11_ (self);
#line 577 "sudoku-view.c"
}

static void
________lambda12_ (Block12Data* _data12_,
                   GObject* s,
                   GParamSpec* p)
{
	Block11Data* _data11_;
	SudokuView* self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	SudokuCell* _tmp9_;
#line 140 "../src/sudoku-view.vala"
	_data11_ = _data12_->_data11_;
#line 140 "../src/sudoku-view.vala"
	self = _data11_->self;
#line 140 "../src/sudoku-view.vala"
	g_return_if_fail (s != NULL);
#line 140 "../src/sudoku-view.vala"
	g_return_if_fail (p != NULL);
#line 141 "../src/sudoku-view.vala"
	if (self->priv->_show_possibilities) {
#line 141 "../src/sudoku-view.vala"
		_tmp2_ = TRUE;
#line 603 "sudoku-view.c"
	} else {
#line 141 "../src/sudoku-view.vala"
		_tmp2_ = self->priv->_show_warnings;
#line 607 "sudoku-view.c"
	}
#line 141 "../src/sudoku-view.vala"
	if (_tmp2_) {
#line 141 "../src/sudoku-view.vala"
		_tmp1_ = TRUE;
#line 613 "sudoku-view.c"
	} else {
		SudokuBoard* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 141 "../src/sudoku-view.vala"
		_tmp3_ = _data11_->game->board;
#line 141 "../src/sudoku-view.vala"
		_tmp4_ = sudoku_board_get_broken (_tmp3_);
#line 141 "../src/sudoku-view.vala"
		_tmp5_ = _tmp4_;
#line 141 "../src/sudoku-view.vala"
		_tmp1_ = _tmp5_;
#line 626 "sudoku-view.c"
	}
#line 141 "../src/sudoku-view.vala"
	if (_tmp1_) {
#line 141 "../src/sudoku-view.vala"
		_tmp0_ = TRUE;
#line 632 "sudoku-view.c"
	} else {
#line 141 "../src/sudoku-view.vala"
		_tmp0_ = self->priv->previous_board_broken_state;
#line 636 "sudoku-view.c"
	}
#line 141 "../src/sudoku-view.vala"
	if (_tmp0_) {
#line 640 "sudoku-view.c"
		SudokuBoard* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 142 "../src/sudoku-view.vala"
		_tmp6_ = _data11_->game->board;
#line 142 "../src/sudoku-view.vala"
		_tmp7_ = sudoku_board_get_broken (_tmp6_);
#line 142 "../src/sudoku-view.vala"
		_tmp8_ = _tmp7_;
#line 142 "../src/sudoku-view.vala"
		self->priv->previous_board_broken_state = _tmp8_;
#line 652 "sudoku-view.c"
	}
#line 144 "../src/sudoku-view.vala"
	sudoku_view_update_highlights (self);
#line 145 "../src/sudoku-view.vala"
	_tmp9_ = _data12_->cell;
#line 145 "../src/sudoku-view.vala"
	sudoku_cell_check_warnings (_tmp9_);
#line 660 "sudoku-view.c"
}

static void
_________lambda12__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self)
{
#line 140 "../src/sudoku-view.vala"
	________lambda12_ (self, _sender, pspec);
#line 670 "sudoku-view.c"
}

SudokuView*
sudoku_view_construct (GType object_type,
                       gint frame_size,
                       SudokuGame* game)
{
	SudokuView * self = NULL;
	Block11Data* _data11_;
	SudokuGame* _tmp0_;
	GtkOverlay* _tmp1_;
	SudokuFrame* frame = NULL;
	GtkOverlay* _tmp2_;
	SudokuFrame* _tmp3_;
	SudokuFrame* _tmp4_;
	GtkLabel* _tmp5_;
	GtkLabel* _tmp6_;
	GtkGrid* _tmp7_;
	SudokuGame* _tmp9_;
	SudokuGame* _tmp10_;
	GtkGrid* _tmp11_ = NULL;
	GtkGrid* _tmp12_;
	GtkGrid** blocks = NULL;
	SudokuBoard* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	SudokuBoard* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	GtkGrid** _tmp19_;
	gint blocks_length1;
	gint blocks_length2;
	SudokuBoard* _tmp41_;
	gint _tmp42_;
	gint _tmp43_;
	SudokuBoard* _tmp44_;
	gint _tmp45_;
	gint _tmp46_;
	SudokuCell** _tmp47_;
	GtkOverlay* _tmp79_;
	GtkLabel* _tmp80_;
	GtkOverlay* _tmp81_;
	GtkGrid* _tmp82_;
	GtkGrid* _tmp83_;
	GtkOverlay* _tmp84_;
	GtkLabel* _tmp85_;
#line 53 "../src/sudoku-view.vala"
	g_return_val_if_fail (game != NULL, NULL);
#line 53 "../src/sudoku-view.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 53 "../src/sudoku-view.vala"
	_data11_->_ref_count_ = 1;
#line 53 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (game);
#line 53 "../src/sudoku-view.vala"
	_g_object_unref0 (_data11_->game);
#line 53 "../src/sudoku-view.vala"
	_data11_->game = _tmp0_;
#line 53 "../src/sudoku-view.vala"
	self = (SudokuView*) g_object_new (object_type, NULL);
#line 53 "../src/sudoku-view.vala"
	_data11_->self = g_object_ref (self);
#line 55 "../src/sudoku-view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
#line 57 "../src/sudoku-view.vala"
	gtk_widget_set_focusable ((GtkWidget*) self, TRUE);
#line 58 "../src/sudoku-view.vala"
	gtk_widget_set_can_focus ((GtkWidget*) self, TRUE);
#line 60 "../src/sudoku-view.vala"
	_tmp1_ = (GtkOverlay*) gtk_overlay_new ();
#line 60 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp1_);
#line 60 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->overlay);
#line 60 "../src/sudoku-view.vala"
	self->priv->overlay = _tmp1_;
#line 61 "../src/sudoku-view.vala"
	_tmp2_ = self->priv->overlay;
#line 61 "../src/sudoku-view.vala"
	_tmp3_ = sudoku_frame_new ((GtkWidget*) _tmp2_);
#line 61 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp3_);
#line 61 "../src/sudoku-view.vala"
	frame = _tmp3_;
#line 62 "../src/sudoku-view.vala"
	_tmp4_ = frame;
#line 62 "../src/sudoku-view.vala"
	adw_bin_set_child ((AdwBin*) self, (GtkWidget*) _tmp4_);
#line 64 "../src/sudoku-view.vala"
	_tmp5_ = (GtkLabel*) gtk_label_new ("Paused");
#line 64 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp5_);
#line 64 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->paused);
#line 64 "../src/sudoku-view.vala"
	self->priv->paused = _tmp5_;
#line 65 "../src/sudoku-view.vala"
	_tmp6_ = self->priv->paused;
#line 65 "../src/sudoku-view.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp6_, "paused");
#line 67 "../src/sudoku-view.vala"
	_tmp7_ = self->priv->grid;
#line 67 "../src/sudoku-view.vala"
	if (_tmp7_ != NULL) {
#line 775 "sudoku-view.c"
		GtkOverlay* _tmp8_;
#line 68 "../src/sudoku-view.vala"
		_tmp8_ = self->priv->overlay;
#line 68 "../src/sudoku-view.vala"
		gtk_overlay_set_child (_tmp8_, NULL);
#line 781 "sudoku-view.c"
	}
#line 70 "../src/sudoku-view.vala"
	_tmp9_ = _g_object_ref0 (_data11_->game);
#line 70 "../src/sudoku-view.vala"
	_g_object_unref0 (self->game);
#line 70 "../src/sudoku-view.vala"
	self->game = _tmp9_;
#line 71 "../src/sudoku-view.vala"
	_tmp10_ = self->game;
#line 71 "../src/sudoku-view.vala"
	g_signal_connect_object (_tmp10_, "paused-changed", (GCallback) ___lambda10__sudoku_game_paused_changed, self, 0);
#line 89 "../src/sudoku-view.vala"
	_tmp11_ = (GtkGrid*) gtk_grid_new ();
#line 89 "../src/sudoku-view.vala"
	gtk_grid_set_row_spacing (_tmp11_, 2);
#line 89 "../src/sudoku-view.vala"
	gtk_grid_set_column_spacing (_tmp11_, 2);
#line 89 "../src/sudoku-view.vala"
	gtk_grid_set_column_homogeneous (_tmp11_, TRUE);
#line 89 "../src/sudoku-view.vala"
	gtk_grid_set_row_homogeneous (_tmp11_, TRUE);
#line 89 "../src/sudoku-view.vala"
	gtk_widget_set_vexpand ((GtkWidget*) _tmp11_, TRUE);
#line 89 "../src/sudoku-view.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp11_, TRUE);
#line 89 "../src/sudoku-view.vala"
	g_object_ref_sink (_tmp11_);
#line 89 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->grid);
#line 89 "../src/sudoku-view.vala"
	self->priv->grid = _tmp11_;
#line 97 "../src/sudoku-view.vala"
	_tmp12_ = self->priv->grid;
#line 97 "../src/sudoku-view.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp12_, "board");
#line 99 "../src/sudoku-view.vala"
	_tmp13_ = _data11_->game->board;
#line 99 "../src/sudoku-view.vala"
	_tmp14_ = sudoku_board_get_block_rows (_tmp13_);
#line 99 "../src/sudoku-view.vala"
	_tmp15_ = _tmp14_;
#line 99 "../src/sudoku-view.vala"
	_tmp16_ = _data11_->game->board;
#line 99 "../src/sudoku-view.vala"
	_tmp17_ = sudoku_board_get_block_cols (_tmp16_);
#line 99 "../src/sudoku-view.vala"
	_tmp18_ = _tmp17_;
#line 99 "../src/sudoku-view.vala"
	_tmp19_ = g_new0 (GtkGrid*, (_tmp15_ * _tmp18_) + 1);
#line 99 "../src/sudoku-view.vala"
	blocks = _tmp19_;
#line 99 "../src/sudoku-view.vala"
	blocks_length1 = _tmp15_;
#line 99 "../src/sudoku-view.vala"
	blocks_length2 = _tmp18_;
#line 837 "sudoku-view.c"
	{
		gint block_row = 0;
#line 100 "../src/sudoku-view.vala"
		block_row = 0;
#line 842 "sudoku-view.c"
		{
			gboolean _tmp20_ = FALSE;
#line 100 "../src/sudoku-view.vala"
			_tmp20_ = TRUE;
#line 100 "../src/sudoku-view.vala"
			while (TRUE) {
#line 849 "sudoku-view.c"
				SudokuBoard* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
#line 100 "../src/sudoku-view.vala"
				if (!_tmp20_) {
#line 855 "sudoku-view.c"
					gint _tmp21_;
#line 100 "../src/sudoku-view.vala"
					_tmp21_ = block_row;
#line 100 "../src/sudoku-view.vala"
					block_row = _tmp21_ + 1;
#line 861 "sudoku-view.c"
				}
#line 100 "../src/sudoku-view.vala"
				_tmp20_ = FALSE;
#line 100 "../src/sudoku-view.vala"
				_tmp22_ = _data11_->game->board;
#line 100 "../src/sudoku-view.vala"
				_tmp23_ = sudoku_board_get_block_rows (_tmp22_);
#line 100 "../src/sudoku-view.vala"
				_tmp24_ = _tmp23_;
#line 100 "../src/sudoku-view.vala"
				if (!(block_row < _tmp24_)) {
#line 100 "../src/sudoku-view.vala"
					break;
#line 875 "sudoku-view.c"
				}
				{
					gint block_col = 0;
#line 102 "../src/sudoku-view.vala"
					block_col = 0;
#line 881 "sudoku-view.c"
					{
						gboolean _tmp25_ = FALSE;
#line 102 "../src/sudoku-view.vala"
						_tmp25_ = TRUE;
#line 102 "../src/sudoku-view.vala"
						while (TRUE) {
#line 888 "sudoku-view.c"
							SudokuBoard* _tmp27_;
							gint _tmp28_;
							gint _tmp29_;
							GtkGrid* block_grid = NULL;
							GtkGrid* _tmp30_;
							GtkGrid* _tmp31_;
							GtkGrid* _tmp32_;
							GtkGrid* _tmp33_;
							GtkGrid* _tmp34_;
							GtkGrid* _tmp35_;
							GtkGrid* _tmp36_;
							GtkGrid* _tmp37_;
							GtkGrid** _tmp38_;
							gint _tmp38__length1;
							gint _tmp38__length2;
							GtkGrid* _tmp39_;
							GtkGrid* _tmp40_;
#line 102 "../src/sudoku-view.vala"
							if (!_tmp25_) {
#line 908 "sudoku-view.c"
								gint _tmp26_;
#line 102 "../src/sudoku-view.vala"
								_tmp26_ = block_col;
#line 102 "../src/sudoku-view.vala"
								block_col = _tmp26_ + 1;
#line 914 "sudoku-view.c"
							}
#line 102 "../src/sudoku-view.vala"
							_tmp25_ = FALSE;
#line 102 "../src/sudoku-view.vala"
							_tmp27_ = _data11_->game->board;
#line 102 "../src/sudoku-view.vala"
							_tmp28_ = sudoku_board_get_block_cols (_tmp27_);
#line 102 "../src/sudoku-view.vala"
							_tmp29_ = _tmp28_;
#line 102 "../src/sudoku-view.vala"
							if (!(block_col < _tmp29_)) {
#line 102 "../src/sudoku-view.vala"
								break;
#line 928 "sudoku-view.c"
							}
#line 104 "../src/sudoku-view.vala"
							_tmp30_ = (GtkGrid*) gtk_grid_new ();
#line 104 "../src/sudoku-view.vala"
							g_object_ref_sink (_tmp30_);
#line 104 "../src/sudoku-view.vala"
							block_grid = _tmp30_;
#line 105 "../src/sudoku-view.vala"
							_tmp31_ = block_grid;
#line 105 "../src/sudoku-view.vala"
							gtk_grid_set_row_spacing (_tmp31_, 1);
#line 106 "../src/sudoku-view.vala"
							_tmp32_ = block_grid;
#line 106 "../src/sudoku-view.vala"
							gtk_grid_set_column_spacing (_tmp32_, 1);
#line 107 "../src/sudoku-view.vala"
							_tmp33_ = block_grid;
#line 107 "../src/sudoku-view.vala"
							gtk_grid_set_column_homogeneous (_tmp33_, TRUE);
#line 108 "../src/sudoku-view.vala"
							_tmp34_ = block_grid;
#line 108 "../src/sudoku-view.vala"
							gtk_grid_set_row_homogeneous (_tmp34_, TRUE);
#line 109 "../src/sudoku-view.vala"
							_tmp35_ = block_grid;
#line 109 "../src/sudoku-view.vala"
							gtk_widget_add_css_class ((GtkWidget*) _tmp35_, "block");
#line 110 "../src/sudoku-view.vala"
							_tmp36_ = self->priv->grid;
#line 110 "../src/sudoku-view.vala"
							_tmp37_ = block_grid;
#line 110 "../src/sudoku-view.vala"
							gtk_grid_attach (_tmp36_, (GtkWidget*) _tmp37_, block_col, block_row, 1, 1);
#line 112 "../src/sudoku-view.vala"
							_tmp38_ = blocks;
#line 112 "../src/sudoku-view.vala"
							_tmp38__length1 = blocks_length1;
#line 112 "../src/sudoku-view.vala"
							_tmp38__length2 = blocks_length2;
#line 112 "../src/sudoku-view.vala"
							_tmp39_ = block_grid;
#line 112 "../src/sudoku-view.vala"
							_tmp40_ = _g_object_ref0 (_tmp39_);
#line 112 "../src/sudoku-view.vala"
							_g_object_unref0 (_tmp38_[(block_row * _tmp38__length2) + block_col]);
#line 112 "../src/sudoku-view.vala"
							_tmp38_[(block_row * _tmp38__length2) + block_col] = _tmp40_;
#line 102 "../src/sudoku-view.vala"
							_g_object_unref0 (block_grid);
#line 978 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 116 "../src/sudoku-view.vala"
	_tmp41_ = _data11_->game->board;
#line 116 "../src/sudoku-view.vala"
	_tmp42_ = sudoku_board_get_rows (_tmp41_);
#line 116 "../src/sudoku-view.vala"
	_tmp43_ = _tmp42_;
#line 116 "../src/sudoku-view.vala"
	_tmp44_ = _data11_->game->board;
#line 116 "../src/sudoku-view.vala"
	_tmp45_ = sudoku_board_get_cols (_tmp44_);
#line 116 "../src/sudoku-view.vala"
	_tmp46_ = _tmp45_;
#line 116 "../src/sudoku-view.vala"
	_tmp47_ = g_new0 (SudokuCell*, (_tmp43_ * _tmp46_) + 1);
#line 116 "../src/sudoku-view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 116 "../src/sudoku-view.vala"
	self->priv->cells = _tmp47_;
#line 116 "../src/sudoku-view.vala"
	self->priv->cells_length1 = _tmp43_;
#line 116 "../src/sudoku-view.vala"
	self->priv->cells_length2 = _tmp46_;
#line 1007 "sudoku-view.c"
	{
		gint row = 0;
#line 117 "../src/sudoku-view.vala"
		row = 0;
#line 1012 "sudoku-view.c"
		{
			gboolean _tmp48_ = FALSE;
#line 117 "../src/sudoku-view.vala"
			_tmp48_ = TRUE;
#line 117 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1019 "sudoku-view.c"
				SudokuBoard* _tmp50_;
				gint _tmp51_;
				gint _tmp52_;
#line 117 "../src/sudoku-view.vala"
				if (!_tmp48_) {
#line 1025 "sudoku-view.c"
					gint _tmp49_;
#line 117 "../src/sudoku-view.vala"
					_tmp49_ = row;
#line 117 "../src/sudoku-view.vala"
					row = _tmp49_ + 1;
#line 1031 "sudoku-view.c"
				}
#line 117 "../src/sudoku-view.vala"
				_tmp48_ = FALSE;
#line 117 "../src/sudoku-view.vala"
				_tmp50_ = _data11_->game->board;
#line 117 "../src/sudoku-view.vala"
				_tmp51_ = sudoku_board_get_rows (_tmp50_);
#line 117 "../src/sudoku-view.vala"
				_tmp52_ = _tmp51_;
#line 117 "../src/sudoku-view.vala"
				if (!(row < _tmp52_)) {
#line 117 "../src/sudoku-view.vala"
					break;
#line 1045 "sudoku-view.c"
				}
				{
					gint col = 0;
#line 119 "../src/sudoku-view.vala"
					col = 0;
#line 1051 "sudoku-view.c"
					{
						gboolean _tmp53_ = FALSE;
#line 119 "../src/sudoku-view.vala"
						_tmp53_ = TRUE;
#line 119 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1058 "sudoku-view.c"
							Block12Data* _data12_;
							SudokuBoard* _tmp55_;
							gint _tmp56_;
							gint _tmp57_;
							SudokuCell* _tmp58_;
							SudokuCell* _tmp59_;
							SudokuCell* _tmp60_;
							SudokuCell** _tmp61_;
							gint _tmp61__length1;
							gint _tmp61__length2;
							SudokuCell* _tmp62_;
							SudokuCell* _tmp63_;
							GtkGrid** _tmp64_;
							gint _tmp64__length1;
							gint _tmp64__length2;
							SudokuBoard* _tmp65_;
							gint _tmp66_;
							gint _tmp67_;
							SudokuBoard* _tmp68_;
							gint _tmp69_;
							gint _tmp70_;
							GtkGrid* _tmp71_;
							SudokuCell* _tmp72_;
							SudokuBoard* _tmp73_;
							gint _tmp74_;
							gint _tmp75_;
							SudokuBoard* _tmp76_;
							gint _tmp77_;
							gint _tmp78_;
#line 119 "../src/sudoku-view.vala"
							_data12_ = g_slice_new0 (Block12Data);
#line 119 "../src/sudoku-view.vala"
							_data12_->_ref_count_ = 1;
#line 119 "../src/sudoku-view.vala"
							_data12_->_data11_ = block11_data_ref (_data11_);
#line 119 "../src/sudoku-view.vala"
							if (!_tmp53_) {
#line 1096 "sudoku-view.c"
								gint _tmp54_;
#line 119 "../src/sudoku-view.vala"
								_tmp54_ = col;
#line 119 "../src/sudoku-view.vala"
								col = _tmp54_ + 1;
#line 1102 "sudoku-view.c"
							}
#line 119 "../src/sudoku-view.vala"
							_tmp53_ = FALSE;
#line 119 "../src/sudoku-view.vala"
							_tmp55_ = _data11_->game->board;
#line 119 "../src/sudoku-view.vala"
							_tmp56_ = sudoku_board_get_cols (_tmp55_);
#line 119 "../src/sudoku-view.vala"
							_tmp57_ = _tmp56_;
#line 119 "../src/sudoku-view.vala"
							if (!(col < _tmp57_)) {
#line 119 "../src/sudoku-view.vala"
								block12_data_unref (_data12_);
#line 119 "../src/sudoku-view.vala"
								_data12_ = NULL;
#line 119 "../src/sudoku-view.vala"
								break;
#line 1120 "sudoku-view.c"
							}
#line 121 "../src/sudoku-view.vala"
							_tmp58_ = sudoku_cell_new (row, col, &self->game);
#line 121 "../src/sudoku-view.vala"
							g_object_ref_sink (_tmp58_);
#line 121 "../src/sudoku-view.vala"
							_data12_->cell = _tmp58_;
#line 122 "../src/sudoku-view.vala"
							_data12_->cell_row = row;
#line 123 "../src/sudoku-view.vala"
							_data12_->cell_col = col;
#line 125 "../src/sudoku-view.vala"
							_tmp59_ = _data12_->cell;
#line 125 "../src/sudoku-view.vala"
							g_signal_connect_data ((GObject*) _tmp59_, "notify::has-focus", (GCallback) _________lambda11__g_object_notify, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 140 "../src/sudoku-view.vala"
							_tmp60_ = _data12_->cell;
#line 140 "../src/sudoku-view.vala"
							g_signal_connect_data ((GObject*) _tmp60_, "notify::value", (GCallback) _________lambda12__g_object_notify, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 148 "../src/sudoku-view.vala"
							_tmp61_ = self->priv->cells;
#line 148 "../src/sudoku-view.vala"
							_tmp61__length1 = self->priv->cells_length1;
#line 148 "../src/sudoku-view.vala"
							_tmp61__length2 = self->priv->cells_length2;
#line 148 "../src/sudoku-view.vala"
							_tmp62_ = _data12_->cell;
#line 148 "../src/sudoku-view.vala"
							_tmp63_ = _g_object_ref0 (_tmp62_);
#line 148 "../src/sudoku-view.vala"
							_g_object_unref0 (_tmp61_[(row * _tmp61__length2) + col]);
#line 148 "../src/sudoku-view.vala"
							_tmp61_[(row * _tmp61__length2) + col] = _tmp63_;
#line 150 "../src/sudoku-view.vala"
							_tmp64_ = blocks;
#line 150 "../src/sudoku-view.vala"
							_tmp64__length1 = blocks_length1;
#line 150 "../src/sudoku-view.vala"
							_tmp64__length2 = blocks_length2;
#line 150 "../src/sudoku-view.vala"
							_tmp65_ = _data11_->game->board;
#line 150 "../src/sudoku-view.vala"
							_tmp66_ = sudoku_board_get_block_rows (_tmp65_);
#line 150 "../src/sudoku-view.vala"
							_tmp67_ = _tmp66_;
#line 150 "../src/sudoku-view.vala"
							_tmp68_ = _data11_->game->board;
#line 150 "../src/sudoku-view.vala"
							_tmp69_ = sudoku_board_get_block_cols (_tmp68_);
#line 150 "../src/sudoku-view.vala"
							_tmp70_ = _tmp69_;
#line 150 "../src/sudoku-view.vala"
							_tmp71_ = _tmp64_[((row / _tmp67_) * _tmp64__length2) + (col / _tmp70_)];
#line 150 "../src/sudoku-view.vala"
							_tmp72_ = _data12_->cell;
#line 150 "../src/sudoku-view.vala"
							_tmp73_ = _data11_->game->board;
#line 150 "../src/sudoku-view.vala"
							_tmp74_ = sudoku_board_get_block_cols (_tmp73_);
#line 150 "../src/sudoku-view.vala"
							_tmp75_ = _tmp74_;
#line 150 "../src/sudoku-view.vala"
							_tmp76_ = _data11_->game->board;
#line 150 "../src/sudoku-view.vala"
							_tmp77_ = sudoku_board_get_block_rows (_tmp76_);
#line 150 "../src/sudoku-view.vala"
							_tmp78_ = _tmp77_;
#line 150 "../src/sudoku-view.vala"
							gtk_grid_attach (_tmp71_, (GtkWidget*) _tmp72_, col % _tmp75_, row % _tmp78_, 1, 1);
#line 119 "../src/sudoku-view.vala"
							block12_data_unref (_data12_);
#line 119 "../src/sudoku-view.vala"
							_data12_ = NULL;
#line 1194 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 154 "../src/sudoku-view.vala"
	_tmp79_ = self->priv->overlay;
#line 154 "../src/sudoku-view.vala"
	_tmp80_ = self->priv->paused;
#line 154 "../src/sudoku-view.vala"
	gtk_overlay_add_overlay (_tmp79_, (GtkWidget*) _tmp80_);
#line 155 "../src/sudoku-view.vala"
	_tmp81_ = self->priv->overlay;
#line 155 "../src/sudoku-view.vala"
	_tmp82_ = self->priv->grid;
#line 155 "../src/sudoku-view.vala"
	gtk_overlay_set_child (_tmp81_, (GtkWidget*) _tmp82_);
#line 156 "../src/sudoku-view.vala"
	_tmp83_ = self->priv->grid;
#line 156 "../src/sudoku-view.vala"
	gtk_widget_show ((GtkWidget*) _tmp83_);
#line 157 "../src/sudoku-view.vala"
	_tmp84_ = self->priv->overlay;
#line 157 "../src/sudoku-view.vala"
	gtk_widget_show ((GtkWidget*) _tmp84_);
#line 158 "../src/sudoku-view.vala"
	_tmp85_ = self->priv->paused;
#line 158 "../src/sudoku-view.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp85_, FALSE);
#line 53 "../src/sudoku-view.vala"
	blocks = (_vala_array_free (blocks, blocks_length1 * blocks_length2, (GDestroyNotify) g_object_unref), NULL);
#line 53 "../src/sudoku-view.vala"
	_g_object_unref0 (frame);
#line 53 "../src/sudoku-view.vala"
	block11_data_unref (_data11_);
#line 53 "../src/sudoku-view.vala"
	_data11_ = NULL;
#line 53 "../src/sudoku-view.vala"
	return self;
#line 1235 "sudoku-view.c"
}

SudokuView*
sudoku_view_new (gint frame_size,
                 SudokuGame* game)
{
#line 53 "../src/sudoku-view.vala"
	return sudoku_view_construct (TYPE_SUDOKU_VIEW, frame_size, game);
#line 1244 "sudoku-view.c"
}

static void
sudoku_view_update_highlights (SudokuView* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean has_selection = FALSE;
	gint cell_value = 0;
#line 217 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 219 "../src/sudoku-view.vala"
	if (self->selected_row >= 0) {
#line 219 "../src/sudoku-view.vala"
		_tmp0_ = self->selected_col >= 0;
#line 1259 "sudoku-view.c"
	} else {
#line 219 "../src/sudoku-view.vala"
		_tmp0_ = FALSE;
#line 1263 "sudoku-view.c"
	}
#line 219 "../src/sudoku-view.vala"
	has_selection = _tmp0_;
#line 220 "../src/sudoku-view.vala"
	cell_value = -1;
#line 221 "../src/sudoku-view.vala"
	if (has_selection) {
#line 1271 "sudoku-view.c"
		SudokuCell** _tmp1_;
		gint _tmp1__length1;
		gint _tmp1__length2;
		SudokuCell* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 222 "../src/sudoku-view.vala"
		_tmp1_ = self->priv->cells;
#line 222 "../src/sudoku-view.vala"
		_tmp1__length1 = self->priv->cells_length1;
#line 222 "../src/sudoku-view.vala"
		_tmp1__length2 = self->priv->cells_length2;
#line 222 "../src/sudoku-view.vala"
		_tmp2_ = _tmp1_[(self->selected_row * _tmp1__length2) + self->selected_col];
#line 222 "../src/sudoku-view.vala"
		_tmp3_ = sudoku_cell_get_value (_tmp2_);
#line 222 "../src/sudoku-view.vala"
		_tmp4_ = _tmp3_;
#line 222 "../src/sudoku-view.vala"
		cell_value = _tmp4_;
#line 1292 "sudoku-view.c"
	}
	{
		gint col_tmp = 0;
#line 224 "../src/sudoku-view.vala"
		col_tmp = 0;
#line 1298 "sudoku-view.c"
		{
			gboolean _tmp5_ = FALSE;
#line 224 "../src/sudoku-view.vala"
			_tmp5_ = TRUE;
#line 224 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1305 "sudoku-view.c"
				SudokuGame* _tmp7_;
				SudokuBoard* _tmp8_;
				gint _tmp9_;
				gint _tmp10_;
#line 224 "../src/sudoku-view.vala"
				if (!_tmp5_) {
#line 1312 "sudoku-view.c"
					gint _tmp6_;
#line 224 "../src/sudoku-view.vala"
					_tmp6_ = col_tmp;
#line 224 "../src/sudoku-view.vala"
					col_tmp = _tmp6_ + 1;
#line 1318 "sudoku-view.c"
				}
#line 224 "../src/sudoku-view.vala"
				_tmp5_ = FALSE;
#line 224 "../src/sudoku-view.vala"
				_tmp7_ = self->game;
#line 224 "../src/sudoku-view.vala"
				_tmp8_ = _tmp7_->board;
#line 224 "../src/sudoku-view.vala"
				_tmp9_ = sudoku_board_get_cols (_tmp8_);
#line 224 "../src/sudoku-view.vala"
				_tmp10_ = _tmp9_;
#line 224 "../src/sudoku-view.vala"
				if (!(col_tmp < _tmp10_)) {
#line 224 "../src/sudoku-view.vala"
					break;
#line 1334 "sudoku-view.c"
				}
				{
					gint row_tmp = 0;
#line 226 "../src/sudoku-view.vala"
					row_tmp = 0;
#line 1340 "sudoku-view.c"
					{
						gboolean _tmp11_ = FALSE;
#line 226 "../src/sudoku-view.vala"
						_tmp11_ = TRUE;
#line 226 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1347 "sudoku-view.c"
							SudokuGame* _tmp13_;
							SudokuBoard* _tmp14_;
							gint _tmp15_;
							gint _tmp16_;
							SudokuCell** _tmp17_;
							gint _tmp17__length1;
							gint _tmp17__length2;
							SudokuCell* _tmp18_;
							gboolean _tmp19_ = FALSE;
#line 226 "../src/sudoku-view.vala"
							if (!_tmp11_) {
#line 1359 "sudoku-view.c"
								gint _tmp12_;
#line 226 "../src/sudoku-view.vala"
								_tmp12_ = row_tmp;
#line 226 "../src/sudoku-view.vala"
								row_tmp = _tmp12_ + 1;
#line 1365 "sudoku-view.c"
							}
#line 226 "../src/sudoku-view.vala"
							_tmp11_ = FALSE;
#line 226 "../src/sudoku-view.vala"
							_tmp13_ = self->game;
#line 226 "../src/sudoku-view.vala"
							_tmp14_ = _tmp13_->board;
#line 226 "../src/sudoku-view.vala"
							_tmp15_ = sudoku_board_get_rows (_tmp14_);
#line 226 "../src/sudoku-view.vala"
							_tmp16_ = _tmp15_;
#line 226 "../src/sudoku-view.vala"
							if (!(row_tmp < _tmp16_)) {
#line 226 "../src/sudoku-view.vala"
								break;
#line 1381 "sudoku-view.c"
							}
#line 228 "../src/sudoku-view.vala"
							_tmp17_ = self->priv->cells;
#line 228 "../src/sudoku-view.vala"
							_tmp17__length1 = self->priv->cells_length1;
#line 228 "../src/sudoku-view.vala"
							_tmp17__length2 = self->priv->cells_length2;
#line 228 "../src/sudoku-view.vala"
							_tmp18_ = _tmp17_[(row_tmp * _tmp17__length2) + col_tmp];
#line 228 "../src/sudoku-view.vala"
							sudoku_cell_check_warnings (_tmp18_);
#line 229 "../src/sudoku-view.vala"
							if (has_selection) {
#line 229 "../src/sudoku-view.vala"
								_tmp19_ = self->priv->_highlighter;
#line 1397 "sudoku-view.c"
							} else {
#line 229 "../src/sudoku-view.vala"
								_tmp19_ = FALSE;
#line 1401 "sudoku-view.c"
							}
#line 229 "../src/sudoku-view.vala"
							if (_tmp19_) {
#line 1405 "sudoku-view.c"
								gboolean _tmp20_ = FALSE;
								gboolean _tmp21_ = FALSE;
								SudokuCell** _tmp39_;
								gint _tmp39__length1;
								gint _tmp39__length2;
								SudokuCell* _tmp40_;
								SudokuCell** _tmp41_;
								gint _tmp41__length1;
								gint _tmp41__length2;
								SudokuCell* _tmp42_;
								SudokuCell** _tmp43_;
								gint _tmp43__length1;
								gint _tmp43__length2;
								SudokuCell* _tmp44_;
								gint _tmp45_;
								gint _tmp46_;
#line 231 "../src/sudoku-view.vala"
								if (col_tmp == self->selected_col) {
#line 231 "../src/sudoku-view.vala"
									_tmp21_ = TRUE;
#line 1426 "sudoku-view.c"
								} else {
#line 232 "../src/sudoku-view.vala"
									_tmp21_ = row_tmp == self->selected_row;
#line 1430 "sudoku-view.c"
								}
#line 230 "../src/sudoku-view.vala"
								if (_tmp21_) {
#line 231 "../src/sudoku-view.vala"
									_tmp20_ = TRUE;
#line 1436 "sudoku-view.c"
								} else {
									gboolean _tmp22_ = FALSE;
									SudokuGame* _tmp23_;
									SudokuBoard* _tmp24_;
									gint _tmp25_;
									gint _tmp26_;
									SudokuGame* _tmp27_;
									SudokuBoard* _tmp28_;
									gint _tmp29_;
									gint _tmp30_;
#line 233 "../src/sudoku-view.vala"
									_tmp23_ = self->game;
#line 233 "../src/sudoku-view.vala"
									_tmp24_ = _tmp23_->board;
#line 233 "../src/sudoku-view.vala"
									_tmp25_ = sudoku_board_get_block_cols (_tmp24_);
#line 233 "../src/sudoku-view.vala"
									_tmp26_ = _tmp25_;
#line 233 "../src/sudoku-view.vala"
									_tmp27_ = self->game;
#line 233 "../src/sudoku-view.vala"
									_tmp28_ = _tmp27_->board;
#line 233 "../src/sudoku-view.vala"
									_tmp29_ = sudoku_board_get_block_cols (_tmp28_);
#line 233 "../src/sudoku-view.vala"
									_tmp30_ = _tmp29_;
#line 233 "../src/sudoku-view.vala"
									if ((col_tmp / _tmp26_) == (self->selected_col / _tmp30_)) {
#line 1465 "sudoku-view.c"
										SudokuGame* _tmp31_;
										SudokuBoard* _tmp32_;
										gint _tmp33_;
										gint _tmp34_;
										SudokuGame* _tmp35_;
										SudokuBoard* _tmp36_;
										gint _tmp37_;
										gint _tmp38_;
#line 234 "../src/sudoku-view.vala"
										_tmp31_ = self->game;
#line 234 "../src/sudoku-view.vala"
										_tmp32_ = _tmp31_->board;
#line 234 "../src/sudoku-view.vala"
										_tmp33_ = sudoku_board_get_block_rows (_tmp32_);
#line 234 "../src/sudoku-view.vala"
										_tmp34_ = _tmp33_;
#line 234 "../src/sudoku-view.vala"
										_tmp35_ = self->game;
#line 234 "../src/sudoku-view.vala"
										_tmp36_ = _tmp35_->board;
#line 234 "../src/sudoku-view.vala"
										_tmp37_ = sudoku_board_get_block_rows (_tmp36_);
#line 234 "../src/sudoku-view.vala"
										_tmp38_ = _tmp37_;
#line 234 "../src/sudoku-view.vala"
										_tmp22_ = (row_tmp / _tmp34_) == (self->selected_row / _tmp38_);
#line 1492 "sudoku-view.c"
									} else {
#line 233 "../src/sudoku-view.vala"
										_tmp22_ = FALSE;
#line 1496 "sudoku-view.c"
									}
#line 233 "../src/sudoku-view.vala"
									_tmp20_ = _tmp22_;
#line 1500 "sudoku-view.c"
								}
#line 230 "../src/sudoku-view.vala"
								_tmp39_ = self->priv->cells;
#line 230 "../src/sudoku-view.vala"
								_tmp39__length1 = self->priv->cells_length1;
#line 230 "../src/sudoku-view.vala"
								_tmp39__length2 = self->priv->cells_length2;
#line 230 "../src/sudoku-view.vala"
								_tmp40_ = _tmp39_[(row_tmp * _tmp39__length2) + col_tmp];
#line 230 "../src/sudoku-view.vala"
								sudoku_cell_set_highlighted_background (_tmp40_, _tmp20_);
#line 236 "../src/sudoku-view.vala"
								_tmp41_ = self->priv->cells;
#line 236 "../src/sudoku-view.vala"
								_tmp41__length1 = self->priv->cells_length1;
#line 236 "../src/sudoku-view.vala"
								_tmp41__length2 = self->priv->cells_length2;
#line 236 "../src/sudoku-view.vala"
								_tmp42_ = _tmp41_[(row_tmp * _tmp41__length2) + col_tmp];
#line 236 "../src/sudoku-view.vala"
								_tmp43_ = self->priv->cells;
#line 236 "../src/sudoku-view.vala"
								_tmp43__length1 = self->priv->cells_length1;
#line 236 "../src/sudoku-view.vala"
								_tmp43__length2 = self->priv->cells_length2;
#line 236 "../src/sudoku-view.vala"
								_tmp44_ = _tmp43_[(row_tmp * _tmp43__length2) + col_tmp];
#line 236 "../src/sudoku-view.vala"
								_tmp45_ = sudoku_cell_get_value (_tmp44_);
#line 236 "../src/sudoku-view.vala"
								_tmp46_ = _tmp45_;
#line 236 "../src/sudoku-view.vala"
								sudoku_cell_set_highlighted_value (_tmp42_, cell_value == _tmp46_);
#line 1534 "sudoku-view.c"
							}
						}
					}
				}
			}
		}
	}
}

void
sudoku_view_clear (SudokuView* self)
{
#line 242 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 1549 "sudoku-view.c"
	{
		gint i = 0;
#line 244 "../src/sudoku-view.vala"
		i = 0;
#line 1554 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 244 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 244 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1561 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 244 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 1568 "sudoku-view.c"
					gint _tmp1_;
#line 244 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 244 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 1574 "sudoku-view.c"
				}
#line 244 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 244 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 244 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 244 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
#line 244 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 244 "../src/sudoku-view.vala"
				if (!(i < _tmp5_)) {
#line 244 "../src/sudoku-view.vala"
					break;
#line 1590 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 245 "../src/sudoku-view.vala"
					j = 0;
#line 1596 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 245 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 245 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1603 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuGame* _tmp12_;
							SudokuBoard* _tmp13_;
#line 245 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 1612 "sudoku-view.c"
								gint _tmp7_;
#line 245 "../src/sudoku-view.vala"
								_tmp7_ = j;
#line 245 "../src/sudoku-view.vala"
								j = _tmp7_ + 1;
#line 1618 "sudoku-view.c"
							}
#line 245 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 245 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 245 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 245 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 245 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 245 "../src/sudoku-view.vala"
							if (!(j < _tmp11_)) {
#line 245 "../src/sudoku-view.vala"
								break;
#line 1634 "sudoku-view.c"
							}
#line 246 "../src/sudoku-view.vala"
							_tmp12_ = self->game;
#line 246 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_->board;
#line 246 "../src/sudoku-view.vala"
							sudoku_board_disable_all_earmarks (_tmp13_, i, j);
#line 1642 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

void
sudoku_view_redraw (SudokuView* self)
{
#line 249 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 1656 "sudoku-view.c"
	{
		gint i = 0;
#line 251 "../src/sudoku-view.vala"
		i = 0;
#line 1661 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 251 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 251 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1668 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 251 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 1675 "sudoku-view.c"
					gint _tmp1_;
#line 251 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 251 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 1681 "sudoku-view.c"
				}
#line 251 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 251 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 251 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 251 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
#line 251 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 251 "../src/sudoku-view.vala"
				if (!(i < _tmp5_)) {
#line 251 "../src/sudoku-view.vala"
					break;
#line 1697 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 252 "../src/sudoku-view.vala"
					j = 0;
#line 1703 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 252 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 252 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1710 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCell** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCell* _tmp13_;
#line 252 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 1721 "sudoku-view.c"
								gint _tmp7_;
#line 252 "../src/sudoku-view.vala"
								_tmp7_ = j;
#line 252 "../src/sudoku-view.vala"
								j = _tmp7_ + 1;
#line 1727 "sudoku-view.c"
							}
#line 252 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 252 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 252 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 252 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 252 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 252 "../src/sudoku-view.vala"
							if (!(j < _tmp11_)) {
#line 252 "../src/sudoku-view.vala"
								break;
#line 1743 "sudoku-view.c"
							}
#line 253 "../src/sudoku-view.vala"
							_tmp12_ = self->priv->cells;
#line 253 "../src/sudoku-view.vala"
							_tmp12__length1 = self->priv->cells_length1;
#line 253 "../src/sudoku-view.vala"
							_tmp12__length2 = self->priv->cells_length2;
#line 253 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
#line 253 "../src/sudoku-view.vala"
							sudoku_cell_check_warnings (_tmp13_);
#line 1755 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
}

gboolean
sudoku_view_get_show_warnings (SudokuView* self)
{
	gboolean result;
#line 259 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 259 "../src/sudoku-view.vala"
	result = self->priv->_show_warnings;
#line 259 "../src/sudoku-view.vala"
	return result;
#line 1774 "sudoku-view.c"
}

void
sudoku_view_set_show_warnings (SudokuView* self,
                               gboolean value)
{
#line 260 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 261 "../src/sudoku-view.vala"
	self->priv->_show_warnings = value;
#line 1785 "sudoku-view.c"
	{
		gint i = 0;
#line 262 "../src/sudoku-view.vala"
		i = 0;
#line 1790 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 262 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 262 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1797 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 262 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 1804 "sudoku-view.c"
					gint _tmp1_;
#line 262 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 262 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 1810 "sudoku-view.c"
				}
#line 262 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 262 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 262 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 262 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
#line 262 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 262 "../src/sudoku-view.vala"
				if (!(i < _tmp5_)) {
#line 262 "../src/sudoku-view.vala"
					break;
#line 1826 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 263 "../src/sudoku-view.vala"
					j = 0;
#line 1832 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 263 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 263 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1839 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCell** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCell* _tmp13_;
#line 263 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 1850 "sudoku-view.c"
								gint _tmp7_;
#line 263 "../src/sudoku-view.vala"
								_tmp7_ = j;
#line 263 "../src/sudoku-view.vala"
								j = _tmp7_ + 1;
#line 1856 "sudoku-view.c"
							}
#line 263 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 263 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 263 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 263 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 263 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 263 "../src/sudoku-view.vala"
							if (!(j < _tmp11_)) {
#line 263 "../src/sudoku-view.vala"
								break;
#line 1872 "sudoku-view.c"
							}
#line 264 "../src/sudoku-view.vala"
							_tmp12_ = self->priv->cells;
#line 264 "../src/sudoku-view.vala"
							_tmp12__length1 = self->priv->cells_length1;
#line 264 "../src/sudoku-view.vala"
							_tmp12__length2 = self->priv->cells_length2;
#line 264 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
#line 264 "../src/sudoku-view.vala"
							sudoku_cell_set_show_warnings (_tmp13_, self->priv->_show_warnings);
#line 1884 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 260 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY]);
#line 1893 "sudoku-view.c"
}

gboolean
sudoku_view_get_show_extra_warnings (SudokuView* self)
{
	gboolean result;
#line 271 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 271 "../src/sudoku-view.vala"
	result = self->priv->_show_extra_warnings;
#line 271 "../src/sudoku-view.vala"
	return result;
#line 1906 "sudoku-view.c"
}

void
sudoku_view_set_show_extra_warnings (SudokuView* self,
                                     gboolean value)
{
#line 272 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 273 "../src/sudoku-view.vala"
	self->priv->_show_extra_warnings = value;
#line 1917 "sudoku-view.c"
	{
		gint i = 0;
#line 274 "../src/sudoku-view.vala"
		i = 0;
#line 1922 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 274 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 274 "../src/sudoku-view.vala"
			while (TRUE) {
#line 1929 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 274 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 1936 "sudoku-view.c"
					gint _tmp1_;
#line 274 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 274 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 1942 "sudoku-view.c"
				}
#line 274 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 274 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 274 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 274 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
#line 274 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 274 "../src/sudoku-view.vala"
				if (!(i < _tmp5_)) {
#line 274 "../src/sudoku-view.vala"
					break;
#line 1958 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 275 "../src/sudoku-view.vala"
					j = 0;
#line 1964 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 275 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 275 "../src/sudoku-view.vala"
						while (TRUE) {
#line 1971 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCell** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCell* _tmp13_;
#line 275 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 1982 "sudoku-view.c"
								gint _tmp7_;
#line 275 "../src/sudoku-view.vala"
								_tmp7_ = j;
#line 275 "../src/sudoku-view.vala"
								j = _tmp7_ + 1;
#line 1988 "sudoku-view.c"
							}
#line 275 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 275 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 275 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 275 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 275 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 275 "../src/sudoku-view.vala"
							if (!(j < _tmp11_)) {
#line 275 "../src/sudoku-view.vala"
								break;
#line 2004 "sudoku-view.c"
							}
#line 276 "../src/sudoku-view.vala"
							_tmp12_ = self->priv->cells;
#line 276 "../src/sudoku-view.vala"
							_tmp12__length1 = self->priv->cells_length1;
#line 276 "../src/sudoku-view.vala"
							_tmp12__length2 = self->priv->cells_length2;
#line 276 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
#line 276 "../src/sudoku-view.vala"
							sudoku_cell_set_show_extra_warnings (_tmp13_, self->priv->_show_extra_warnings);
#line 2016 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 272 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY]);
#line 2025 "sudoku-view.c"
}

gboolean
sudoku_view_get_show_possibilities (SudokuView* self)
{
	gboolean result;
#line 283 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 283 "../src/sudoku-view.vala"
	result = self->priv->_show_possibilities;
#line 283 "../src/sudoku-view.vala"
	return result;
#line 2038 "sudoku-view.c"
}

void
sudoku_view_set_show_possibilities (SudokuView* self,
                                    gboolean value)
{
#line 284 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 285 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = value;
#line 2049 "sudoku-view.c"
	{
		gint i = 0;
#line 286 "../src/sudoku-view.vala"
		i = 0;
#line 2054 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 286 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 286 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2061 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 286 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2068 "sudoku-view.c"
					gint _tmp1_;
#line 286 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 286 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 2074 "sudoku-view.c"
				}
#line 286 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 286 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 286 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 286 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
#line 286 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 286 "../src/sudoku-view.vala"
				if (!(i < _tmp5_)) {
#line 286 "../src/sudoku-view.vala"
					break;
#line 2090 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 287 "../src/sudoku-view.vala"
					j = 0;
#line 2096 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 287 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 287 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2103 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCell** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCell* _tmp13_;
#line 287 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 2114 "sudoku-view.c"
								gint _tmp7_;
#line 287 "../src/sudoku-view.vala"
								_tmp7_ = j;
#line 287 "../src/sudoku-view.vala"
								j = _tmp7_ + 1;
#line 2120 "sudoku-view.c"
							}
#line 287 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 287 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 287 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 287 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 287 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 287 "../src/sudoku-view.vala"
							if (!(j < _tmp11_)) {
#line 287 "../src/sudoku-view.vala"
								break;
#line 2136 "sudoku-view.c"
							}
#line 288 "../src/sudoku-view.vala"
							_tmp12_ = self->priv->cells;
#line 288 "../src/sudoku-view.vala"
							_tmp12__length1 = self->priv->cells_length1;
#line 288 "../src/sudoku-view.vala"
							_tmp12__length2 = self->priv->cells_length2;
#line 288 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
#line 288 "../src/sudoku-view.vala"
							_tmp13_->show_possibilities = value;
#line 2148 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 284 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY]);
#line 2157 "sudoku-view.c"
}

gboolean
sudoku_view_get_initialize_earmarks (SudokuView* self)
{
	gboolean result;
#line 295 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 295 "../src/sudoku-view.vala"
	result = self->priv->_initialize_earmarks;
#line 295 "../src/sudoku-view.vala"
	return result;
#line 2170 "sudoku-view.c"
}

void
sudoku_view_set_initialize_earmarks (SudokuView* self,
                                     gboolean value)
{
#line 296 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 297 "../src/sudoku-view.vala"
	self->priv->_initialize_earmarks = value;
#line 2181 "sudoku-view.c"
	{
		gint i = 0;
#line 298 "../src/sudoku-view.vala"
		i = 0;
#line 2186 "sudoku-view.c"
		{
			gboolean _tmp0_ = FALSE;
#line 298 "../src/sudoku-view.vala"
			_tmp0_ = TRUE;
#line 298 "../src/sudoku-view.vala"
			while (TRUE) {
#line 2193 "sudoku-view.c"
				SudokuGame* _tmp2_;
				SudokuBoard* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
#line 298 "../src/sudoku-view.vala"
				if (!_tmp0_) {
#line 2200 "sudoku-view.c"
					gint _tmp1_;
#line 298 "../src/sudoku-view.vala"
					_tmp1_ = i;
#line 298 "../src/sudoku-view.vala"
					i = _tmp1_ + 1;
#line 2206 "sudoku-view.c"
				}
#line 298 "../src/sudoku-view.vala"
				_tmp0_ = FALSE;
#line 298 "../src/sudoku-view.vala"
				_tmp2_ = self->game;
#line 298 "../src/sudoku-view.vala"
				_tmp3_ = _tmp2_->board;
#line 298 "../src/sudoku-view.vala"
				_tmp4_ = sudoku_board_get_rows (_tmp3_);
#line 298 "../src/sudoku-view.vala"
				_tmp5_ = _tmp4_;
#line 298 "../src/sudoku-view.vala"
				if (!(i < _tmp5_)) {
#line 298 "../src/sudoku-view.vala"
					break;
#line 2222 "sudoku-view.c"
				}
				{
					gint j = 0;
#line 299 "../src/sudoku-view.vala"
					j = 0;
#line 2228 "sudoku-view.c"
					{
						gboolean _tmp6_ = FALSE;
#line 299 "../src/sudoku-view.vala"
						_tmp6_ = TRUE;
#line 299 "../src/sudoku-view.vala"
						while (TRUE) {
#line 2235 "sudoku-view.c"
							SudokuGame* _tmp8_;
							SudokuBoard* _tmp9_;
							gint _tmp10_;
							gint _tmp11_;
							SudokuCell** _tmp12_;
							gint _tmp12__length1;
							gint _tmp12__length2;
							SudokuCell* _tmp13_;
#line 299 "../src/sudoku-view.vala"
							if (!_tmp6_) {
#line 2246 "sudoku-view.c"
								gint _tmp7_;
#line 299 "../src/sudoku-view.vala"
								_tmp7_ = j;
#line 299 "../src/sudoku-view.vala"
								j = _tmp7_ + 1;
#line 2252 "sudoku-view.c"
							}
#line 299 "../src/sudoku-view.vala"
							_tmp6_ = FALSE;
#line 299 "../src/sudoku-view.vala"
							_tmp8_ = self->game;
#line 299 "../src/sudoku-view.vala"
							_tmp9_ = _tmp8_->board;
#line 299 "../src/sudoku-view.vala"
							_tmp10_ = sudoku_board_get_cols (_tmp9_);
#line 299 "../src/sudoku-view.vala"
							_tmp11_ = _tmp10_;
#line 299 "../src/sudoku-view.vala"
							if (!(j < _tmp11_)) {
#line 299 "../src/sudoku-view.vala"
								break;
#line 2268 "sudoku-view.c"
							}
#line 300 "../src/sudoku-view.vala"
							_tmp12_ = self->priv->cells;
#line 300 "../src/sudoku-view.vala"
							_tmp12__length1 = self->priv->cells_length1;
#line 300 "../src/sudoku-view.vala"
							_tmp12__length2 = self->priv->cells_length2;
#line 300 "../src/sudoku-view.vala"
							_tmp13_ = _tmp12_[(i * _tmp12__length2) + j];
#line 300 "../src/sudoku-view.vala"
							sudoku_cell_set_initialize_earmarks (_tmp13_, value);
#line 2280 "sudoku-view.c"
						}
					}
				}
			}
		}
	}
#line 296 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY]);
#line 2289 "sudoku-view.c"
}

gboolean
sudoku_view_get_highlighter (SudokuView* self)
{
	gboolean result;
#line 307 "../src/sudoku-view.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 307 "../src/sudoku-view.vala"
	result = self->priv->_highlighter;
#line 307 "../src/sudoku-view.vala"
	return result;
#line 2302 "sudoku-view.c"
}

void
sudoku_view_set_highlighter (SudokuView* self,
                             gboolean value)
{
#line 308 "../src/sudoku-view.vala"
	g_return_if_fail (self != NULL);
#line 309 "../src/sudoku-view.vala"
	self->priv->_highlighter = value;
#line 308 "../src/sudoku-view.vala"
	g_object_notify_by_pspec ((GObject *) self, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY]);
#line 2315 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda13_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	SudokuView* _tmp1_;
	gboolean result;
#line 162 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 163 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 163 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 165 "../src/sudoku-view.vala"
	_tmp1_ = view;
#line 165 "../src/sudoku-view.vala"
	if (_tmp1_->selected_row == 0) {
#line 2335 "sudoku-view.c"
		SudokuView* _tmp2_;
		SudokuCell** _tmp3_;
		gint _tmp3__length1;
		gint _tmp3__length2;
		SudokuView* _tmp4_;
		SudokuCell* _tmp5_;
#line 166 "../src/sudoku-view.vala"
		_tmp2_ = view;
#line 166 "../src/sudoku-view.vala"
		_tmp3_ = _tmp2_->priv->cells;
#line 166 "../src/sudoku-view.vala"
		_tmp3__length1 = _tmp2_->priv->cells_length1;
#line 166 "../src/sudoku-view.vala"
		_tmp3__length2 = _tmp2_->priv->cells_length2;
#line 166 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 166 "../src/sudoku-view.vala"
		_tmp5_ = _tmp3_[(8 * _tmp3__length2) + _tmp4_->selected_col];
#line 166 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp5_);
#line 2356 "sudoku-view.c"
	} else {
		SudokuView* _tmp6_;
		SudokuCell** _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		SudokuView* _tmp8_;
		SudokuView* _tmp9_;
		SudokuCell* _tmp10_;
#line 168 "../src/sudoku-view.vala"
		_tmp6_ = view;
#line 168 "../src/sudoku-view.vala"
		_tmp7_ = _tmp6_->priv->cells;
#line 168 "../src/sudoku-view.vala"
		_tmp7__length1 = _tmp6_->priv->cells_length1;
#line 168 "../src/sudoku-view.vala"
		_tmp7__length2 = _tmp6_->priv->cells_length2;
#line 168 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 168 "../src/sudoku-view.vala"
		_tmp9_ = view;
#line 168 "../src/sudoku-view.vala"
		_tmp10_ = _tmp7_[((_tmp8_->selected_row - 1) * _tmp7__length2) + _tmp9_->selected_col];
#line 168 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp10_);
#line 2381 "sudoku-view.c"
	}
#line 170 "../src/sudoku-view.vala"
	result = TRUE;
#line 170 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 170 "../src/sudoku-view.vala"
	return result;
#line 2389 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda13__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda13_ (widget);
#line 162 "../src/sudoku-view.vala"
	return result;
#line 2401 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda14_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	SudokuView* _tmp1_;
	gboolean result;
#line 172 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 173 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 173 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 175 "../src/sudoku-view.vala"
	_tmp1_ = view;
#line 175 "../src/sudoku-view.vala"
	if (_tmp1_->selected_row == 8) {
#line 2421 "sudoku-view.c"
		SudokuView* _tmp2_;
		SudokuCell** _tmp3_;
		gint _tmp3__length1;
		gint _tmp3__length2;
		SudokuView* _tmp4_;
		SudokuCell* _tmp5_;
#line 176 "../src/sudoku-view.vala"
		_tmp2_ = view;
#line 176 "../src/sudoku-view.vala"
		_tmp3_ = _tmp2_->priv->cells;
#line 176 "../src/sudoku-view.vala"
		_tmp3__length1 = _tmp2_->priv->cells_length1;
#line 176 "../src/sudoku-view.vala"
		_tmp3__length2 = _tmp2_->priv->cells_length2;
#line 176 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 176 "../src/sudoku-view.vala"
		_tmp5_ = _tmp3_[(0 * _tmp3__length2) + _tmp4_->selected_col];
#line 176 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp5_);
#line 2442 "sudoku-view.c"
	} else {
		SudokuView* _tmp6_;
		SudokuCell** _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		SudokuView* _tmp8_;
		SudokuView* _tmp9_;
		SudokuCell* _tmp10_;
#line 178 "../src/sudoku-view.vala"
		_tmp6_ = view;
#line 178 "../src/sudoku-view.vala"
		_tmp7_ = _tmp6_->priv->cells;
#line 178 "../src/sudoku-view.vala"
		_tmp7__length1 = _tmp6_->priv->cells_length1;
#line 178 "../src/sudoku-view.vala"
		_tmp7__length2 = _tmp6_->priv->cells_length2;
#line 178 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 178 "../src/sudoku-view.vala"
		_tmp9_ = view;
#line 178 "../src/sudoku-view.vala"
		_tmp10_ = _tmp7_[((_tmp8_->selected_row + 1) * _tmp7__length2) + _tmp9_->selected_col];
#line 178 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp10_);
#line 2467 "sudoku-view.c"
	}
#line 180 "../src/sudoku-view.vala"
	result = TRUE;
#line 180 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 180 "../src/sudoku-view.vala"
	return result;
#line 2475 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda14__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda14_ (widget);
#line 172 "../src/sudoku-view.vala"
	return result;
#line 2487 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda15_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	SudokuView* _tmp1_;
	gboolean result;
#line 182 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 183 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 183 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 185 "../src/sudoku-view.vala"
	_tmp1_ = view;
#line 185 "../src/sudoku-view.vala"
	if (_tmp1_->selected_col == 0) {
#line 2507 "sudoku-view.c"
		SudokuView* _tmp2_;
		SudokuCell** _tmp3_;
		gint _tmp3__length1;
		gint _tmp3__length2;
		SudokuView* _tmp4_;
		SudokuCell* _tmp5_;
#line 186 "../src/sudoku-view.vala"
		_tmp2_ = view;
#line 186 "../src/sudoku-view.vala"
		_tmp3_ = _tmp2_->priv->cells;
#line 186 "../src/sudoku-view.vala"
		_tmp3__length1 = _tmp2_->priv->cells_length1;
#line 186 "../src/sudoku-view.vala"
		_tmp3__length2 = _tmp2_->priv->cells_length2;
#line 186 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 186 "../src/sudoku-view.vala"
		_tmp5_ = _tmp3_[(_tmp4_->selected_row * _tmp3__length2) + 8];
#line 186 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp5_);
#line 2528 "sudoku-view.c"
	} else {
		SudokuView* _tmp6_;
		SudokuCell** _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		SudokuView* _tmp8_;
		SudokuView* _tmp9_;
		SudokuCell* _tmp10_;
#line 188 "../src/sudoku-view.vala"
		_tmp6_ = view;
#line 188 "../src/sudoku-view.vala"
		_tmp7_ = _tmp6_->priv->cells;
#line 188 "../src/sudoku-view.vala"
		_tmp7__length1 = _tmp6_->priv->cells_length1;
#line 188 "../src/sudoku-view.vala"
		_tmp7__length2 = _tmp6_->priv->cells_length2;
#line 188 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 188 "../src/sudoku-view.vala"
		_tmp9_ = view;
#line 188 "../src/sudoku-view.vala"
		_tmp10_ = _tmp7_[(_tmp8_->selected_row * _tmp7__length2) + (_tmp9_->selected_col - 1)];
#line 188 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp10_);
#line 2553 "sudoku-view.c"
	}
#line 190 "../src/sudoku-view.vala"
	result = TRUE;
#line 190 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 190 "../src/sudoku-view.vala"
	return result;
#line 2561 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda15__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda15_ (widget);
#line 182 "../src/sudoku-view.vala"
	return result;
#line 2573 "sudoku-view.c"
}

static gboolean
_sudoku_view___lambda16_ (GtkWidget* _self_)
{
	SudokuView* view = NULL;
	SudokuView* _tmp0_;
	SudokuView* _tmp1_;
	gboolean result;
#line 192 "../src/sudoku-view.vala"
	g_return_val_if_fail (_self_ != NULL, FALSE);
#line 193 "../src/sudoku-view.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_self_, TYPE_SUDOKU_VIEW, SudokuView));
#line 193 "../src/sudoku-view.vala"
	view = _tmp0_;
#line 195 "../src/sudoku-view.vala"
	_tmp1_ = view;
#line 195 "../src/sudoku-view.vala"
	if (_tmp1_->selected_col == 8) {
#line 2593 "sudoku-view.c"
		SudokuView* _tmp2_;
		SudokuCell** _tmp3_;
		gint _tmp3__length1;
		gint _tmp3__length2;
		SudokuView* _tmp4_;
		SudokuCell* _tmp5_;
#line 196 "../src/sudoku-view.vala"
		_tmp2_ = view;
#line 196 "../src/sudoku-view.vala"
		_tmp3_ = _tmp2_->priv->cells;
#line 196 "../src/sudoku-view.vala"
		_tmp3__length1 = _tmp2_->priv->cells_length1;
#line 196 "../src/sudoku-view.vala"
		_tmp3__length2 = _tmp2_->priv->cells_length2;
#line 196 "../src/sudoku-view.vala"
		_tmp4_ = view;
#line 196 "../src/sudoku-view.vala"
		_tmp5_ = _tmp3_[(_tmp4_->selected_row * _tmp3__length2) + 0];
#line 196 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp5_);
#line 2614 "sudoku-view.c"
	} else {
		SudokuView* _tmp6_;
		SudokuCell** _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		SudokuView* _tmp8_;
		SudokuView* _tmp9_;
		SudokuCell* _tmp10_;
#line 198 "../src/sudoku-view.vala"
		_tmp6_ = view;
#line 198 "../src/sudoku-view.vala"
		_tmp7_ = _tmp6_->priv->cells;
#line 198 "../src/sudoku-view.vala"
		_tmp7__length1 = _tmp6_->priv->cells_length1;
#line 198 "../src/sudoku-view.vala"
		_tmp7__length2 = _tmp6_->priv->cells_length2;
#line 198 "../src/sudoku-view.vala"
		_tmp8_ = view;
#line 198 "../src/sudoku-view.vala"
		_tmp9_ = view;
#line 198 "../src/sudoku-view.vala"
		_tmp10_ = _tmp7_[(_tmp8_->selected_row * _tmp7__length2) + (_tmp9_->selected_col + 1)];
#line 198 "../src/sudoku-view.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp10_);
#line 2639 "sudoku-view.c"
	}
#line 200 "../src/sudoku-view.vala"
	result = TRUE;
#line 200 "../src/sudoku-view.vala"
	_g_object_unref0 (view);
#line 200 "../src/sudoku-view.vala"
	return result;
#line 2647 "sudoku-view.c"
}

static gboolean
__sudoku_view___lambda16__gtk_shortcut_func (GtkWidget* widget,
                                             GVariant* args,
                                             gpointer self)
{
	gboolean result;
	result = _sudoku_view___lambda16_ (widget);
#line 192 "../src/sudoku-view.vala"
	return result;
#line 2659 "sudoku-view.c"
}

static void
sudoku_view_class_init (SudokuViewClass * klass,
                        gpointer klass_data)
{
	GtkShortcutFunc up_func = NULL;
	gpointer up_func_target;
	GDestroyNotify up_func_target_destroy_notify;
	GtkShortcutFunc down_func = NULL;
	gpointer down_func_target;
	GDestroyNotify down_func_target_destroy_notify;
	GtkShortcutFunc left_func = NULL;
	gpointer left_func_target;
	GDestroyNotify left_func_target_destroy_notify;
	GtkShortcutFunc right_func = NULL;
	gpointer right_func_target;
	GDestroyNotify right_func_target_destroy_notify;
	GtkShortcutFunc _tmp0_;
	gpointer _tmp0__target;
	GtkShortcutFunc _tmp1_;
	gpointer _tmp1__target;
	GtkShortcutFunc _tmp2_;
	gpointer _tmp2__target;
	GtkShortcutFunc _tmp3_;
	gpointer _tmp3__target;
	GtkShortcutFunc _tmp4_;
	gpointer _tmp4__target;
	GtkShortcutFunc _tmp5_;
	gpointer _tmp5__target;
	GtkShortcutFunc _tmp6_;
	gpointer _tmp6__target;
	GtkShortcutFunc _tmp7_;
	gpointer _tmp7__target;
	GtkShortcutFunc _tmp8_;
	gpointer _tmp8__target;
	GtkShortcutFunc _tmp9_;
	gpointer _tmp9__target;
	GtkShortcutFunc _tmp10_;
	gpointer _tmp10__target;
	GtkShortcutFunc _tmp11_;
	gpointer _tmp11__target;
#line 26 "../src/sudoku-view.vala"
	sudoku_view_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/sudoku-view.vala"
	g_type_class_adjust_private_offset (klass, &SudokuView_private_offset);
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_view_get_property;
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_view_set_property;
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_view_finalize;
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-warnings", "show-warnings", "show-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY] = g_param_spec_boolean ("show-extra-warnings", "show-extra-warnings", "show-extra-warnings", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY] = g_param_spec_boolean ("show-possibilities", "show-possibilities", "show-possibilities", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY] = g_param_spec_boolean ("initialize-earmarks", "initialize-earmarks", "initialize-earmarks", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/sudoku-view.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_VIEW_HIGHLIGHTER_PROPERTY, sudoku_view_properties[SUDOKU_VIEW_HIGHLIGHTER_PROPERTY] = g_param_spec_boolean ("highlighter", "highlighter", "highlighter", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 162 "../src/sudoku-view.vala"
	up_func = __sudoku_view___lambda13__gtk_shortcut_func;
#line 162 "../src/sudoku-view.vala"
	up_func_target = NULL;
#line 162 "../src/sudoku-view.vala"
	up_func_target_destroy_notify = NULL;
#line 172 "../src/sudoku-view.vala"
	down_func = __sudoku_view___lambda14__gtk_shortcut_func;
#line 172 "../src/sudoku-view.vala"
	down_func_target = NULL;
#line 172 "../src/sudoku-view.vala"
	down_func_target_destroy_notify = NULL;
#line 182 "../src/sudoku-view.vala"
	left_func = __sudoku_view___lambda15__gtk_shortcut_func;
#line 182 "../src/sudoku-view.vala"
	left_func_target = NULL;
#line 182 "../src/sudoku-view.vala"
	left_func_target_destroy_notify = NULL;
#line 192 "../src/sudoku-view.vala"
	right_func = __sudoku_view___lambda16__gtk_shortcut_func;
#line 192 "../src/sudoku-view.vala"
	right_func_target = NULL;
#line 192 "../src/sudoku-view.vala"
	right_func_target_destroy_notify = NULL;
#line 203 "../src/sudoku-view.vala"
	_tmp0_ = up_func;
#line 203 "../src/sudoku-view.vala"
	_tmp0__target = up_func_target;
#line 203 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Up, 0, _tmp0_, _tmp0__target, NULL, NULL);
#line 204 "../src/sudoku-view.vala"
	_tmp1_ = up_func;
#line 204 "../src/sudoku-view.vala"
	_tmp1__target = up_func_target;
#line 204 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Up, 0, _tmp1_, _tmp1__target, NULL, NULL);
#line 205 "../src/sudoku-view.vala"
	_tmp2_ = up_func;
#line 205 "../src/sudoku-view.vala"
	_tmp2__target = up_func_target;
#line 205 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_w, 0, _tmp2_, _tmp2__target, NULL, NULL);
#line 206 "../src/sudoku-view.vala"
	_tmp3_ = down_func;
#line 206 "../src/sudoku-view.vala"
	_tmp3__target = down_func_target;
#line 206 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Down, 0, _tmp3_, _tmp3__target, NULL, NULL);
#line 207 "../src/sudoku-view.vala"
	_tmp4_ = down_func;
#line 207 "../src/sudoku-view.vala"
	_tmp4__target = down_func_target;
#line 207 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Down, 0, _tmp4_, _tmp4__target, NULL, NULL);
#line 208 "../src/sudoku-view.vala"
	_tmp5_ = down_func;
#line 208 "../src/sudoku-view.vala"
	_tmp5__target = down_func_target;
#line 208 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_s, 0, _tmp5_, _tmp5__target, NULL, NULL);
#line 209 "../src/sudoku-view.vala"
	_tmp6_ = left_func;
#line 209 "../src/sudoku-view.vala"
	_tmp6__target = left_func_target;
#line 209 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Left, 0, _tmp6_, _tmp6__target, NULL, NULL);
#line 210 "../src/sudoku-view.vala"
	_tmp7_ = left_func;
#line 210 "../src/sudoku-view.vala"
	_tmp7__target = left_func_target;
#line 210 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Left, 0, _tmp7_, _tmp7__target, NULL, NULL);
#line 211 "../src/sudoku-view.vala"
	_tmp8_ = left_func;
#line 211 "../src/sudoku-view.vala"
	_tmp8__target = left_func_target;
#line 211 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_a, 0, _tmp8_, _tmp8__target, NULL, NULL);
#line 212 "../src/sudoku-view.vala"
	_tmp9_ = right_func;
#line 212 "../src/sudoku-view.vala"
	_tmp9__target = right_func_target;
#line 212 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_Right, 0, _tmp9_, _tmp9__target, NULL, NULL);
#line 213 "../src/sudoku-view.vala"
	_tmp10_ = right_func;
#line 213 "../src/sudoku-view.vala"
	_tmp10__target = right_func_target;
#line 213 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_KP_Right, 0, _tmp10_, _tmp10__target, NULL, NULL);
#line 214 "../src/sudoku-view.vala"
	_tmp11_ = right_func;
#line 214 "../src/sudoku-view.vala"
	_tmp11__target = right_func_target;
#line 214 "../src/sudoku-view.vala"
	gtk_widget_class_add_binding (GTK_WIDGET_CLASS (klass), GDK_KEY_d, 0, _tmp11_, _tmp11__target, NULL, NULL);
#line 161 "../src/sudoku-view.vala"
	(right_func_target_destroy_notify == NULL) ? NULL : (right_func_target_destroy_notify (right_func_target), NULL);
#line 161 "../src/sudoku-view.vala"
	right_func = NULL;
#line 161 "../src/sudoku-view.vala"
	right_func_target = NULL;
#line 161 "../src/sudoku-view.vala"
	right_func_target_destroy_notify = NULL;
#line 161 "../src/sudoku-view.vala"
	(left_func_target_destroy_notify == NULL) ? NULL : (left_func_target_destroy_notify (left_func_target), NULL);
#line 161 "../src/sudoku-view.vala"
	left_func = NULL;
#line 161 "../src/sudoku-view.vala"
	left_func_target = NULL;
#line 161 "../src/sudoku-view.vala"
	left_func_target_destroy_notify = NULL;
#line 161 "../src/sudoku-view.vala"
	(down_func_target_destroy_notify == NULL) ? NULL : (down_func_target_destroy_notify (down_func_target), NULL);
#line 161 "../src/sudoku-view.vala"
	down_func = NULL;
#line 161 "../src/sudoku-view.vala"
	down_func_target = NULL;
#line 161 "../src/sudoku-view.vala"
	down_func_target_destroy_notify = NULL;
#line 161 "../src/sudoku-view.vala"
	(up_func_target_destroy_notify == NULL) ? NULL : (up_func_target_destroy_notify (up_func_target), NULL);
#line 161 "../src/sudoku-view.vala"
	up_func = NULL;
#line 161 "../src/sudoku-view.vala"
	up_func_target = NULL;
#line 161 "../src/sudoku-view.vala"
	up_func_target_destroy_notify = NULL;
#line 2850 "sudoku-view.c"
}

static void
sudoku_view_instance_init (SudokuView * self,
                           gpointer klass)
{
#line 26 "../src/sudoku-view.vala"
	self->priv = sudoku_view_get_instance_private (self);
#line 32 "../src/sudoku-view.vala"
	self->priv->previous_board_broken_state = FALSE;
#line 37 "../src/sudoku-view.vala"
	self->selected_row = 0;
#line 38 "../src/sudoku-view.vala"
	self->selected_col = 0;
#line 256 "../src/sudoku-view.vala"
	self->priv->_show_warnings = FALSE;
#line 268 "../src/sudoku-view.vala"
	self->priv->_show_extra_warnings = FALSE;
#line 280 "../src/sudoku-view.vala"
	self->priv->_show_possibilities = FALSE;
#line 292 "../src/sudoku-view.vala"
	self->priv->_initialize_earmarks = FALSE;
#line 304 "../src/sudoku-view.vala"
	self->priv->_highlighter = FALSE;
#line 2875 "sudoku-view.c"
}

static void
sudoku_view_finalize (GObject * obj)
{
	SudokuView * self;
#line 26 "../src/sudoku-view.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_VIEW, SudokuView);
#line 28 "../src/sudoku-view.vala"
	_g_object_unref0 (self->game);
#line 29 "../src/sudoku-view.vala"
	self->priv->cells = (_vala_array_free (self->priv->cells, self->priv->cells_length1 * self->priv->cells_length2, (GDestroyNotify) g_object_unref), NULL);
#line 30 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->paused);
#line 34 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->overlay);
#line 35 "../src/sudoku-view.vala"
	_g_object_unref0 (self->priv->grid);
#line 26 "../src/sudoku-view.vala"
	G_OBJECT_CLASS (sudoku_view_parent_class)->finalize (obj);
#line 2896 "sudoku-view.c"
}

static GType
sudoku_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuView), 0, (GInstanceInitFunc) sudoku_view_instance_init, NULL };
	GType sudoku_view_type_id;
	sudoku_view_type_id = g_type_register_static (adw_bin_get_type (), "SudokuView", &g_define_type_info, 0);
	SudokuView_private_offset = g_type_add_instance_private (sudoku_view_type_id, sizeof (SudokuViewPrivate));
	return sudoku_view_type_id;
}

GType
sudoku_view_get_type (void)
{
	static volatile gsize sudoku_view_type_id__once = 0;
	if (g_once_init_enter (&sudoku_view_type_id__once)) {
		GType sudoku_view_type_id;
		sudoku_view_type_id = sudoku_view_get_type_once ();
		g_once_init_leave (&sudoku_view_type_id__once, sudoku_view_type_id);
	}
	return sudoku_view_type_id__once;
}

static void
_vala_sudoku_view_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 26 "../src/sudoku-view.vala"
	switch (property_id) {
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_warnings (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_extra_warnings (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_show_possibilities (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_initialize_earmarks (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		g_value_set_boolean (value, sudoku_view_get_highlighter (self));
#line 26 "../src/sudoku-view.vala"
		break;
#line 2961 "sudoku-view.c"
		default:
#line 26 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/sudoku-view.vala"
		break;
#line 2967 "sudoku-view.c"
	}
}

static void
_vala_sudoku_view_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	SudokuView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_VIEW, SudokuView);
#line 26 "../src/sudoku-view.vala"
	switch (property_id) {
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_warnings (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_EXTRA_WARNINGS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_extra_warnings (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_SHOW_POSSIBILITIES_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_show_possibilities (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_INITIALIZE_EARMARKS_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_initialize_earmarks (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 26 "../src/sudoku-view.vala"
		case SUDOKU_VIEW_HIGHLIGHTER_PROPERTY:
#line 26 "../src/sudoku-view.vala"
		sudoku_view_set_highlighter (self, g_value_get_boolean (value));
#line 26 "../src/sudoku-view.vala"
		break;
#line 3011 "sudoku-view.c"
		default:
#line 26 "../src/sudoku-view.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/sudoku-view.vala"
		break;
#line 3017 "sudoku-view.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

