/* sudoku-board.c generated by valac 0.56.13, the Vala compiler
 * generated from sudoku-board.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */
/*
 * Copyright © 2014 Parin Porecha
 * Copyright © 2014 Michael Catanzaro
 *
 * This file is part of GNOME Sudoku.
 *
 * GNOME Sudoku is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * GNOME Sudoku is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with GNOME Sudoku. If not, see <http://www.gnu.org/licenses/>.
 */

#include "libsudoku.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <gee.h>
#include <qqwing-wrapper.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>

enum  {
	SUDOKU_BOARD_0_PROPERTY,
	SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY,
	SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY,
	SUDOKU_BOARD_BLOCK_ROWS_PROPERTY,
	SUDOKU_BOARD_BLOCK_COLS_PROPERTY,
	SUDOKU_BOARD_ROWS_PROPERTY,
	SUDOKU_BOARD_COLS_PROPERTY,
	SUDOKU_BOARD_MAX_VAL_PROPERTY,
	SUDOKU_BOARD_BROKEN_PROPERTY,
	SUDOKU_BOARD_FILLED_PROPERTY,
	SUDOKU_BOARD_FIXED_PROPERTY,
	SUDOKU_BOARD_SIZE_PROPERTY,
	SUDOKU_BOARD_COMPLETE_PROPERTY,
	SUDOKU_BOARD_NUM_PROPERTIES
};
static GParamSpec* sudoku_board_properties[SUDOKU_BOARD_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _coord_free0(var) ((var == NULL) ? NULL : (var = (coord_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	SUDOKU_BOARD_COMPLETED_SIGNAL,
	SUDOKU_BOARD_NUM_SIGNALS
};
static guint sudoku_board_signals[SUDOKU_BOARD_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _SudokuBoardPrivate {
	gboolean* possible_in_row;
	gint possible_in_row_length1;
	gint possible_in_row_length2;
	gboolean* possible_in_col;
	gint possible_in_col_length1;
	gint possible_in_col_length2;
	gboolean* possible_in_block;
	gint possible_in_block_length1;
	gint possible_in_block_length2;
	gint possible_in_block_length3;
	gboolean* earmarks;
	gint earmarks_length1;
	gint earmarks_length2;
	gint earmarks_length3;
	gint n_earmarks;
	gdouble _previous_played_time;
	DifficultyCategory _difficulty_category;
	gint _block_rows;
	gint _block_cols;
	gint _rows;
	gint _cols;
	gint _filled;
	gint _fixed;
};

static gint SudokuBoard_private_offset;
static gpointer sudoku_board_parent_class = NULL;

static void sudoku_board_set_cols (SudokuBoard* self,
                            gint value);
static void sudoku_board_set_rows (SudokuBoard* self,
                            gint value);
static void sudoku_board_set_block_rows (SudokuBoard* self,
                                  gint value);
static void sudoku_board_set_block_cols (SudokuBoard* self,
                                  gint value);
static gint* _vala_array_dup1 (gint* self,
                        gssize length);
static gint* _vala_array_dup2 (gint* self,
                        gssize length);
static gboolean* _vala_array_dup3 (gboolean* self,
                            gssize length);
static gboolean* _vala_array_dup4 (gboolean* self,
                            gssize length);
static gboolean* _vala_array_dup5 (gboolean* self,
                            gssize length);
static gboolean* _vala_array_dup6 (gboolean* self,
                            gssize length);
static void sudoku_board_set_filled (SudokuBoard* self,
                              gint value);
static void sudoku_board_set_fixed (SudokuBoard* self,
                             gint value);
static gboolean* _vala_array_dup7 (gboolean* self,
                            gssize length);
static gint* _vala_array_dup8 (gint* self,
                        gssize length);
static void sudoku_board_mark_breakages_for (SudokuBoard* self,
                                      GeeList* coords,
                                      gint val);
static void sudoku_board_remove_breakages_for (SudokuBoard* self,
                                        GeeList* coords,
                                        gint val);
static gint* sudoku_board_convert_2d_to_1d (SudokuBoard* self,
                                     gint* ints_2d,
                                     gint ints_2d_length1,
                                     gint ints_2d_length2,
                                     gint* result_length1);
static gint* sudoku_board_convert_1d_to_2d (SudokuBoard* self,
                                     gint* ints_1d,
                                     gint ints_1d_length1,
                                     gint* result_length1,
                                     gint* result_length2);
static gint* _vala_array_dup9 (gint* self,
                        gssize length);
static void sudoku_board_finalize (GObject * obj);
static GType sudoku_board_get_type_once (void);
static void _vala_sudoku_board_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_sudoku_board_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
sudoku_board_get_instance_private (SudokuBoard* self)
{
	return G_STRUCT_MEMBER_P (self, SudokuBoard_private_offset);
}

gboolean
sudoku_board_is_empty (SudokuBoard* self)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result;
#line 81 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 83 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_filled;
#line 83 "../lib/sudoku-board.vala"
	_tmp2_ = self->priv->_fixed;
#line 83 "../lib/sudoku-board.vala"
	if (_tmp1_ == _tmp2_) {
#line 83 "../lib/sudoku-board.vala"
		_tmp0_ = self->priv->n_earmarks == 0;
#line 180 "sudoku-board.c"
	} else {
#line 83 "../lib/sudoku-board.vala"
		_tmp0_ = FALSE;
#line 184 "sudoku-board.c"
	}
#line 83 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 83 "../lib/sudoku-board.vala"
	return result;
#line 190 "sudoku-board.c"
}

gboolean
sudoku_board_is_fully_filled (SudokuBoard* self)
{
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gboolean result;
#line 86 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 88 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_filled;
#line 88 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_cols;
#line 88 "../lib/sudoku-board.vala"
	_tmp2_ = self->priv->_rows;
#line 88 "../lib/sudoku-board.vala"
	result = _tmp0_ == (_tmp1_ * _tmp2_);
#line 88 "../lib/sudoku-board.vala"
	return result;
#line 212 "sudoku-board.c"
}

SudokuBoard*
sudoku_board_construct (GType object_type,
                        gint block_rows,
                        gint block_cols)
{
	SudokuBoard * self = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gboolean* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gboolean* _tmp11_;
	gboolean* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	gint _tmp16_;
	gboolean* _tmp17_;
	GeeHashSet* _tmp37_;
	GeeArrayList* _tmp38_;
	GeeList* _tmp59_;
	GeeList* _tmp60_;
	GeeList* _tmp61_;
	GeeArrayList* _tmp62_;
	GeeList* _tmp83_;
	GeeList* _tmp84_;
	GeeList* _tmp85_;
	GeeHashMap* _tmp86_;
	GeeMap* _tmp119_;
	GeeMap* _tmp120_;
	GeeMap* _tmp121_;
#line 105 "../lib/sudoku-board.vala"
	self = (SudokuBoard*) g_object_new (object_type, NULL);
#line 107 "../lib/sudoku-board.vala"
	sudoku_board_set_cols (self, block_rows * block_cols);
#line 107 "../lib/sudoku-board.vala"
	sudoku_board_set_rows (self, block_rows * block_cols);
#line 108 "../lib/sudoku-board.vala"
	sudoku_board_set_block_rows (self, block_rows);
#line 109 "../lib/sudoku-board.vala"
	sudoku_board_set_block_cols (self, block_cols);
#line 110 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_rows;
#line 110 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_cols;
#line 110 "../lib/sudoku-board.vala"
	_tmp2_ = g_new0 (gint, _tmp0_ * _tmp1_);
#line 110 "../lib/sudoku-board.vala"
	self->cells = (g_free (self->cells), NULL);
#line 110 "../lib/sudoku-board.vala"
	self->cells = _tmp2_;
#line 110 "../lib/sudoku-board.vala"
	self->cells_length1 = _tmp0_;
#line 110 "../lib/sudoku-board.vala"
	self->cells_length2 = _tmp1_;
#line 111 "../lib/sudoku-board.vala"
	_tmp3_ = self->priv->_rows;
#line 111 "../lib/sudoku-board.vala"
	_tmp4_ = self->priv->_cols;
#line 111 "../lib/sudoku-board.vala"
	_tmp5_ = g_new0 (gboolean, _tmp3_ * _tmp4_);
#line 111 "../lib/sudoku-board.vala"
	self->is_fixed = (g_free (self->is_fixed), NULL);
#line 111 "../lib/sudoku-board.vala"
	self->is_fixed = _tmp5_;
#line 111 "../lib/sudoku-board.vala"
	self->is_fixed_length1 = _tmp3_;
#line 111 "../lib/sudoku-board.vala"
	self->is_fixed_length2 = _tmp4_;
#line 112 "../lib/sudoku-board.vala"
	_tmp6_ = self->priv->_rows;
#line 112 "../lib/sudoku-board.vala"
	_tmp7_ = self->priv->_cols;
#line 112 "../lib/sudoku-board.vala"
	_tmp8_ = g_new0 (gboolean, _tmp6_ * _tmp7_);
#line 112 "../lib/sudoku-board.vala"
	self->priv->possible_in_row = (g_free (self->priv->possible_in_row), NULL);
#line 112 "../lib/sudoku-board.vala"
	self->priv->possible_in_row = _tmp8_;
#line 112 "../lib/sudoku-board.vala"
	self->priv->possible_in_row_length1 = _tmp6_;
#line 112 "../lib/sudoku-board.vala"
	self->priv->possible_in_row_length2 = _tmp7_;
#line 113 "../lib/sudoku-board.vala"
	_tmp9_ = self->priv->_cols;
#line 113 "../lib/sudoku-board.vala"
	_tmp10_ = self->priv->_rows;
#line 113 "../lib/sudoku-board.vala"
	_tmp11_ = g_new0 (gboolean, _tmp9_ * _tmp10_);
#line 113 "../lib/sudoku-board.vala"
	self->priv->possible_in_col = (g_free (self->priv->possible_in_col), NULL);
#line 113 "../lib/sudoku-board.vala"
	self->priv->possible_in_col = _tmp11_;
#line 113 "../lib/sudoku-board.vala"
	self->priv->possible_in_col_length1 = _tmp9_;
#line 113 "../lib/sudoku-board.vala"
	self->priv->possible_in_col_length2 = _tmp10_;
#line 114 "../lib/sudoku-board.vala"
	_tmp12_ = g_new0 (gboolean, (block_rows * block_cols) * (block_rows * block_cols));
#line 114 "../lib/sudoku-board.vala"
	self->priv->possible_in_block = (g_free (self->priv->possible_in_block), NULL);
#line 114 "../lib/sudoku-board.vala"
	self->priv->possible_in_block = _tmp12_;
#line 114 "../lib/sudoku-board.vala"
	self->priv->possible_in_block_length1 = block_rows;
#line 114 "../lib/sudoku-board.vala"
	self->priv->possible_in_block_length2 = block_cols;
#line 114 "../lib/sudoku-board.vala"
	self->priv->possible_in_block_length3 = block_rows * block_cols;
#line 115 "../lib/sudoku-board.vala"
	_tmp13_ = self->priv->_rows;
#line 115 "../lib/sudoku-board.vala"
	_tmp14_ = self->priv->_cols;
#line 115 "../lib/sudoku-board.vala"
	_tmp15_ = sudoku_board_get_max_val (self);
#line 115 "../lib/sudoku-board.vala"
	_tmp16_ = _tmp15_;
#line 115 "../lib/sudoku-board.vala"
	_tmp17_ = g_new0 (gboolean, (_tmp13_ * _tmp14_) * _tmp16_);
#line 115 "../lib/sudoku-board.vala"
	self->priv->earmarks = (g_free (self->priv->earmarks), NULL);
#line 115 "../lib/sudoku-board.vala"
	self->priv->earmarks = _tmp17_;
#line 115 "../lib/sudoku-board.vala"
	self->priv->earmarks_length1 = _tmp13_;
#line 115 "../lib/sudoku-board.vala"
	self->priv->earmarks_length2 = _tmp14_;
#line 115 "../lib/sudoku-board.vala"
	self->priv->earmarks_length3 = _tmp16_;
#line 350 "sudoku-board.c"
	{
		gint l1 = 0;
#line 117 "../lib/sudoku-board.vala"
		l1 = 0;
#line 355 "sudoku-board.c"
		{
			gboolean _tmp18_ = FALSE;
#line 117 "../lib/sudoku-board.vala"
			_tmp18_ = TRUE;
#line 117 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 362 "sudoku-board.c"
				gint _tmp20_;
#line 117 "../lib/sudoku-board.vala"
				if (!_tmp18_) {
#line 366 "sudoku-board.c"
					gint _tmp19_;
#line 117 "../lib/sudoku-board.vala"
					_tmp19_ = l1;
#line 117 "../lib/sudoku-board.vala"
					l1 = _tmp19_ + 1;
#line 372 "sudoku-board.c"
				}
#line 117 "../lib/sudoku-board.vala"
				_tmp18_ = FALSE;
#line 117 "../lib/sudoku-board.vala"
				_tmp20_ = self->priv->_rows;
#line 117 "../lib/sudoku-board.vala"
				if (!(l1 < _tmp20_)) {
#line 117 "../lib/sudoku-board.vala"
					break;
#line 382 "sudoku-board.c"
				}
				{
					gint l2 = 0;
#line 119 "../lib/sudoku-board.vala"
					l2 = 0;
#line 388 "sudoku-board.c"
					{
						gboolean _tmp21_ = FALSE;
#line 119 "../lib/sudoku-board.vala"
						_tmp21_ = TRUE;
#line 119 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 395 "sudoku-board.c"
							gint _tmp23_;
							gint* _tmp24_;
							gint _tmp24__length1;
							gint _tmp24__length2;
							gboolean* _tmp25_;
							gint _tmp25__length1;
							gint _tmp25__length2;
							gboolean* _tmp26_;
							gint _tmp26__length1;
							gint _tmp26__length2;
							gboolean* _tmp27_;
							gint _tmp27__length1;
							gint _tmp27__length2;
#line 119 "../lib/sudoku-board.vala"
							if (!_tmp21_) {
#line 411 "sudoku-board.c"
								gint _tmp22_;
#line 119 "../lib/sudoku-board.vala"
								_tmp22_ = l2;
#line 119 "../lib/sudoku-board.vala"
								l2 = _tmp22_ + 1;
#line 417 "sudoku-board.c"
							}
#line 119 "../lib/sudoku-board.vala"
							_tmp21_ = FALSE;
#line 119 "../lib/sudoku-board.vala"
							_tmp23_ = self->priv->_cols;
#line 119 "../lib/sudoku-board.vala"
							if (!(l2 < _tmp23_)) {
#line 119 "../lib/sudoku-board.vala"
								break;
#line 427 "sudoku-board.c"
							}
#line 121 "../lib/sudoku-board.vala"
							_tmp24_ = self->cells;
#line 121 "../lib/sudoku-board.vala"
							_tmp24__length1 = self->cells_length1;
#line 121 "../lib/sudoku-board.vala"
							_tmp24__length2 = self->cells_length2;
#line 121 "../lib/sudoku-board.vala"
							_tmp24_[(l1 * _tmp24__length2) + l2] = 0;
#line 122 "../lib/sudoku-board.vala"
							_tmp25_ = self->is_fixed;
#line 122 "../lib/sudoku-board.vala"
							_tmp25__length1 = self->is_fixed_length1;
#line 122 "../lib/sudoku-board.vala"
							_tmp25__length2 = self->is_fixed_length2;
#line 122 "../lib/sudoku-board.vala"
							_tmp25_[(l1 * _tmp25__length2) + l2] = FALSE;
#line 123 "../lib/sudoku-board.vala"
							_tmp26_ = self->priv->possible_in_row;
#line 123 "../lib/sudoku-board.vala"
							_tmp26__length1 = self->priv->possible_in_row_length1;
#line 123 "../lib/sudoku-board.vala"
							_tmp26__length2 = self->priv->possible_in_row_length2;
#line 123 "../lib/sudoku-board.vala"
							_tmp26_[(l1 * _tmp26__length2) + l2] = TRUE;
#line 124 "../lib/sudoku-board.vala"
							_tmp27_ = self->priv->possible_in_col;
#line 124 "../lib/sudoku-board.vala"
							_tmp27__length1 = self->priv->possible_in_col_length1;
#line 124 "../lib/sudoku-board.vala"
							_tmp27__length2 = self->priv->possible_in_col_length2;
#line 124 "../lib/sudoku-board.vala"
							_tmp27_[(l2 * _tmp27__length2) + l1] = TRUE;
#line 461 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
	{
		gint l1 = 0;
#line 127 "../lib/sudoku-board.vala"
		l1 = 0;
#line 472 "sudoku-board.c"
		{
			gboolean _tmp28_ = FALSE;
#line 127 "../lib/sudoku-board.vala"
			_tmp28_ = TRUE;
#line 127 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 127 "../lib/sudoku-board.vala"
				if (!_tmp28_) {
#line 481 "sudoku-board.c"
					gint _tmp29_;
#line 127 "../lib/sudoku-board.vala"
					_tmp29_ = l1;
#line 127 "../lib/sudoku-board.vala"
					l1 = _tmp29_ + 1;
#line 487 "sudoku-board.c"
				}
#line 127 "../lib/sudoku-board.vala"
				_tmp28_ = FALSE;
#line 127 "../lib/sudoku-board.vala"
				if (!(l1 < block_rows)) {
#line 127 "../lib/sudoku-board.vala"
					break;
#line 495 "sudoku-board.c"
				}
				{
					gint l2 = 0;
#line 128 "../lib/sudoku-board.vala"
					l2 = 0;
#line 501 "sudoku-board.c"
					{
						gboolean _tmp30_ = FALSE;
#line 128 "../lib/sudoku-board.vala"
						_tmp30_ = TRUE;
#line 128 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 128 "../lib/sudoku-board.vala"
							if (!_tmp30_) {
#line 510 "sudoku-board.c"
								gint _tmp31_;
#line 128 "../lib/sudoku-board.vala"
								_tmp31_ = l2;
#line 128 "../lib/sudoku-board.vala"
								l2 = _tmp31_ + 1;
#line 516 "sudoku-board.c"
							}
#line 128 "../lib/sudoku-board.vala"
							_tmp30_ = FALSE;
#line 128 "../lib/sudoku-board.vala"
							if (!(l2 < block_cols)) {
#line 128 "../lib/sudoku-board.vala"
								break;
#line 524 "sudoku-board.c"
							}
							{
								gint l3 = 0;
#line 129 "../lib/sudoku-board.vala"
								l3 = 0;
#line 530 "sudoku-board.c"
								{
									gboolean _tmp32_ = FALSE;
#line 129 "../lib/sudoku-board.vala"
									_tmp32_ = TRUE;
#line 129 "../lib/sudoku-board.vala"
									while (TRUE) {
#line 537 "sudoku-board.c"
										gint _tmp34_;
										gint _tmp35_;
										gboolean* _tmp36_;
										gint _tmp36__length1;
										gint _tmp36__length2;
										gint _tmp36__length3;
#line 129 "../lib/sudoku-board.vala"
										if (!_tmp32_) {
#line 546 "sudoku-board.c"
											gint _tmp33_;
#line 129 "../lib/sudoku-board.vala"
											_tmp33_ = l3;
#line 129 "../lib/sudoku-board.vala"
											l3 = _tmp33_ + 1;
#line 552 "sudoku-board.c"
										}
#line 129 "../lib/sudoku-board.vala"
										_tmp32_ = FALSE;
#line 129 "../lib/sudoku-board.vala"
										_tmp34_ = sudoku_board_get_max_val (self);
#line 129 "../lib/sudoku-board.vala"
										_tmp35_ = _tmp34_;
#line 129 "../lib/sudoku-board.vala"
										if (!(l3 < _tmp35_)) {
#line 129 "../lib/sudoku-board.vala"
											break;
#line 564 "sudoku-board.c"
										}
#line 130 "../lib/sudoku-board.vala"
										_tmp36_ = self->priv->possible_in_block;
#line 130 "../lib/sudoku-board.vala"
										_tmp36__length1 = self->priv->possible_in_block_length1;
#line 130 "../lib/sudoku-board.vala"
										_tmp36__length2 = self->priv->possible_in_block_length2;
#line 130 "../lib/sudoku-board.vala"
										_tmp36__length3 = self->priv->possible_in_block_length3;
#line 130 "../lib/sudoku-board.vala"
										_tmp36_[(((l1 * _tmp36__length2) + l2) * _tmp36__length3) + l3] = TRUE;
#line 576 "sudoku-board.c"
									}
								}
							}
						}
					}
				}
			}
		}
	}
#line 132 "../lib/sudoku-board.vala"
	_tmp37_ = gee_hash_set_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, (GeeHashDataFunc) coord_hash, NULL, NULL, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 132 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->broken_coords);
#line 132 "../lib/sudoku-board.vala"
	self->broken_coords = (GeeSet*) _tmp37_;
#line 134 "../lib/sudoku-board.vala"
	_tmp38_ = gee_array_list_new (GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 134 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_col);
#line 134 "../lib/sudoku-board.vala"
	self->coords_for_col = (GeeList*) _tmp38_;
#line 598 "sudoku-board.c"
	{
		gint col = 0;
#line 135 "../lib/sudoku-board.vala"
		col = 0;
#line 603 "sudoku-board.c"
		{
			gboolean _tmp39_ = FALSE;
#line 135 "../lib/sudoku-board.vala"
			_tmp39_ = TRUE;
#line 135 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 610 "sudoku-board.c"
				gint _tmp41_;
				GeeList* _tmp42_;
				GeeArrayList* _tmp43_;
				GeeArrayList* _tmp44_;
				GeeList* _tmp52_;
				GeeList* _tmp53_;
				gpointer _tmp54_;
				GeeList* _tmp55_;
				GeeList* _tmp56_;
				GeeList* _tmp57_;
				GeeList* _tmp58_;
#line 135 "../lib/sudoku-board.vala"
				if (!_tmp39_) {
#line 624 "sudoku-board.c"
					gint _tmp40_;
#line 135 "../lib/sudoku-board.vala"
					_tmp40_ = col;
#line 135 "../lib/sudoku-board.vala"
					col = _tmp40_ + 1;
#line 630 "sudoku-board.c"
				}
#line 135 "../lib/sudoku-board.vala"
				_tmp39_ = FALSE;
#line 135 "../lib/sudoku-board.vala"
				_tmp41_ = self->priv->_cols;
#line 135 "../lib/sudoku-board.vala"
				if (!(col < _tmp41_)) {
#line 135 "../lib/sudoku-board.vala"
					break;
#line 640 "sudoku-board.c"
				}
#line 137 "../lib/sudoku-board.vala"
				_tmp42_ = self->coords_for_col;
#line 137 "../lib/sudoku-board.vala"
				_tmp43_ = gee_array_list_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 137 "../lib/sudoku-board.vala"
				_tmp44_ = _tmp43_;
#line 137 "../lib/sudoku-board.vala"
				gee_collection_add ((GeeCollection*) _tmp42_, (GeeList*) _tmp44_);
#line 137 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp44_);
#line 652 "sudoku-board.c"
				{
					gint row = 0;
#line 138 "../lib/sudoku-board.vala"
					row = 0;
#line 657 "sudoku-board.c"
					{
						gboolean _tmp45_ = FALSE;
#line 138 "../lib/sudoku-board.vala"
						_tmp45_ = TRUE;
#line 138 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 664 "sudoku-board.c"
							gint _tmp47_;
							GeeList* _tmp48_;
							gpointer _tmp49_;
							GeeList* _tmp50_;
							Coord _tmp51_ = {0};
#line 138 "../lib/sudoku-board.vala"
							if (!_tmp45_) {
#line 672 "sudoku-board.c"
								gint _tmp46_;
#line 138 "../lib/sudoku-board.vala"
								_tmp46_ = row;
#line 138 "../lib/sudoku-board.vala"
								row = _tmp46_ + 1;
#line 678 "sudoku-board.c"
							}
#line 138 "../lib/sudoku-board.vala"
							_tmp45_ = FALSE;
#line 138 "../lib/sudoku-board.vala"
							_tmp47_ = self->priv->_rows;
#line 138 "../lib/sudoku-board.vala"
							if (!(row < _tmp47_)) {
#line 138 "../lib/sudoku-board.vala"
								break;
#line 688 "sudoku-board.c"
							}
#line 139 "../lib/sudoku-board.vala"
							_tmp48_ = self->coords_for_col;
#line 139 "../lib/sudoku-board.vala"
							_tmp49_ = gee_list_get (_tmp48_, col);
#line 139 "../lib/sudoku-board.vala"
							_tmp50_ = (GeeList*) _tmp49_;
#line 139 "../lib/sudoku-board.vala"
							coord_init (&_tmp51_, row, col);
#line 139 "../lib/sudoku-board.vala"
							gee_collection_add ((GeeCollection*) _tmp50_, &_tmp51_);
#line 139 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp50_);
#line 702 "sudoku-board.c"
						}
					}
				}
#line 141 "../lib/sudoku-board.vala"
				_tmp52_ = self->coords_for_col;
#line 141 "../lib/sudoku-board.vala"
				_tmp53_ = self->coords_for_col;
#line 141 "../lib/sudoku-board.vala"
				_tmp54_ = gee_list_get (_tmp53_, col);
#line 141 "../lib/sudoku-board.vala"
				_tmp55_ = (GeeList*) _tmp54_;
#line 141 "../lib/sudoku-board.vala"
				_tmp56_ = gee_list_get_read_only_view (_tmp55_);
#line 141 "../lib/sudoku-board.vala"
				_tmp57_ = _tmp56_;
#line 141 "../lib/sudoku-board.vala"
				_tmp58_ = _tmp57_;
#line 141 "../lib/sudoku-board.vala"
				gee_list_set (_tmp52_, col, _tmp58_);
#line 141 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp58_);
#line 141 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp55_);
#line 726 "sudoku-board.c"
			}
		}
	}
#line 143 "../lib/sudoku-board.vala"
	_tmp59_ = self->coords_for_col;
#line 143 "../lib/sudoku-board.vala"
	_tmp60_ = gee_list_get_read_only_view (_tmp59_);
#line 143 "../lib/sudoku-board.vala"
	_tmp61_ = _tmp60_;
#line 143 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_col);
#line 143 "../lib/sudoku-board.vala"
	self->coords_for_col = _tmp61_;
#line 145 "../lib/sudoku-board.vala"
	_tmp62_ = gee_array_list_new (GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 145 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_row);
#line 145 "../lib/sudoku-board.vala"
	self->coords_for_row = (GeeList*) _tmp62_;
#line 746 "sudoku-board.c"
	{
		gint row = 0;
#line 146 "../lib/sudoku-board.vala"
		row = 0;
#line 751 "sudoku-board.c"
		{
			gboolean _tmp63_ = FALSE;
#line 146 "../lib/sudoku-board.vala"
			_tmp63_ = TRUE;
#line 146 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 758 "sudoku-board.c"
				gint _tmp65_;
				GeeList* _tmp66_;
				GeeArrayList* _tmp67_;
				GeeArrayList* _tmp68_;
				GeeList* _tmp76_;
				GeeList* _tmp77_;
				gpointer _tmp78_;
				GeeList* _tmp79_;
				GeeList* _tmp80_;
				GeeList* _tmp81_;
				GeeList* _tmp82_;
#line 146 "../lib/sudoku-board.vala"
				if (!_tmp63_) {
#line 772 "sudoku-board.c"
					gint _tmp64_;
#line 146 "../lib/sudoku-board.vala"
					_tmp64_ = row;
#line 146 "../lib/sudoku-board.vala"
					row = _tmp64_ + 1;
#line 778 "sudoku-board.c"
				}
#line 146 "../lib/sudoku-board.vala"
				_tmp63_ = FALSE;
#line 146 "../lib/sudoku-board.vala"
				_tmp65_ = self->priv->_rows;
#line 146 "../lib/sudoku-board.vala"
				if (!(row < _tmp65_)) {
#line 146 "../lib/sudoku-board.vala"
					break;
#line 788 "sudoku-board.c"
				}
#line 148 "../lib/sudoku-board.vala"
				_tmp66_ = self->coords_for_row;
#line 148 "../lib/sudoku-board.vala"
				_tmp67_ = gee_array_list_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 148 "../lib/sudoku-board.vala"
				_tmp68_ = _tmp67_;
#line 148 "../lib/sudoku-board.vala"
				gee_collection_add ((GeeCollection*) _tmp66_, (GeeList*) _tmp68_);
#line 148 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp68_);
#line 800 "sudoku-board.c"
				{
					gint col = 0;
#line 149 "../lib/sudoku-board.vala"
					col = 0;
#line 805 "sudoku-board.c"
					{
						gboolean _tmp69_ = FALSE;
#line 149 "../lib/sudoku-board.vala"
						_tmp69_ = TRUE;
#line 149 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 812 "sudoku-board.c"
							gint _tmp71_;
							GeeList* _tmp72_;
							gpointer _tmp73_;
							GeeList* _tmp74_;
							Coord _tmp75_ = {0};
#line 149 "../lib/sudoku-board.vala"
							if (!_tmp69_) {
#line 820 "sudoku-board.c"
								gint _tmp70_;
#line 149 "../lib/sudoku-board.vala"
								_tmp70_ = col;
#line 149 "../lib/sudoku-board.vala"
								col = _tmp70_ + 1;
#line 826 "sudoku-board.c"
							}
#line 149 "../lib/sudoku-board.vala"
							_tmp69_ = FALSE;
#line 149 "../lib/sudoku-board.vala"
							_tmp71_ = self->priv->_cols;
#line 149 "../lib/sudoku-board.vala"
							if (!(col < _tmp71_)) {
#line 149 "../lib/sudoku-board.vala"
								break;
#line 836 "sudoku-board.c"
							}
#line 150 "../lib/sudoku-board.vala"
							_tmp72_ = self->coords_for_row;
#line 150 "../lib/sudoku-board.vala"
							_tmp73_ = gee_list_get (_tmp72_, row);
#line 150 "../lib/sudoku-board.vala"
							_tmp74_ = (GeeList*) _tmp73_;
#line 150 "../lib/sudoku-board.vala"
							coord_init (&_tmp75_, row, col);
#line 150 "../lib/sudoku-board.vala"
							gee_collection_add ((GeeCollection*) _tmp74_, &_tmp75_);
#line 150 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp74_);
#line 850 "sudoku-board.c"
						}
					}
				}
#line 152 "../lib/sudoku-board.vala"
				_tmp76_ = self->coords_for_row;
#line 152 "../lib/sudoku-board.vala"
				_tmp77_ = self->coords_for_row;
#line 152 "../lib/sudoku-board.vala"
				_tmp78_ = gee_list_get (_tmp77_, row);
#line 152 "../lib/sudoku-board.vala"
				_tmp79_ = (GeeList*) _tmp78_;
#line 152 "../lib/sudoku-board.vala"
				_tmp80_ = gee_list_get_read_only_view (_tmp79_);
#line 152 "../lib/sudoku-board.vala"
				_tmp81_ = _tmp80_;
#line 152 "../lib/sudoku-board.vala"
				_tmp82_ = _tmp81_;
#line 152 "../lib/sudoku-board.vala"
				gee_list_set (_tmp76_, row, _tmp82_);
#line 152 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp82_);
#line 152 "../lib/sudoku-board.vala"
				_g_object_unref0 (_tmp79_);
#line 874 "sudoku-board.c"
			}
		}
	}
#line 154 "../lib/sudoku-board.vala"
	_tmp83_ = self->coords_for_row;
#line 154 "../lib/sudoku-board.vala"
	_tmp84_ = gee_list_get_read_only_view (_tmp83_);
#line 154 "../lib/sudoku-board.vala"
	_tmp85_ = _tmp84_;
#line 154 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_row);
#line 154 "../lib/sudoku-board.vala"
	self->coords_for_row = _tmp85_;
#line 156 "../lib/sudoku-board.vala"
	_tmp86_ = gee_hash_map_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, (GeeHashDataFunc) coord_hash, NULL, NULL, (GeeEqualDataFunc) coord_equal, NULL, NULL, NULL, NULL, NULL);
#line 156 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_block);
#line 156 "../lib/sudoku-board.vala"
	self->coords_for_block = (GeeMap*) _tmp86_;
#line 894 "sudoku-board.c"
	{
		gint col = 0;
#line 157 "../lib/sudoku-board.vala"
		col = 0;
#line 899 "sudoku-board.c"
		{
			gboolean _tmp87_ = FALSE;
#line 157 "../lib/sudoku-board.vala"
			_tmp87_ = TRUE;
#line 157 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 157 "../lib/sudoku-board.vala"
				if (!_tmp87_) {
#line 908 "sudoku-board.c"
					gint _tmp88_;
#line 157 "../lib/sudoku-board.vala"
					_tmp88_ = col;
#line 157 "../lib/sudoku-board.vala"
					col = _tmp88_ + 1;
#line 914 "sudoku-board.c"
				}
#line 157 "../lib/sudoku-board.vala"
				_tmp87_ = FALSE;
#line 157 "../lib/sudoku-board.vala"
				if (!(col < block_cols)) {
#line 157 "../lib/sudoku-board.vala"
					break;
#line 922 "sudoku-board.c"
				}
				{
					gint row = 0;
#line 158 "../lib/sudoku-board.vala"
					row = 0;
#line 928 "sudoku-board.c"
					{
						gboolean _tmp89_ = FALSE;
#line 158 "../lib/sudoku-board.vala"
						_tmp89_ = TRUE;
#line 158 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 935 "sudoku-board.c"
							GeeMap* _tmp91_;
							Coord _tmp92_ = {0};
							GeeArrayList* _tmp93_;
							GeeArrayList* _tmp94_;
#line 158 "../lib/sudoku-board.vala"
							if (!_tmp89_) {
#line 942 "sudoku-board.c"
								gint _tmp90_;
#line 158 "../lib/sudoku-board.vala"
								_tmp90_ = row;
#line 158 "../lib/sudoku-board.vala"
								row = _tmp90_ + 1;
#line 948 "sudoku-board.c"
							}
#line 158 "../lib/sudoku-board.vala"
							_tmp89_ = FALSE;
#line 158 "../lib/sudoku-board.vala"
							if (!(row < block_rows)) {
#line 158 "../lib/sudoku-board.vala"
								break;
#line 956 "sudoku-board.c"
							}
#line 159 "../lib/sudoku-board.vala"
							_tmp91_ = self->coords_for_block;
#line 159 "../lib/sudoku-board.vala"
							coord_init (&_tmp92_, row, col);
#line 159 "../lib/sudoku-board.vala"
							_tmp93_ = gee_array_list_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 159 "../lib/sudoku-board.vala"
							_tmp94_ = _tmp93_;
#line 159 "../lib/sudoku-board.vala"
							gee_map_set (_tmp91_, &_tmp92_, (GeeList*) _tmp94_);
#line 159 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp94_);
#line 970 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
	{
		gint col = 0;
#line 161 "../lib/sudoku-board.vala"
		col = 0;
#line 981 "sudoku-board.c"
		{
			gboolean _tmp95_ = FALSE;
#line 161 "../lib/sudoku-board.vala"
			_tmp95_ = TRUE;
#line 161 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 988 "sudoku-board.c"
				gint _tmp97_;
#line 161 "../lib/sudoku-board.vala"
				if (!_tmp95_) {
#line 992 "sudoku-board.c"
					gint _tmp96_;
#line 161 "../lib/sudoku-board.vala"
					_tmp96_ = col;
#line 161 "../lib/sudoku-board.vala"
					col = _tmp96_ + 1;
#line 998 "sudoku-board.c"
				}
#line 161 "../lib/sudoku-board.vala"
				_tmp95_ = FALSE;
#line 161 "../lib/sudoku-board.vala"
				_tmp97_ = self->priv->_cols;
#line 161 "../lib/sudoku-board.vala"
				if (!(col < _tmp97_)) {
#line 161 "../lib/sudoku-board.vala"
					break;
#line 1008 "sudoku-board.c"
				}
				{
					gint row = 0;
#line 162 "../lib/sudoku-board.vala"
					row = 0;
#line 1014 "sudoku-board.c"
					{
						gboolean _tmp98_ = FALSE;
#line 162 "../lib/sudoku-board.vala"
						_tmp98_ = TRUE;
#line 162 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 1021 "sudoku-board.c"
							gint _tmp100_;
							GeeMap* _tmp101_;
							Coord _tmp102_ = {0};
							gpointer _tmp103_;
							GeeList* _tmp104_;
							Coord _tmp105_ = {0};
#line 162 "../lib/sudoku-board.vala"
							if (!_tmp98_) {
#line 1030 "sudoku-board.c"
								gint _tmp99_;
#line 162 "../lib/sudoku-board.vala"
								_tmp99_ = row;
#line 162 "../lib/sudoku-board.vala"
								row = _tmp99_ + 1;
#line 1036 "sudoku-board.c"
							}
#line 162 "../lib/sudoku-board.vala"
							_tmp98_ = FALSE;
#line 162 "../lib/sudoku-board.vala"
							_tmp100_ = self->priv->_rows;
#line 162 "../lib/sudoku-board.vala"
							if (!(row < _tmp100_)) {
#line 162 "../lib/sudoku-board.vala"
								break;
#line 1046 "sudoku-board.c"
							}
#line 163 "../lib/sudoku-board.vala"
							_tmp101_ = self->coords_for_block;
#line 163 "../lib/sudoku-board.vala"
							coord_init (&_tmp102_, row / block_rows, col / block_cols);
#line 163 "../lib/sudoku-board.vala"
							_tmp103_ = gee_map_get (_tmp101_, &_tmp102_);
#line 163 "../lib/sudoku-board.vala"
							_tmp104_ = (GeeList*) _tmp103_;
#line 163 "../lib/sudoku-board.vala"
							coord_init (&_tmp105_, row, col);
#line 163 "../lib/sudoku-board.vala"
							gee_collection_add ((GeeCollection*) _tmp104_, &_tmp105_);
#line 163 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp104_);
#line 1062 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
	{
		gint col = 0;
#line 165 "../lib/sudoku-board.vala"
		col = 0;
#line 1073 "sudoku-board.c"
		{
			gboolean _tmp106_ = FALSE;
#line 165 "../lib/sudoku-board.vala"
			_tmp106_ = TRUE;
#line 165 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 165 "../lib/sudoku-board.vala"
				if (!_tmp106_) {
#line 1082 "sudoku-board.c"
					gint _tmp107_;
#line 165 "../lib/sudoku-board.vala"
					_tmp107_ = col;
#line 165 "../lib/sudoku-board.vala"
					col = _tmp107_ + 1;
#line 1088 "sudoku-board.c"
				}
#line 165 "../lib/sudoku-board.vala"
				_tmp106_ = FALSE;
#line 165 "../lib/sudoku-board.vala"
				if (!(col < block_cols)) {
#line 165 "../lib/sudoku-board.vala"
					break;
#line 1096 "sudoku-board.c"
				}
				{
					gint row = 0;
#line 166 "../lib/sudoku-board.vala"
					row = 0;
#line 1102 "sudoku-board.c"
					{
						gboolean _tmp108_ = FALSE;
#line 166 "../lib/sudoku-board.vala"
						_tmp108_ = TRUE;
#line 166 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 1109 "sudoku-board.c"
							GeeMap* _tmp110_;
							Coord _tmp111_ = {0};
							GeeMap* _tmp112_;
							Coord _tmp113_ = {0};
							gpointer _tmp114_;
							GeeList* _tmp115_;
							GeeList* _tmp116_;
							GeeList* _tmp117_;
							GeeList* _tmp118_;
#line 166 "../lib/sudoku-board.vala"
							if (!_tmp108_) {
#line 1121 "sudoku-board.c"
								gint _tmp109_;
#line 166 "../lib/sudoku-board.vala"
								_tmp109_ = row;
#line 166 "../lib/sudoku-board.vala"
								row = _tmp109_ + 1;
#line 1127 "sudoku-board.c"
							}
#line 166 "../lib/sudoku-board.vala"
							_tmp108_ = FALSE;
#line 166 "../lib/sudoku-board.vala"
							if (!(row < block_rows)) {
#line 166 "../lib/sudoku-board.vala"
								break;
#line 1135 "sudoku-board.c"
							}
#line 167 "../lib/sudoku-board.vala"
							_tmp110_ = self->coords_for_block;
#line 167 "../lib/sudoku-board.vala"
							coord_init (&_tmp111_, row, col);
#line 167 "../lib/sudoku-board.vala"
							_tmp112_ = self->coords_for_block;
#line 167 "../lib/sudoku-board.vala"
							coord_init (&_tmp113_, row, col);
#line 167 "../lib/sudoku-board.vala"
							_tmp114_ = gee_map_get (_tmp112_, &_tmp113_);
#line 167 "../lib/sudoku-board.vala"
							_tmp115_ = (GeeList*) _tmp114_;
#line 167 "../lib/sudoku-board.vala"
							_tmp116_ = gee_list_get_read_only_view (_tmp115_);
#line 167 "../lib/sudoku-board.vala"
							_tmp117_ = _tmp116_;
#line 167 "../lib/sudoku-board.vala"
							_tmp118_ = _tmp117_;
#line 167 "../lib/sudoku-board.vala"
							gee_map_set (_tmp110_, &_tmp111_, _tmp118_);
#line 167 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp118_);
#line 167 "../lib/sudoku-board.vala"
							_g_object_unref0 (_tmp115_);
#line 1161 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
#line 169 "../lib/sudoku-board.vala"
	_tmp119_ = self->coords_for_block;
#line 169 "../lib/sudoku-board.vala"
	_tmp120_ = gee_map_get_read_only_view (_tmp119_);
#line 169 "../lib/sudoku-board.vala"
	_tmp121_ = _tmp120_;
#line 169 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_block);
#line 169 "../lib/sudoku-board.vala"
	self->coords_for_block = _tmp121_;
#line 105 "../lib/sudoku-board.vala"
	return self;
#line 1180 "sudoku-board.c"
}

SudokuBoard*
sudoku_board_new (gint block_rows,
                  gint block_cols)
{
#line 105 "../lib/sudoku-board.vala"
	return sudoku_board_construct (TYPE_SUDOKU_BOARD, block_rows, block_cols);
#line 1189 "sudoku-board.c"
}

static gint*
_vala_array_dup1 (gint* self,
                  gssize length)
{
#line 175 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 175 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gint));
#line 1200 "sudoku-board.c"
	}
#line 175 "../lib/sudoku-board.vala"
	return NULL;
#line 1204 "sudoku-board.c"
}

static gint*
_vala_array_dup2 (gint* self,
                  gssize length)
{
#line 176 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 176 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gint));
#line 1215 "sudoku-board.c"
	}
#line 176 "../lib/sudoku-board.vala"
	return NULL;
#line 1219 "sudoku-board.c"
}

static gboolean*
_vala_array_dup3 (gboolean* self,
                  gssize length)
{
#line 177 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 177 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gboolean));
#line 1230 "sudoku-board.c"
	}
#line 177 "../lib/sudoku-board.vala"
	return NULL;
#line 1234 "sudoku-board.c"
}

static gboolean*
_vala_array_dup4 (gboolean* self,
                  gssize length)
{
#line 178 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 178 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gboolean));
#line 1245 "sudoku-board.c"
	}
#line 178 "../lib/sudoku-board.vala"
	return NULL;
#line 1249 "sudoku-board.c"
}

static gboolean*
_vala_array_dup5 (gboolean* self,
                  gssize length)
{
#line 179 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 179 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gboolean));
#line 1260 "sudoku-board.c"
	}
#line 179 "../lib/sudoku-board.vala"
	return NULL;
#line 1264 "sudoku-board.c"
}

static gboolean*
_vala_array_dup6 (gboolean* self,
                  gssize length)
{
#line 180 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 180 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gboolean));
#line 1275 "sudoku-board.c"
	}
#line 180 "../lib/sudoku-board.vala"
	return NULL;
#line 1279 "sudoku-board.c"
}

static gboolean*
_vala_array_dup7 (gboolean* self,
                  gssize length)
{
#line 185 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 185 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gboolean));
#line 1290 "sudoku-board.c"
	}
#line 185 "../lib/sudoku-board.vala"
	return NULL;
#line 1294 "sudoku-board.c"
}

SudokuBoard*
sudoku_board_clone (SudokuBoard* self)
{
	SudokuBoard* board = NULL;
	gint _tmp0_;
	gint _tmp1_;
	SudokuBoard* _tmp2_;
	gint* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	gint* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	gint* _tmp5_;
	gint _tmp5__length1;
	gint _tmp5__length2;
	gint* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	gboolean* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	gboolean* _tmp8_;
	gint _tmp8__length1;
	gint _tmp8__length2;
	gboolean* _tmp9_;
	gint _tmp9__length1;
	gint _tmp9__length2;
	gboolean* _tmp10_;
	gint _tmp10__length1;
	gint _tmp10__length2;
	gboolean* _tmp11_;
	gint _tmp11__length1;
	gint _tmp11__length2;
	gboolean* _tmp12_;
	gint _tmp12__length1;
	gint _tmp12__length2;
	gboolean* _tmp13_;
	gint _tmp13__length1;
	gint _tmp13__length2;
	gint _tmp13__length3;
	gboolean* _tmp14_;
	gint _tmp14__length1;
	gint _tmp14__length2;
	gint _tmp14__length3;
	gint _tmp15_;
	gint _tmp16_;
	GeeSet* _tmp17_;
	GeeSet* _tmp18_;
	gboolean* _tmp19_;
	gint _tmp19__length1;
	gint _tmp19__length2;
	gint _tmp19__length3;
	gboolean* _tmp20_;
	gint _tmp20__length1;
	gint _tmp20__length2;
	gint _tmp20__length3;
	DifficultyCategory _tmp21_;
	SudokuBoard* result;
#line 172 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 174 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_block_rows;
#line 174 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_block_cols;
#line 174 "../lib/sudoku-board.vala"
	_tmp2_ = sudoku_board_new (_tmp0_, _tmp1_);
#line 174 "../lib/sudoku-board.vala"
	board = _tmp2_;
#line 175 "../lib/sudoku-board.vala"
	_tmp3_ = self->cells;
#line 175 "../lib/sudoku-board.vala"
	_tmp3__length1 = self->cells_length1;
#line 175 "../lib/sudoku-board.vala"
	_tmp3__length2 = self->cells_length2;
#line 175 "../lib/sudoku-board.vala"
	_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup1 (_tmp3_, _tmp3__length1 * _tmp3__length2) : _tmp3_;
#line 175 "../lib/sudoku-board.vala"
	_tmp4__length1 = _tmp3__length1;
#line 175 "../lib/sudoku-board.vala"
	_tmp4__length2 = _tmp3__length2;
#line 175 "../lib/sudoku-board.vala"
	board->cells = (g_free (board->cells), NULL);
#line 175 "../lib/sudoku-board.vala"
	board->cells = _tmp4_;
#line 175 "../lib/sudoku-board.vala"
	board->cells_length1 = _tmp4__length1;
#line 175 "../lib/sudoku-board.vala"
	board->cells_length2 = _tmp4__length2;
#line 176 "../lib/sudoku-board.vala"
	_tmp5_ = self->solution;
#line 176 "../lib/sudoku-board.vala"
	_tmp5__length1 = self->solution_length1;
#line 176 "../lib/sudoku-board.vala"
	_tmp5__length2 = self->solution_length2;
#line 176 "../lib/sudoku-board.vala"
	_tmp6_ = (_tmp5_ != NULL) ? _vala_array_dup2 (_tmp5_, _tmp5__length1 * _tmp5__length2) : _tmp5_;
#line 176 "../lib/sudoku-board.vala"
	_tmp6__length1 = _tmp5__length1;
#line 176 "../lib/sudoku-board.vala"
	_tmp6__length2 = _tmp5__length2;
#line 176 "../lib/sudoku-board.vala"
	board->solution = (g_free (board->solution), NULL);
#line 176 "../lib/sudoku-board.vala"
	board->solution = _tmp6_;
#line 176 "../lib/sudoku-board.vala"
	board->solution_length1 = _tmp6__length1;
#line 176 "../lib/sudoku-board.vala"
	board->solution_length2 = _tmp6__length2;
#line 177 "../lib/sudoku-board.vala"
	_tmp7_ = self->is_fixed;
#line 177 "../lib/sudoku-board.vala"
	_tmp7__length1 = self->is_fixed_length1;
#line 177 "../lib/sudoku-board.vala"
	_tmp7__length2 = self->is_fixed_length2;
#line 177 "../lib/sudoku-board.vala"
	_tmp8_ = (_tmp7_ != NULL) ? _vala_array_dup3 (_tmp7_, _tmp7__length1 * _tmp7__length2) : _tmp7_;
#line 177 "../lib/sudoku-board.vala"
	_tmp8__length1 = _tmp7__length1;
#line 177 "../lib/sudoku-board.vala"
	_tmp8__length2 = _tmp7__length2;
#line 177 "../lib/sudoku-board.vala"
	board->is_fixed = (g_free (board->is_fixed), NULL);
#line 177 "../lib/sudoku-board.vala"
	board->is_fixed = _tmp8_;
#line 177 "../lib/sudoku-board.vala"
	board->is_fixed_length1 = _tmp8__length1;
#line 177 "../lib/sudoku-board.vala"
	board->is_fixed_length2 = _tmp8__length2;
#line 178 "../lib/sudoku-board.vala"
	_tmp9_ = self->priv->possible_in_row;
#line 178 "../lib/sudoku-board.vala"
	_tmp9__length1 = self->priv->possible_in_row_length1;
#line 178 "../lib/sudoku-board.vala"
	_tmp9__length2 = self->priv->possible_in_row_length2;
#line 178 "../lib/sudoku-board.vala"
	_tmp10_ = (_tmp9_ != NULL) ? _vala_array_dup4 (_tmp9_, _tmp9__length1 * _tmp9__length2) : _tmp9_;
#line 178 "../lib/sudoku-board.vala"
	_tmp10__length1 = _tmp9__length1;
#line 178 "../lib/sudoku-board.vala"
	_tmp10__length2 = _tmp9__length2;
#line 178 "../lib/sudoku-board.vala"
	board->priv->possible_in_row = (g_free (board->priv->possible_in_row), NULL);
#line 178 "../lib/sudoku-board.vala"
	board->priv->possible_in_row = _tmp10_;
#line 178 "../lib/sudoku-board.vala"
	board->priv->possible_in_row_length1 = _tmp10__length1;
#line 178 "../lib/sudoku-board.vala"
	board->priv->possible_in_row_length2 = _tmp10__length2;
#line 179 "../lib/sudoku-board.vala"
	_tmp11_ = self->priv->possible_in_col;
#line 179 "../lib/sudoku-board.vala"
	_tmp11__length1 = self->priv->possible_in_col_length1;
#line 179 "../lib/sudoku-board.vala"
	_tmp11__length2 = self->priv->possible_in_col_length2;
#line 179 "../lib/sudoku-board.vala"
	_tmp12_ = (_tmp11_ != NULL) ? _vala_array_dup5 (_tmp11_, _tmp11__length1 * _tmp11__length2) : _tmp11_;
#line 179 "../lib/sudoku-board.vala"
	_tmp12__length1 = _tmp11__length1;
#line 179 "../lib/sudoku-board.vala"
	_tmp12__length2 = _tmp11__length2;
#line 179 "../lib/sudoku-board.vala"
	board->priv->possible_in_col = (g_free (board->priv->possible_in_col), NULL);
#line 179 "../lib/sudoku-board.vala"
	board->priv->possible_in_col = _tmp12_;
#line 179 "../lib/sudoku-board.vala"
	board->priv->possible_in_col_length1 = _tmp12__length1;
#line 179 "../lib/sudoku-board.vala"
	board->priv->possible_in_col_length2 = _tmp12__length2;
#line 180 "../lib/sudoku-board.vala"
	_tmp13_ = self->priv->possible_in_block;
#line 180 "../lib/sudoku-board.vala"
	_tmp13__length1 = self->priv->possible_in_block_length1;
#line 180 "../lib/sudoku-board.vala"
	_tmp13__length2 = self->priv->possible_in_block_length2;
#line 180 "../lib/sudoku-board.vala"
	_tmp13__length3 = self->priv->possible_in_block_length3;
#line 180 "../lib/sudoku-board.vala"
	_tmp14_ = (_tmp13_ != NULL) ? _vala_array_dup6 (_tmp13_, (_tmp13__length1 * _tmp13__length2) * _tmp13__length3) : _tmp13_;
#line 180 "../lib/sudoku-board.vala"
	_tmp14__length1 = _tmp13__length1;
#line 180 "../lib/sudoku-board.vala"
	_tmp14__length2 = _tmp13__length2;
#line 180 "../lib/sudoku-board.vala"
	_tmp14__length3 = _tmp13__length3;
#line 180 "../lib/sudoku-board.vala"
	board->priv->possible_in_block = (g_free (board->priv->possible_in_block), NULL);
#line 180 "../lib/sudoku-board.vala"
	board->priv->possible_in_block = _tmp14_;
#line 180 "../lib/sudoku-board.vala"
	board->priv->possible_in_block_length1 = _tmp14__length1;
#line 180 "../lib/sudoku-board.vala"
	board->priv->possible_in_block_length2 = _tmp14__length2;
#line 180 "../lib/sudoku-board.vala"
	board->priv->possible_in_block_length3 = _tmp14__length3;
#line 181 "../lib/sudoku-board.vala"
	_tmp15_ = self->priv->_filled;
#line 181 "../lib/sudoku-board.vala"
	sudoku_board_set_filled (board, _tmp15_);
#line 182 "../lib/sudoku-board.vala"
	_tmp16_ = self->priv->_fixed;
#line 182 "../lib/sudoku-board.vala"
	sudoku_board_set_fixed (board, _tmp16_);
#line 183 "../lib/sudoku-board.vala"
	board->priv->n_earmarks = self->priv->n_earmarks;
#line 184 "../lib/sudoku-board.vala"
	_tmp17_ = board->broken_coords;
#line 184 "../lib/sudoku-board.vala"
	_tmp18_ = self->broken_coords;
#line 184 "../lib/sudoku-board.vala"
	gee_collection_add_all ((GeeCollection*) _tmp17_, (GeeCollection*) _tmp18_);
#line 185 "../lib/sudoku-board.vala"
	_tmp19_ = self->priv->earmarks;
#line 185 "../lib/sudoku-board.vala"
	_tmp19__length1 = self->priv->earmarks_length1;
#line 185 "../lib/sudoku-board.vala"
	_tmp19__length2 = self->priv->earmarks_length2;
#line 185 "../lib/sudoku-board.vala"
	_tmp19__length3 = self->priv->earmarks_length3;
#line 185 "../lib/sudoku-board.vala"
	_tmp20_ = (_tmp19_ != NULL) ? _vala_array_dup7 (_tmp19_, (_tmp19__length1 * _tmp19__length2) * _tmp19__length3) : _tmp19_;
#line 185 "../lib/sudoku-board.vala"
	_tmp20__length1 = _tmp19__length1;
#line 185 "../lib/sudoku-board.vala"
	_tmp20__length2 = _tmp19__length2;
#line 185 "../lib/sudoku-board.vala"
	_tmp20__length3 = _tmp19__length3;
#line 185 "../lib/sudoku-board.vala"
	board->priv->earmarks = (g_free (board->priv->earmarks), NULL);
#line 185 "../lib/sudoku-board.vala"
	board->priv->earmarks = _tmp20_;
#line 185 "../lib/sudoku-board.vala"
	board->priv->earmarks_length1 = _tmp20__length1;
#line 185 "../lib/sudoku-board.vala"
	board->priv->earmarks_length2 = _tmp20__length2;
#line 185 "../lib/sudoku-board.vala"
	board->priv->earmarks_length3 = _tmp20__length3;
#line 186 "../lib/sudoku-board.vala"
	_tmp21_ = self->priv->_difficulty_category;
#line 186 "../lib/sudoku-board.vala"
	sudoku_board_set_difficulty_category (board, _tmp21_);
#line 188 "../lib/sudoku-board.vala"
	result = board;
#line 188 "../lib/sudoku-board.vala"
	return result;
#line 1542 "sudoku-board.c"
}

void
sudoku_board_enable_earmark (SudokuBoard* self,
                             gint row,
                             gint column,
                             gint digit)
{
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp0__length3;
	gboolean _tmp1_;
#line 191 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 194 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->earmarks;
#line 194 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->earmarks_length1;
#line 194 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->earmarks_length2;
#line 194 "../lib/sudoku-board.vala"
	_tmp0__length3 = self->priv->earmarks_length3;
#line 194 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(((row * _tmp0__length2) + column) * _tmp0__length3) + (digit - 1)];
#line 194 "../lib/sudoku-board.vala"
	if (!_tmp1_) {
#line 1570 "sudoku-board.c"
		gboolean* _tmp2_;
		gint _tmp2__length1;
		gint _tmp2__length2;
		gint _tmp2__length3;
		gint _tmp3_;
#line 196 "../lib/sudoku-board.vala"
		_tmp2_ = self->priv->earmarks;
#line 196 "../lib/sudoku-board.vala"
		_tmp2__length1 = self->priv->earmarks_length1;
#line 196 "../lib/sudoku-board.vala"
		_tmp2__length2 = self->priv->earmarks_length2;
#line 196 "../lib/sudoku-board.vala"
		_tmp2__length3 = self->priv->earmarks_length3;
#line 196 "../lib/sudoku-board.vala"
		_tmp2_[(((row * _tmp2__length2) + column) * _tmp2__length3) + (digit - 1)] = TRUE;
#line 197 "../lib/sudoku-board.vala"
		_tmp3_ = self->priv->n_earmarks;
#line 197 "../lib/sudoku-board.vala"
		self->priv->n_earmarks = _tmp3_ + 1;
#line 1590 "sudoku-board.c"
	}
#line 191 "../lib/sudoku-board.vala"
	_vala_warn_if_fail (self->priv->n_earmarks > 0, "n_earmarks > 0");
#line 1594 "sudoku-board.c"
}

void
sudoku_board_disable_earmark (SudokuBoard* self,
                              gint row,
                              gint column,
                              gint digit)
{
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp0__length3;
	gboolean _tmp1_;
#line 201 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 204 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->earmarks;
#line 204 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->earmarks_length1;
#line 204 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->earmarks_length2;
#line 204 "../lib/sudoku-board.vala"
	_tmp0__length3 = self->priv->earmarks_length3;
#line 204 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(((row * _tmp0__length2) + column) * _tmp0__length3) + (digit - 1)];
#line 204 "../lib/sudoku-board.vala"
	if (_tmp1_) {
#line 1622 "sudoku-board.c"
		gboolean* _tmp2_;
		gint _tmp2__length1;
		gint _tmp2__length2;
		gint _tmp2__length3;
		gint _tmp3_;
#line 206 "../lib/sudoku-board.vala"
		_tmp2_ = self->priv->earmarks;
#line 206 "../lib/sudoku-board.vala"
		_tmp2__length1 = self->priv->earmarks_length1;
#line 206 "../lib/sudoku-board.vala"
		_tmp2__length2 = self->priv->earmarks_length2;
#line 206 "../lib/sudoku-board.vala"
		_tmp2__length3 = self->priv->earmarks_length3;
#line 206 "../lib/sudoku-board.vala"
		_tmp2_[(((row * _tmp2__length2) + column) * _tmp2__length3) + (digit - 1)] = FALSE;
#line 207 "../lib/sudoku-board.vala"
		_tmp3_ = self->priv->n_earmarks;
#line 207 "../lib/sudoku-board.vala"
		self->priv->n_earmarks = _tmp3_ - 1;
#line 1642 "sudoku-board.c"
	}
#line 201 "../lib/sudoku-board.vala"
	_vala_warn_if_fail (self->priv->n_earmarks >= 0, "n_earmarks >= 0");
#line 1646 "sudoku-board.c"
}

void
sudoku_board_disable_all_earmarks (SudokuBoard* self,
                                   gint row,
                                   gint column)
{
#line 211 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 1656 "sudoku-board.c"
	{
		gint i = 0;
#line 214 "../lib/sudoku-board.vala"
		i = 1;
#line 1661 "sudoku-board.c"
		{
			gboolean _tmp0_ = FALSE;
#line 214 "../lib/sudoku-board.vala"
			_tmp0_ = TRUE;
#line 214 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 1668 "sudoku-board.c"
				gint _tmp2_;
				gint _tmp3_;
				gboolean* _tmp4_;
				gint _tmp4__length1;
				gint _tmp4__length2;
				gint _tmp4__length3;
				gboolean _tmp5_;
#line 214 "../lib/sudoku-board.vala"
				if (!_tmp0_) {
#line 1678 "sudoku-board.c"
					gint _tmp1_;
#line 214 "../lib/sudoku-board.vala"
					_tmp1_ = i;
#line 214 "../lib/sudoku-board.vala"
					i = _tmp1_ + 1;
#line 1684 "sudoku-board.c"
				}
#line 214 "../lib/sudoku-board.vala"
				_tmp0_ = FALSE;
#line 214 "../lib/sudoku-board.vala"
				_tmp2_ = sudoku_board_get_max_val (self);
#line 214 "../lib/sudoku-board.vala"
				_tmp3_ = _tmp2_;
#line 214 "../lib/sudoku-board.vala"
				if (!(i <= _tmp3_)) {
#line 214 "../lib/sudoku-board.vala"
					break;
#line 1696 "sudoku-board.c"
				}
#line 215 "../lib/sudoku-board.vala"
				_tmp4_ = self->priv->earmarks;
#line 215 "../lib/sudoku-board.vala"
				_tmp4__length1 = self->priv->earmarks_length1;
#line 215 "../lib/sudoku-board.vala"
				_tmp4__length2 = self->priv->earmarks_length2;
#line 215 "../lib/sudoku-board.vala"
				_tmp4__length3 = self->priv->earmarks_length3;
#line 215 "../lib/sudoku-board.vala"
				_tmp5_ = _tmp4_[(((row * _tmp4__length2) + column) * _tmp4__length3) + (i - 1)];
#line 215 "../lib/sudoku-board.vala"
				if (_tmp5_) {
#line 216 "../lib/sudoku-board.vala"
					sudoku_board_disable_earmark (self, row, column, i);
#line 1712 "sudoku-board.c"
				}
			}
		}
	}
#line 211 "../lib/sudoku-board.vala"
	_vala_warn_if_fail (self->priv->n_earmarks >= 0, "n_earmarks >= 0");
#line 1719 "sudoku-board.c"
}

gboolean
sudoku_board_is_earmark_enabled (SudokuBoard* self,
                                 gint row,
                                 gint column,
                                 gint digit)
{
	gboolean* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp0__length3;
	gboolean _tmp1_;
	gboolean result;
#line 219 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 221 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->earmarks;
#line 221 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->priv->earmarks_length1;
#line 221 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->priv->earmarks_length2;
#line 221 "../lib/sudoku-board.vala"
	_tmp0__length3 = self->priv->earmarks_length3;
#line 221 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(((row * _tmp0__length2) + column) * _tmp0__length3) + (digit - 1)];
#line 221 "../lib/sudoku-board.vala"
	result = _tmp1_;
#line 221 "../lib/sudoku-board.vala"
	return result;
#line 1750 "sudoku-board.c"
}

gboolean
sudoku_board_is_possible (SudokuBoard* self,
                          gint row,
                          gint col,
                          gint val)
{
	gint _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean* _tmp3_;
	gint _tmp3__length1;
	gint _tmp3__length2;
	gboolean _tmp4_;
	gboolean result;
#line 224 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 226 "../lib/sudoku-board.vala"
	_tmp0_ = val;
#line 226 "../lib/sudoku-board.vala"
	val = _tmp0_ - 1;
#line 227 "../lib/sudoku-board.vala"
	_tmp3_ = self->priv->possible_in_row;
#line 227 "../lib/sudoku-board.vala"
	_tmp3__length1 = self->priv->possible_in_row_length1;
#line 227 "../lib/sudoku-board.vala"
	_tmp3__length2 = self->priv->possible_in_row_length2;
#line 227 "../lib/sudoku-board.vala"
	_tmp4_ = _tmp3_[(row * _tmp3__length2) + val];
#line 227 "../lib/sudoku-board.vala"
	if (_tmp4_) {
#line 1783 "sudoku-board.c"
		gboolean* _tmp5_;
		gint _tmp5__length1;
		gint _tmp5__length2;
		gboolean _tmp6_;
#line 227 "../lib/sudoku-board.vala"
		_tmp5_ = self->priv->possible_in_col;
#line 227 "../lib/sudoku-board.vala"
		_tmp5__length1 = self->priv->possible_in_col_length1;
#line 227 "../lib/sudoku-board.vala"
		_tmp5__length2 = self->priv->possible_in_col_length2;
#line 227 "../lib/sudoku-board.vala"
		_tmp6_ = _tmp5_[(col * _tmp5__length2) + val];
#line 227 "../lib/sudoku-board.vala"
		_tmp2_ = _tmp6_;
#line 1798 "sudoku-board.c"
	} else {
#line 227 "../lib/sudoku-board.vala"
		_tmp2_ = FALSE;
#line 1802 "sudoku-board.c"
	}
#line 227 "../lib/sudoku-board.vala"
	if (_tmp2_) {
#line 1806 "sudoku-board.c"
		gboolean* _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		gint _tmp7__length3;
		gint _tmp8_;
		gint _tmp9_;
		gboolean _tmp10_;
#line 227 "../lib/sudoku-board.vala"
		_tmp7_ = self->priv->possible_in_block;
#line 227 "../lib/sudoku-board.vala"
		_tmp7__length1 = self->priv->possible_in_block_length1;
#line 227 "../lib/sudoku-board.vala"
		_tmp7__length2 = self->priv->possible_in_block_length2;
#line 227 "../lib/sudoku-board.vala"
		_tmp7__length3 = self->priv->possible_in_block_length3;
#line 227 "../lib/sudoku-board.vala"
		_tmp8_ = self->priv->_block_cols;
#line 227 "../lib/sudoku-board.vala"
		_tmp9_ = self->priv->_block_rows;
#line 227 "../lib/sudoku-board.vala"
		_tmp10_ = _tmp7_[((((row / _tmp8_) * _tmp7__length2) + (col / _tmp9_)) * _tmp7__length3) + val];
#line 227 "../lib/sudoku-board.vala"
		_tmp1_ = _tmp10_;
#line 1830 "sudoku-board.c"
	} else {
#line 227 "../lib/sudoku-board.vala"
		_tmp1_ = FALSE;
#line 1834 "sudoku-board.c"
	}
#line 227 "../lib/sudoku-board.vala"
	result = _tmp1_;
#line 227 "../lib/sudoku-board.vala"
	return result;
#line 1840 "sudoku-board.c"
}

gint
sudoku_board_count_possibilities (SudokuBoard* self,
                                  gint row,
                                  gint col)
{
	gint _tmp0_ = 0;
	gint* _tmp1_;
	gint* _tmp2_;
	gint _tmp2__length1;
	gint _tmp3_;
	gint result;
#line 230 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 232 "../lib/sudoku-board.vala"
	_tmp1_ = sudoku_board_get_possibilities (self, row, col, &_tmp0_);
#line 232 "../lib/sudoku-board.vala"
	_tmp2_ = _tmp1_;
#line 232 "../lib/sudoku-board.vala"
	_tmp2__length1 = _tmp0_;
#line 232 "../lib/sudoku-board.vala"
	_tmp3_ = _tmp0_;
#line 232 "../lib/sudoku-board.vala"
	_tmp2_ = (g_free (_tmp2_), NULL);
#line 232 "../lib/sudoku-board.vala"
	result = _tmp3_;
#line 232 "../lib/sudoku-board.vala"
	return result;
#line 1870 "sudoku-board.c"
}

static gint*
_vala_array_dup8 (gint* self,
                  gssize length)
{
#line 251 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 251 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gint));
#line 1881 "sudoku-board.c"
	}
#line 251 "../lib/sudoku-board.vala"
	return NULL;
#line 1885 "sudoku-board.c"
}

gint*
sudoku_board_get_possibilities (SudokuBoard* self,
                                gint row,
                                gint col,
                                gint* result_length1)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint* possibilities = NULL;
	gint* _tmp4_;
	gint possibilities_length1;
	gint _possibilities_size_;
	gint count = 0;
	gint* _tmp11_;
	gint _tmp11__length1;
	gint* _tmp12_;
	gint _tmp12__length1;
	gint* _tmp13_;
	gint _tmp13__length1;
	gint* result;
#line 235 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 237 "../lib/sudoku-board.vala"
	_tmp0_ = self->cells;
#line 237 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->cells_length1;
#line 237 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->cells_length2;
#line 237 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + col];
#line 237 "../lib/sudoku-board.vala"
	if (_tmp1_ != 0) {
#line 1922 "sudoku-board.c"
		gint* _tmp2_;
		gint* _tmp3_;
		gint _tmp3__length1;
#line 238 "../lib/sudoku-board.vala"
		_tmp2_ = g_new0 (gint, 0);
#line 238 "../lib/sudoku-board.vala"
		_tmp3_ = _tmp2_;
#line 238 "../lib/sudoku-board.vala"
		_tmp3__length1 = 0;
#line 238 "../lib/sudoku-board.vala"
		if (result_length1) {
#line 238 "../lib/sudoku-board.vala"
			*result_length1 = _tmp3__length1;
#line 1936 "sudoku-board.c"
		}
#line 238 "../lib/sudoku-board.vala"
		result = _tmp3_;
#line 238 "../lib/sudoku-board.vala"
		return result;
#line 1942 "sudoku-board.c"
	}
#line 240 "../lib/sudoku-board.vala"
	_tmp4_ = g_new0 (gint, 9);
#line 240 "../lib/sudoku-board.vala"
	possibilities = _tmp4_;
#line 240 "../lib/sudoku-board.vala"
	possibilities_length1 = 9;
#line 240 "../lib/sudoku-board.vala"
	_possibilities_size_ = possibilities_length1;
#line 241 "../lib/sudoku-board.vala"
	count = 0;
#line 1954 "sudoku-board.c"
	{
		gint l = 0;
#line 243 "../lib/sudoku-board.vala"
		l = 1;
#line 1959 "sudoku-board.c"
		{
			gboolean _tmp5_ = FALSE;
#line 243 "../lib/sudoku-board.vala"
			_tmp5_ = TRUE;
#line 243 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 1966 "sudoku-board.c"
				gint _tmp7_;
				gint _tmp8_;
#line 243 "../lib/sudoku-board.vala"
				if (!_tmp5_) {
#line 1971 "sudoku-board.c"
					gint _tmp6_;
#line 243 "../lib/sudoku-board.vala"
					_tmp6_ = l;
#line 243 "../lib/sudoku-board.vala"
					l = _tmp6_ + 1;
#line 1977 "sudoku-board.c"
				}
#line 243 "../lib/sudoku-board.vala"
				_tmp5_ = FALSE;
#line 243 "../lib/sudoku-board.vala"
				_tmp7_ = sudoku_board_get_max_val (self);
#line 243 "../lib/sudoku-board.vala"
				_tmp8_ = _tmp7_;
#line 243 "../lib/sudoku-board.vala"
				if (!(l <= _tmp8_)) {
#line 243 "../lib/sudoku-board.vala"
					break;
#line 1989 "sudoku-board.c"
				}
#line 245 "../lib/sudoku-board.vala"
				if (sudoku_board_is_possible (self, row, col, l)) {
#line 1993 "sudoku-board.c"
					gint* _tmp9_;
					gint _tmp9__length1;
					gint _tmp10_;
#line 247 "../lib/sudoku-board.vala"
					_tmp9_ = possibilities;
#line 247 "../lib/sudoku-board.vala"
					_tmp9__length1 = possibilities_length1;
#line 247 "../lib/sudoku-board.vala"
					_tmp9_[count] = l;
#line 248 "../lib/sudoku-board.vala"
					_tmp10_ = count;
#line 248 "../lib/sudoku-board.vala"
					count = _tmp10_ + 1;
#line 2007 "sudoku-board.c"
				}
			}
		}
	}
#line 251 "../lib/sudoku-board.vala"
	_tmp11_ = possibilities;
#line 251 "../lib/sudoku-board.vala"
	_tmp11__length1 = possibilities_length1;
#line 251 "../lib/sudoku-board.vala"
	_tmp12_ = (_tmp11_ != NULL) ? _vala_array_dup8 (_tmp11_ + 0, count - 0) : _tmp11_;
#line 251 "../lib/sudoku-board.vala"
	_tmp12__length1 = count - 0;
#line 251 "../lib/sudoku-board.vala"
	_tmp13_ = _tmp12_;
#line 251 "../lib/sudoku-board.vala"
	_tmp13__length1 = _tmp12__length1;
#line 251 "../lib/sudoku-board.vala"
	if (result_length1) {
#line 251 "../lib/sudoku-board.vala"
		*result_length1 = _tmp13__length1;
#line 2028 "sudoku-board.c"
	}
#line 251 "../lib/sudoku-board.vala"
	result = _tmp13_;
#line 251 "../lib/sudoku-board.vala"
	possibilities = (g_free (possibilities), NULL);
#line 251 "../lib/sudoku-board.vala"
	return result;
#line 2036 "sudoku-board.c"
}

gboolean*
sudoku_board_get_possibilities_as_bool_array (SudokuBoard* self,
                                              gint row,
                                              gint col,
                                              gint* result_length1)
{
	gboolean* possibilities = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gboolean* _tmp2_;
	gint possibilities_length1;
	gint _possibilities_size_;
	gboolean* _tmp8_;
	gint _tmp8__length1;
	gboolean* result;
#line 254 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 256 "../lib/sudoku-board.vala"
	_tmp0_ = sudoku_board_get_max_val (self);
#line 256 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_;
#line 256 "../lib/sudoku-board.vala"
	_tmp2_ = g_new0 (gboolean, _tmp1_);
#line 256 "../lib/sudoku-board.vala"
	possibilities = _tmp2_;
#line 256 "../lib/sudoku-board.vala"
	possibilities_length1 = _tmp1_;
#line 256 "../lib/sudoku-board.vala"
	_possibilities_size_ = possibilities_length1;
#line 2068 "sudoku-board.c"
	{
		gint l = 0;
#line 258 "../lib/sudoku-board.vala"
		l = 1;
#line 2073 "sudoku-board.c"
		{
			gboolean _tmp3_ = FALSE;
#line 258 "../lib/sudoku-board.vala"
			_tmp3_ = TRUE;
#line 258 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 2080 "sudoku-board.c"
				gint _tmp5_;
				gint _tmp6_;
				gboolean* _tmp7_;
				gint _tmp7__length1;
#line 258 "../lib/sudoku-board.vala"
				if (!_tmp3_) {
#line 2087 "sudoku-board.c"
					gint _tmp4_;
#line 258 "../lib/sudoku-board.vala"
					_tmp4_ = l;
#line 258 "../lib/sudoku-board.vala"
					l = _tmp4_ + 1;
#line 2093 "sudoku-board.c"
				}
#line 258 "../lib/sudoku-board.vala"
				_tmp3_ = FALSE;
#line 258 "../lib/sudoku-board.vala"
				_tmp5_ = sudoku_board_get_max_val (self);
#line 258 "../lib/sudoku-board.vala"
				_tmp6_ = _tmp5_;
#line 258 "../lib/sudoku-board.vala"
				if (!(l <= _tmp6_)) {
#line 258 "../lib/sudoku-board.vala"
					break;
#line 2105 "sudoku-board.c"
				}
#line 259 "../lib/sudoku-board.vala"
				_tmp7_ = possibilities;
#line 259 "../lib/sudoku-board.vala"
				_tmp7__length1 = possibilities_length1;
#line 259 "../lib/sudoku-board.vala"
				_tmp7_[l - 1] = sudoku_board_is_possible (self, row, col, l);
#line 2113 "sudoku-board.c"
			}
		}
	}
#line 261 "../lib/sudoku-board.vala"
	_tmp8_ = possibilities;
#line 261 "../lib/sudoku-board.vala"
	_tmp8__length1 = possibilities_length1;
#line 261 "../lib/sudoku-board.vala"
	if (result_length1) {
#line 261 "../lib/sudoku-board.vala"
		*result_length1 = _tmp8__length1;
#line 2125 "sudoku-board.c"
	}
#line 261 "../lib/sudoku-board.vala"
	result = _tmp8_;
#line 261 "../lib/sudoku-board.vala"
	return result;
#line 2131 "sudoku-board.c"
}

void
sudoku_board_get_block_for (SudokuBoard* self,
                            gint row,
                            gint col,
                            Coord* result)
{
	gint _tmp0_;
	gint _tmp1_;
	Coord _tmp2_ = {0};
#line 264 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 266 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_block_rows;
#line 266 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_block_cols;
#line 266 "../lib/sudoku-board.vala"
	coord_init (&_tmp2_, row / _tmp0_, col / _tmp1_);
#line 266 "../lib/sudoku-board.vala"
	*result = _tmp2_;
#line 266 "../lib/sudoku-board.vala"
	return;
#line 2155 "sudoku-board.c"
}

void
sudoku_board_insert (SudokuBoard* self,
                     gint row,
                     gint col,
                     gint val,
                     gboolean is_fixed)
{
	gint _tmp0_;
	gint _tmp1_;
	gint* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	gint _tmp5_;
	gint* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	gboolean* _tmp7_;
	gint _tmp7__length1;
	gint _tmp7__length2;
	gint _tmp8_;
	gboolean* _tmp10_;
	gint _tmp10__length1;
	gint _tmp10__length2;
	gboolean _tmp11_;
	gboolean* _tmp15_;
	gint _tmp15__length1;
	gint _tmp15__length2;
	gboolean _tmp16_;
	gboolean* _tmp20_;
	gint _tmp20__length1;
	gint _tmp20__length2;
	gint _tmp20__length3;
	gint _tmp21_;
	gint _tmp22_;
	gboolean _tmp23_;
	gint _tmp30_;
	gboolean* _tmp31_;
	gint _tmp31__length1;
	gint _tmp31__length2;
	gboolean* _tmp32_;
	gint _tmp32__length1;
	gint _tmp32__length2;
	gboolean* _tmp33_;
	gint _tmp33__length1;
	gint _tmp33__length2;
	gint _tmp33__length3;
	gint _tmp34_;
	gint _tmp35_;
	gboolean _tmp36_;
	gboolean _tmp37_;
#line 269 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 272 "../lib/sudoku-board.vala"
	_vala_assert (val > 0, "val > 0");
#line 273 "../lib/sudoku-board.vala"
	_tmp0_ = sudoku_board_get_max_val (self);
#line 273 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_;
#line 273 "../lib/sudoku-board.vala"
	_vala_assert (val <= _tmp1_, "val <= max_val");
#line 276 "../lib/sudoku-board.vala"
	if (!is_fixed) {
#line 2220 "sudoku-board.c"
		gboolean* _tmp2_;
		gint _tmp2__length1;
		gint _tmp2__length2;
		gboolean _tmp3_;
#line 277 "../lib/sudoku-board.vala"
		_tmp2_ = self->is_fixed;
#line 277 "../lib/sudoku-board.vala"
		_tmp2__length1 = self->is_fixed_length1;
#line 277 "../lib/sudoku-board.vala"
		_tmp2__length2 = self->is_fixed_length2;
#line 277 "../lib/sudoku-board.vala"
		_tmp3_ = _tmp2_[(row * _tmp2__length2) + col];
#line 277 "../lib/sudoku-board.vala"
		_vala_assert (!_tmp3_, "!this.is_fixed[row, col]");
#line 2235 "sudoku-board.c"
	}
#line 280 "../lib/sudoku-board.vala"
	_tmp4_ = self->cells;
#line 280 "../lib/sudoku-board.vala"
	_tmp4__length1 = self->cells_length1;
#line 280 "../lib/sudoku-board.vala"
	_tmp4__length2 = self->cells_length2;
#line 280 "../lib/sudoku-board.vala"
	_tmp5_ = _tmp4_[(row * _tmp4__length2) + col];
#line 280 "../lib/sudoku-board.vala"
	if (_tmp5_ != 0) {
#line 281 "../lib/sudoku-board.vala"
		sudoku_board_remove (self, row, col, is_fixed);
#line 2249 "sudoku-board.c"
	}
#line 283 "../lib/sudoku-board.vala"
	_tmp6_ = self->cells;
#line 283 "../lib/sudoku-board.vala"
	_tmp6__length1 = self->cells_length1;
#line 283 "../lib/sudoku-board.vala"
	_tmp6__length2 = self->cells_length2;
#line 283 "../lib/sudoku-board.vala"
	_tmp6_[(row * _tmp6__length2) + col] = val;
#line 284 "../lib/sudoku-board.vala"
	_tmp7_ = self->is_fixed;
#line 284 "../lib/sudoku-board.vala"
	_tmp7__length1 = self->is_fixed_length1;
#line 284 "../lib/sudoku-board.vala"
	_tmp7__length2 = self->is_fixed_length2;
#line 284 "../lib/sudoku-board.vala"
	_tmp7_[(row * _tmp7__length2) + col] = is_fixed;
#line 285 "../lib/sudoku-board.vala"
	_tmp8_ = self->priv->_filled;
#line 285 "../lib/sudoku-board.vala"
	sudoku_board_set_filled (self, _tmp8_ + 1);
#line 286 "../lib/sudoku-board.vala"
	if (is_fixed) {
#line 2273 "sudoku-board.c"
		gint _tmp9_;
#line 287 "../lib/sudoku-board.vala"
		_tmp9_ = self->priv->_fixed;
#line 287 "../lib/sudoku-board.vala"
		sudoku_board_set_fixed (self, _tmp9_ + 1);
#line 2279 "sudoku-board.c"
	}
#line 289 "../lib/sudoku-board.vala"
	_tmp10_ = self->priv->possible_in_row;
#line 289 "../lib/sudoku-board.vala"
	_tmp10__length1 = self->priv->possible_in_row_length1;
#line 289 "../lib/sudoku-board.vala"
	_tmp10__length2 = self->priv->possible_in_row_length2;
#line 289 "../lib/sudoku-board.vala"
	_tmp11_ = _tmp10_[(row * _tmp10__length2) + (val - 1)];
#line 289 "../lib/sudoku-board.vala"
	if (!_tmp11_) {
#line 2291 "sudoku-board.c"
		GeeList* _tmp12_;
		gpointer _tmp13_;
		GeeList* _tmp14_;
#line 290 "../lib/sudoku-board.vala"
		_tmp12_ = self->coords_for_row;
#line 290 "../lib/sudoku-board.vala"
		_tmp13_ = gee_list_get (_tmp12_, row);
#line 290 "../lib/sudoku-board.vala"
		_tmp14_ = (GeeList*) _tmp13_;
#line 290 "../lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp14_, val);
#line 290 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp14_);
#line 2305 "sudoku-board.c"
	}
#line 292 "../lib/sudoku-board.vala"
	_tmp15_ = self->priv->possible_in_col;
#line 292 "../lib/sudoku-board.vala"
	_tmp15__length1 = self->priv->possible_in_col_length1;
#line 292 "../lib/sudoku-board.vala"
	_tmp15__length2 = self->priv->possible_in_col_length2;
#line 292 "../lib/sudoku-board.vala"
	_tmp16_ = _tmp15_[(col * _tmp15__length2) + (val - 1)];
#line 292 "../lib/sudoku-board.vala"
	if (!_tmp16_) {
#line 2317 "sudoku-board.c"
		GeeList* _tmp17_;
		gpointer _tmp18_;
		GeeList* _tmp19_;
#line 293 "../lib/sudoku-board.vala"
		_tmp17_ = self->coords_for_col;
#line 293 "../lib/sudoku-board.vala"
		_tmp18_ = gee_list_get (_tmp17_, col);
#line 293 "../lib/sudoku-board.vala"
		_tmp19_ = (GeeList*) _tmp18_;
#line 293 "../lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp19_, val);
#line 293 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp19_);
#line 2331 "sudoku-board.c"
	}
#line 295 "../lib/sudoku-board.vala"
	_tmp20_ = self->priv->possible_in_block;
#line 295 "../lib/sudoku-board.vala"
	_tmp20__length1 = self->priv->possible_in_block_length1;
#line 295 "../lib/sudoku-board.vala"
	_tmp20__length2 = self->priv->possible_in_block_length2;
#line 295 "../lib/sudoku-board.vala"
	_tmp20__length3 = self->priv->possible_in_block_length3;
#line 295 "../lib/sudoku-board.vala"
	_tmp21_ = self->priv->_block_cols;
#line 295 "../lib/sudoku-board.vala"
	_tmp22_ = self->priv->_block_rows;
#line 295 "../lib/sudoku-board.vala"
	_tmp23_ = _tmp20_[((((row / _tmp21_) * _tmp20__length2) + (col / _tmp22_)) * _tmp20__length3) + (val - 1)];
#line 295 "../lib/sudoku-board.vala"
	if (!_tmp23_) {
#line 2349 "sudoku-board.c"
		GeeMap* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
		Coord _tmp27_ = {0};
		gpointer _tmp28_;
		GeeList* _tmp29_;
#line 296 "../lib/sudoku-board.vala"
		_tmp24_ = self->coords_for_block;
#line 296 "../lib/sudoku-board.vala"
		_tmp25_ = self->priv->_block_cols;
#line 296 "../lib/sudoku-board.vala"
		_tmp26_ = self->priv->_block_rows;
#line 296 "../lib/sudoku-board.vala"
		coord_init (&_tmp27_, row / _tmp25_, col / _tmp26_);
#line 296 "../lib/sudoku-board.vala"
		_tmp28_ = gee_map_get (_tmp24_, &_tmp27_);
#line 296 "../lib/sudoku-board.vala"
		_tmp29_ = (GeeList*) _tmp28_;
#line 296 "../lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp29_, val);
#line 296 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp29_);
#line 2372 "sudoku-board.c"
	}
#line 299 "../lib/sudoku-board.vala"
	_tmp30_ = val;
#line 299 "../lib/sudoku-board.vala"
	val = _tmp30_ - 1;
#line 300 "../lib/sudoku-board.vala"
	_tmp31_ = self->priv->possible_in_row;
#line 300 "../lib/sudoku-board.vala"
	_tmp31__length1 = self->priv->possible_in_row_length1;
#line 300 "../lib/sudoku-board.vala"
	_tmp31__length2 = self->priv->possible_in_row_length2;
#line 300 "../lib/sudoku-board.vala"
	_tmp31_[(row * _tmp31__length2) + val] = FALSE;
#line 301 "../lib/sudoku-board.vala"
	_tmp32_ = self->priv->possible_in_col;
#line 301 "../lib/sudoku-board.vala"
	_tmp32__length1 = self->priv->possible_in_col_length1;
#line 301 "../lib/sudoku-board.vala"
	_tmp32__length2 = self->priv->possible_in_col_length2;
#line 301 "../lib/sudoku-board.vala"
	_tmp32_[(col * _tmp32__length2) + val] = FALSE;
#line 302 "../lib/sudoku-board.vala"
	_tmp33_ = self->priv->possible_in_block;
#line 302 "../lib/sudoku-board.vala"
	_tmp33__length1 = self->priv->possible_in_block_length1;
#line 302 "../lib/sudoku-board.vala"
	_tmp33__length2 = self->priv->possible_in_block_length2;
#line 302 "../lib/sudoku-board.vala"
	_tmp33__length3 = self->priv->possible_in_block_length3;
#line 302 "../lib/sudoku-board.vala"
	_tmp34_ = self->priv->_block_cols;
#line 302 "../lib/sudoku-board.vala"
	_tmp35_ = self->priv->_block_rows;
#line 302 "../lib/sudoku-board.vala"
	_tmp33_[((((row / _tmp34_) * _tmp33__length2) + (col / _tmp35_)) * _tmp33__length3) + val] = FALSE;
#line 304 "../lib/sudoku-board.vala"
	_tmp36_ = sudoku_board_get_complete (self);
#line 304 "../lib/sudoku-board.vala"
	_tmp37_ = _tmp36_;
#line 304 "../lib/sudoku-board.vala"
	if (_tmp37_) {
#line 305 "../lib/sudoku-board.vala"
		g_signal_emit (self, sudoku_board_signals[SUDOKU_BOARD_COMPLETED_SIGNAL], 0);
#line 2416 "sudoku-board.c"
	}
}

void
sudoku_board_set (SudokuBoard* self,
                  gint row,
                  gint col,
                  gint val)
{
#line 308 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 310 "../lib/sudoku-board.vala"
	if (val == 0) {
#line 311 "../lib/sudoku-board.vala"
		sudoku_board_remove (self, row, col, FALSE);
#line 2432 "sudoku-board.c"
	} else {
		gboolean _tmp0_ = FALSE;
#line 312 "../lib/sudoku-board.vala"
		if (val > 0) {
#line 2437 "sudoku-board.c"
			gint _tmp1_;
			gint _tmp2_;
#line 312 "../lib/sudoku-board.vala"
			_tmp1_ = sudoku_board_get_max_val (self);
#line 312 "../lib/sudoku-board.vala"
			_tmp2_ = _tmp1_;
#line 312 "../lib/sudoku-board.vala"
			_tmp0_ = val <= _tmp2_;
#line 2446 "sudoku-board.c"
		} else {
#line 312 "../lib/sudoku-board.vala"
			_tmp0_ = FALSE;
#line 2450 "sudoku-board.c"
		}
#line 312 "../lib/sudoku-board.vala"
		if (_tmp0_) {
#line 313 "../lib/sudoku-board.vala"
			sudoku_board_insert (self, row, col, val, FALSE);
#line 2456 "sudoku-board.c"
		} else {
#line 315 "../lib/sudoku-board.vala"
			g_assert_not_reached ();
#line 2460 "sudoku-board.c"
		}
	}
}

gint
sudoku_board_get (SudokuBoard* self,
                  gint row,
                  gint col)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint result;
#line 318 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 320 "../lib/sudoku-board.vala"
	_tmp0_ = self->cells;
#line 320 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->cells_length1;
#line 320 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->cells_length2;
#line 320 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + col];
#line 320 "../lib/sudoku-board.vala"
	result = _tmp1_;
#line 320 "../lib/sudoku-board.vala"
	return result;
#line 2489 "sudoku-board.c"
}

void
sudoku_board_remove (SudokuBoard* self,
                     gint row,
                     gint col,
                     gboolean is_fixed)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint previous_val = 0;
	gint* _tmp4_;
	gint _tmp4__length1;
	gint _tmp4__length2;
	gint _tmp5_;
	gint* _tmp6_;
	gint _tmp6__length1;
	gint _tmp6__length2;
	GeeSet* _tmp7_;
	Coord _tmp8_ = {0};
	gint _tmp70_;
#line 323 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 326 "../lib/sudoku-board.vala"
	_tmp0_ = self->cells;
#line 326 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->cells_length1;
#line 326 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->cells_length2;
#line 326 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + col];
#line 326 "../lib/sudoku-board.vala"
	if (_tmp1_ == 0) {
#line 327 "../lib/sudoku-board.vala"
		return;
#line 2527 "sudoku-board.c"
	}
#line 330 "../lib/sudoku-board.vala"
	if (!is_fixed) {
#line 2531 "sudoku-board.c"
		gboolean* _tmp2_;
		gint _tmp2__length1;
		gint _tmp2__length2;
		gboolean _tmp3_;
#line 331 "../lib/sudoku-board.vala"
		_tmp2_ = self->is_fixed;
#line 331 "../lib/sudoku-board.vala"
		_tmp2__length1 = self->is_fixed_length1;
#line 331 "../lib/sudoku-board.vala"
		_tmp2__length2 = self->is_fixed_length2;
#line 331 "../lib/sudoku-board.vala"
		_tmp3_ = _tmp2_[(row * _tmp2__length2) + col];
#line 331 "../lib/sudoku-board.vala"
		_vala_assert (!_tmp3_, "!this.is_fixed[row, col]");
#line 2546 "sudoku-board.c"
	}
#line 333 "../lib/sudoku-board.vala"
	_tmp4_ = self->cells;
#line 333 "../lib/sudoku-board.vala"
	_tmp4__length1 = self->cells_length1;
#line 333 "../lib/sudoku-board.vala"
	_tmp4__length2 = self->cells_length2;
#line 333 "../lib/sudoku-board.vala"
	_tmp5_ = _tmp4_[(row * _tmp4__length2) + col];
#line 333 "../lib/sudoku-board.vala"
	previous_val = _tmp5_;
#line 334 "../lib/sudoku-board.vala"
	_tmp6_ = self->cells;
#line 334 "../lib/sudoku-board.vala"
	_tmp6__length1 = self->cells_length1;
#line 334 "../lib/sudoku-board.vala"
	_tmp6__length2 = self->cells_length2;
#line 334 "../lib/sudoku-board.vala"
	_tmp6_[(row * _tmp6__length2) + col] = 0;
#line 336 "../lib/sudoku-board.vala"
	_tmp7_ = self->broken_coords;
#line 336 "../lib/sudoku-board.vala"
	coord_init (&_tmp8_, row, col);
#line 336 "../lib/sudoku-board.vala"
	if (gee_collection_contains ((GeeCollection*) _tmp7_, &_tmp8_)) {
#line 2572 "sudoku-board.c"
		GeeList* _tmp9_;
		gpointer _tmp10_;
		GeeList* _tmp11_;
		GeeList* _tmp12_;
		gpointer _tmp13_;
		GeeList* _tmp14_;
		GeeMap* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		Coord _tmp18_ = {0};
		gpointer _tmp19_;
		GeeList* _tmp20_;
		GeeSet* _tmp21_;
		Coord _tmp22_ = {0};
		GeeList* _tmp23_;
		gpointer _tmp24_;
		GeeList* _tmp25_;
		GeeList* _tmp26_;
		gpointer _tmp27_;
		GeeList* _tmp28_;
		GeeMap* _tmp29_;
		gint _tmp30_;
		gint _tmp31_;
		Coord _tmp32_ = {0};
		gpointer _tmp33_;
		GeeList* _tmp34_;
		gboolean* _tmp35_;
		gint _tmp35__length1;
		gint _tmp35__length2;
		GeeList* _tmp36_;
		gpointer _tmp37_;
		GeeList* _tmp38_;
		GeeSet* _tmp39_;
		GeeSet* _tmp40_;
		gint _tmp41_;
		gint _tmp42_;
		gboolean* _tmp43_;
		gint _tmp43__length1;
		gint _tmp43__length2;
		GeeList* _tmp44_;
		gpointer _tmp45_;
		GeeList* _tmp46_;
		GeeSet* _tmp47_;
		GeeSet* _tmp48_;
		gint _tmp49_;
		gint _tmp50_;
		gboolean* _tmp51_;
		gint _tmp51__length1;
		gint _tmp51__length2;
		gint _tmp51__length3;
		gint _tmp52_;
		gint _tmp53_;
		GeeMap* _tmp54_;
		gint _tmp55_;
		gint _tmp56_;
		Coord _tmp57_ = {0};
		gpointer _tmp58_;
		GeeList* _tmp59_;
		GeeSet* _tmp60_;
		GeeSet* _tmp61_;
		gint _tmp62_;
		gint _tmp63_;
#line 339 "../lib/sudoku-board.vala"
		_tmp9_ = self->coords_for_row;
#line 339 "../lib/sudoku-board.vala"
		_tmp10_ = gee_list_get (_tmp9_, row);
#line 339 "../lib/sudoku-board.vala"
		_tmp11_ = (GeeList*) _tmp10_;
#line 339 "../lib/sudoku-board.vala"
		sudoku_board_remove_breakages_for (self, _tmp11_, previous_val);
#line 339 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp11_);
#line 340 "../lib/sudoku-board.vala"
		_tmp12_ = self->coords_for_col;
#line 340 "../lib/sudoku-board.vala"
		_tmp13_ = gee_list_get (_tmp12_, col);
#line 340 "../lib/sudoku-board.vala"
		_tmp14_ = (GeeList*) _tmp13_;
#line 340 "../lib/sudoku-board.vala"
		sudoku_board_remove_breakages_for (self, _tmp14_, previous_val);
#line 340 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp14_);
#line 341 "../lib/sudoku-board.vala"
		_tmp15_ = self->coords_for_block;
#line 341 "../lib/sudoku-board.vala"
		_tmp16_ = self->priv->_block_rows;
#line 341 "../lib/sudoku-board.vala"
		_tmp17_ = self->priv->_block_cols;
#line 341 "../lib/sudoku-board.vala"
		coord_init (&_tmp18_, row / _tmp16_, col / _tmp17_);
#line 341 "../lib/sudoku-board.vala"
		_tmp19_ = gee_map_get (_tmp15_, &_tmp18_);
#line 341 "../lib/sudoku-board.vala"
		_tmp20_ = (GeeList*) _tmp19_;
#line 341 "../lib/sudoku-board.vala"
		sudoku_board_remove_breakages_for (self, _tmp20_, previous_val);
#line 341 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp20_);
#line 342 "../lib/sudoku-board.vala"
		_tmp21_ = self->broken_coords;
#line 342 "../lib/sudoku-board.vala"
		coord_init (&_tmp22_, row, col);
#line 342 "../lib/sudoku-board.vala"
		gee_collection_remove ((GeeCollection*) _tmp21_, &_tmp22_);
#line 345 "../lib/sudoku-board.vala"
		_tmp23_ = self->coords_for_row;
#line 345 "../lib/sudoku-board.vala"
		_tmp24_ = gee_list_get (_tmp23_, row);
#line 345 "../lib/sudoku-board.vala"
		_tmp25_ = (GeeList*) _tmp24_;
#line 345 "../lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp25_, previous_val);
#line 345 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp25_);
#line 346 "../lib/sudoku-board.vala"
		_tmp26_ = self->coords_for_col;
#line 346 "../lib/sudoku-board.vala"
		_tmp27_ = gee_list_get (_tmp26_, col);
#line 346 "../lib/sudoku-board.vala"
		_tmp28_ = (GeeList*) _tmp27_;
#line 346 "../lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp28_, previous_val);
#line 346 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp28_);
#line 347 "../lib/sudoku-board.vala"
		_tmp29_ = self->coords_for_block;
#line 347 "../lib/sudoku-board.vala"
		_tmp30_ = self->priv->_block_rows;
#line 347 "../lib/sudoku-board.vala"
		_tmp31_ = self->priv->_block_cols;
#line 347 "../lib/sudoku-board.vala"
		coord_init (&_tmp32_, row / _tmp30_, col / _tmp31_);
#line 347 "../lib/sudoku-board.vala"
		_tmp33_ = gee_map_get (_tmp29_, &_tmp32_);
#line 347 "../lib/sudoku-board.vala"
		_tmp34_ = (GeeList*) _tmp33_;
#line 347 "../lib/sudoku-board.vala"
		sudoku_board_mark_breakages_for (self, _tmp34_, previous_val);
#line 347 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp34_);
#line 350 "../lib/sudoku-board.vala"
		_tmp35_ = self->priv->possible_in_row;
#line 350 "../lib/sudoku-board.vala"
		_tmp35__length1 = self->priv->possible_in_row_length1;
#line 350 "../lib/sudoku-board.vala"
		_tmp35__length2 = self->priv->possible_in_row_length2;
#line 350 "../lib/sudoku-board.vala"
		_tmp36_ = self->coords_for_row;
#line 350 "../lib/sudoku-board.vala"
		_tmp37_ = gee_list_get (_tmp36_, row);
#line 350 "../lib/sudoku-board.vala"
		_tmp38_ = (GeeList*) _tmp37_;
#line 350 "../lib/sudoku-board.vala"
		_tmp39_ = sudoku_board_get_occurances (self, _tmp38_, previous_val);
#line 350 "../lib/sudoku-board.vala"
		_tmp40_ = _tmp39_;
#line 350 "../lib/sudoku-board.vala"
		_tmp41_ = gee_collection_get_size ((GeeCollection*) _tmp40_);
#line 350 "../lib/sudoku-board.vala"
		_tmp42_ = _tmp41_;
#line 350 "../lib/sudoku-board.vala"
		_tmp35_[(row * _tmp35__length2) + (previous_val - 1)] = _tmp42_ == 0;
#line 350 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp40_);
#line 350 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp38_);
#line 351 "../lib/sudoku-board.vala"
		_tmp43_ = self->priv->possible_in_col;
#line 351 "../lib/sudoku-board.vala"
		_tmp43__length1 = self->priv->possible_in_col_length1;
#line 351 "../lib/sudoku-board.vala"
		_tmp43__length2 = self->priv->possible_in_col_length2;
#line 351 "../lib/sudoku-board.vala"
		_tmp44_ = self->coords_for_col;
#line 351 "../lib/sudoku-board.vala"
		_tmp45_ = gee_list_get (_tmp44_, col);
#line 351 "../lib/sudoku-board.vala"
		_tmp46_ = (GeeList*) _tmp45_;
#line 351 "../lib/sudoku-board.vala"
		_tmp47_ = sudoku_board_get_occurances (self, _tmp46_, previous_val);
#line 351 "../lib/sudoku-board.vala"
		_tmp48_ = _tmp47_;
#line 351 "../lib/sudoku-board.vala"
		_tmp49_ = gee_collection_get_size ((GeeCollection*) _tmp48_);
#line 351 "../lib/sudoku-board.vala"
		_tmp50_ = _tmp49_;
#line 351 "../lib/sudoku-board.vala"
		_tmp43_[(col * _tmp43__length2) + (previous_val - 1)] = _tmp50_ == 0;
#line 351 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp48_);
#line 351 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp46_);
#line 352 "../lib/sudoku-board.vala"
		_tmp51_ = self->priv->possible_in_block;
#line 352 "../lib/sudoku-board.vala"
		_tmp51__length1 = self->priv->possible_in_block_length1;
#line 352 "../lib/sudoku-board.vala"
		_tmp51__length2 = self->priv->possible_in_block_length2;
#line 352 "../lib/sudoku-board.vala"
		_tmp51__length3 = self->priv->possible_in_block_length3;
#line 352 "../lib/sudoku-board.vala"
		_tmp52_ = self->priv->_block_cols;
#line 352 "../lib/sudoku-board.vala"
		_tmp53_ = self->priv->_block_rows;
#line 352 "../lib/sudoku-board.vala"
		_tmp54_ = self->coords_for_block;
#line 352 "../lib/sudoku-board.vala"
		_tmp55_ = self->priv->_block_rows;
#line 352 "../lib/sudoku-board.vala"
		_tmp56_ = self->priv->_block_cols;
#line 352 "../lib/sudoku-board.vala"
		coord_init (&_tmp57_, row / _tmp55_, col / _tmp56_);
#line 352 "../lib/sudoku-board.vala"
		_tmp58_ = gee_map_get (_tmp54_, &_tmp57_);
#line 352 "../lib/sudoku-board.vala"
		_tmp59_ = (GeeList*) _tmp58_;
#line 352 "../lib/sudoku-board.vala"
		_tmp60_ = sudoku_board_get_occurances (self, _tmp59_, previous_val);
#line 352 "../lib/sudoku-board.vala"
		_tmp61_ = _tmp60_;
#line 352 "../lib/sudoku-board.vala"
		_tmp62_ = gee_collection_get_size ((GeeCollection*) _tmp61_);
#line 352 "../lib/sudoku-board.vala"
		_tmp63_ = _tmp62_;
#line 352 "../lib/sudoku-board.vala"
		_tmp51_[((((row / _tmp52_) * _tmp51__length2) + (col / _tmp53_)) * _tmp51__length3) + (previous_val - 1)] = _tmp63_ == 0;
#line 352 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp61_);
#line 352 "../lib/sudoku-board.vala"
		_g_object_unref0 (_tmp59_);
#line 2803 "sudoku-board.c"
	} else {
		gint _tmp64_;
		gboolean* _tmp65_;
		gint _tmp65__length1;
		gint _tmp65__length2;
		gboolean* _tmp66_;
		gint _tmp66__length1;
		gint _tmp66__length2;
		gboolean* _tmp67_;
		gint _tmp67__length1;
		gint _tmp67__length2;
		gint _tmp67__length3;
		gint _tmp68_;
		gint _tmp69_;
#line 356 "../lib/sudoku-board.vala"
		_tmp64_ = previous_val;
#line 356 "../lib/sudoku-board.vala"
		previous_val = _tmp64_ - 1;
#line 358 "../lib/sudoku-board.vala"
		_tmp65_ = self->priv->possible_in_row;
#line 358 "../lib/sudoku-board.vala"
		_tmp65__length1 = self->priv->possible_in_row_length1;
#line 358 "../lib/sudoku-board.vala"
		_tmp65__length2 = self->priv->possible_in_row_length2;
#line 358 "../lib/sudoku-board.vala"
		_tmp65_[(row * _tmp65__length2) + previous_val] = TRUE;
#line 359 "../lib/sudoku-board.vala"
		_tmp66_ = self->priv->possible_in_col;
#line 359 "../lib/sudoku-board.vala"
		_tmp66__length1 = self->priv->possible_in_col_length1;
#line 359 "../lib/sudoku-board.vala"
		_tmp66__length2 = self->priv->possible_in_col_length2;
#line 359 "../lib/sudoku-board.vala"
		_tmp66_[(col * _tmp66__length2) + previous_val] = TRUE;
#line 360 "../lib/sudoku-board.vala"
		_tmp67_ = self->priv->possible_in_block;
#line 360 "../lib/sudoku-board.vala"
		_tmp67__length1 = self->priv->possible_in_block_length1;
#line 360 "../lib/sudoku-board.vala"
		_tmp67__length2 = self->priv->possible_in_block_length2;
#line 360 "../lib/sudoku-board.vala"
		_tmp67__length3 = self->priv->possible_in_block_length3;
#line 360 "../lib/sudoku-board.vala"
		_tmp68_ = self->priv->_block_cols;
#line 360 "../lib/sudoku-board.vala"
		_tmp69_ = self->priv->_block_rows;
#line 360 "../lib/sudoku-board.vala"
		_tmp67_[((((row / _tmp68_) * _tmp67__length2) + (col / _tmp69_)) * _tmp67__length3) + previous_val] = TRUE;
#line 2852 "sudoku-board.c"
	}
#line 363 "../lib/sudoku-board.vala"
	_tmp70_ = self->priv->_filled;
#line 363 "../lib/sudoku-board.vala"
	sudoku_board_set_filled (self, _tmp70_ - 1);
#line 365 "../lib/sudoku-board.vala"
	if (is_fixed) {
#line 2860 "sudoku-board.c"
		gint _tmp71_;
#line 366 "../lib/sudoku-board.vala"
		_tmp71_ = self->priv->_fixed;
#line 366 "../lib/sudoku-board.vala"
		sudoku_board_set_fixed (self, _tmp71_ - 1);
#line 2866 "sudoku-board.c"
	}
}

void
sudoku_board_set_solution (SudokuBoard* self,
                           gint row,
                           gint col,
                           gint val)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
#line 369 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 371 "../lib/sudoku-board.vala"
	_tmp0_ = self->solution;
#line 371 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->solution_length1;
#line 371 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->solution_length2;
#line 371 "../lib/sudoku-board.vala"
	_tmp0_[(row * _tmp0__length2) + col] = val;
#line 2889 "sudoku-board.c"
}

gint
sudoku_board_get_solution (SudokuBoard* self,
                           gint row,
                           gint col)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_;
	gint result;
#line 374 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 376 "../lib/sudoku-board.vala"
	_tmp0_ = self->solution;
#line 376 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->solution_length1;
#line 376 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->solution_length2;
#line 376 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_[(row * _tmp0__length2) + col];
#line 376 "../lib/sudoku-board.vala"
	result = _tmp1_;
#line 376 "../lib/sudoku-board.vala"
	return result;
#line 2916 "sudoku-board.c"
}

void
sudoku_board_solve (SudokuBoard* self)
{
	gint* solution_1d = NULL;
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_ = 0;
	gint* _tmp2_;
	gint solution_1d_length1;
	gint _solution_1d_size_;
	gint* _tmp3_;
	gint _tmp3__length1;
#line 379 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 381 "../lib/sudoku-board.vala"
	_tmp0_ = self->cells;
#line 381 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->cells_length1;
#line 381 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->cells_length2;
#line 381 "../lib/sudoku-board.vala"
	_tmp2_ = sudoku_board_convert_2d_to_1d (self, _tmp0_, (gint) _tmp0__length1, (gint) _tmp0__length2, &_tmp1_);
#line 381 "../lib/sudoku-board.vala"
	solution_1d = _tmp2_;
#line 381 "../lib/sudoku-board.vala"
	solution_1d_length1 = _tmp1_;
#line 381 "../lib/sudoku-board.vala"
	_solution_1d_size_ = solution_1d_length1;
#line 383 "../lib/sudoku-board.vala"
	_tmp3_ = solution_1d;
#line 383 "../lib/sudoku-board.vala"
	_tmp3__length1 = solution_1d_length1;
#line 383 "../lib/sudoku-board.vala"
	if (qqwing_solve_puzzle (_tmp3_)) {
#line 2954 "sudoku-board.c"
		gint* _tmp4_;
		gint _tmp4__length1;
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
		gint* _tmp7_;
#line 384 "../lib/sudoku-board.vala"
		_tmp4_ = solution_1d;
#line 384 "../lib/sudoku-board.vala"
		_tmp4__length1 = solution_1d_length1;
#line 384 "../lib/sudoku-board.vala"
		_tmp7_ = sudoku_board_convert_1d_to_2d (self, _tmp4_, (gint) _tmp4__length1, &_tmp5_, &_tmp6_);
#line 384 "../lib/sudoku-board.vala"
		self->solution = (g_free (self->solution), NULL);
#line 384 "../lib/sudoku-board.vala"
		self->solution = _tmp7_;
#line 384 "../lib/sudoku-board.vala"
		self->solution_length1 = _tmp5_;
#line 384 "../lib/sudoku-board.vala"
		self->solution_length2 = _tmp6_;
#line 2974 "sudoku-board.c"
	} else {
#line 386 "../lib/sudoku-board.vala"
		self->solution = (g_free (self->solution), NULL);
#line 386 "../lib/sudoku-board.vala"
		self->solution = NULL;
#line 386 "../lib/sudoku-board.vala"
		self->solution_length1 = 0;
#line 386 "../lib/sudoku-board.vala"
		self->solution_length2 = 0;
#line 2984 "sudoku-board.c"
	}
#line 379 "../lib/sudoku-board.vala"
	solution_1d = (g_free (solution_1d), NULL);
#line 2988 "sudoku-board.c"
}

gboolean
sudoku_board_solved (SudokuBoard* self)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gboolean result;
#line 389 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 391 "../lib/sudoku-board.vala"
	_tmp0_ = self->solution;
#line 391 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->solution_length1;
#line 391 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->solution_length2;
#line 391 "../lib/sudoku-board.vala"
	result = _tmp0_ != NULL;
#line 391 "../lib/sudoku-board.vala"
	return result;
#line 3010 "sudoku-board.c"
}

gint
sudoku_board_count_solutions_limited (SudokuBoard* self)
{
	gint* cells_1d = NULL;
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint _tmp1_ = 0;
	gint* _tmp2_;
	gint cells_1d_length1;
	gint _cells_1d_size_;
	gint result;
#line 394 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 396 "../lib/sudoku-board.vala"
	_tmp0_ = self->cells;
#line 396 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->cells_length1;
#line 396 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->cells_length2;
#line 396 "../lib/sudoku-board.vala"
	_tmp2_ = sudoku_board_convert_2d_to_1d (self, _tmp0_, (gint) _tmp0__length1, (gint) _tmp0__length2, &_tmp1_);
#line 396 "../lib/sudoku-board.vala"
	cells_1d = _tmp2_;
#line 396 "../lib/sudoku-board.vala"
	cells_1d_length1 = _tmp1_;
#line 396 "../lib/sudoku-board.vala"
	_cells_1d_size_ = cells_1d_length1;
#line 398 "../lib/sudoku-board.vala"
	result = qqwing_count_solutions_limited (cells_1d);
#line 398 "../lib/sudoku-board.vala"
	cells_1d = (g_free (cells_1d), NULL);
#line 398 "../lib/sudoku-board.vala"
	return result;
#line 3047 "sudoku-board.c"
}

GeeSet*
sudoku_board_get_occurances (SudokuBoard* self,
                             GeeList* coords,
                             gint val)
{
	GeeSet* occurances = NULL;
	GeeHashSet* _tmp0_;
	GeeSet* result;
#line 401 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 401 "../lib/sudoku-board.vala"
	g_return_val_if_fail (coords != NULL, NULL);
#line 403 "../lib/sudoku-board.vala"
	_tmp0_ = gee_hash_set_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, (GeeHashDataFunc) coord_hash, NULL, NULL, (GeeEqualDataFunc) coord_equal, NULL, NULL);
#line 403 "../lib/sudoku-board.vala"
	occurances = (GeeSet*) _tmp0_;
#line 3066 "sudoku-board.c"
	{
		GeeList* _coord_list = NULL;
		gint _coord_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _coord_index = 0;
#line 404 "../lib/sudoku-board.vala"
		_coord_list = coords;
#line 404 "../lib/sudoku-board.vala"
		_tmp1_ = _coord_list;
#line 404 "../lib/sudoku-board.vala"
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 404 "../lib/sudoku-board.vala"
		_tmp3_ = _tmp2_;
#line 404 "../lib/sudoku-board.vala"
		_coord_size = _tmp3_;
#line 404 "../lib/sudoku-board.vala"
		_coord_index = -1;
#line 404 "../lib/sudoku-board.vala"
		while (TRUE) {
#line 3088 "sudoku-board.c"
			gint _tmp4_;
			gint _tmp5_;
			Coord coord = {0};
			GeeList* _tmp6_;
			gpointer _tmp7_;
			Coord* _tmp8_;
			Coord _tmp9_;
			gint* _tmp10_;
			gint _tmp10__length1;
			gint _tmp10__length2;
			Coord _tmp11_;
			Coord _tmp12_;
			gint _tmp13_;
#line 404 "../lib/sudoku-board.vala"
			_coord_index = _coord_index + 1;
#line 404 "../lib/sudoku-board.vala"
			_tmp4_ = _coord_index;
#line 404 "../lib/sudoku-board.vala"
			_tmp5_ = _coord_size;
#line 404 "../lib/sudoku-board.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 404 "../lib/sudoku-board.vala"
				break;
#line 3112 "sudoku-board.c"
			}
#line 404 "../lib/sudoku-board.vala"
			_tmp6_ = _coord_list;
#line 404 "../lib/sudoku-board.vala"
			_tmp7_ = gee_list_get (_tmp6_, _coord_index);
#line 404 "../lib/sudoku-board.vala"
			_tmp8_ = (Coord*) _tmp7_;
#line 404 "../lib/sudoku-board.vala"
			_tmp9_ = *_tmp8_;
#line 404 "../lib/sudoku-board.vala"
			_coord_free0 (_tmp8_);
#line 404 "../lib/sudoku-board.vala"
			coord = _tmp9_;
#line 405 "../lib/sudoku-board.vala"
			_tmp10_ = self->cells;
#line 405 "../lib/sudoku-board.vala"
			_tmp10__length1 = self->cells_length1;
#line 405 "../lib/sudoku-board.vala"
			_tmp10__length2 = self->cells_length2;
#line 405 "../lib/sudoku-board.vala"
			_tmp11_ = coord;
#line 405 "../lib/sudoku-board.vala"
			_tmp12_ = coord;
#line 405 "../lib/sudoku-board.vala"
			_tmp13_ = _tmp10_[(_tmp11_.row * _tmp10__length2) + _tmp12_.col];
#line 405 "../lib/sudoku-board.vala"
			if (_tmp13_ == val) {
#line 3140 "sudoku-board.c"
				GeeSet* _tmp14_;
				Coord _tmp15_;
#line 406 "../lib/sudoku-board.vala"
				_tmp14_ = occurances;
#line 406 "../lib/sudoku-board.vala"
				_tmp15_ = coord;
#line 406 "../lib/sudoku-board.vala"
				gee_collection_add ((GeeCollection*) _tmp14_, &_tmp15_);
#line 3149 "sudoku-board.c"
			}
		}
	}
#line 408 "../lib/sudoku-board.vala"
	result = occurances;
#line 408 "../lib/sudoku-board.vala"
	return result;
#line 3157 "sudoku-board.c"
}

gboolean
sudoku_board_row_contains (SudokuBoard* self,
                           gint row,
                           gint val)
{
	GeeList* _tmp0_;
	gpointer _tmp1_;
	GeeList* _tmp2_;
	GeeSet* _tmp3_;
	GeeSet* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gboolean _tmp7_;
	gboolean result;
#line 411 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 413 "../lib/sudoku-board.vala"
	_tmp0_ = self->coords_for_row;
#line 413 "../lib/sudoku-board.vala"
	_tmp1_ = gee_list_get (_tmp0_, row);
#line 413 "../lib/sudoku-board.vala"
	_tmp2_ = (GeeList*) _tmp1_;
#line 413 "../lib/sudoku-board.vala"
	_tmp3_ = sudoku_board_get_occurances (self, _tmp2_, val);
#line 413 "../lib/sudoku-board.vala"
	_tmp4_ = _tmp3_;
#line 413 "../lib/sudoku-board.vala"
	_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
#line 413 "../lib/sudoku-board.vala"
	_tmp6_ = _tmp5_;
#line 413 "../lib/sudoku-board.vala"
	_tmp7_ = _tmp6_ != 0;
#line 413 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp4_);
#line 413 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp2_);
#line 413 "../lib/sudoku-board.vala"
	result = _tmp7_;
#line 413 "../lib/sudoku-board.vala"
	return result;
#line 3200 "sudoku-board.c"
}

gboolean
sudoku_board_col_contains (SudokuBoard* self,
                           gint col,
                           gint val)
{
	GeeList* _tmp0_;
	gpointer _tmp1_;
	GeeList* _tmp2_;
	GeeSet* _tmp3_;
	GeeSet* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gboolean _tmp7_;
	gboolean result;
#line 416 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 418 "../lib/sudoku-board.vala"
	_tmp0_ = self->coords_for_col;
#line 418 "../lib/sudoku-board.vala"
	_tmp1_ = gee_list_get (_tmp0_, col);
#line 418 "../lib/sudoku-board.vala"
	_tmp2_ = (GeeList*) _tmp1_;
#line 418 "../lib/sudoku-board.vala"
	_tmp3_ = sudoku_board_get_occurances (self, _tmp2_, val);
#line 418 "../lib/sudoku-board.vala"
	_tmp4_ = _tmp3_;
#line 418 "../lib/sudoku-board.vala"
	_tmp5_ = gee_collection_get_size ((GeeCollection*) _tmp4_);
#line 418 "../lib/sudoku-board.vala"
	_tmp6_ = _tmp5_;
#line 418 "../lib/sudoku-board.vala"
	_tmp7_ = _tmp6_ != 0;
#line 418 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp4_);
#line 418 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp2_);
#line 418 "../lib/sudoku-board.vala"
	result = _tmp7_;
#line 418 "../lib/sudoku-board.vala"
	return result;
#line 3243 "sudoku-board.c"
}

gboolean
sudoku_board_block_contains (SudokuBoard* self,
                             Coord* block,
                             gint val)
{
	GeeMap* _tmp0_;
	Coord _tmp1_;
	gpointer _tmp2_;
	GeeList* _tmp3_;
	GeeSet* _tmp4_;
	GeeSet* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gboolean _tmp8_;
	gboolean result;
#line 421 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 421 "../lib/sudoku-board.vala"
	g_return_val_if_fail (block != NULL, FALSE);
#line 423 "../lib/sudoku-board.vala"
	_tmp0_ = self->coords_for_block;
#line 423 "../lib/sudoku-board.vala"
	_tmp1_ = *block;
#line 423 "../lib/sudoku-board.vala"
	_tmp2_ = gee_map_get (_tmp0_, &_tmp1_);
#line 423 "../lib/sudoku-board.vala"
	_tmp3_ = (GeeList*) _tmp2_;
#line 423 "../lib/sudoku-board.vala"
	_tmp4_ = sudoku_board_get_occurances (self, _tmp3_, val);
#line 423 "../lib/sudoku-board.vala"
	_tmp5_ = _tmp4_;
#line 423 "../lib/sudoku-board.vala"
	_tmp6_ = gee_collection_get_size ((GeeCollection*) _tmp5_);
#line 423 "../lib/sudoku-board.vala"
	_tmp7_ = _tmp6_;
#line 423 "../lib/sudoku-board.vala"
	_tmp8_ = _tmp7_ != 0;
#line 423 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp5_);
#line 423 "../lib/sudoku-board.vala"
	_g_object_unref0 (_tmp3_);
#line 423 "../lib/sudoku-board.vala"
	result = _tmp8_;
#line 423 "../lib/sudoku-board.vala"
	return result;
#line 3291 "sudoku-board.c"
}

static void
sudoku_board_remove_breakages_for (SudokuBoard* self,
                                   GeeList* coords,
                                   gint val)
{
#line 426 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 426 "../lib/sudoku-board.vala"
	g_return_if_fail (coords != NULL);
#line 3303 "sudoku-board.c"
	{
		GeeList* _coord_list = NULL;
		gint _coord_size = 0;
		GeeList* _tmp0_;
		gint _tmp1_;
		gint _tmp2_;
		gint _coord_index = 0;
#line 428 "../lib/sudoku-board.vala"
		_coord_list = coords;
#line 428 "../lib/sudoku-board.vala"
		_tmp0_ = _coord_list;
#line 428 "../lib/sudoku-board.vala"
		_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 428 "../lib/sudoku-board.vala"
		_tmp2_ = _tmp1_;
#line 428 "../lib/sudoku-board.vala"
		_coord_size = _tmp2_;
#line 428 "../lib/sudoku-board.vala"
		_coord_index = -1;
#line 428 "../lib/sudoku-board.vala"
		while (TRUE) {
#line 3325 "sudoku-board.c"
			gint _tmp3_;
			gint _tmp4_;
			Coord coord = {0};
			GeeList* _tmp5_;
			gpointer _tmp6_;
			Coord* _tmp7_;
			Coord _tmp8_;
			gboolean _tmp9_ = FALSE;
			gint* _tmp10_;
			gint _tmp10__length1;
			gint _tmp10__length2;
			Coord _tmp11_;
			Coord _tmp12_;
			gint _tmp13_;
#line 428 "../lib/sudoku-board.vala"
			_coord_index = _coord_index + 1;
#line 428 "../lib/sudoku-board.vala"
			_tmp3_ = _coord_index;
#line 428 "../lib/sudoku-board.vala"
			_tmp4_ = _coord_size;
#line 428 "../lib/sudoku-board.vala"
			if (!(_tmp3_ < _tmp4_)) {
#line 428 "../lib/sudoku-board.vala"
				break;
#line 3350 "sudoku-board.c"
			}
#line 428 "../lib/sudoku-board.vala"
			_tmp5_ = _coord_list;
#line 428 "../lib/sudoku-board.vala"
			_tmp6_ = gee_list_get (_tmp5_, _coord_index);
#line 428 "../lib/sudoku-board.vala"
			_tmp7_ = (Coord*) _tmp6_;
#line 428 "../lib/sudoku-board.vala"
			_tmp8_ = *_tmp7_;
#line 428 "../lib/sudoku-board.vala"
			_coord_free0 (_tmp7_);
#line 428 "../lib/sudoku-board.vala"
			coord = _tmp8_;
#line 429 "../lib/sudoku-board.vala"
			_tmp10_ = self->cells;
#line 429 "../lib/sudoku-board.vala"
			_tmp10__length1 = self->cells_length1;
#line 429 "../lib/sudoku-board.vala"
			_tmp10__length2 = self->cells_length2;
#line 429 "../lib/sudoku-board.vala"
			_tmp11_ = coord;
#line 429 "../lib/sudoku-board.vala"
			_tmp12_ = coord;
#line 429 "../lib/sudoku-board.vala"
			_tmp13_ = _tmp10_[(_tmp11_.row * _tmp10__length2) + _tmp12_.col];
#line 429 "../lib/sudoku-board.vala"
			if (_tmp13_ == val) {
#line 3378 "sudoku-board.c"
				GeeSet* _tmp14_;
				Coord _tmp15_;
#line 429 "../lib/sudoku-board.vala"
				_tmp14_ = self->broken_coords;
#line 429 "../lib/sudoku-board.vala"
				_tmp15_ = coord;
#line 429 "../lib/sudoku-board.vala"
				_tmp9_ = gee_collection_contains ((GeeCollection*) _tmp14_, &_tmp15_);
#line 3387 "sudoku-board.c"
			} else {
#line 429 "../lib/sudoku-board.vala"
				_tmp9_ = FALSE;
#line 3391 "sudoku-board.c"
			}
#line 429 "../lib/sudoku-board.vala"
			if (_tmp9_) {
#line 3395 "sudoku-board.c"
				GeeSet* _tmp16_;
				Coord _tmp17_;
#line 430 "../lib/sudoku-board.vala"
				_tmp16_ = self->broken_coords;
#line 430 "../lib/sudoku-board.vala"
				_tmp17_ = coord;
#line 430 "../lib/sudoku-board.vala"
				gee_collection_remove ((GeeCollection*) _tmp16_, &_tmp17_);
#line 3404 "sudoku-board.c"
			}
		}
	}
}

static void
sudoku_board_mark_breakages_for (SudokuBoard* self,
                                 GeeList* coords,
                                 gint val)
{
	GeeSet* occurances = NULL;
	GeeSet* _tmp0_;
	GeeSet* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 434 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 434 "../lib/sudoku-board.vala"
	g_return_if_fail (coords != NULL);
#line 436 "../lib/sudoku-board.vala"
	_tmp0_ = sudoku_board_get_occurances (self, coords, val);
#line 436 "../lib/sudoku-board.vala"
	occurances = _tmp0_;
#line 437 "../lib/sudoku-board.vala"
	_tmp1_ = occurances;
#line 437 "../lib/sudoku-board.vala"
	_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 437 "../lib/sudoku-board.vala"
	_tmp3_ = _tmp2_;
#line 437 "../lib/sudoku-board.vala"
	if (_tmp3_ != 1) {
#line 3436 "sudoku-board.c"
		GeeSet* _tmp4_;
		GeeSet* _tmp5_;
#line 438 "../lib/sudoku-board.vala"
		_tmp4_ = self->broken_coords;
#line 438 "../lib/sudoku-board.vala"
		_tmp5_ = occurances;
#line 438 "../lib/sudoku-board.vala"
		gee_collection_add_all ((GeeCollection*) _tmp4_, (GeeCollection*) _tmp5_);
#line 3445 "sudoku-board.c"
	}
#line 434 "../lib/sudoku-board.vala"
	_g_object_unref0 (occurances);
#line 3449 "sudoku-board.c"
}

void
sudoku_board_to_initial_state (SudokuBoard* self)
{
#line 441 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 3457 "sudoku-board.c"
	{
		gint l1 = 0;
#line 443 "../lib/sudoku-board.vala"
		l1 = 0;
#line 3462 "sudoku-board.c"
		{
			gboolean _tmp0_ = FALSE;
#line 443 "../lib/sudoku-board.vala"
			_tmp0_ = TRUE;
#line 443 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 3469 "sudoku-board.c"
				gint _tmp2_;
#line 443 "../lib/sudoku-board.vala"
				if (!_tmp0_) {
#line 3473 "sudoku-board.c"
					gint _tmp1_;
#line 443 "../lib/sudoku-board.vala"
					_tmp1_ = l1;
#line 443 "../lib/sudoku-board.vala"
					l1 = _tmp1_ + 1;
#line 3479 "sudoku-board.c"
				}
#line 443 "../lib/sudoku-board.vala"
				_tmp0_ = FALSE;
#line 443 "../lib/sudoku-board.vala"
				_tmp2_ = self->priv->_rows;
#line 443 "../lib/sudoku-board.vala"
				if (!(l1 < _tmp2_)) {
#line 443 "../lib/sudoku-board.vala"
					break;
#line 3489 "sudoku-board.c"
				}
				{
					gint l2 = 0;
#line 444 "../lib/sudoku-board.vala"
					l2 = 0;
#line 3495 "sudoku-board.c"
					{
						gboolean _tmp3_ = FALSE;
#line 444 "../lib/sudoku-board.vala"
						_tmp3_ = TRUE;
#line 444 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 3502 "sudoku-board.c"
							gint _tmp5_;
							gboolean* _tmp6_;
							gint _tmp6__length1;
							gint _tmp6__length2;
							gboolean _tmp7_;
#line 444 "../lib/sudoku-board.vala"
							if (!_tmp3_) {
#line 3510 "sudoku-board.c"
								gint _tmp4_;
#line 444 "../lib/sudoku-board.vala"
								_tmp4_ = l2;
#line 444 "../lib/sudoku-board.vala"
								l2 = _tmp4_ + 1;
#line 3516 "sudoku-board.c"
							}
#line 444 "../lib/sudoku-board.vala"
							_tmp3_ = FALSE;
#line 444 "../lib/sudoku-board.vala"
							_tmp5_ = self->priv->_cols;
#line 444 "../lib/sudoku-board.vala"
							if (!(l2 < _tmp5_)) {
#line 444 "../lib/sudoku-board.vala"
								break;
#line 3526 "sudoku-board.c"
							}
#line 445 "../lib/sudoku-board.vala"
							_tmp6_ = self->is_fixed;
#line 445 "../lib/sudoku-board.vala"
							_tmp6__length1 = self->is_fixed_length1;
#line 445 "../lib/sudoku-board.vala"
							_tmp6__length2 = self->is_fixed_length2;
#line 445 "../lib/sudoku-board.vala"
							_tmp7_ = _tmp6_[(l1 * _tmp6__length2) + l2];
#line 445 "../lib/sudoku-board.vala"
							if (!_tmp7_) {
#line 446 "../lib/sudoku-board.vala"
								sudoku_board_remove (self, l1, l2, FALSE);
#line 3540 "sudoku-board.c"
							}
						}
					}
				}
			}
		}
	}
}

void
sudoku_board_print (SudokuBoard* self,
                    gint indent)
{
	FILE* _tmp14_;
#line 449 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 3557 "sudoku-board.c"
	{
		gint l1 = 0;
#line 451 "../lib/sudoku-board.vala"
		l1 = 0;
#line 3562 "sudoku-board.c"
		{
			gboolean _tmp0_ = FALSE;
#line 451 "../lib/sudoku-board.vala"
			_tmp0_ = TRUE;
#line 451 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 3569 "sudoku-board.c"
				FILE* _tmp13_;
#line 451 "../lib/sudoku-board.vala"
				if (!_tmp0_) {
#line 3573 "sudoku-board.c"
					gint _tmp1_;
#line 451 "../lib/sudoku-board.vala"
					_tmp1_ = l1;
#line 451 "../lib/sudoku-board.vala"
					l1 = _tmp1_ + 1;
#line 3579 "sudoku-board.c"
				}
#line 451 "../lib/sudoku-board.vala"
				_tmp0_ = FALSE;
#line 451 "../lib/sudoku-board.vala"
				if (!(l1 < 9)) {
#line 451 "../lib/sudoku-board.vala"
					break;
#line 3587 "sudoku-board.c"
				}
				{
					gint i = 0;
#line 453 "../lib/sudoku-board.vala"
					i = 0;
#line 3593 "sudoku-board.c"
					{
						gboolean _tmp2_ = FALSE;
#line 453 "../lib/sudoku-board.vala"
						_tmp2_ = TRUE;
#line 453 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 3600 "sudoku-board.c"
							FILE* _tmp4_;
#line 453 "../lib/sudoku-board.vala"
							if (!_tmp2_) {
#line 3604 "sudoku-board.c"
								gint _tmp3_;
#line 453 "../lib/sudoku-board.vala"
								_tmp3_ = i;
#line 453 "../lib/sudoku-board.vala"
								i = _tmp3_ + 1;
#line 3610 "sudoku-board.c"
							}
#line 453 "../lib/sudoku-board.vala"
							_tmp2_ = FALSE;
#line 453 "../lib/sudoku-board.vala"
							if (!(i < indent)) {
#line 453 "../lib/sudoku-board.vala"
								break;
#line 3618 "sudoku-board.c"
							}
#line 454 "../lib/sudoku-board.vala"
							_tmp4_ = stdout;
#line 454 "../lib/sudoku-board.vala"
							fprintf (_tmp4_, " ");
#line 3624 "sudoku-board.c"
						}
					}
				}
				{
					gint l2 = 0;
#line 455 "../lib/sudoku-board.vala"
					l2 = 0;
#line 3632 "sudoku-board.c"
					{
						gboolean _tmp5_ = FALSE;
#line 455 "../lib/sudoku-board.vala"
						_tmp5_ = TRUE;
#line 455 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 3639 "sudoku-board.c"
							gint* _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							gint _tmp8_;
#line 455 "../lib/sudoku-board.vala"
							if (!_tmp5_) {
#line 3646 "sudoku-board.c"
								gint _tmp6_;
#line 455 "../lib/sudoku-board.vala"
								_tmp6_ = l2;
#line 455 "../lib/sudoku-board.vala"
								l2 = _tmp6_ + 1;
#line 3652 "sudoku-board.c"
							}
#line 455 "../lib/sudoku-board.vala"
							_tmp5_ = FALSE;
#line 455 "../lib/sudoku-board.vala"
							if (!(l2 < 9)) {
#line 455 "../lib/sudoku-board.vala"
								break;
#line 3660 "sudoku-board.c"
							}
#line 457 "../lib/sudoku-board.vala"
							_tmp7_ = self->cells;
#line 457 "../lib/sudoku-board.vala"
							_tmp7__length1 = self->cells_length1;
#line 457 "../lib/sudoku-board.vala"
							_tmp7__length2 = self->cells_length2;
#line 457 "../lib/sudoku-board.vala"
							_tmp8_ = _tmp7_[(l1 * _tmp7__length2) + l2];
#line 457 "../lib/sudoku-board.vala"
							if (_tmp8_ != 0) {
#line 3672 "sudoku-board.c"
								FILE* _tmp9_;
								gint* _tmp10_;
								gint _tmp10__length1;
								gint _tmp10__length2;
								gint _tmp11_;
#line 458 "../lib/sudoku-board.vala"
								_tmp9_ = stdout;
#line 458 "../lib/sudoku-board.vala"
								_tmp10_ = self->cells;
#line 458 "../lib/sudoku-board.vala"
								_tmp10__length1 = self->cells_length1;
#line 458 "../lib/sudoku-board.vala"
								_tmp10__length2 = self->cells_length2;
#line 458 "../lib/sudoku-board.vala"
								_tmp11_ = _tmp10_[(l1 * _tmp10__length2) + l2];
#line 458 "../lib/sudoku-board.vala"
								fprintf (_tmp9_, "%d ", _tmp11_);
#line 3690 "sudoku-board.c"
							} else {
								FILE* _tmp12_;
#line 460 "../lib/sudoku-board.vala"
								_tmp12_ = stdout;
#line 460 "../lib/sudoku-board.vala"
								fprintf (_tmp12_, "  ");
#line 3697 "sudoku-board.c"
							}
						}
					}
				}
#line 462 "../lib/sudoku-board.vala"
				_tmp13_ = stdout;
#line 462 "../lib/sudoku-board.vala"
				fprintf (_tmp13_, "\n");
#line 3706 "sudoku-board.c"
			}
		}
	}
#line 464 "../lib/sudoku-board.vala"
	_tmp14_ = stdout;
#line 464 "../lib/sudoku-board.vala"
	fflush (_tmp14_);
#line 3714 "sudoku-board.c"
}

void
sudoku_board_get_string (SudokuBoard* self)
{
	FILE* _tmp0_;
	FILE* _tmp12_;
#line 467 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 469 "../lib/sudoku-board.vala"
	_tmp0_ = stdout;
#line 469 "../lib/sudoku-board.vala"
	fprintf (_tmp0_, "[ ");
#line 3728 "sudoku-board.c"
	{
		gint l1 = 0;
#line 470 "../lib/sudoku-board.vala"
		l1 = 0;
#line 3733 "sudoku-board.c"
		{
			gboolean _tmp1_ = FALSE;
#line 470 "../lib/sudoku-board.vala"
			_tmp1_ = TRUE;
#line 470 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 3740 "sudoku-board.c"
				FILE* _tmp3_;
				FILE* _tmp10_;
#line 470 "../lib/sudoku-board.vala"
				if (!_tmp1_) {
#line 3745 "sudoku-board.c"
					gint _tmp2_;
#line 470 "../lib/sudoku-board.vala"
					_tmp2_ = l1;
#line 470 "../lib/sudoku-board.vala"
					l1 = _tmp2_ + 1;
#line 3751 "sudoku-board.c"
				}
#line 470 "../lib/sudoku-board.vala"
				_tmp1_ = FALSE;
#line 470 "../lib/sudoku-board.vala"
				if (!(l1 < 9)) {
#line 470 "../lib/sudoku-board.vala"
					break;
#line 3759 "sudoku-board.c"
				}
#line 472 "../lib/sudoku-board.vala"
				_tmp3_ = stdout;
#line 472 "../lib/sudoku-board.vala"
				fprintf (_tmp3_, "[ ");
#line 3765 "sudoku-board.c"
				{
					gint l2 = 0;
#line 473 "../lib/sudoku-board.vala"
					l2 = 0;
#line 3770 "sudoku-board.c"
					{
						gboolean _tmp4_ = FALSE;
#line 473 "../lib/sudoku-board.vala"
						_tmp4_ = TRUE;
#line 473 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 3777 "sudoku-board.c"
							FILE* _tmp6_;
							gint* _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							gint _tmp8_;
#line 473 "../lib/sudoku-board.vala"
							if (!_tmp4_) {
#line 3785 "sudoku-board.c"
								gint _tmp5_;
#line 473 "../lib/sudoku-board.vala"
								_tmp5_ = l2;
#line 473 "../lib/sudoku-board.vala"
								l2 = _tmp5_ + 1;
#line 3791 "sudoku-board.c"
							}
#line 473 "../lib/sudoku-board.vala"
							_tmp4_ = FALSE;
#line 473 "../lib/sudoku-board.vala"
							if (!(l2 < 9)) {
#line 473 "../lib/sudoku-board.vala"
								break;
#line 3799 "sudoku-board.c"
							}
#line 475 "../lib/sudoku-board.vala"
							_tmp6_ = stdout;
#line 475 "../lib/sudoku-board.vala"
							_tmp7_ = self->cells;
#line 475 "../lib/sudoku-board.vala"
							_tmp7__length1 = self->cells_length1;
#line 475 "../lib/sudoku-board.vala"
							_tmp7__length2 = self->cells_length2;
#line 475 "../lib/sudoku-board.vala"
							_tmp8_ = _tmp7_[(l1 * _tmp7__length2) + l2];
#line 475 "../lib/sudoku-board.vala"
							fprintf (_tmp6_, "%d", _tmp8_);
#line 476 "../lib/sudoku-board.vala"
							if (l2 != 8) {
#line 3815 "sudoku-board.c"
								FILE* _tmp9_;
#line 477 "../lib/sudoku-board.vala"
								_tmp9_ = stdout;
#line 477 "../lib/sudoku-board.vala"
								fprintf (_tmp9_, ",");
#line 3821 "sudoku-board.c"
							}
						}
					}
				}
#line 479 "../lib/sudoku-board.vala"
				_tmp10_ = stdout;
#line 479 "../lib/sudoku-board.vala"
				fprintf (_tmp10_, " ]");
#line 480 "../lib/sudoku-board.vala"
				if (l1 != 8) {
#line 3832 "sudoku-board.c"
					FILE* _tmp11_;
#line 481 "../lib/sudoku-board.vala"
					_tmp11_ = stdout;
#line 481 "../lib/sudoku-board.vala"
					fprintf (_tmp11_, ",");
#line 3838 "sudoku-board.c"
				}
			}
		}
	}
#line 483 "../lib/sudoku-board.vala"
	_tmp12_ = stdout;
#line 483 "../lib/sudoku-board.vala"
	fprintf (_tmp12_, " ]");
#line 3847 "sudoku-board.c"
}

gchar*
sudoku_board_to_string (SudokuBoard* self,
                        gboolean get_original_state)
{
	gchar* board_string = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 486 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 488 "../lib/sudoku-board.vala"
	_tmp0_ = g_strdup ("");
#line 488 "../lib/sudoku-board.vala"
	board_string = _tmp0_;
#line 3863 "sudoku-board.c"
	{
		gint i = 0;
#line 489 "../lib/sudoku-board.vala"
		i = 0;
#line 3868 "sudoku-board.c"
		{
			gboolean _tmp1_ = FALSE;
#line 489 "../lib/sudoku-board.vala"
			_tmp1_ = TRUE;
#line 489 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 3875 "sudoku-board.c"
				gint _tmp3_;
#line 489 "../lib/sudoku-board.vala"
				if (!_tmp1_) {
#line 3879 "sudoku-board.c"
					gint _tmp2_;
#line 489 "../lib/sudoku-board.vala"
					_tmp2_ = i;
#line 489 "../lib/sudoku-board.vala"
					i = _tmp2_ + 1;
#line 3885 "sudoku-board.c"
				}
#line 489 "../lib/sudoku-board.vala"
				_tmp1_ = FALSE;
#line 489 "../lib/sudoku-board.vala"
				_tmp3_ = self->priv->_rows;
#line 489 "../lib/sudoku-board.vala"
				if (!(i < _tmp3_)) {
#line 489 "../lib/sudoku-board.vala"
					break;
#line 3895 "sudoku-board.c"
				}
				{
					gint j = 0;
#line 491 "../lib/sudoku-board.vala"
					j = 0;
#line 3901 "sudoku-board.c"
					{
						gboolean _tmp4_ = FALSE;
#line 491 "../lib/sudoku-board.vala"
						_tmp4_ = TRUE;
#line 491 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 3908 "sudoku-board.c"
							gint _tmp6_;
							gboolean* _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							gboolean _tmp8_;
#line 491 "../lib/sudoku-board.vala"
							if (!_tmp4_) {
#line 3916 "sudoku-board.c"
								gint _tmp5_;
#line 491 "../lib/sudoku-board.vala"
								_tmp5_ = j;
#line 491 "../lib/sudoku-board.vala"
								j = _tmp5_ + 1;
#line 3922 "sudoku-board.c"
							}
#line 491 "../lib/sudoku-board.vala"
							_tmp4_ = FALSE;
#line 491 "../lib/sudoku-board.vala"
							_tmp6_ = self->priv->_cols;
#line 491 "../lib/sudoku-board.vala"
							if (!(j < _tmp6_)) {
#line 491 "../lib/sudoku-board.vala"
								break;
#line 3932 "sudoku-board.c"
							}
#line 493 "../lib/sudoku-board.vala"
							_tmp7_ = self->is_fixed;
#line 493 "../lib/sudoku-board.vala"
							_tmp7__length1 = self->is_fixed_length1;
#line 493 "../lib/sudoku-board.vala"
							_tmp7__length2 = self->is_fixed_length2;
#line 493 "../lib/sudoku-board.vala"
							_tmp8_ = _tmp7_[(i * _tmp7__length2) + j];
#line 493 "../lib/sudoku-board.vala"
							if (_tmp8_) {
#line 3944 "sudoku-board.c"
								const gchar* _tmp9_;
								gint* _tmp10_;
								gint _tmp10__length1;
								gint _tmp10__length2;
								gint _tmp11_;
								gchar* _tmp12_;
								gchar* _tmp13_;
								gchar* _tmp14_;
#line 494 "../lib/sudoku-board.vala"
								_tmp9_ = board_string;
#line 494 "../lib/sudoku-board.vala"
								_tmp10_ = self->cells;
#line 494 "../lib/sudoku-board.vala"
								_tmp10__length1 = self->cells_length1;
#line 494 "../lib/sudoku-board.vala"
								_tmp10__length2 = self->cells_length2;
#line 494 "../lib/sudoku-board.vala"
								_tmp11_ = _tmp10_[(i * _tmp10__length2) + j];
#line 494 "../lib/sudoku-board.vala"
								_tmp12_ = g_strdup_printf ("%i", _tmp11_);
#line 494 "../lib/sudoku-board.vala"
								_tmp13_ = _tmp12_;
#line 494 "../lib/sudoku-board.vala"
								_tmp14_ = g_strconcat (_tmp9_, _tmp13_, NULL);
#line 494 "../lib/sudoku-board.vala"
								_g_free0 (board_string);
#line 494 "../lib/sudoku-board.vala"
								board_string = _tmp14_;
#line 494 "../lib/sudoku-board.vala"
								_g_free0 (_tmp13_);
#line 3975 "sudoku-board.c"
							} else {
								gchar* _tmp15_ = NULL;
								const gchar* _tmp20_;
								gchar* _tmp21_;
#line 496 "../lib/sudoku-board.vala"
								if (get_original_state) {
#line 3982 "sudoku-board.c"
									gchar* _tmp16_;
#line 496 "../lib/sudoku-board.vala"
									_tmp16_ = g_strdup ("0");
#line 496 "../lib/sudoku-board.vala"
									_g_free0 (_tmp15_);
#line 496 "../lib/sudoku-board.vala"
									_tmp15_ = _tmp16_;
#line 3990 "sudoku-board.c"
								} else {
									gint* _tmp17_;
									gint _tmp17__length1;
									gint _tmp17__length2;
									gint _tmp18_;
									gchar* _tmp19_;
#line 496 "../lib/sudoku-board.vala"
									_tmp17_ = self->cells;
#line 496 "../lib/sudoku-board.vala"
									_tmp17__length1 = self->cells_length1;
#line 496 "../lib/sudoku-board.vala"
									_tmp17__length2 = self->cells_length2;
#line 496 "../lib/sudoku-board.vala"
									_tmp18_ = _tmp17_[(i * _tmp17__length2) + j];
#line 496 "../lib/sudoku-board.vala"
									_tmp19_ = g_strdup_printf ("%i", _tmp18_);
#line 496 "../lib/sudoku-board.vala"
									_g_free0 (_tmp15_);
#line 496 "../lib/sudoku-board.vala"
									_tmp15_ = _tmp19_;
#line 4011 "sudoku-board.c"
								}
#line 496 "../lib/sudoku-board.vala"
								_tmp20_ = board_string;
#line 496 "../lib/sudoku-board.vala"
								_tmp21_ = g_strconcat (_tmp20_, _tmp15_, NULL);
#line 496 "../lib/sudoku-board.vala"
								_g_free0 (board_string);
#line 496 "../lib/sudoku-board.vala"
								board_string = _tmp21_;
#line 493 "../lib/sudoku-board.vala"
								_g_free0 (_tmp15_);
#line 4023 "sudoku-board.c"
							}
						}
					}
				}
			}
		}
	}
#line 499 "../lib/sudoku-board.vala"
	result = board_string;
#line 499 "../lib/sudoku-board.vala"
	return result;
#line 4035 "sudoku-board.c"
}

static gint*
_vala_array_dup9 (gint* self,
                  gssize length)
{
#line 504 "../lib/sudoku-board.vala"
	if (length > 0) {
#line 504 "../lib/sudoku-board.vala"
		return _vala_memdup2 (self, length * sizeof (gint));
#line 4046 "sudoku-board.c"
	}
#line 504 "../lib/sudoku-board.vala"
	return NULL;
#line 4050 "sudoku-board.c"
}

gint*
sudoku_board_get_cells (SudokuBoard* self,
                        gint* result_length1,
                        gint* result_length2)
{
	gint* _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gint* _tmp1_;
	gint _tmp1__length1;
	gint _tmp1__length2;
	gint* _tmp2_;
	gint _tmp2__length1;
	gint _tmp2__length2;
	gint* result;
#line 502 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 504 "../lib/sudoku-board.vala"
	_tmp0_ = self->cells;
#line 504 "../lib/sudoku-board.vala"
	_tmp0__length1 = self->cells_length1;
#line 504 "../lib/sudoku-board.vala"
	_tmp0__length2 = self->cells_length2;
#line 504 "../lib/sudoku-board.vala"
	_tmp1_ = (_tmp0_ != NULL) ? _vala_array_dup9 (_tmp0_, _tmp0__length1 * _tmp0__length2) : _tmp0_;
#line 504 "../lib/sudoku-board.vala"
	_tmp1__length1 = _tmp0__length1;
#line 504 "../lib/sudoku-board.vala"
	_tmp1__length2 = _tmp0__length2;
#line 504 "../lib/sudoku-board.vala"
	_tmp2_ = _tmp1_;
#line 504 "../lib/sudoku-board.vala"
	_tmp2__length1 = _tmp1__length1;
#line 504 "../lib/sudoku-board.vala"
	_tmp2__length2 = _tmp1__length2;
#line 504 "../lib/sudoku-board.vala"
	if (result_length1) {
#line 504 "../lib/sudoku-board.vala"
		*result_length1 = _tmp2__length1;
#line 4092 "sudoku-board.c"
	}
#line 504 "../lib/sudoku-board.vala"
	if (result_length2) {
#line 504 "../lib/sudoku-board.vala"
		*result_length2 = _tmp2__length2;
#line 4098 "sudoku-board.c"
	}
#line 504 "../lib/sudoku-board.vala"
	result = _tmp2_;
#line 504 "../lib/sudoku-board.vala"
	return result;
#line 4104 "sudoku-board.c"
}

GeeHashMap*
sudoku_board_calculate_open_squares (SudokuBoard* self)
{
	GeeHashMap* possibilities = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* result;
#line 507 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 509 "../lib/sudoku-board.vala"
	_tmp0_ = gee_hash_map_new (TYPE_COORD, (GBoxedCopyFunc) coord_dup, (GDestroyNotify) coord_free, GEE_TYPE_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, (GeeHashDataFunc) coord_hash, NULL, NULL, (GeeEqualDataFunc) coord_equal, NULL, NULL, NULL, NULL, NULL);
#line 509 "../lib/sudoku-board.vala"
	possibilities = _tmp0_;
#line 4119 "sudoku-board.c"
	{
		gint l1 = 0;
#line 510 "../lib/sudoku-board.vala"
		l1 = 0;
#line 4124 "sudoku-board.c"
		{
			gboolean _tmp1_ = FALSE;
#line 510 "../lib/sudoku-board.vala"
			_tmp1_ = TRUE;
#line 510 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 4131 "sudoku-board.c"
				gint _tmp3_;
#line 510 "../lib/sudoku-board.vala"
				if (!_tmp1_) {
#line 4135 "sudoku-board.c"
					gint _tmp2_;
#line 510 "../lib/sudoku-board.vala"
					_tmp2_ = l1;
#line 510 "../lib/sudoku-board.vala"
					l1 = _tmp2_ + 1;
#line 4141 "sudoku-board.c"
				}
#line 510 "../lib/sudoku-board.vala"
				_tmp1_ = FALSE;
#line 510 "../lib/sudoku-board.vala"
				_tmp3_ = self->priv->_rows;
#line 510 "../lib/sudoku-board.vala"
				if (!(l1 < _tmp3_)) {
#line 510 "../lib/sudoku-board.vala"
					break;
#line 4151 "sudoku-board.c"
				}
				{
					gint l2 = 0;
#line 512 "../lib/sudoku-board.vala"
					l2 = 0;
#line 4157 "sudoku-board.c"
					{
						gboolean _tmp4_ = FALSE;
#line 512 "../lib/sudoku-board.vala"
						_tmp4_ = TRUE;
#line 512 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 4164 "sudoku-board.c"
							gint _tmp6_;
							gint* _tmp7_;
							gint _tmp7__length1;
							gint _tmp7__length2;
							gint _tmp8_;
#line 512 "../lib/sudoku-board.vala"
							if (!_tmp4_) {
#line 4172 "sudoku-board.c"
								gint _tmp5_;
#line 512 "../lib/sudoku-board.vala"
								_tmp5_ = l2;
#line 512 "../lib/sudoku-board.vala"
								l2 = _tmp5_ + 1;
#line 4178 "sudoku-board.c"
							}
#line 512 "../lib/sudoku-board.vala"
							_tmp4_ = FALSE;
#line 512 "../lib/sudoku-board.vala"
							_tmp6_ = self->priv->_cols;
#line 512 "../lib/sudoku-board.vala"
							if (!(l2 < _tmp6_)) {
#line 512 "../lib/sudoku-board.vala"
								break;
#line 4188 "sudoku-board.c"
							}
#line 514 "../lib/sudoku-board.vala"
							_tmp7_ = self->cells;
#line 514 "../lib/sudoku-board.vala"
							_tmp7__length1 = self->cells_length1;
#line 514 "../lib/sudoku-board.vala"
							_tmp7__length2 = self->cells_length2;
#line 514 "../lib/sudoku-board.vala"
							_tmp8_ = _tmp7_[(l1 * _tmp7__length2) + l2];
#line 514 "../lib/sudoku-board.vala"
							if (_tmp8_ == 0) {
#line 4200 "sudoku-board.c"
								GeeList* possArrayList = NULL;
								GeeArrayList* _tmp9_;
								gint* possArray = NULL;
								gint _tmp10_ = 0;
								gint* _tmp11_;
								gint possArray_length1;
								gint _possArray_size_;
								gint* _tmp12_;
								gint _tmp12__length1;
								GeeHashMap* _tmp14_;
								Coord _tmp15_ = {0};
								GeeList* _tmp16_;
#line 516 "../lib/sudoku-board.vala"
								_tmp9_ = gee_array_list_new (G_TYPE_INT, NULL, NULL, NULL, NULL, NULL);
#line 516 "../lib/sudoku-board.vala"
								possArrayList = (GeeList*) _tmp9_;
#line 517 "../lib/sudoku-board.vala"
								_tmp11_ = sudoku_board_get_possibilities (self, l1, l2, &_tmp10_);
#line 517 "../lib/sudoku-board.vala"
								possArray = _tmp11_;
#line 517 "../lib/sudoku-board.vala"
								possArray_length1 = _tmp10_;
#line 517 "../lib/sudoku-board.vala"
								_possArray_size_ = possArray_length1;
#line 518 "../lib/sudoku-board.vala"
								_tmp12_ = possArray;
#line 518 "../lib/sudoku-board.vala"
								_tmp12__length1 = possArray_length1;
#line 4229 "sudoku-board.c"
								{
									gint* i_collection = NULL;
									gint i_collection_length1 = 0;
									gint _i_collection_size_ = 0;
									gint i_it = 0;
#line 518 "../lib/sudoku-board.vala"
									i_collection = _tmp12_;
#line 518 "../lib/sudoku-board.vala"
									i_collection_length1 = _tmp12__length1;
#line 518 "../lib/sudoku-board.vala"
									for (i_it = 0; i_it < i_collection_length1; i_it = i_it + 1) {
#line 4241 "sudoku-board.c"
										gint i = 0;
#line 518 "../lib/sudoku-board.vala"
										i = i_collection[i_it];
#line 4245 "sudoku-board.c"
										{
											GeeList* _tmp13_;
#line 519 "../lib/sudoku-board.vala"
											_tmp13_ = possArrayList;
#line 519 "../lib/sudoku-board.vala"
											gee_collection_add ((GeeCollection*) _tmp13_, (gpointer) ((gintptr) i));
#line 4252 "sudoku-board.c"
										}
									}
								}
#line 520 "../lib/sudoku-board.vala"
								_tmp14_ = possibilities;
#line 520 "../lib/sudoku-board.vala"
								coord_init (&_tmp15_, l1, l2);
#line 520 "../lib/sudoku-board.vala"
								_tmp16_ = possArrayList;
#line 520 "../lib/sudoku-board.vala"
								gee_abstract_map_set ((GeeAbstractMap*) _tmp14_, &_tmp15_, _tmp16_);
#line 514 "../lib/sudoku-board.vala"
								possArray = (g_free (possArray), NULL);
#line 514 "../lib/sudoku-board.vala"
								_g_object_unref0 (possArrayList);
#line 4268 "sudoku-board.c"
							}
						}
					}
				}
			}
		}
	}
#line 524 "../lib/sudoku-board.vala"
	result = possibilities;
#line 524 "../lib/sudoku-board.vala"
	return result;
#line 4280 "sudoku-board.c"
}

gboolean
sudoku_board_is_finished (SudokuBoard* self)
{
	gchar* board_string = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* finishgame_file = NULL;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	GFile* file = NULL;
	GFile* _tmp7_;
	gboolean result;
#line 527 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 529 "../lib/sudoku-board.vala"
	_tmp0_ = sudoku_board_to_string (self, TRUE);
#line 529 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_;
#line 529 "../lib/sudoku-board.vala"
	_tmp2_ = g_strconcat (_tmp1_, ".save", NULL);
#line 529 "../lib/sudoku-board.vala"
	_tmp3_ = _tmp2_;
#line 529 "../lib/sudoku-board.vala"
	_g_free0 (_tmp1_);
#line 529 "../lib/sudoku-board.vala"
	board_string = _tmp3_;
#line 530 "../lib/sudoku-board.vala"
	_tmp4_ = sudoku_saver_get_finishgame_dir ();
#line 530 "../lib/sudoku-board.vala"
	_tmp5_ = _tmp4_;
#line 530 "../lib/sudoku-board.vala"
	_tmp6_ = g_build_path (G_DIR_SEPARATOR_S, _tmp5_, board_string, NULL);
#line 530 "../lib/sudoku-board.vala"
	finishgame_file = _tmp6_;
#line 531 "../lib/sudoku-board.vala"
	_tmp7_ = g_file_new_for_path (finishgame_file);
#line 531 "../lib/sudoku-board.vala"
	file = _tmp7_;
#line 533 "../lib/sudoku-board.vala"
	result = g_file_query_exists (file, NULL);
#line 533 "../lib/sudoku-board.vala"
	_g_object_unref0 (file);
#line 533 "../lib/sudoku-board.vala"
	_g_free0 (finishgame_file);
#line 533 "../lib/sudoku-board.vala"
	_g_free0 (board_string);
#line 533 "../lib/sudoku-board.vala"
	return result;
#line 4334 "sudoku-board.c"
}

gboolean*
sudoku_board_get_earmarks (SudokuBoard* self,
                           gint row,
                           gint col,
                           gint* result_length1)
{
	gboolean* the_earmarks = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gboolean* _tmp2_;
	gint the_earmarks_length1;
	gint _the_earmarks_size_;
	gboolean* _tmp10_;
	gint _tmp10__length1;
	gboolean* result;
#line 536 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 538 "../lib/sudoku-board.vala"
	_tmp0_ = sudoku_board_get_max_val (self);
#line 538 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_;
#line 538 "../lib/sudoku-board.vala"
	_tmp2_ = g_new0 (gboolean, _tmp1_);
#line 538 "../lib/sudoku-board.vala"
	the_earmarks = _tmp2_;
#line 538 "../lib/sudoku-board.vala"
	the_earmarks_length1 = _tmp1_;
#line 538 "../lib/sudoku-board.vala"
	_the_earmarks_size_ = the_earmarks_length1;
#line 4366 "sudoku-board.c"
	{
		gint i = 0;
#line 539 "../lib/sudoku-board.vala"
		i = 1;
#line 4371 "sudoku-board.c"
		{
			gboolean _tmp3_ = FALSE;
#line 539 "../lib/sudoku-board.vala"
			_tmp3_ = TRUE;
#line 539 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 4378 "sudoku-board.c"
				gint _tmp5_;
				gint _tmp6_;
				gboolean* _tmp7_;
				gint _tmp7__length1;
				gboolean* _tmp8_;
				gint _tmp8__length1;
				gint _tmp8__length2;
				gint _tmp8__length3;
				gboolean _tmp9_;
#line 539 "../lib/sudoku-board.vala"
				if (!_tmp3_) {
#line 4390 "sudoku-board.c"
					gint _tmp4_;
#line 539 "../lib/sudoku-board.vala"
					_tmp4_ = i;
#line 539 "../lib/sudoku-board.vala"
					i = _tmp4_ + 1;
#line 4396 "sudoku-board.c"
				}
#line 539 "../lib/sudoku-board.vala"
				_tmp3_ = FALSE;
#line 539 "../lib/sudoku-board.vala"
				_tmp5_ = sudoku_board_get_max_val (self);
#line 539 "../lib/sudoku-board.vala"
				_tmp6_ = _tmp5_;
#line 539 "../lib/sudoku-board.vala"
				if (!(i <= _tmp6_)) {
#line 539 "../lib/sudoku-board.vala"
					break;
#line 4408 "sudoku-board.c"
				}
#line 540 "../lib/sudoku-board.vala"
				_tmp7_ = the_earmarks;
#line 540 "../lib/sudoku-board.vala"
				_tmp7__length1 = the_earmarks_length1;
#line 540 "../lib/sudoku-board.vala"
				_tmp8_ = self->priv->earmarks;
#line 540 "../lib/sudoku-board.vala"
				_tmp8__length1 = self->priv->earmarks_length1;
#line 540 "../lib/sudoku-board.vala"
				_tmp8__length2 = self->priv->earmarks_length2;
#line 540 "../lib/sudoku-board.vala"
				_tmp8__length3 = self->priv->earmarks_length3;
#line 540 "../lib/sudoku-board.vala"
				_tmp9_ = _tmp8_[(((row * _tmp8__length2) + col) * _tmp8__length3) + (i - 1)];
#line 540 "../lib/sudoku-board.vala"
				_tmp7_[i - 1] = _tmp9_;
#line 4426 "sudoku-board.c"
			}
		}
	}
#line 541 "../lib/sudoku-board.vala"
	_tmp10_ = the_earmarks;
#line 541 "../lib/sudoku-board.vala"
	_tmp10__length1 = the_earmarks_length1;
#line 541 "../lib/sudoku-board.vala"
	if (result_length1) {
#line 541 "../lib/sudoku-board.vala"
		*result_length1 = _tmp10__length1;
#line 4438 "sudoku-board.c"
	}
#line 541 "../lib/sudoku-board.vala"
	result = _tmp10_;
#line 541 "../lib/sudoku-board.vala"
	return result;
#line 4444 "sudoku-board.c"
}

gboolean
sudoku_board_has_earmarks (SudokuBoard* self,
                           gint row,
                           gint col)
{
	gboolean* current_earmarks = NULL;
	gint _tmp0_ = 0;
	gboolean* _tmp1_;
	gint current_earmarks_length1;
	gint _current_earmarks_size_;
	gboolean has_earmarks = FALSE;
	gboolean result;
#line 544 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 546 "../lib/sudoku-board.vala"
	_tmp1_ = sudoku_board_get_earmarks (self, row, col, &_tmp0_);
#line 546 "../lib/sudoku-board.vala"
	current_earmarks = _tmp1_;
#line 546 "../lib/sudoku-board.vala"
	current_earmarks_length1 = _tmp0_;
#line 546 "../lib/sudoku-board.vala"
	_current_earmarks_size_ = current_earmarks_length1;
#line 547 "../lib/sudoku-board.vala"
	has_earmarks = FALSE;
#line 4471 "sudoku-board.c"
	{
		gint i = 0;
#line 548 "../lib/sudoku-board.vala"
		i = 0;
#line 4476 "sudoku-board.c"
		{
			gboolean _tmp2_ = FALSE;
#line 548 "../lib/sudoku-board.vala"
			_tmp2_ = TRUE;
#line 548 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 4483 "sudoku-board.c"
				gboolean* _tmp4_;
				gint _tmp4__length1;
				gboolean _tmp5_;
#line 548 "../lib/sudoku-board.vala"
				if (!_tmp2_) {
#line 4489 "sudoku-board.c"
					gint _tmp3_;
#line 548 "../lib/sudoku-board.vala"
					_tmp3_ = i;
#line 548 "../lib/sudoku-board.vala"
					i = _tmp3_ + 1;
#line 4495 "sudoku-board.c"
				}
#line 548 "../lib/sudoku-board.vala"
				_tmp2_ = FALSE;
#line 548 "../lib/sudoku-board.vala"
				if (!(i < 9)) {
#line 548 "../lib/sudoku-board.vala"
					break;
#line 4503 "sudoku-board.c"
				}
#line 549 "../lib/sudoku-board.vala"
				_tmp4_ = current_earmarks;
#line 549 "../lib/sudoku-board.vala"
				_tmp4__length1 = current_earmarks_length1;
#line 549 "../lib/sudoku-board.vala"
				_tmp5_ = _tmp4_[i];
#line 549 "../lib/sudoku-board.vala"
				if (_tmp5_) {
#line 551 "../lib/sudoku-board.vala"
					has_earmarks = TRUE;
#line 552 "../lib/sudoku-board.vala"
					break;
#line 4517 "sudoku-board.c"
				}
			}
		}
	}
#line 554 "../lib/sudoku-board.vala"
	result = has_earmarks;
#line 554 "../lib/sudoku-board.vala"
	current_earmarks = (g_free (current_earmarks), NULL);
#line 554 "../lib/sudoku-board.vala"
	return result;
#line 4528 "sudoku-board.c"
}

gchar*
sudoku_board_get_earmarks_string (SudokuBoard* self,
                                  gint row,
                                  gint col)
{
	gchar* s = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 557 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 559 "../lib/sudoku-board.vala"
	_tmp0_ = g_strdup ("");
#line 559 "../lib/sudoku-board.vala"
	s = _tmp0_;
#line 4545 "sudoku-board.c"
	{
		gint i = 0;
#line 560 "../lib/sudoku-board.vala"
		i = 1;
#line 4550 "sudoku-board.c"
		{
			gboolean _tmp1_ = FALSE;
#line 560 "../lib/sudoku-board.vala"
			_tmp1_ = TRUE;
#line 560 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 4557 "sudoku-board.c"
				gint _tmp3_;
				gint _tmp4_;
				gboolean* _tmp5_;
				gint _tmp5__length1;
				gint _tmp5__length2;
				gint _tmp5__length3;
				gboolean _tmp6_;
#line 560 "../lib/sudoku-board.vala"
				if (!_tmp1_) {
#line 4567 "sudoku-board.c"
					gint _tmp2_;
#line 560 "../lib/sudoku-board.vala"
					_tmp2_ = i;
#line 560 "../lib/sudoku-board.vala"
					i = _tmp2_ + 1;
#line 4573 "sudoku-board.c"
				}
#line 560 "../lib/sudoku-board.vala"
				_tmp1_ = FALSE;
#line 560 "../lib/sudoku-board.vala"
				_tmp3_ = sudoku_board_get_max_val (self);
#line 560 "../lib/sudoku-board.vala"
				_tmp4_ = _tmp3_;
#line 560 "../lib/sudoku-board.vala"
				if (!(i <= _tmp4_)) {
#line 560 "../lib/sudoku-board.vala"
					break;
#line 4585 "sudoku-board.c"
				}
#line 561 "../lib/sudoku-board.vala"
				_tmp5_ = self->priv->earmarks;
#line 561 "../lib/sudoku-board.vala"
				_tmp5__length1 = self->priv->earmarks_length1;
#line 561 "../lib/sudoku-board.vala"
				_tmp5__length2 = self->priv->earmarks_length2;
#line 561 "../lib/sudoku-board.vala"
				_tmp5__length3 = self->priv->earmarks_length3;
#line 561 "../lib/sudoku-board.vala"
				_tmp6_ = _tmp5_[(((row * _tmp5__length2) + col) * _tmp5__length3) + (i - 1)];
#line 561 "../lib/sudoku-board.vala"
				if (_tmp6_) {
#line 4599 "sudoku-board.c"
					const gchar* _tmp7_;
					gchar* _tmp8_;
					gchar* _tmp9_;
					gchar* _tmp10_;
#line 562 "../lib/sudoku-board.vala"
					_tmp7_ = s;
#line 562 "../lib/sudoku-board.vala"
					_tmp8_ = g_strdup_printf ("%i", i);
#line 562 "../lib/sudoku-board.vala"
					_tmp9_ = _tmp8_;
#line 562 "../lib/sudoku-board.vala"
					_tmp10_ = g_strconcat (_tmp7_, _tmp9_, NULL);
#line 562 "../lib/sudoku-board.vala"
					_g_free0 (s);
#line 562 "../lib/sudoku-board.vala"
					s = _tmp10_;
#line 562 "../lib/sudoku-board.vala"
					_g_free0 (_tmp9_);
#line 4618 "sudoku-board.c"
				}
			}
		}
	}
#line 564 "../lib/sudoku-board.vala"
	result = s;
#line 564 "../lib/sudoku-board.vala"
	return result;
#line 4627 "sudoku-board.c"
}

static gint*
sudoku_board_convert_2d_to_1d (SudokuBoard* self,
                               gint* ints_2d,
                               gint ints_2d_length1,
                               gint ints_2d_length2,
                               gint* result_length1)
{
	gint* ints_1d = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint* _tmp2_;
	gint ints_1d_length1;
	gint _ints_1d_size_;
	gint i = 0;
	gint* _tmp12_;
	gint _tmp12__length1;
	gint* result;
#line 569 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 571 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_rows;
#line 571 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_cols;
#line 571 "../lib/sudoku-board.vala"
	_tmp2_ = g_new0 (gint, _tmp0_ * _tmp1_);
#line 571 "../lib/sudoku-board.vala"
	ints_1d = _tmp2_;
#line 571 "../lib/sudoku-board.vala"
	ints_1d_length1 = _tmp0_ * _tmp1_;
#line 571 "../lib/sudoku-board.vala"
	_ints_1d_size_ = ints_1d_length1;
#line 572 "../lib/sudoku-board.vala"
	i = 0;
#line 4663 "sudoku-board.c"
	{
		gint row = 0;
#line 573 "../lib/sudoku-board.vala"
		row = 0;
#line 4668 "sudoku-board.c"
		{
			gboolean _tmp3_ = FALSE;
#line 573 "../lib/sudoku-board.vala"
			_tmp3_ = TRUE;
#line 573 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 4675 "sudoku-board.c"
				gint _tmp5_;
#line 573 "../lib/sudoku-board.vala"
				if (!_tmp3_) {
#line 4679 "sudoku-board.c"
					gint _tmp4_;
#line 573 "../lib/sudoku-board.vala"
					_tmp4_ = row;
#line 573 "../lib/sudoku-board.vala"
					row = _tmp4_ + 1;
#line 4685 "sudoku-board.c"
				}
#line 573 "../lib/sudoku-board.vala"
				_tmp3_ = FALSE;
#line 573 "../lib/sudoku-board.vala"
				_tmp5_ = self->priv->_rows;
#line 573 "../lib/sudoku-board.vala"
				if (!(row < _tmp5_)) {
#line 573 "../lib/sudoku-board.vala"
					break;
#line 4695 "sudoku-board.c"
				}
				{
					gint col = 0;
#line 574 "../lib/sudoku-board.vala"
					col = 0;
#line 4701 "sudoku-board.c"
					{
						gboolean _tmp6_ = FALSE;
#line 574 "../lib/sudoku-board.vala"
						_tmp6_ = TRUE;
#line 574 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 4708 "sudoku-board.c"
							gint _tmp8_;
							gint* _tmp9_;
							gint _tmp9__length1;
							gint _tmp10_;
							gint _tmp11_;
#line 574 "../lib/sudoku-board.vala"
							if (!_tmp6_) {
#line 4716 "sudoku-board.c"
								gint _tmp7_;
#line 574 "../lib/sudoku-board.vala"
								_tmp7_ = col;
#line 574 "../lib/sudoku-board.vala"
								col = _tmp7_ + 1;
#line 4722 "sudoku-board.c"
							}
#line 574 "../lib/sudoku-board.vala"
							_tmp6_ = FALSE;
#line 574 "../lib/sudoku-board.vala"
							_tmp8_ = self->priv->_cols;
#line 574 "../lib/sudoku-board.vala"
							if (!(col < _tmp8_)) {
#line 574 "../lib/sudoku-board.vala"
								break;
#line 4732 "sudoku-board.c"
							}
#line 575 "../lib/sudoku-board.vala"
							_tmp9_ = ints_1d;
#line 575 "../lib/sudoku-board.vala"
							_tmp9__length1 = ints_1d_length1;
#line 575 "../lib/sudoku-board.vala"
							_tmp10_ = i;
#line 575 "../lib/sudoku-board.vala"
							i = _tmp10_ + 1;
#line 575 "../lib/sudoku-board.vala"
							_tmp11_ = ints_2d[(row * ints_2d_length2) + col];
#line 575 "../lib/sudoku-board.vala"
							_tmp9_[_tmp10_] = _tmp11_;
#line 4746 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
#line 576 "../lib/sudoku-board.vala"
	_tmp12_ = ints_1d;
#line 576 "../lib/sudoku-board.vala"
	_tmp12__length1 = ints_1d_length1;
#line 576 "../lib/sudoku-board.vala"
	if (result_length1) {
#line 576 "../lib/sudoku-board.vala"
		*result_length1 = _tmp12__length1;
#line 4761 "sudoku-board.c"
	}
#line 576 "../lib/sudoku-board.vala"
	result = _tmp12_;
#line 576 "../lib/sudoku-board.vala"
	return result;
#line 4767 "sudoku-board.c"
}

static gint*
sudoku_board_convert_1d_to_2d (SudokuBoard* self,
                               gint* ints_1d,
                               gint ints_1d_length1,
                               gint* result_length1,
                               gint* result_length2)
{
	gint* ints_2d = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint* _tmp2_;
	gint ints_2d_length1;
	gint ints_2d_length2;
	gint i = 0;
	gint* _tmp12_;
	gint _tmp12__length1;
	gint _tmp12__length2;
	gint* result;
#line 581 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 583 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_rows;
#line 583 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_cols;
#line 583 "../lib/sudoku-board.vala"
	_tmp2_ = g_new0 (gint, _tmp0_ * _tmp1_);
#line 583 "../lib/sudoku-board.vala"
	ints_2d = _tmp2_;
#line 583 "../lib/sudoku-board.vala"
	ints_2d_length1 = _tmp0_;
#line 583 "../lib/sudoku-board.vala"
	ints_2d_length2 = _tmp1_;
#line 584 "../lib/sudoku-board.vala"
	i = 0;
#line 4804 "sudoku-board.c"
	{
		gint row = 0;
#line 585 "../lib/sudoku-board.vala"
		row = 0;
#line 4809 "sudoku-board.c"
		{
			gboolean _tmp3_ = FALSE;
#line 585 "../lib/sudoku-board.vala"
			_tmp3_ = TRUE;
#line 585 "../lib/sudoku-board.vala"
			while (TRUE) {
#line 4816 "sudoku-board.c"
				gint _tmp5_;
#line 585 "../lib/sudoku-board.vala"
				if (!_tmp3_) {
#line 4820 "sudoku-board.c"
					gint _tmp4_;
#line 585 "../lib/sudoku-board.vala"
					_tmp4_ = row;
#line 585 "../lib/sudoku-board.vala"
					row = _tmp4_ + 1;
#line 4826 "sudoku-board.c"
				}
#line 585 "../lib/sudoku-board.vala"
				_tmp3_ = FALSE;
#line 585 "../lib/sudoku-board.vala"
				_tmp5_ = self->priv->_rows;
#line 585 "../lib/sudoku-board.vala"
				if (!(row < _tmp5_)) {
#line 585 "../lib/sudoku-board.vala"
					break;
#line 4836 "sudoku-board.c"
				}
				{
					gint col = 0;
#line 586 "../lib/sudoku-board.vala"
					col = 0;
#line 4842 "sudoku-board.c"
					{
						gboolean _tmp6_ = FALSE;
#line 586 "../lib/sudoku-board.vala"
						_tmp6_ = TRUE;
#line 586 "../lib/sudoku-board.vala"
						while (TRUE) {
#line 4849 "sudoku-board.c"
							gint _tmp8_;
							gint* _tmp9_;
							gint _tmp9__length1;
							gint _tmp9__length2;
							gint _tmp10_;
							gint _tmp11_;
#line 586 "../lib/sudoku-board.vala"
							if (!_tmp6_) {
#line 4858 "sudoku-board.c"
								gint _tmp7_;
#line 586 "../lib/sudoku-board.vala"
								_tmp7_ = col;
#line 586 "../lib/sudoku-board.vala"
								col = _tmp7_ + 1;
#line 4864 "sudoku-board.c"
							}
#line 586 "../lib/sudoku-board.vala"
							_tmp6_ = FALSE;
#line 586 "../lib/sudoku-board.vala"
							_tmp8_ = self->priv->_cols;
#line 586 "../lib/sudoku-board.vala"
							if (!(col < _tmp8_)) {
#line 586 "../lib/sudoku-board.vala"
								break;
#line 4874 "sudoku-board.c"
							}
#line 587 "../lib/sudoku-board.vala"
							_tmp9_ = ints_2d;
#line 587 "../lib/sudoku-board.vala"
							_tmp9__length1 = ints_2d_length1;
#line 587 "../lib/sudoku-board.vala"
							_tmp9__length2 = ints_2d_length2;
#line 587 "../lib/sudoku-board.vala"
							_tmp10_ = i;
#line 587 "../lib/sudoku-board.vala"
							i = _tmp10_ + 1;
#line 587 "../lib/sudoku-board.vala"
							_tmp11_ = ints_1d[_tmp10_];
#line 587 "../lib/sudoku-board.vala"
							_tmp9_[(row * _tmp9__length2) + col] = _tmp11_;
#line 4890 "sudoku-board.c"
						}
					}
				}
			}
		}
	}
#line 588 "../lib/sudoku-board.vala"
	_tmp12_ = ints_2d;
#line 588 "../lib/sudoku-board.vala"
	_tmp12__length1 = ints_2d_length1;
#line 588 "../lib/sudoku-board.vala"
	_tmp12__length2 = ints_2d_length2;
#line 588 "../lib/sudoku-board.vala"
	if (result_length1) {
#line 588 "../lib/sudoku-board.vala"
		*result_length1 = _tmp12__length1;
#line 4907 "sudoku-board.c"
	}
#line 588 "../lib/sudoku-board.vala"
	if (result_length2) {
#line 588 "../lib/sudoku-board.vala"
		*result_length2 = _tmp12__length2;
#line 4913 "sudoku-board.c"
	}
#line 588 "../lib/sudoku-board.vala"
	result = _tmp12_;
#line 588 "../lib/sudoku-board.vala"
	return result;
#line 4919 "sudoku-board.c"
}

gdouble
sudoku_board_get_previous_played_time (SudokuBoard* self)
{
	gdouble result;
#line 38 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 38 "../lib/sudoku-board.vala"
	result = self->priv->_previous_played_time;
#line 38 "../lib/sudoku-board.vala"
	return result;
#line 4932 "sudoku-board.c"
}

void
sudoku_board_set_previous_played_time (SudokuBoard* self,
                                       gdouble value)
{
	gdouble old_value;
#line 38 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 38 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_previous_played_time (self);
#line 38 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 38 "../lib/sudoku-board.vala"
		self->priv->_previous_played_time = value;
#line 38 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY]);
#line 4950 "sudoku-board.c"
	}
}

DifficultyCategory
sudoku_board_get_difficulty_category (SudokuBoard* self)
{
	DifficultyCategory result;
#line 40 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 40 "../lib/sudoku-board.vala"
	result = self->priv->_difficulty_category;
#line 40 "../lib/sudoku-board.vala"
	return result;
#line 4964 "sudoku-board.c"
}

void
sudoku_board_set_difficulty_category (SudokuBoard* self,
                                      DifficultyCategory value)
{
	DifficultyCategory old_value;
#line 40 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 40 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_difficulty_category (self);
#line 40 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 40 "../lib/sudoku-board.vala"
		self->priv->_difficulty_category = value;
#line 40 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY]);
#line 4982 "sudoku-board.c"
	}
}

gint
sudoku_board_get_block_rows (SudokuBoard* self)
{
	gint result;
#line 43 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 43 "../lib/sudoku-board.vala"
	result = self->priv->_block_rows;
#line 43 "../lib/sudoku-board.vala"
	return result;
#line 4996 "sudoku-board.c"
}

static void
sudoku_board_set_block_rows (SudokuBoard* self,
                             gint value)
{
	gint old_value;
#line 43 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 43 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_block_rows (self);
#line 43 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 43 "../lib/sudoku-board.vala"
		self->priv->_block_rows = value;
#line 43 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_BLOCK_ROWS_PROPERTY]);
#line 5014 "sudoku-board.c"
	}
}

gint
sudoku_board_get_block_cols (SudokuBoard* self)
{
	gint result;
#line 46 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 46 "../lib/sudoku-board.vala"
	result = self->priv->_block_cols;
#line 46 "../lib/sudoku-board.vala"
	return result;
#line 5028 "sudoku-board.c"
}

static void
sudoku_board_set_block_cols (SudokuBoard* self,
                             gint value)
{
	gint old_value;
#line 46 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 46 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_block_cols (self);
#line 46 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 46 "../lib/sudoku-board.vala"
		self->priv->_block_cols = value;
#line 46 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_BLOCK_COLS_PROPERTY]);
#line 5046 "sudoku-board.c"
	}
}

gint
sudoku_board_get_rows (SudokuBoard* self)
{
	gint result;
#line 49 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 49 "../lib/sudoku-board.vala"
	result = self->priv->_rows;
#line 49 "../lib/sudoku-board.vala"
	return result;
#line 5060 "sudoku-board.c"
}

static void
sudoku_board_set_rows (SudokuBoard* self,
                       gint value)
{
	gint old_value;
#line 49 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 49 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_rows (self);
#line 49 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 49 "../lib/sudoku-board.vala"
		self->priv->_rows = value;
#line 49 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_ROWS_PROPERTY]);
#line 5078 "sudoku-board.c"
	}
}

gint
sudoku_board_get_cols (SudokuBoard* self)
{
	gint result;
#line 52 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 52 "../lib/sudoku-board.vala"
	result = self->priv->_cols;
#line 52 "../lib/sudoku-board.vala"
	return result;
#line 5092 "sudoku-board.c"
}

static void
sudoku_board_set_cols (SudokuBoard* self,
                       gint value)
{
	gint old_value;
#line 52 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 52 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_cols (self);
#line 52 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 52 "../lib/sudoku-board.vala"
		self->priv->_cols = value;
#line 52 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_COLS_PROPERTY]);
#line 5110 "sudoku-board.c"
	}
}

gint
sudoku_board_get_max_val (SudokuBoard* self)
{
	gint result;
	gint _tmp0_;
	gint _tmp1_;
#line 57 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 57 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_block_rows;
#line 57 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_block_cols;
#line 57 "../lib/sudoku-board.vala"
	result = _tmp0_ * _tmp1_;
#line 57 "../lib/sudoku-board.vala"
	return result;
#line 5130 "sudoku-board.c"
}

gboolean
sudoku_board_get_broken (SudokuBoard* self)
{
	gboolean result;
	GeeSet* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 62 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 62 "../lib/sudoku-board.vala"
	_tmp0_ = self->broken_coords;
#line 62 "../lib/sudoku-board.vala"
	_tmp1_ = gee_collection_get_size ((GeeCollection*) _tmp0_);
#line 62 "../lib/sudoku-board.vala"
	_tmp2_ = _tmp1_;
#line 62 "../lib/sudoku-board.vala"
	result = _tmp2_ != 0;
#line 62 "../lib/sudoku-board.vala"
	return result;
#line 5152 "sudoku-board.c"
}

gint
sudoku_board_get_filled (SudokuBoard* self)
{
	gint result;
#line 66 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 66 "../lib/sudoku-board.vala"
	result = self->priv->_filled;
#line 66 "../lib/sudoku-board.vala"
	return result;
#line 5165 "sudoku-board.c"
}

static void
sudoku_board_set_filled (SudokuBoard* self,
                         gint value)
{
	gint old_value;
#line 66 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 66 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_filled (self);
#line 66 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 66 "../lib/sudoku-board.vala"
		self->priv->_filled = value;
#line 66 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_FILLED_PROPERTY]);
#line 5183 "sudoku-board.c"
	}
}

gint
sudoku_board_get_fixed (SudokuBoard* self)
{
	gint result;
#line 69 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 69 "../lib/sudoku-board.vala"
	result = self->priv->_fixed;
#line 69 "../lib/sudoku-board.vala"
	return result;
#line 5197 "sudoku-board.c"
}

static void
sudoku_board_set_fixed (SudokuBoard* self,
                        gint value)
{
	gint old_value;
#line 69 "../lib/sudoku-board.vala"
	g_return_if_fail (self != NULL);
#line 69 "../lib/sudoku-board.vala"
	old_value = sudoku_board_get_fixed (self);
#line 69 "../lib/sudoku-board.vala"
	if (old_value != value) {
#line 69 "../lib/sudoku-board.vala"
		self->priv->_fixed = value;
#line 69 "../lib/sudoku-board.vala"
		g_object_notify_by_pspec ((GObject *) self, sudoku_board_properties[SUDOKU_BOARD_FIXED_PROPERTY]);
#line 5215 "sudoku-board.c"
	}
}

gint
sudoku_board_get_size (SudokuBoard* self)
{
	gint result;
	gint _tmp0_;
	gint _tmp1_;
#line 73 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 73 "../lib/sudoku-board.vala"
	_tmp0_ = self->priv->_rows;
#line 73 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_cols;
#line 73 "../lib/sudoku-board.vala"
	result = _tmp0_ * _tmp1_;
#line 73 "../lib/sudoku-board.vala"
	return result;
#line 5235 "sudoku-board.c"
}

gboolean
sudoku_board_get_complete (SudokuBoard* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 78 "../lib/sudoku-board.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 78 "../lib/sudoku-board.vala"
	_tmp1_ = self->priv->_filled;
#line 78 "../lib/sudoku-board.vala"
	_tmp2_ = self->priv->_cols;
#line 78 "../lib/sudoku-board.vala"
	_tmp3_ = self->priv->_rows;
#line 78 "../lib/sudoku-board.vala"
	if (_tmp1_ == (_tmp2_ * _tmp3_)) {
#line 5256 "sudoku-board.c"
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 78 "../lib/sudoku-board.vala"
		_tmp4_ = sudoku_board_get_broken (self);
#line 78 "../lib/sudoku-board.vala"
		_tmp5_ = _tmp4_;
#line 78 "../lib/sudoku-board.vala"
		_tmp0_ = !_tmp5_;
#line 5265 "sudoku-board.c"
	} else {
#line 78 "../lib/sudoku-board.vala"
		_tmp0_ = FALSE;
#line 5269 "sudoku-board.c"
	}
#line 78 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 78 "../lib/sudoku-board.vala"
	return result;
#line 5275 "sudoku-board.c"
}

static void
sudoku_board_class_init (SudokuBoardClass * klass,
                         gpointer klass_data)
{
#line 24 "../lib/sudoku-board.vala"
	sudoku_board_parent_class = g_type_class_peek_parent (klass);
#line 24 "../lib/sudoku-board.vala"
	g_type_class_adjust_private_offset (klass, &SudokuBoard_private_offset);
#line 24 "../lib/sudoku-board.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sudoku_board_get_property;
#line 24 "../lib/sudoku-board.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sudoku_board_set_property;
#line 24 "../lib/sudoku-board.vala"
	G_OBJECT_CLASS (klass)->finalize = sudoku_board_finalize;
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY] = g_param_spec_double ("previous-played-time", "previous-played-time", "previous-played-time", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY] = g_param_spec_enum ("difficulty-category", "difficulty-category", "difficulty-category", TYPE_DIFFICULTY_CATEGORY, DIFFICULTY_CATEGORY_UNKNOWN, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_BLOCK_ROWS_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_BLOCK_ROWS_PROPERTY] = g_param_spec_int ("block-rows", "block-rows", "block-rows", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_BLOCK_COLS_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_BLOCK_COLS_PROPERTY] = g_param_spec_int ("block-cols", "block-cols", "block-cols", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_ROWS_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_ROWS_PROPERTY] = g_param_spec_int ("rows", "rows", "rows", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_COLS_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_COLS_PROPERTY] = g_param_spec_int ("cols", "cols", "cols", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_MAX_VAL_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_MAX_VAL_PROPERTY] = g_param_spec_int ("max-val", "max-val", "max-val", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_BROKEN_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_BROKEN_PROPERTY] = g_param_spec_boolean ("broken", "broken", "broken", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_FILLED_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_FILLED_PROPERTY] = g_param_spec_int ("filled", "filled", "filled", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_FIXED_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_FIXED_PROPERTY] = g_param_spec_int ("fixed", "fixed", "fixed", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_SIZE_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_SIZE_PROPERTY] = g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SUDOKU_BOARD_COMPLETE_PROPERTY, sudoku_board_properties[SUDOKU_BOARD_COMPLETE_PROPERTY] = g_param_spec_boolean ("complete", "complete", "complete", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 24 "../lib/sudoku-board.vala"
	sudoku_board_signals[SUDOKU_BOARD_COMPLETED_SIGNAL] = g_signal_new ("completed", TYPE_SUDOKU_BOARD, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 5318 "sudoku-board.c"
}

static void
sudoku_board_instance_init (SudokuBoard * self,
                            gpointer klass)
{
#line 24 "../lib/sudoku-board.vala"
	self->priv = sudoku_board_get_instance_private (self);
#line 38 "../lib/sudoku-board.vala"
	self->priv->_previous_played_time = (gdouble) 0;
#line 40 "../lib/sudoku-board.vala"
	self->priv->_difficulty_category = DIFFICULTY_CATEGORY_UNKNOWN;
#line 5331 "sudoku-board.c"
}

static void
sudoku_board_finalize (GObject * obj)
{
	SudokuBoard * self;
#line 24 "../lib/sudoku-board.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SUDOKU_BOARD, SudokuBoard);
#line 28 "../lib/sudoku-board.vala"
	self->cells = (g_free (self->cells), NULL);
#line 29 "../lib/sudoku-board.vala"
	self->solution = (g_free (self->solution), NULL);
#line 30 "../lib/sudoku-board.vala"
	self->is_fixed = (g_free (self->is_fixed), NULL);
#line 31 "../lib/sudoku-board.vala"
	self->priv->possible_in_row = (g_free (self->priv->possible_in_row), NULL);
#line 32 "../lib/sudoku-board.vala"
	self->priv->possible_in_col = (g_free (self->priv->possible_in_col), NULL);
#line 33 "../lib/sudoku-board.vala"
	self->priv->possible_in_block = (g_free (self->priv->possible_in_block), NULL);
#line 35 "../lib/sudoku-board.vala"
	self->priv->earmarks = (g_free (self->priv->earmarks), NULL);
#line 94 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->broken_coords);
#line 97 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_col);
#line 100 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_row);
#line 103 "../lib/sudoku-board.vala"
	_g_object_unref0 (self->coords_for_block);
#line 24 "../lib/sudoku-board.vala"
	G_OBJECT_CLASS (sudoku_board_parent_class)->finalize (obj);
#line 5364 "sudoku-board.c"
}

static GType
sudoku_board_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SudokuBoardClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sudoku_board_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SudokuBoard), 0, (GInstanceInitFunc) sudoku_board_instance_init, NULL };
	GType sudoku_board_type_id;
	sudoku_board_type_id = g_type_register_static (G_TYPE_OBJECT, "SudokuBoard", &g_define_type_info, 0);
	SudokuBoard_private_offset = g_type_add_instance_private (sudoku_board_type_id, sizeof (SudokuBoardPrivate));
	return sudoku_board_type_id;
}

GType
sudoku_board_get_type (void)
{
	static volatile gsize sudoku_board_type_id__once = 0;
	if (g_once_init_enter (&sudoku_board_type_id__once)) {
		GType sudoku_board_type_id;
		sudoku_board_type_id = sudoku_board_get_type_once ();
		g_once_init_leave (&sudoku_board_type_id__once, sudoku_board_type_id);
	}
	return sudoku_board_type_id__once;
}

static void
_vala_sudoku_board_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	SudokuBoard * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_BOARD, SudokuBoard);
#line 24 "../lib/sudoku-board.vala"
	switch (property_id) {
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_double (value, sudoku_board_get_previous_played_time (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_enum (value, sudoku_board_get_difficulty_category (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BLOCK_ROWS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_block_rows (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BLOCK_COLS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_block_cols (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_ROWS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_rows (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COLS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_cols (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_MAX_VAL_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_max_val (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BROKEN_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_boolean (value, sudoku_board_get_broken (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_FILLED_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_filled (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_FIXED_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_fixed (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_SIZE_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_int (value, sudoku_board_get_size (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COMPLETE_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		g_value_set_boolean (value, sudoku_board_get_complete (self));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 5471 "sudoku-board.c"
		default:
#line 24 "../lib/sudoku-board.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/sudoku-board.vala"
		break;
#line 5477 "sudoku-board.c"
	}
}

static void
_vala_sudoku_board_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	SudokuBoard * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SUDOKU_BOARD, SudokuBoard);
#line 24 "../lib/sudoku-board.vala"
	switch (property_id) {
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_PREVIOUS_PLAYED_TIME_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_previous_played_time (self, g_value_get_double (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_DIFFICULTY_CATEGORY_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_difficulty_category (self, g_value_get_enum (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BLOCK_ROWS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_block_rows (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_BLOCK_COLS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_block_cols (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_ROWS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_rows (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_COLS_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_cols (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_FILLED_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_filled (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 24 "../lib/sudoku-board.vala"
		case SUDOKU_BOARD_FIXED_PROPERTY:
#line 24 "../lib/sudoku-board.vala"
		sudoku_board_set_fixed (self, g_value_get_int (value));
#line 24 "../lib/sudoku-board.vala"
		break;
#line 5539 "sudoku-board.c"
		default:
#line 24 "../lib/sudoku-board.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../lib/sudoku-board.vala"
		break;
#line 5545 "sudoku-board.c"
	}
}

static GType
house_get_type_once (void)
{
	static const GEnumValue values[] = {{HOUSE_ROW, "HOUSE_ROW", "row"}, {HOUSE_COLUMN, "HOUSE_COLUMN", "column"}, {HOUSE_BLOCK, "HOUSE_BLOCK", "block"}, {0, NULL, NULL}};
	GType house_type_id;
	house_type_id = g_enum_register_static ("House", values);
	return house_type_id;
}

GType
house_get_type (void)
{
	static volatile gsize house_type_id__once = 0;
	if (g_once_init_enter (&house_type_id__once)) {
		GType house_type_id;
		house_type_id = house_get_type_once ();
		g_once_init_leave (&house_type_id__once, house_type_id);
	}
	return house_type_id__once;
}

void
coord_init (Coord *self,
            gint row,
            gint col)
{
#line 604 "../lib/sudoku-board.vala"
	memset (self, 0, sizeof (Coord));
#line 606 "../lib/sudoku-board.vala"
	(*self).row = row;
#line 607 "../lib/sudoku-board.vala"
	(*self).col = col;
#line 5581 "sudoku-board.c"
}

gint
coord_hash (Coord* coord)
{
	Coord _tmp0_;
	Coord _tmp1_;
	gint result;
#line 610 "../lib/sudoku-board.vala"
	g_return_val_if_fail (coord != NULL, 0);
#line 612 "../lib/sudoku-board.vala"
	_tmp0_ = *coord;
#line 612 "../lib/sudoku-board.vala"
	_tmp1_ = *coord;
#line 612 "../lib/sudoku-board.vala"
	result = (_tmp0_.row * 33) ^ _tmp1_.col;
#line 612 "../lib/sudoku-board.vala"
	return result;
#line 5600 "sudoku-board.c"
}

gboolean
coord_equal (Coord* a,
             Coord* b)
{
	gboolean _tmp0_ = FALSE;
	Coord _tmp1_;
	Coord _tmp2_;
	gboolean result;
#line 615 "../lib/sudoku-board.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 615 "../lib/sudoku-board.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 617 "../lib/sudoku-board.vala"
	_tmp1_ = *a;
#line 617 "../lib/sudoku-board.vala"
	_tmp2_ = *b;
#line 617 "../lib/sudoku-board.vala"
	if (_tmp1_.row == _tmp2_.row) {
#line 5621 "sudoku-board.c"
		Coord _tmp3_;
		Coord _tmp4_;
#line 617 "../lib/sudoku-board.vala"
		_tmp3_ = *a;
#line 617 "../lib/sudoku-board.vala"
		_tmp4_ = *b;
#line 617 "../lib/sudoku-board.vala"
		_tmp0_ = _tmp3_.col == _tmp4_.col;
#line 5630 "sudoku-board.c"
	} else {
#line 617 "../lib/sudoku-board.vala"
		_tmp0_ = FALSE;
#line 5634 "sudoku-board.c"
	}
#line 617 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 617 "../lib/sudoku-board.vala"
	return result;
#line 5640 "sudoku-board.c"
}

Coord*
coord_dup (const Coord* self)
{
	Coord* dup;
#line 599 "../lib/sudoku-board.vala"
	dup = g_new0 (Coord, 1);
#line 599 "../lib/sudoku-board.vala"
	memcpy (dup, self, sizeof (Coord));
#line 599 "../lib/sudoku-board.vala"
	return dup;
#line 5653 "sudoku-board.c"
}

void
coord_free (Coord* self)
{
#line 599 "../lib/sudoku-board.vala"
	g_free (self);
#line 5661 "sudoku-board.c"
}

static GType
coord_get_type_once (void)
{
	GType coord_type_id;
	coord_type_id = g_boxed_type_register_static ("Coord", (GBoxedCopyFunc) coord_dup, (GBoxedFreeFunc) coord_free);
	return coord_type_id;
}

GType
coord_get_type (void)
{
	static volatile gsize coord_type_id__once = 0;
	if (g_once_init_enter (&coord_type_id__once)) {
		GType coord_type_id;
		coord_type_id = coord_get_type_once ();
		g_once_init_leave (&coord_type_id__once, coord_type_id);
	}
	return coord_type_id__once;
}

void
cell_init (Cell *self,
           Coord* coord,
           gint val)
{
	Coord _tmp0_;
#line 626 "../lib/sudoku-board.vala"
	g_return_if_fail (coord != NULL);
#line 626 "../lib/sudoku-board.vala"
	memset (self, 0, sizeof (Cell));
#line 628 "../lib/sudoku-board.vala"
	_tmp0_ = *coord;
#line 628 "../lib/sudoku-board.vala"
	(*self).coord = _tmp0_;
#line 629 "../lib/sudoku-board.vala"
	(*self).val = val;
#line 5700 "sudoku-board.c"
}

gint
cell_hash (Cell* cell)
{
	Cell _tmp0_;
	Coord _tmp1_;
	Cell _tmp2_;
	gint result;
#line 632 "../lib/sudoku-board.vala"
	g_return_val_if_fail (cell != NULL, 0);
#line 634 "../lib/sudoku-board.vala"
	_tmp0_ = *cell;
#line 634 "../lib/sudoku-board.vala"
	_tmp1_ = _tmp0_.coord;
#line 634 "../lib/sudoku-board.vala"
	_tmp2_ = *cell;
#line 634 "../lib/sudoku-board.vala"
	result = (coord_hash (&_tmp1_) * 33) ^ _tmp2_.val;
#line 634 "../lib/sudoku-board.vala"
	return result;
#line 5722 "sudoku-board.c"
}

gboolean
cell_equal (Cell* a,
            Cell* b)
{
	gboolean _tmp0_ = FALSE;
	Cell _tmp1_;
	Coord _tmp2_;
	Cell _tmp3_;
	Coord _tmp4_;
	gboolean result;
#line 637 "../lib/sudoku-board.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 637 "../lib/sudoku-board.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 639 "../lib/sudoku-board.vala"
	_tmp1_ = *a;
#line 639 "../lib/sudoku-board.vala"
	_tmp2_ = _tmp1_.coord;
#line 639 "../lib/sudoku-board.vala"
	_tmp3_ = *b;
#line 639 "../lib/sudoku-board.vala"
	_tmp4_ = _tmp3_.coord;
#line 639 "../lib/sudoku-board.vala"
	if (coord_equal (&_tmp2_, &_tmp4_)) {
#line 5749 "sudoku-board.c"
		Cell _tmp5_;
		Cell _tmp6_;
#line 639 "../lib/sudoku-board.vala"
		_tmp5_ = *a;
#line 639 "../lib/sudoku-board.vala"
		_tmp6_ = *b;
#line 639 "../lib/sudoku-board.vala"
		_tmp0_ = _tmp5_.val == _tmp6_.val;
#line 5758 "sudoku-board.c"
	} else {
#line 639 "../lib/sudoku-board.vala"
		_tmp0_ = FALSE;
#line 5762 "sudoku-board.c"
	}
#line 639 "../lib/sudoku-board.vala"
	result = _tmp0_;
#line 639 "../lib/sudoku-board.vala"
	return result;
#line 5768 "sudoku-board.c"
}

Cell*
cell_dup (const Cell* self)
{
	Cell* dup;
#line 621 "../lib/sudoku-board.vala"
	dup = g_new0 (Cell, 1);
#line 621 "../lib/sudoku-board.vala"
	memcpy (dup, self, sizeof (Cell));
#line 621 "../lib/sudoku-board.vala"
	return dup;
#line 5781 "sudoku-board.c"
}

void
cell_free (Cell* self)
{
#line 621 "../lib/sudoku-board.vala"
	g_free (self);
#line 5789 "sudoku-board.c"
}

static GType
cell_get_type_once (void)
{
	GType cell_type_id;
	cell_type_id = g_boxed_type_register_static ("Cell", (GBoxedCopyFunc) cell_dup, (GBoxedFreeFunc) cell_free);
	return cell_type_id;
}

GType
cell_get_type (void)
{
	static volatile gsize cell_type_id__once = 0;
	if (g_once_init_enter (&cell_type_id__once)) {
		GType cell_type_id;
		cell_type_id = cell_get_type_once ();
		g_once_init_leave (&cell_type_id__once, cell_type_id);
	}
	return cell_type_id__once;
}

gchar*
difficulty_category_to_string (DifficultyCategory self)
{
	gchar* result;
#line 654 "../lib/sudoku-board.vala"
	switch (self) {
#line 654 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_UNKNOWN:
#line 5820 "sudoku-board.c"
		{
			gchar* _tmp0_;
#line 657 "../lib/sudoku-board.vala"
			_tmp0_ = g_strdup (_ ("Unknown Difficulty"));
#line 657 "../lib/sudoku-board.vala"
			result = _tmp0_;
#line 657 "../lib/sudoku-board.vala"
			return result;
#line 5829 "sudoku-board.c"
		}
#line 654 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_EASY:
#line 5833 "sudoku-board.c"
		{
			gchar* _tmp1_;
#line 659 "../lib/sudoku-board.vala"
			_tmp1_ = g_strdup (_ ("Easy Difficulty"));
#line 659 "../lib/sudoku-board.vala"
			result = _tmp1_;
#line 659 "../lib/sudoku-board.vala"
			return result;
#line 5842 "sudoku-board.c"
		}
#line 654 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_MEDIUM:
#line 5846 "sudoku-board.c"
		{
			gchar* _tmp2_;
#line 661 "../lib/sudoku-board.vala"
			_tmp2_ = g_strdup (_ ("Medium Difficulty"));
#line 661 "../lib/sudoku-board.vala"
			result = _tmp2_;
#line 661 "../lib/sudoku-board.vala"
			return result;
#line 5855 "sudoku-board.c"
		}
#line 654 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_HARD:
#line 5859 "sudoku-board.c"
		{
			gchar* _tmp3_;
#line 663 "../lib/sudoku-board.vala"
			_tmp3_ = g_strdup (_ ("Hard Difficulty"));
#line 663 "../lib/sudoku-board.vala"
			result = _tmp3_;
#line 663 "../lib/sudoku-board.vala"
			return result;
#line 5868 "sudoku-board.c"
		}
#line 654 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_VERY_HARD:
#line 5872 "sudoku-board.c"
		{
			gchar* _tmp4_;
#line 665 "../lib/sudoku-board.vala"
			_tmp4_ = g_strdup (_ ("Very Hard Difficulty"));
#line 665 "../lib/sudoku-board.vala"
			result = _tmp4_;
#line 665 "../lib/sudoku-board.vala"
			return result;
#line 5881 "sudoku-board.c"
		}
#line 654 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_CUSTOM:
#line 5885 "sudoku-board.c"
		{
			gchar* _tmp5_;
#line 667 "../lib/sudoku-board.vala"
			_tmp5_ = g_strdup (_ ("Custom Puzzle"));
#line 667 "../lib/sudoku-board.vala"
			result = _tmp5_;
#line 667 "../lib/sudoku-board.vala"
			return result;
#line 5894 "sudoku-board.c"
		}
		default:
		{
#line 669 "../lib/sudoku-board.vala"
			g_assert_not_reached ();
#line 5900 "sudoku-board.c"
		}
	}
}

gchar*
difficulty_category_to_untranslated_string (DifficultyCategory self)
{
	gchar* result;
#line 675 "../lib/sudoku-board.vala"
	switch (self) {
#line 675 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_UNKNOWN:
#line 5913 "sudoku-board.c"
		{
			gchar* _tmp0_;
#line 678 "../lib/sudoku-board.vala"
			_tmp0_ = g_strdup ("Unknown Difficulty");
#line 678 "../lib/sudoku-board.vala"
			result = _tmp0_;
#line 678 "../lib/sudoku-board.vala"
			return result;
#line 5922 "sudoku-board.c"
		}
#line 675 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_EASY:
#line 5926 "sudoku-board.c"
		{
			gchar* _tmp1_;
#line 680 "../lib/sudoku-board.vala"
			_tmp1_ = g_strdup ("Easy Difficulty");
#line 680 "../lib/sudoku-board.vala"
			result = _tmp1_;
#line 680 "../lib/sudoku-board.vala"
			return result;
#line 5935 "sudoku-board.c"
		}
#line 675 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_MEDIUM:
#line 5939 "sudoku-board.c"
		{
			gchar* _tmp2_;
#line 682 "../lib/sudoku-board.vala"
			_tmp2_ = g_strdup ("Medium Difficulty");
#line 682 "../lib/sudoku-board.vala"
			result = _tmp2_;
#line 682 "../lib/sudoku-board.vala"
			return result;
#line 5948 "sudoku-board.c"
		}
#line 675 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_HARD:
#line 5952 "sudoku-board.c"
		{
			gchar* _tmp3_;
#line 684 "../lib/sudoku-board.vala"
			_tmp3_ = g_strdup ("Hard Difficulty");
#line 684 "../lib/sudoku-board.vala"
			result = _tmp3_;
#line 684 "../lib/sudoku-board.vala"
			return result;
#line 5961 "sudoku-board.c"
		}
#line 675 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_VERY_HARD:
#line 5965 "sudoku-board.c"
		{
			gchar* _tmp4_;
#line 686 "../lib/sudoku-board.vala"
			_tmp4_ = g_strdup ("Very Hard Difficulty");
#line 686 "../lib/sudoku-board.vala"
			result = _tmp4_;
#line 686 "../lib/sudoku-board.vala"
			return result;
#line 5974 "sudoku-board.c"
		}
#line 675 "../lib/sudoku-board.vala"
		case DIFFICULTY_CATEGORY_CUSTOM:
#line 5978 "sudoku-board.c"
		{
			gchar* _tmp5_;
#line 688 "../lib/sudoku-board.vala"
			_tmp5_ = g_strdup ("Custom Puzzle");
#line 688 "../lib/sudoku-board.vala"
			result = _tmp5_;
#line 688 "../lib/sudoku-board.vala"
			return result;
#line 5987 "sudoku-board.c"
		}
		default:
		{
#line 690 "../lib/sudoku-board.vala"
			g_assert_not_reached ();
#line 5993 "sudoku-board.c"
		}
	}
}

DifficultyCategory
difficulty_category_from_string (const gchar* input)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 696 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label0 = 0;
#line 696 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label1 = 0;
#line 696 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label2 = 0;
#line 696 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label3 = 0;
#line 696 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label4 = 0;
#line 696 "../lib/sudoku-board.vala"
	static GQuark _tmp1_label5 = 0;
#line 6015 "sudoku-board.c"
	DifficultyCategory result;
#line 694 "../lib/sudoku-board.vala"
	g_return_val_if_fail (input != NULL, 0);
#line 696 "../lib/sudoku-board.vala"
	_tmp0_ = input;
#line 696 "../lib/sudoku-board.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 696 "../lib/sudoku-board.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("Unknown Difficulty")))) {
#line 696 "../lib/sudoku-board.vala"
		switch (0) {
#line 6027 "sudoku-board.c"
			default:
			{
#line 699 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_UNKNOWN;
#line 699 "../lib/sudoku-board.vala"
				return result;
#line 6034 "sudoku-board.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("Easy Difficulty")))) {
#line 696 "../lib/sudoku-board.vala"
		switch (0) {
#line 6040 "sudoku-board.c"
			default:
			{
#line 701 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_EASY;
#line 701 "../lib/sudoku-board.vala"
				return result;
#line 6047 "sudoku-board.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("Medium Difficulty")))) {
#line 696 "../lib/sudoku-board.vala"
		switch (0) {
#line 6053 "sudoku-board.c"
			default:
			{
#line 703 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_MEDIUM;
#line 703 "../lib/sudoku-board.vala"
				return result;
#line 6060 "sudoku-board.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("Hard Difficulty")))) {
#line 696 "../lib/sudoku-board.vala"
		switch (0) {
#line 6066 "sudoku-board.c"
			default:
			{
#line 705 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_HARD;
#line 705 "../lib/sudoku-board.vala"
				return result;
#line 6073 "sudoku-board.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("Very Hard Difficulty")))) {
#line 696 "../lib/sudoku-board.vala"
		switch (0) {
#line 6079 "sudoku-board.c"
			default:
			{
#line 707 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_VERY_HARD;
#line 707 "../lib/sudoku-board.vala"
				return result;
#line 6086 "sudoku-board.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("Custom Puzzle")))) {
#line 696 "../lib/sudoku-board.vala"
		switch (0) {
#line 6092 "sudoku-board.c"
			default:
			{
#line 709 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_CUSTOM;
#line 709 "../lib/sudoku-board.vala"
				return result;
#line 6099 "sudoku-board.c"
			}
		}
	} else {
#line 696 "../lib/sudoku-board.vala"
		switch (0) {
#line 6105 "sudoku-board.c"
			default:
			{
#line 711 "../lib/sudoku-board.vala"
				g_warning ("sudoku-board.vala:711: Could not parse difficulty level. Falling back " \
"to Easy difficulty");
#line 712 "../lib/sudoku-board.vala"
				result = DIFFICULTY_CATEGORY_EASY;
#line 712 "../lib/sudoku-board.vala"
				return result;
#line 6114 "sudoku-board.c"
			}
		}
	}
}

static GType
difficulty_category_get_type_once (void)
{
	static const GEnumValue values[] = {{DIFFICULTY_CATEGORY_UNKNOWN, "DIFFICULTY_CATEGORY_UNKNOWN", "unknown"}, {DIFFICULTY_CATEGORY_EASY, "DIFFICULTY_CATEGORY_EASY", "easy"}, {DIFFICULTY_CATEGORY_MEDIUM, "DIFFICULTY_CATEGORY_MEDIUM", "medium"}, {DIFFICULTY_CATEGORY_HARD, "DIFFICULTY_CATEGORY_HARD", "hard"}, {DIFFICULTY_CATEGORY_VERY_HARD, "DIFFICULTY_CATEGORY_VERY_HARD", "very-hard"}, {DIFFICULTY_CATEGORY_CUSTOM, "DIFFICULTY_CATEGORY_CUSTOM", "custom"}, {0, NULL, NULL}};
	GType difficulty_category_type_id;
	difficulty_category_type_id = g_enum_register_static ("DifficultyCategory", values);
	return difficulty_category_type_id;
}

GType
difficulty_category_get_type (void)
{
	static volatile gsize difficulty_category_type_id__once = 0;
	if (g_once_init_enter (&difficulty_category_type_id__once)) {
		GType difficulty_category_type_id;
		difficulty_category_type_id = difficulty_category_get_type_once ();
		g_once_init_leave (&difficulty_category_type_id__once, difficulty_category_type_id);
	}
	return difficulty_category_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

